; Script generated by the HM NIS Edit Script Wizard.

Name "Build 14 Beta 3.5 WIP"
OutFile "b14_beta3_installer_internal.exe"
InstallDir "$PROGRAMFILES\Bethesda Softworks\Pirates of the Caribbean\"

ShowInstDetails nevershow
SetCompressor lzma
ComponentText "READ THE DESCRIPTIONS! Only install additional options if you REALLY need or want them."

; Request application privileges for Windows Vista
RequestExecutionLevel highest

; HM NIS Edit Wizard helper defines
!define PRODUCT_NAME "Pirates of the Caribbean: New Horizons"
!define PRODUCT_VERSION "Build 14 Beta 3.5 WIP"
!define PRODUCT_PUBLISHER "PiratesAhoy! Community"
!define PRODUCT_WEB_SITE "http://www.piratesahoy.net"

; MUI 1.67 compatible ------
!include "MUI.nsh"

; MUI Settings
!define MUI_ABORTWARNING
!define MUI_ICON "C:\Users\PDM Boelen\Desktop\NEW\Installer\UsedFiles\A Compass That Doesn't Point North.ico"

; Welcome page
!insertmacro MUI_PAGE_WELCOME
; License page
!define MUI_LICENSEPAGE_CHECKBOX
!define MUI_PAGE_CUSTOMFUNCTION_SHOW licpageshow
!insertmacro MUI_PAGE_LICENSE "C:\Users\PDM Boelen\Desktop\NEW\Installer\UsedFiles\Installation Instructions.txt"
; Components page
!insertmacro MUI_PAGE_COMPONENTS
; Directory page
!insertmacro MUI_PAGE_DIRECTORY
; Instfiles page
!insertmacro MUI_PAGE_INSTFILES
; Finish page
!define MUI_FINISHPAGE_RUN "$INSTDIR\Config.exe"
!define MUI_FINISHPAGE_RUN_TEXT "Configure game resolution and basic settings"
!define MUI_FINISHPAGE_SHOWREADME "$INSTDIR\Build Info.txt"
!define MUI_FINISHPAGE_SHOWREADME_TEXT "See Overview of Latest Changes"
!insertmacro MUI_PAGE_FINISH

; Language files
!insertmacro MUI_LANGUAGE "English"



; ================================================
;  Copy Folder with Overwrite
; ================================================
!include 'LogicLib.nsh'
!include 'FileFunc.nsh'
!insertmacro Locate

Var /GLOBAL switch_overwrite
!include 'UsedFiles\MoveFileFolder.nsh'



; ================================================
;  License Page with Courier New Font
; ================================================

Function licpageshow
FindWindow $0 "#32770" "" $HWNDPARENT
CreateFont $1 "Courier New" "$(^FontSize)"
GetDlgItem $0 $0 1000
SendMessage $0 ${WM_SETFONT} $1 1
FunctionEnd


; ================================================
;  Start Main Files Section
; ================================================

Section "!Main Files" SEC01
  ${If} ${FileExists} "$INSTDIR\ENGINE.exe"
  ${Else}
    MessageBox MB_OK|MB_ICONINFORMATION "Original game not found. Make sure you install the 2003 Pirates of the Caribbean game by Akella first!" IDOK abort1
    abort1:
    Banner::destroy
    Abort
  ${EndIf}
  ${If} ${FileExists} "$INSTDIR\readme.txt"
  ${Else}
    MessageBox MB_OK|MB_ICONINFORMATION "Original game not found. Make sure you install the 2003 Pirates of the Caribbean game by Akella first!" IDOK abort2
    abort2:
    Banner::destroy
    Abort
  ${EndIf}

  ; Only do this if the file is there
  ${If} ${FileExists} "$EXEDIR\b14_beta3_full.potc"
    CRCCheck::GenCRC "$EXEDIR\b14_beta3_full.potc" ; Get a CRC from file
    Pop $R1
  ${Else}
    ${If} ${FileExists} "$EXEDIR\b14_beta3_full.7z"
      CRCCheck::GenCRC "$EXEDIR\b14_beta3_full.7z" ; Get a CRC from file
      Pop $R1
    ${Else}
      MessageBox MB_OK|MB_ICONINFORMATION "Main Files archive file not present. Place 'b14_beta3_full.potc' in this folder to continue." IDOK continue
      continue:
      ${If} ${FileExists} "$EXEDIR\b14_beta3_full.potc"
        CRCCheck::GenCRC "$EXEDIR\b14_beta3_full.potc" ; Get a CRC from file
        Pop $R1
      ${Else}
        ${If} ${FileExists} "$EXEDIR\b14_beta3_full.7z"
          CRCCheck::GenCRC "$EXEDIR\b14_beta3_full.7z" ; Get a CRC from file
          Pop $R1
        ${Else}
          MessageBox MB_OK|MB_ICONINFORMATION "Main Files archive not found. Skipping section." IDOK abort3
          abort3:
          return
        ${EndIf}
      ${EndIf}
    ${EndIf}
  ${EndIf}

  ${If} $R1 == 284994485
  ${Else}
    MessageBox MB_OK|MB_ICONINFORMATION "Main Files archive incomplete or corrupt. Please redownload!" IDOK abort4
    abort4:
    Banner::destroy
    Abort
  ${EndIf}

; ================================================
;  Prepare and Clean Up Stock Game Folder
; ================================================

  StrCpy $switch_overwrite 1

  ; Delete unnecessary main game files
  Delete $INSTDIR\memory.mp
  Delete $INSTDIR\options
  Delete $INSTDIR\DrvMgt.dll
  Delete $INSTDIR\Config.exe
  Delete $INSTDIR\SECDRV.SYS
  RMDir /r $INSTDIR\MODULES
  RMDir /r $INSTDIR\PROGRAM
  RMDir /r $INSTDIR\SAVE
  RMDir /r $INSTDIR\RESOURCE\INI
  RMDir /r $INSTDIR\RESOURCE\QUESTSTEXT
  RMDir /r $INSTDIR\RESOURCE\Textures\Loading\English
  CreateDirectory $INSTDIR\RESOURCE\VIDEOS\common
  CreateDirectory $INSTDIR\RESOURCE\VIDEOS\standard\English

  ; Delocalize folder structure

  ${If} ${FileExists} "$INSTDIR\RESOURCE\Sounds\voice\GERMAN\Dut_f_a_001.wav"
  Goto ger
  ${EndIf}

  ${If} ${FileExists} "$INSTDIR\RESOURCE\Sounds\voice\FRENCH\Dut_f_a_001.wav"
  Goto fre
  ${EndIf}

  ${If} ${FileExists} "$INSTDIR\RESOURCE\Sounds\voice\SPANISH\Dut_f_a_001.wav"
  Goto spa
  ${EndIf}

  ${If} ${FileExists} "$INSTDIR\RESOURCE\Sounds\voice\RUSSIAN\Dut_f_a_001.wav"
  Goto rus
  ${EndIf}

  Goto eng

  eng:
  ${If} ${FileExists} "$INSTDIR\RESOURCE\Sounds\voice\Dut_f_a_001.wav"
    Rename $INSTDIR\RESOURCE\Sounds\VOICE								$INSTDIR\RESOURCE\Sounds\VOICE_temp
    !insertmacro MoveFolder "$INSTDIR\RESOURCE\Sounds\VOICE_temp\"					"$INSTDIR\RESOURCE\Sounds\VOICE\ENGLISH\" "*.*"
  ${EndIf}

  Rename $INSTDIR\RESOURCE\VIDEOS\AkellaLogo.wmv							$INSTDIR\RESOURCE\VIDEOS\common\AkellaLogo.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\Artefact.wmv								$INSTDIR\RESOURCE\VIDEOS\common\Artefact.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\BethesdaLogo.wmv							$INSTDIR\RESOURCE\VIDEOS\common\BethesdaLogo.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\BlackPearl.wmv							$INSTDIR\RESOURCE\VIDEOS\common\BlackPearl.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\Blaze_land_dead.wmv							$INSTDIR\RESOURCE\VIDEOS\common\Blaze_land_dead.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\Blaze_mutiny_dead.wmv							$INSTDIR\RESOURCE\VIDEOS\common\Blaze_mutiny_dead.wmv
  Delete $INSTDIR\RESOURCE\VIDEOS\Credits.wmv
  Delete $INSTDIR\RESOURCE\VIDEOS\Ending.wmv
  Delete $INSTDIR\RESOURCE\VIDEOS\Ending_eng.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\Idol.wmv								$INSTDIR\RESOURCE\VIDEOS\standard\Idol.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\Skeleton_on_beach.wmv							$INSTDIR\RESOURCE\VIDEOS\common\Skeleton_on_beach.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\Storm.wmv								$INSTDIR\RESOURCE\VIDEOS\common\Storm.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\Temple.wmv								$INSTDIR\RESOURCE\VIDEOS\standard\Temple.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\UBI.wmv								$INSTDIR\RESOURCE\VIDEOS\common\UBI.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\Undersea.wmv								$INSTDIR\RESOURCE\VIDEOS\common\Undersea.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\WaltDisneyLogo.wmv							$INSTDIR\RESOURCE\VIDEOS\common\WaltDisneyLogo.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\Invasion.wmv								$INSTDIR\RESOURCE\VIDEOS\standard\English\Invasion.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\English\Invasion.wmv							$INSTDIR\RESOURCE\VIDEOS\standard\English\Invasion.wmv
  Goto end

  ger:
  Rename $INSTDIR\RESOURCE\Sounds\VOICE\GERMAN								$INSTDIR\RESOURCE\Sounds\VOICE\ENGLISH

  Rename $INSTDIR\RESOURCE\VIDEOS\GERMAN\AkellaLogo.wmv							$INSTDIR\RESOURCE\VIDEOS\common\AkellaLogo.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\GERMAN\Artefact.wmv							$INSTDIR\RESOURCE\VIDEOS\common\Artefact.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\GERMAN\BethesdaLogo.wmv						$INSTDIR\RESOURCE\VIDEOS\common\BethesdaLogo.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\GERMAN\BlackPearl.wmv							$INSTDIR\RESOURCE\VIDEOS\common\BlackPearl.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\GERMAN\Blaze_land_dead.wmv						$INSTDIR\RESOURCE\VIDEOS\common\Blaze_land_dead.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\GERMAN\Blaze_mutiny_dead.wmv						$INSTDIR\RESOURCE\VIDEOS\common\Blaze_mutiny_dead.wmv
  Delete $INSTDIR\RESOURCE\VIDEOS\GERMAN\Credits.wmv
  Delete $INSTDIR\RESOURCE\VIDEOS\GERMAN\Ending.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\GERMAN\Idol.wmv							$INSTDIR\RESOURCE\VIDEOS\standard\Idol.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\GERMAN\Skeleton_on_beach.wmv						$INSTDIR\RESOURCE\VIDEOS\common\Skeleton_on_beach.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\GERMAN\Storm.wmv							$INSTDIR\RESOURCE\VIDEOS\common\Storm.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\GERMAN\Temple.wmv							$INSTDIR\RESOURCE\VIDEOS\standard\Temple.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\GERMAN\UBI.wmv							$INSTDIR\RESOURCE\VIDEOS\common\UBI.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\GERMAN\Undersea.wmv							$INSTDIR\RESOURCE\VIDEOS\common\Undersea.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\GERMAN\WaltDisneyLogo.wmv						$INSTDIR\RESOURCE\VIDEOS\common\WaltDisneyLogo.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\GERMAN\Invasion.wmv							$INSTDIR\RESOURCE\VIDEOS\standard\English\Invasion.wmv
  Goto end

  fre:
  Rename $INSTDIR\RESOURCE\Sounds\VOICE\FRENCH								$INSTDIR\RESOURCE\Sounds\VOICE\ENGLISH
  Rename $INSTDIR\RESOURCE\Sounds\VOICE\ENGLISH\fra_f_a_001.wav						$INSTDIR\RESOURCE\Sounds\VOICE\ENGLISH\fre_f_a_001.wav
  Rename $INSTDIR\RESOURCE\Sounds\VOICE\ENGLISH\fra_f_a_002.wav						$INSTDIR\RESOURCE\Sounds\VOICE\ENGLISH\fre_f_a_002.wav
  Rename $INSTDIR\RESOURCE\Sounds\VOICE\ENGLISH\fra_f_a_003.wav						$INSTDIR\RESOURCE\Sounds\VOICE\ENGLISH\fre_f_a_003.wav
  Rename $INSTDIR\RESOURCE\Sounds\VOICE\ENGLISH\fra_f_a_004.wav						$INSTDIR\RESOURCE\Sounds\VOICE\ENGLISH\fre_f_a_004.wav
  Rename $INSTDIR\RESOURCE\Sounds\VOICE\ENGLISH\fra_f_a_005.wav						$INSTDIR\RESOURCE\Sounds\VOICE\ENGLISH\fre_f_a_005.wav
  Rename $INSTDIR\RESOURCE\Sounds\VOICE\ENGLISH\fra_f_a_006.wav						$INSTDIR\RESOURCE\Sounds\VOICE\ENGLISH\fre_f_a_006.wav
  Rename $INSTDIR\RESOURCE\Sounds\VOICE\ENGLISH\fra_f_a_007.wav						$INSTDIR\RESOURCE\Sounds\VOICE\ENGLISH\fre_f_a_007.wav
  Rename $INSTDIR\RESOURCE\Sounds\VOICE\ENGLISH\fra_f_a_008.wav						$INSTDIR\RESOURCE\Sounds\VOICE\ENGLISH\fre_f_a_008.wav
  Rename $INSTDIR\RESOURCE\Sounds\VOICE\ENGLISH\fra_f_a_009.wav						$INSTDIR\RESOURCE\Sounds\VOICE\ENGLISH\fre_f_a_009.wav
  Rename $INSTDIR\RESOURCE\Sounds\VOICE\ENGLISH\fra_f_a_010.wav						$INSTDIR\RESOURCE\Sounds\VOICE\ENGLISH\fre_f_a_010.wav
  Rename $INSTDIR\RESOURCE\Sounds\VOICE\ENGLISH\fra_f_a_011.wav						$INSTDIR\RESOURCE\Sounds\VOICE\ENGLISH\fre_f_a_011.wav
  Rename $INSTDIR\RESOURCE\Sounds\VOICE\ENGLISH\fra_f_a_012.wav						$INSTDIR\RESOURCE\Sounds\VOICE\ENGLISH\fre_f_a_012.wav
  Rename $INSTDIR\RESOURCE\Sounds\VOICE\ENGLISH\fra_f_a_013.wav						$INSTDIR\RESOURCE\Sounds\VOICE\ENGLISH\fre_f_a_013.wav

  Rename $INSTDIR\RESOURCE\VIDEOS\FRENCH\AkellaLogo.wmv							$INSTDIR\RESOURCE\VIDEOS\common\AkellaLogo.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\FRENCH\Artefact.wmv							$INSTDIR\RESOURCE\VIDEOS\common\Artefact.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\FRENCH\BethesdaLogo.wmv						$INSTDIR\RESOURCE\VIDEOS\common\BethesdaLogo.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\FRENCH\BlackPearl.wmv							$INSTDIR\RESOURCE\VIDEOS\common\BlackPearl.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\FRENCH\Blaze_land_dead.wmv						$INSTDIR\RESOURCE\VIDEOS\common\Blaze_land_dead.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\FRENCH\Blaze_mutiny_dead.wmv						$INSTDIR\RESOURCE\VIDEOS\common\Blaze_mutiny_dead.wmv
  Delete $INSTDIR\RESOURCE\VIDEOS\FRENCH\Credits.wmv
  Delete $INSTDIR\RESOURCE\VIDEOS\FRENCH\Ending.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\FRENCH\Idol.wmv							$INSTDIR\RESOURCE\VIDEOS\standard\Idol.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\FRENCH\Skeleton_on_beach.wmv						$INSTDIR\RESOURCE\VIDEOS\common\Skeleton_on_beach.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\FRENCH\Storm.wmv							$INSTDIR\RESOURCE\VIDEOS\common\Storm.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\FRENCH\Temple.wmv							$INSTDIR\RESOURCE\VIDEOS\standard\Temple.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\FRENCH\UBI.wmv							$INSTDIR\RESOURCE\VIDEOS\common\UBI.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\FRENCH\Undersea.wmv							$INSTDIR\RESOURCE\VIDEOS\common\Undersea.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\FRENCH\WaltDisneyLogo.wmv						$INSTDIR\RESOURCE\VIDEOS\common\WaltDisneyLogo.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\FRENCH\Invasion.wmv							$INSTDIR\RESOURCE\VIDEOS\standard\English\Invasion.wmv

  Goto end

  spa:
  Rename $INSTDIR\RESOURCE\Sounds\VOICE\SPANISH								$INSTDIR\RESOURCE\Sounds\VOICE\ENGLISH

  Rename $INSTDIR\RESOURCE\VIDEOS\SPANISH\AkellaLogo.wmv						$INSTDIR\RESOURCE\VIDEOS\common\AkellaLogo.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\SPANISH\Artefact.wmv							$INSTDIR\RESOURCE\VIDEOS\common\Artefact.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\SPANISH\BethesdaLogo.wmv						$INSTDIR\RESOURCE\VIDEOS\common\BethesdaLogo.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\SPANISH\BlackPearl.wmv						$INSTDIR\RESOURCE\VIDEOS\common\BlackPearl.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\SPANISH\Blaze_land_dead.wmv						$INSTDIR\RESOURCE\VIDEOS\common\Blaze_land_dead.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\SPANISH\Blaze_mutiny_dead.wmv						$INSTDIR\RESOURCE\VIDEOS\common\Blaze_mutiny_dead.wmv
  Delete $INSTDIR\RESOURCE\VIDEOS\SPANISH\Credits.wmv
  Delete $INSTDIR\RESOURCE\VIDEOS\SPANISH\Ending.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\SPANISH\Idol.wmv							$INSTDIR\RESOURCE\VIDEOS\standard\Idol.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\SPANISH\Skeleton_on_beach.wmv						$INSTDIR\RESOURCE\VIDEOS\common\Skeleton_on_beach.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\SPANISH\Storm.wmv							$INSTDIR\RESOURCE\VIDEOS\common\Storm.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\SPANISH\Temple.wmv							$INSTDIR\RESOURCE\VIDEOS\standard\Temple.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\SPANISH\UBI.wmv							$INSTDIR\RESOURCE\VIDEOS\common\UBI.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\SPANISH\Undersea.wmv							$INSTDIR\RESOURCE\VIDEOS\common\Undersea.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\SPANISH\WaltDisneyLogo.wmv						$INSTDIR\RESOURCE\VIDEOS\common\WaltDisneyLogo.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\SPANISH\Invasion.wmv							$INSTDIR\RESOURCE\VIDEOS\standard\English\Invasion.wmv
  Goto end

  rus:
  Rename $INSTDIR\RESOURCE\Sounds\VOICE\RUSSIAN								$INSTDIR\RESOURCE\Sounds\VOICE\ENGLISH

  Rename $INSTDIR\RESOURCE\VIDEOS\RUSSIAN\AkellaLogo.wmv						$INSTDIR\RESOURCE\VIDEOS\common\AkellaLogo.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\RUSSIAN\Artefact.wmv							$INSTDIR\RESOURCE\VIDEOS\common\Artefact.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\RUSSIAN\BethesdaLogo.wmv						$INSTDIR\RESOURCE\VIDEOS\common\BethesdaLogo.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\RUSSIAN\BlackPearl.wmv						$INSTDIR\RESOURCE\VIDEOS\common\BlackPearl.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\RUSSIAN\Blaze_land_dead.wmv						$INSTDIR\RESOURCE\VIDEOS\common\Blaze_land_dead.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\RUSSIAN\Blaze_mutiny_dead.wmv						$INSTDIR\RESOURCE\VIDEOS\common\Blaze_mutiny_dead.wmv
  Delete $INSTDIR\RESOURCE\VIDEOS\RUSSIAN\Credits.wmv
  Delete $INSTDIR\RESOURCE\VIDEOS\RUSSIAN\Ending.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\RUSSIAN\Idol.wmv							$INSTDIR\RESOURCE\VIDEOS\standard\Idol.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\RUSSIAN\Skeleton_on_beach.wmv						$INSTDIR\RESOURCE\VIDEOS\common\Skeleton_on_beach.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\RUSSIAN\Storm.wmv							$INSTDIR\RESOURCE\VIDEOS\common\Storm.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\RUSSIAN\Temple.wmv							$INSTDIR\RESOURCE\VIDEOS\standard\Temple.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\RUSSIAN\UBI.wmv							$INSTDIR\RESOURCE\VIDEOS\common\UBI.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\RUSSIAN\Undersea.wmv							$INSTDIR\RESOURCE\VIDEOS\common\Undersea.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\RUSSIAN\WaltDisneyLogo.wmv						$INSTDIR\RESOURCE\VIDEOS\common\WaltDisneyLogo.wmv
  Rename $INSTDIR\RESOURCE\VIDEOS\RUSSIAN\Invasion.wmv							$INSTDIR\RESOURCE\VIDEOS\standard\English\Invasion.wmv
  Goto end

  end:

  ; Prepare Ship Deck Folders
  RMDir /r $INSTDIR\RESOURCE\MODELS\locations\decks\Cap
  RMDir /r $INSTDIR\RESOURCE\MODELS\locations\decks\tut_deck

  !insertmacro MoveFolder "$INSTDIR\RESOURCE\Textures\lighting\day\locations\decks\Cap\"		"$INSTDIR\RESOURCE\Textures\lighting\day\locations\decks\cabin\Cap" "*.*"
  !insertmacro MoveFolder "$INSTDIR\RESOURCE\Textures\lighting\day\locations\decks\tut_deck\"		"$INSTDIR\RESOURCE\Textures\lighting\day\locations\decks\cabin\tut_deck" "*.*"

  !insertmacro MoveFolder "$INSTDIR\RESOURCE\Textures\lighting\evening\locations\decks\Cap\"		"$INSTDIR\RESOURCE\Textures\lighting\evening\locations\decks\cabin\Cap" "*.*"
  !insertmacro MoveFolder "$INSTDIR\RESOURCE\Textures\lighting\evening\locations\decks\tut_deck\"	"$INSTDIR\RESOURCE\Textures\lighting\evening\locations\decks\cabin\tut_deck" "*.*"

  !insertmacro MoveFolder "$INSTDIR\RESOURCE\Textures\lighting\mn\locations\decks\Cap\"			"$INSTDIR\RESOURCE\Textures\lighting\mn\locations\decks\cabin\Cap" "*.*"
  !insertmacro MoveFolder "$INSTDIR\RESOURCE\Textures\lighting\mn\locations\decks\tut_deck\"		"$INSTDIR\RESOURCE\Textures\lighting\mn\locations\decks\cabin\tut_deck" "*.*"

  !insertmacro MoveFolder "$INSTDIR\RESOURCE\Textures\lighting\storm\locations\decks\Cap\"		"$INSTDIR\RESOURCE\Textures\lighting\storm\locations\decks\cabin\Cap" "*.*"
  !insertmacro MoveFolder "$INSTDIR\RESOURCE\Textures\lighting\storm\locations\decks\tut_deck\"		"$INSTDIR\RESOURCE\Textures\lighting\storm\locations\decks\cabin\tut_deck" "*.*"

  ; Delete useless head animation files
  Delete $INSTDIR\RESOURCE\animation\Heads\h_Liza.ani
  Delete $INSTDIR\RESOURCE\animation\Heads\h_Offic_eng.ani
  Delete $INSTDIR\RESOURCE\animation\Heads\h_Offic_fra.ani
  Delete $INSTDIR\RESOURCE\animation\Heads\h_Offic_hol.ani
  Delete $INSTDIR\RESOURCE\animation\Heads\h_Offic_por.ani
  Delete $INSTDIR\RESOURCE\animation\Heads\h_Offic_spa.ani
  Delete $INSTDIR\RESOURCE\animation\Heads\h_Soldier_Eng.ani
  Delete $INSTDIR\RESOURCE\animation\Heads\h_Soldier_Eng2.ani
  Delete $INSTDIR\RESOURCE\animation\Heads\h_Soldier_Eng3.ani
  Delete $INSTDIR\RESOURCE\animation\Heads\h_Soldier_Eng4.ani
  Delete $INSTDIR\RESOURCE\animation\Heads\h_Soldier_Eng5.ani
  Delete $INSTDIR\RESOURCE\animation\Heads\h_Soldier_Eng6.ani
  Delete $INSTDIR\RESOURCE\animation\Heads\h_Soldier_Fra.ani
  Delete $INSTDIR\RESOURCE\animation\Heads\h_Soldier_Fra2.ani
  Delete $INSTDIR\RESOURCE\animation\Heads\h_Soldier_Fra3.ani
  Delete $INSTDIR\RESOURCE\animation\Heads\h_Soldier_Fra4.ani
  Delete $INSTDIR\RESOURCE\animation\Heads\h_Soldier_Fra5.ani
  Delete $INSTDIR\RESOURCE\animation\Heads\h_Soldier_Fra6.ani
  Delete $INSTDIR\RESOURCE\animation\Heads\h_Soldier_Hol.ani
  Delete $INSTDIR\RESOURCE\animation\Heads\h_Soldier_Hol2.ani
  Delete $INSTDIR\RESOURCE\animation\Heads\h_Soldier_Hol3.ani
  Delete $INSTDIR\RESOURCE\animation\Heads\h_Soldier_Hol4.ani
  Delete $INSTDIR\RESOURCE\animation\Heads\h_Soldier_Hol5.ani
  Delete $INSTDIR\RESOURCE\animation\Heads\h_Soldier_Hol6.ani
  Delete $INSTDIR\RESOURCE\animation\Heads\h_Soldier_Por.ani
  Delete $INSTDIR\RESOURCE\animation\Heads\h_Soldier_Por2.ani
  Delete $INSTDIR\RESOURCE\animation\Heads\h_Soldier_Por3.ani
  Delete $INSTDIR\RESOURCE\animation\Heads\h_Soldier_Por4.ani
  Delete $INSTDIR\RESOURCE\animation\Heads\h_Soldier_Por5.ani
  Delete $INSTDIR\RESOURCE\animation\Heads\h_Soldier_Por6.ani
  Delete $INSTDIR\RESOURCE\animation\Heads\h_Soldier_Spa.ani
  Delete $INSTDIR\RESOURCE\animation\Heads\h_Soldier_Spa2.ani
  Delete $INSTDIR\RESOURCE\animation\Heads\h_Soldier_Spa3.ani
  Delete $INSTDIR\RESOURCE\animation\Heads\h_Soldier_Spa4.ani
  Delete $INSTDIR\RESOURCE\animation\Heads\h_Soldier_Spa5.ani
  Delete $INSTDIR\RESOURCE\animation\Heads\h_Soldier_Spa6.ani
  Delete $INSTDIR\RESOURCE\animation\Heads\AN\h_Liza.an

  ; Delete useless model files
  Delete $INSTDIR\RESOURCE\MODELS\fish01.qch

  ; Delete useless character model files
  Delete $INSTDIR\RESOURCE\MODELS\Characters\Liza.gm
  Delete $INSTDIR\RESOURCE\MODELS\Characters\Offic_eng.gm
  Delete $INSTDIR\RESOURCE\MODELS\Characters\Offic_fra.gm
  Delete $INSTDIR\RESOURCE\MODELS\Characters\Offic_hol.gm
  Delete $INSTDIR\RESOURCE\MODELS\Characters\Offic_por.gm
  Delete $INSTDIR\RESOURCE\MODELS\Characters\Offic_spa.gm
  Delete $INSTDIR\RESOURCE\MODELS\Characters\Soldier_Eng.gm
  Delete $INSTDIR\RESOURCE\MODELS\Characters\Soldier_Eng2.gm
  Delete $INSTDIR\RESOURCE\MODELS\Characters\Soldier_Eng3.gm
  Delete $INSTDIR\RESOURCE\MODELS\Characters\Soldier_Eng4.gm
  Delete $INSTDIR\RESOURCE\MODELS\Characters\Soldier_Eng5.gm
  Delete $INSTDIR\RESOURCE\MODELS\Characters\Soldier_Eng6.gm
  Delete $INSTDIR\RESOURCE\MODELS\Characters\Soldier_Fra.gm
  Delete $INSTDIR\RESOURCE\MODELS\Characters\Soldier_Fra2.gm
  Delete $INSTDIR\RESOURCE\MODELS\Characters\Soldier_Fra3.gm
  Delete $INSTDIR\RESOURCE\MODELS\Characters\Soldier_Fra4.gm
  Delete $INSTDIR\RESOURCE\MODELS\Characters\Soldier_Fra5.gm
  Delete $INSTDIR\RESOURCE\MODELS\Characters\Soldier_Fra6.gm
  Delete $INSTDIR\RESOURCE\MODELS\Characters\Soldier_Hol.gm
  Delete $INSTDIR\RESOURCE\MODELS\Characters\Soldier_Hol2.gm
  Delete $INSTDIR\RESOURCE\MODELS\Characters\Soldier_Hol3.gm
  Delete $INSTDIR\RESOURCE\MODELS\Characters\Soldier_Hol4.gm
  Delete $INSTDIR\RESOURCE\MODELS\Characters\Soldier_Hol5.gm
  Delete $INSTDIR\RESOURCE\MODELS\Characters\Soldier_Hol6.gm
  Delete $INSTDIR\RESOURCE\MODELS\Characters\Soldier_Por.gm
  Delete $INSTDIR\RESOURCE\MODELS\Characters\Soldier_Por2.gm
  Delete $INSTDIR\RESOURCE\MODELS\Characters\Soldier_Por3.gm
  Delete $INSTDIR\RESOURCE\MODELS\Characters\Soldier_Por4.gm
  Delete $INSTDIR\RESOURCE\MODELS\Characters\Soldier_Por5.gm
  Delete $INSTDIR\RESOURCE\MODELS\Characters\Soldier_Por6.gm
  Delete $INSTDIR\RESOURCE\MODELS\Characters\Soldier_Spa.gm
  Delete $INSTDIR\RESOURCE\MODELS\Characters\Soldier_Spa2.gm
  Delete $INSTDIR\RESOURCE\MODELS\Characters\Soldier_Spa3.gm
  Delete $INSTDIR\RESOURCE\MODELS\Characters\Soldier_Spa4.gm
  Delete $INSTDIR\RESOURCE\MODELS\Characters\Soldier_Spa5.gm
  Delete $INSTDIR\RESOURCE\MODELS\Characters\Soldier_Spa6.gm

  ; Delete useless head model files
  Delete $INSTDIR\RESOURCE\MODELS\Heads\h_Liza.gm
  Delete $INSTDIR\RESOURCE\MODELS\Heads\h_Offic_eng.gm
  Delete $INSTDIR\RESOURCE\MODELS\Heads\h_Offic_fra.gm
  Delete $INSTDIR\RESOURCE\MODELS\Heads\h_Offic_hol.gm
  Delete $INSTDIR\RESOURCE\MODELS\Heads\h_Offic_por.gm
  Delete $INSTDIR\RESOURCE\MODELS\Heads\h_Offic_spa.gm
  Delete $INSTDIR\RESOURCE\MODELS\Heads\h_Soldier_Eng.gm
  Delete $INSTDIR\RESOURCE\MODELS\Heads\h_Soldier_Eng2.gm
  Delete $INSTDIR\RESOURCE\MODELS\Heads\h_Soldier_Eng3.gm
  Delete $INSTDIR\RESOURCE\MODELS\Heads\h_Soldier_Eng4.gm
  Delete $INSTDIR\RESOURCE\MODELS\Heads\h_Soldier_Eng5.gm
  Delete $INSTDIR\RESOURCE\MODELS\Heads\h_Soldier_Eng6.gm
  Delete $INSTDIR\RESOURCE\MODELS\Heads\h_Soldier_Fra.gm
  Delete $INSTDIR\RESOURCE\MODELS\Heads\h_Soldier_Fra2.gm
  Delete $INSTDIR\RESOURCE\MODELS\Heads\h_Soldier_Fra3.gm
  Delete $INSTDIR\RESOURCE\MODELS\Heads\h_Soldier_Fra4.gm
  Delete $INSTDIR\RESOURCE\MODELS\Heads\h_Soldier_Fra5.gm
  Delete $INSTDIR\RESOURCE\MODELS\Heads\h_Soldier_Fra6.gm
  Delete $INSTDIR\RESOURCE\MODELS\Heads\h_Soldier_Hol.gm
  Delete $INSTDIR\RESOURCE\MODELS\Heads\h_Soldier_Hol2.gm
  Delete $INSTDIR\RESOURCE\MODELS\Heads\h_Soldier_Hol3.gm
  Delete $INSTDIR\RESOURCE\MODELS\Heads\h_Soldier_Hol4.gm
  Delete $INSTDIR\RESOURCE\MODELS\Heads\h_Soldier_Hol5.gm
  Delete $INSTDIR\RESOURCE\MODELS\Heads\h_Soldier_Hol6.gm
  Delete $INSTDIR\RESOURCE\MODELS\Heads\h_Soldier_Por.gm
  Delete $INSTDIR\RESOURCE\MODELS\Heads\h_Soldier_Por2.gm
  Delete $INSTDIR\RESOURCE\MODELS\Heads\h_Soldier_Por3.gm
  Delete $INSTDIR\RESOURCE\MODELS\Heads\h_Soldier_Por4.gm
  Delete $INSTDIR\RESOURCE\MODELS\Heads\h_Soldier_Por5.gm
  Delete $INSTDIR\RESOURCE\MODELS\Heads\h_Soldier_Por6.gm
  Delete $INSTDIR\RESOURCE\MODELS\Heads\h_Soldier_Spa.gm
  Delete $INSTDIR\RESOURCE\MODELS\Heads\h_Soldier_Spa2.gm
  Delete $INSTDIR\RESOURCE\MODELS\Heads\h_Soldier_Spa3.gm
  Delete $INSTDIR\RESOURCE\MODELS\Heads\h_Soldier_Spa4.gm
  Delete $INSTDIR\RESOURCE\MODELS\Heads\h_Soldier_Spa5.gm
  Delete $INSTDIR\RESOURCE\MODELS\Heads\h_Soldier_Spa6.gm

  ; Delete useless location model files
  Delete $INSTDIR\RESOURCE\MODELS\Islands\Douwesen\Douwesen.qch
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Incas Temple\Alcove\alcove.qch"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Incas Temple\Labirint\lab1.qch"
  Delete $INSTDIR\RESOURCE\MODELS\Locations\Inside\Cavern\cavern_l_locators.atg
  Delete $INSTDIR\RESOURCE\MODELS\Locations\Inside\Dungeon_1\d01.qch
  Delete $INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Port\Conport.qch
  Delete $INSTDIR\RESOURCE\MODELS\Locations\Town_Oxbay\Exit\oxexit.qch
  Delete $INSTDIR\RESOURCE\MODELS\Locations\Town_Oxbay\Port\OXport_l.gm.old

  ; Delete useless location lighting files
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Conceicao\CONCEICAO_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Conceicao\CONCEICAO_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Conceicao\CONCEICAO_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Conceicao\CONCEICAO_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Conceicao\CONCEICAO_FORT1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Conceicao\CONCEICAO_FORT1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Conceicao\CONCEICAO_FORT1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Conceicao\CONCEICAO_FORT1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Conceicao\CONCEICAO_REFL_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Conceicao\CONCEICAO_REFL_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Conceicao\CONCEICAO_REFL_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Conceicao\CONCEICAO_REFL_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Conceicao\CONCEICAO_SEABED_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Conceicao\CONCEICAO_SEABED_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Conceicao\CONCEICAO_SEABED_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Conceicao\CONCEICAO_SEABED_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Douwesen\DOUWESEN_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Douwesen\DOUWESEN_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Douwesen\DOUWESEN_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Douwesen\DOUWESEN_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Douwesen\DOUWESEN_FORT1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Douwesen\DOUWESEN_FORT1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Douwesen\DOUWESEN_FORT1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Douwesen\DOUWESEN_FORT1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Douwesen\DOUWESEN_REFL_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Douwesen\DOUWESEN_REFL_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Douwesen\DOUWESEN_REFL_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Douwesen\DOUWESEN_REFL_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Douwesen\DOUWESEN_SEABED_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Douwesen\DOUWESEN_SEABED_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Douwesen\DOUWESEN_SEABED_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Douwesen\DOUWESEN_SEABED_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\FalaiseDeFleur\FALAISEDEFLEUR_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\FalaiseDeFleur\FALAISEDEFLEUR_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\FalaiseDeFleur\FALAISEDEFLEUR_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\FalaiseDeFleur\FALAISEDEFLEUR_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\FalaiseDeFleur\FALAISEDEFLEUR_FORT1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\FalaiseDeFleur\FALAISEDEFLEUR_FORT1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\FalaiseDeFleur\FALAISEDEFLEUR_FORT1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\FalaiseDeFleur\FALAISEDEFLEUR_FORT1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\FalaiseDeFleur\FALAISEDEFLEUR_REFL_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\FalaiseDeFleur\FALAISEDEFLEUR_REFL_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\FalaiseDeFleur\FALAISEDEFLEUR_REFL_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\FalaiseDeFleur\FALAISEDEFLEUR_REFL_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\FalaiseDeFleur\FALAISEDEFLEUR_SEABED_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\FalaiseDeFleur\FALAISEDEFLEUR_SEABED_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\FalaiseDeFleur\FALAISEDEFLEUR_SEABED_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\FalaiseDeFleur\FALAISEDEFLEUR_SEABED_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaMuelle\ISLAMUELLE_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaMuelle\ISLAMUELLE_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaMuelle\ISLAMUELLE_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaMuelle\ISLAMUELLE_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaMuelle\ISLAMUELLE_FORT1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaMuelle\ISLAMUELLE_FORT1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaMuelle\ISLAMUELLE_FORT1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaMuelle\ISLAMUELLE_FORT1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaMuelle\ISLAMUELLE_REFL_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaMuelle\ISLAMUELLE_REFL_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaMuelle\ISLAMUELLE_REFL_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaMuelle\ISLAMUELLE_REFL_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaMuelle\ISLAMUELLE_SEABED_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaMuelle\ISLAMUELLE_SEABED_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaMuelle\ISLAMUELLE_SEABED_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaMuelle\ISLAMUELLE_SEABED_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\KhaelRoa\KHAELROA_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\KhaelRoa\KHAELROA_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\KhaelRoa\KHAELROA_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\KhaelRoa\KHAELROA_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\KhaelRoa\KHAELROA_REFL_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\KhaelRoa\KHAELROA_REFL_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\KhaelRoa\KHAELROA_REFL_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\KhaelRoa\KHAELROA_REFL_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\KhaelRoa\KHAELROA_SEABED_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\KhaelRoa\KHAELROA_SEABED_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\KhaelRoa\KHAELROA_SEABED_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\KhaelRoa\KHAELROA_SEABED_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\KhaelRoa1\KHAELROA1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\KhaelRoa1\KHAELROA1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\KhaelRoa1\KHAELROA1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\KhaelRoa1\KHAELROA1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\KhaelRoa1\KHAELROA1_REFL_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\KhaelRoa1\KHAELROA1_REFL_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\KhaelRoa1\KHAELROA1_REFL_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\KhaelRoa1\KHAELROA1_REFL_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\KhaelRoa1\KHAELROA1_SEABED_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\KhaelRoa1\KHAELROA1_SEABED_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\KhaelRoa1\KHAELROA1_SEABED_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\KhaelRoa1\KHAELROA1_SEABED_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Oxbay\OXBAY_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Oxbay\OXBAY_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Oxbay\OXBAY_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Oxbay\OXBAY_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Oxbay\OXBAY_FORT1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Oxbay\OXBAY_FORT1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Oxbay\OXBAY_FORT1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Oxbay\OXBAY_FORT1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Oxbay\OXBAY_FORT2_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Oxbay\OXBAY_FORT2_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Oxbay\OXBAY_FORT2_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Oxbay\OXBAY_FORT2_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Oxbay\OXBAY_REFL_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Oxbay\OXBAY_REFL_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Oxbay\OXBAY_REFL_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Oxbay\OXBAY_REFL_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Oxbay\OXBAY_SEABED_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Oxbay\OXBAY_SEABED_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Oxbay\OXBAY_SEABED_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Oxbay\OXBAY_SEABED_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\QuebradasCostillas\QUEBRADASCOSTILLAS_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\QuebradasCostillas\QUEBRADASCOSTILLAS_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\QuebradasCostillas\QUEBRADASCOSTILLAS_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\QuebradasCostillas\QUEBRADASCOSTILLAS_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\QuebradasCostillas\QUEBRADASCOSTILLAS_REFL_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\QuebradasCostillas\QUEBRADASCOSTILLAS_REFL_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\QuebradasCostillas\QUEBRADASCOSTILLAS_REFL_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\QuebradasCostillas\QUEBRADASCOSTILLAS_REFL_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\QuebradasCostillas\QUEBRADASCOSTILLAS_SEABED_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\QuebradasCostillas\QUEBRADASCOSTILLAS_SEABED_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\QuebradasCostillas\QUEBRADASCOSTILLAS_SEABED_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\QuebradasCostillas\QUEBRADASCOSTILLAS_SEABED_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Redmond\REDMOND_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Redmond\REDMOND_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Redmond\REDMOND_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Redmond\REDMOND_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Redmond\REDMOND_FORT1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Redmond\REDMOND_FORT1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Redmond\REDMOND_FORT1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Redmond\REDMOND_FORT1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Redmond\REDMOND_REFL_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Redmond\REDMOND_REFL_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Redmond\REDMOND_REFL_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Redmond\REDMOND_REFL_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Redmond\REDMOND_SEABED_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Redmond\REDMOND_SEABED_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Redmond\REDMOND_SEABED_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Redmond\REDMOND_SEABED_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Deck1\DECK1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Deck1\DECK1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Deck1\DECK1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Deck1\DECK1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Deck1\DECK1_FD_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Deck1\DECK1_FD_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Deck1\DECK1_FD_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Deck1\DECK1_FD_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Deck2\deck2_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Deck2\DECK2_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Deck2\DECK2_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Deck2\DECK2_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Deck2\deck2_fd_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Deck2\DECK2_FD_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Deck2\DECK2_FD_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Deck2\DECK2_FD_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Hold\HOLD_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Hold\HOLD_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Hold\HOLD_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Hold\HOLD_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Hold\HOLD_FD_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Hold\HOLD_FD_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Hold\HOLD_FD_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Hold\HOLD_FD_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Qdeck\QDECK_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Qdeck\QDECK_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Qdeck\QDECK_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Qdeck\QDECK_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck\UDECK_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck\UDECK_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck\UDECK_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck\UDECK_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Fort_Inside\Fort_1\FORT1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Fort_Inside\Fort_1\FORT1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Fort_Inside\Fort_1\FORT1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Fort_Inside\Fort_1\FORT1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Fort_Inside\Fort_1\FORT1_FD_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Fort_Inside\Fort_1\FORT1_FD_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Fort_Inside\Fort_1\FORT1_FD_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Fort_Inside\Fort_1\FORT1_FD_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Fort_Inside\Fort_2\FORT2_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Fort_Inside\Fort_2\FORT2_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Fort_Inside\Fort_2\FORT2_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Fort_Inside\Fort_2\FORT2_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Fort_Inside\Fort_2\FORT2_FD_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Fort_Inside\Fort_2\FORT2_FD_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Fort_Inside\Fort_2\FORT2_FD_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Fort_Inside\Fort_2\FORT2_FD_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Fort_Inside\Fort_3\FORT3_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Fort_Inside\Fort_3\FORT3_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Fort_Inside\Fort_3\FORT3_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Fort_Inside\Fort_3\FORT3_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Fort_Inside\Fort_3\FORT3_FD_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Fort_Inside\Fort_3\FORT3_FD_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Fort_Inside\Fort_3\FORT3_FD_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Fort_Inside\Fort_3\FORT3_FD_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Incas Temple\Alcove\alcove_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Incas Temple\Alcove\alcove_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Incas Temple\Alcove\alcove_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Incas Temple\Alcove\alcove_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Incas Temple\Alcove\Bird_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Incas Temple\Alcove\Bird_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Incas Temple\Alcove\Bird_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Incas Temple\Alcove\Bird_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Incas Temple\Labirint\DOOR_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Incas Temple\Labirint\DOOR_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Incas Temple\Labirint\DOOR_evening1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Incas Temple\Labirint\DOOR_evening2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Incas Temple\Labirint\lab1_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Incas Temple\Labirint\lab1_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Incas Temple\Labirint\lab1_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Incas Temple\Labirint\lab1_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Incas Temple\Labirint\lab2_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Incas Temple\Labirint\lab2_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Incas Temple\Labirint\lab2_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Incas Temple\Labirint\lab2_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Incas Temple\Labirint\lab3_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Incas Temple\Labirint\lab3_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Incas Temple\Labirint\lab3_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Incas Temple\Labirint\lab3_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Incas Temple\Port\KRport_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Incas Temple\Port\KRport_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Incas Temple\Port\KRport_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Incas Temple\Port\KRport_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Incas Temple\Port\KRport_sb_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Incas Temple\Port\KRport_sb_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Incas Temple\Port\KRport_sb_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Incas Temple\Port\KRport_sb_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Incas Temple\Temple\HRAM_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Incas Temple\Temple\HRAM_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Incas Temple\Temple\HRAM_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Incas Temple\Temple\HRAM_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\ANIMISTS_Cave\SCave_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\ANIMISTS_Cave\SCave_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\ANIMISTS_Cave\SCave_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\ANIMISTS_Cave\SCave_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Cavern\cavern_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Cavern\cavern_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Cavern\cavern_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Cavern\cavern_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Cavern\Crystals_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Cavern\Crystals_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Cavern\Crystals_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Cavern\Crystals_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Church_2\church2_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Church_2\church2_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Church_2\church2_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Church_2\church2_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Church_2\CHURCH2_W_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Church_2\church2_w_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Church_2\church2_w_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\church_3\church3_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\church_3\CHURCH3_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\church_3\church3_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\church_3\church3_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\church_3\CHURCH3_W_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Church_Inside\church_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Church_Inside\church_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Church_Inside\church_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Church_Inside\church_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Church_Inside\church_w_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Church_Inside\church_w_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Church_Inside\church_w_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Doubleflour_house\LF1_W_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Doubleflour_house\LF1_W_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Doubleflour_house\LF1_W_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Doubleflour_house\LF1_W_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Doubleflour_house\LH_F1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Doubleflour_house\LH_F1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Doubleflour_house\LH_F1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Doubleflour_house\LH_F1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Doubleflour_house\LH_F2_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Doubleflour_house\LH_F2_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Doubleflour_house\LH_F2_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Doubleflour_house\LH_F2_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Doubleflour_house\LH_F2_W_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Doubleflour_house\LH_F2_W_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Doubleflour_house\LH_F2_W_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Doubleflour_house\LH_F2_W_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Dungeon_1\d01_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Dungeon_1\d01_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Dungeon_1\d01_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Dungeon_1\d01_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Dungeon_2\d02_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Dungeon_2\d02_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Dungeon_2\d02_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Dungeon_2\d02_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Dungeon_2\D02_FD_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Dungeon_2\D02_FD_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Dungeon_2\D02_FD_evening1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Dungeon_2\D02_FD_evening2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Dungeon_2\D02_FN_day2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Dungeon_2\D02_FN_day3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Dungeon_2\D02_FN_evening1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Dungeon_2\D02_FN_evening2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Dungeon_3\d03_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Dungeon_3\d03_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Dungeon_3\d03_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Dungeon_3\d03_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Dungeon_4\d04_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Dungeon_4\d04_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Dungeon_4\d04_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Dungeon_4\d04_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Dungeon_4\d04_fn_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Dungeon_4\d04_fn_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Dungeon_4\d04_fn_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Dungeon_4\d04_fn_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Grot\Grot_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Grot\Grot_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Grot\Grot_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Grot\Grot_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\LargeStore\LS_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\LargeStore\LS_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\LargeStore\LS_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\LargeStore\LS_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\LargeStore\LS_FN_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\LargeStore\LS_FN_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\LargeStore\LS_FN_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\LargeStore\LS_FN_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\LargeStore\LS_W_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\LargeStore\LS_W_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\LargeStore\LS_W_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\LargeStore\LS_W_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Largetavern\LT_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Largetavern\LT_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Largetavern\LT_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Largetavern\LT_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Largetavern\LT_W_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Largetavern\LT_W_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Largetavern\LT_W_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Largetavern\LT_W_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\MediumHouse\MH_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\MediumHouse\MH_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\MediumHouse\MH_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\MediumHouse\MH_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\MediumHouse\MH_w_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\MediumHouse\MH_W_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\MediumHouse\MH_W_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\MediumHouse\MH_W_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mediumhouse2\MH02_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mediumhouse2\MH02_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mediumhouse2\MH02_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mediumhouse2\MH02_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mediumhouse2\MH02_W_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mediumhouse2\MH02_W_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mediumhouse2\MH02_W_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mediumhouse2\MH02_W_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\MediumStore\MS_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\MediumStore\MS_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\MediumStore\MS_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\MediumStore\MS_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\MediumStore\MS_W_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\MediumStore\MS_W_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\MediumStore\MS_W_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\MediumStore\MS_W_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\MediumTavern\MT_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\MediumTavern\MT_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\MediumTavern\MT_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\MediumTavern\MT_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\MediumTavern\MT_W_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\MediumTavern\MT_W_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\MediumTavern\MT_W_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\MediumTavern\MT_W_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh10\MH10_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh10\MH10_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh10\MH10_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh10\MH10_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh3\MH3_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh3\MH3_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh3\MH3_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh3\MH3_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh3\MH3_W_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh3\MH3_W_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh3\MH3_W_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh3\MH3_W_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh4\MH4_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh4\MH4_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh4\MH4_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh4\MH4_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh4\MH4_W_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh4\MH4_W_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh4\MH4_W_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh4\MH4_W_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh5\MH5_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh5\MH5_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh5\MH5_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh5\MH5_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh5\MH5_W_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh5\MH5_W_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh5\MH5_W_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh5\MH5_W_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh6\MH6_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh6\MH6_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh6\MH6_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh6\MH6_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh6\MH6_W_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh6\MH6_W_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh6\MH6_W_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh6\MH6_W_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh7\MH7_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh7\MH7_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh7\MH7_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh7\MH7_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh7\MH7_W_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh7\MH7_W_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh7\MH7_W_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh7\MH7_W_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh8\MH8_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh8\MH8_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh8\MH8_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh8\MH8_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh8\MH8_W_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh8\MH8_W_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh8\MH8_W_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh8\MH8_W_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh9\MH9_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh9\MH9_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh9\MH9_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh9\MH9_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh9\MH9_W_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh9\MH9_W_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh9\MH9_W_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh9\MH9_W_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\MINE\MINE_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\MINE\MINE_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\MINE\MINE_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\MINE\MINE_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Pirate_House\PIRH_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Pirate_House\PIRH_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Pirate_House\PIRH_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Pirate_House\PIRH_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Pirate_House\PIRH_W_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Pirate_House\PIRH_W_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Pirate_House\PIRH_W_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Pirate_House\PIRH_W_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\pirateresidence\ResP_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\pirateresidence\ResP_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\pirateresidence\ResP_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\pirateresidence\ResP_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Prison\PRI_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Prison\PRI_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Prison\PRI_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Prison\PRI_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Prison\PRI_W_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Prison\PRI_W_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Prison\PRI_W_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Prison\PRI_W_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\ResBedRoom\BED_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\ResBedRoom\BED_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\ResBedRoom\BED_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\ResBedRoom\BED_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\ResBedRoom\BED_W_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\ResBedRoom\BED_W_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\ResBedRoom\BED_W_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\ResBedRoom\BED_W_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence_BackHall\RESB_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence_BackHall\RESB_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence_BackHall\RESB_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence_BackHall\RESB_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence_BackHall\RESB_W_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence_BackHall\RESB_W_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence_BackHall\RESB_W_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence_BackHall\RESB_W_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence1\Res01_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence1\Res01_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence1\Res01_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence1\Res01_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence1\Res01_w_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence1\Res01_w_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence2\RES02_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence2\RES02_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence2\Res02_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence2\Res02_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence2\RES02_W_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence2\RES02_W_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence2\Res02_w_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence2\Res02_w_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence3\Res03_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence3\Res03_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence3\Res03_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence3\Res03_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence3\Res03_w_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence3\Res03_w_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence4\RES04_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence4\RES04_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence4\RES04_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence4\RES04_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence4\RES04_W_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence4\RES04_W_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence4\RES04_W_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence4\RES04_W_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence5\RES05_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence5\RES05_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence5\RES05_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence5\RES05_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence5\RES05_W_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence5\RES05_W_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence5\RES05_W_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence5\RES05_W_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Shipyard\back\REDSH1_E_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Shipyard\back\REDSH1_E_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Shipyard\sh01_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Shipyard\sh01_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Shipyard\SH01_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Shipyard\SH01_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Shipyard\sh01_fd_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Shipyard\sh01_fd_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Shipyard\SH01_FD_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Shipyard\SH01_FD_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Shipyard\SH01_W_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Shipyard\SH01_W_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Shipyard\SH01_W_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Shipyard\SH01_W_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Shipyard2\SH02_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Shipyard2\SH02_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Shipyard2\SH02_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Shipyard2\SH02_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Shipyard2\SH02_W_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Shipyard2\SH02_W_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Shipyard2\SH02_W_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Shipyard2\SH02_W_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Shipyard3\SH03_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Shipyard3\SH03_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Shipyard3\SH03_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Shipyard3\SH03_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Shipyard3\SH03_W_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Shipyard3\SH03_W_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Shipyard3\SH03_W_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Shipyard3\SH03_W_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Smallhome\SH_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Smallhome\SH_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Smallhome\SH_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Smallhome\SH_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Smallhome\SH_W_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Smallhome\SH_W_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Smallhome\SH_W_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Smallhome\SH_W_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\SmallTavern\ST_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\SmallTavern\ST_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\SmallTavern\ST_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\SmallTavern\ST_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\SmallTavern\ST_w_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\SmallTavern\ST_W_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\SmallTavern\ST_W_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\SmallTavern\ST_W_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\StoreSmall\SS_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\StoreSmall\SS_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\StoreSmall\SS_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\StoreSmall\SS_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\StoreSmall\SS_FN_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\StoreSmall\SS_FN_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\StoreSmall\SS_FN_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\StoreSmall\SS_FN_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\StoreSmall\SS_W_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\StoreSmall\SS_W_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\StoreSmall\SS_W_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\StoreSmall\SS_W_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Canyon\plan_1_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Canyon\plan_1_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Canyon\plan_1_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Canyon\plan_1_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Canyon\plan_2_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Canyon\plan_2_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Canyon\plan_2_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Canyon\plan_2_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Canyon\rift_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Canyon\rift_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Canyon\rift_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Canyon\rift_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Canyon\rift_fd_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Canyon\rift_fd_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Canyon\rift_fd_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Canyon\rift_fd_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Cave Entrance\Cave_b01_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Cave Entrance\Cave_b01_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Cave Entrance\Cave_b01_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Cave Entrance\Cave_b01_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Cave Entrance\Cave_b02_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Cave Entrance\Cave_b02_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Cave Entrance\Cave_b02_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Cave Entrance\Cave_b02_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Cave Entrance\Cave_b03_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Cave Entrance\Cave_b03_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Cave Entrance\Cave_b03_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Cave Entrance\Cave_b03_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Cave Entrance\Cave_b04_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Cave Entrance\Cave_b04_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Cave Entrance\Cave_b04_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Cave Entrance\Cave_b04_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Cave Entrance\Cave_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Cave Entrance\Cave_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Cave Entrance\Cave_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Cave Entrance\Cave_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_1\jungle01_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_1\jungle01_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_1\jungle01_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_1\jungle01_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_1\plan_1_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_1\plan_1_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_1\plan_1_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_1\plan_1_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_1\plan_2_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_1\plan_2_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_1\plan_2_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_1\plan_2_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_1\plan_3_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_1\plan_3_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_1\plan_3_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_1\plan_3_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_2\JUNGLE02_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_2\JUNGLE02_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_2\JUNGLE02_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_2\JUNGLE02_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_2\PLAN_1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_2\PLAN_1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_2\PLAN_1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_2\PLAN_1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_2\PLAN_2_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_2\PLAN_2_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_2\PLAN_2_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_2\PLAN_2_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_2\PLAN_3_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_2\PLAN_3_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_2\PLAN_3_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_2\PLAN_3_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_3\JUNGLE03_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_3\JUNGLE03_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_3\JUNGLE03_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_3\JUNGLE03_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_3\PLAN_1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_3\PLAN_1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_3\PLAN_1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_3\PLAN_1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_3\PLAN_2_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_3\PLAN_2_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_3\PLAN_2_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_3\PLAN_2_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_3\PLAN_3_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_3\PLAN_3_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_3\PLAN_3_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_3\PLAN_3_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_4\JUNGLE04_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_4\JUNGLE04_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_4\JUNGLE04_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_4\JUNGLE04_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_4\PLAN_1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_4\PLAN_1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_4\PLAN_1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_4\PLAN_1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_4\PLAN_2_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_4\PLAN_2_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_4\PLAN_2_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_4\PLAN_2_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_4\PLAN_3_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_4\PLAN_3_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_4\PLAN_3_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_4\PLAN_3_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_5\jungle05_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_5\jungle05_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_5\jungle05_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_5\jungle05_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_5\plan_1_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_5\plan_1_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_5\plan_1_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_5\plan_1_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_5\plan_2_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_5\plan_2_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_5\plan_2_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_5\plan_2_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_5\plan_3_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_5\plan_3_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_5\plan_3_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_5\plan_3_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_6\JUNGLE06_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_6\JUNGLE06_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_6\JUNGLE06_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_6\JUNGLE06_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_6\PLAN_1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_6\PLAN_1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_6\PLAN_1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_6\PLAN_1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_6\PLAN_2_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_6\PLAN_2_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_6\PLAN_2_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_6\PLAN_2_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_6\PLAN_3_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_6\PLAN_3_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_6\PLAN_3_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_6\PLAN_3_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_7\JUNGLE07_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_7\JUNGLE07_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_7\JUNGLE07_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_7\JUNGLE07_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_7\PLAN_1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_7\PLAN_1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_7\PLAN_1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_7\PLAN_1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_7\PLAN_2_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_7\PLAN_2_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_7\PLAN_2_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_7\PLAN_2_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_7\PLAN_3_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_7\PLAN_3_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_7\PLAN_3_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_7\PLAN_3_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_8\JUNGLE08_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_8\JUNGLE08_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_8\JUNGLE08_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_8\JUNGLE08_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_8\PLAN_1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_8\PLAN_1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_8\PLAN_1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_8\PLAN_1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_8\PLAN_2_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_8\PLAN_2_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_8\PLAN_2_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_8\PLAN_2_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_8\PLAN_3_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_8\PLAN_3_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_8\PLAN_3_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_8\PLAN_3_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Mayak\MAYAK_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Mayak\MAYAK_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Mayak\MAYAK_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Mayak\MAYAK_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Mayak\MAYAK_FD_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Mayak\MAYAK_FD_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Mayak\MAYAK_FD_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Mayak\MAYAK_FD_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Mayak\MAYAK_SB_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Mayak\MAYAK_SB_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Mayak\MAYAK_SB_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Mayak\MAYAK_SB_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Mayak_inside\IMAYAK_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Mayak_inside\IMAYAK_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Mayak_inside\IMAYAK_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Mayak_inside\IMAYAK_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Mayak_inside\IMAYAK_SB_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Mayak_inside\IMAYAK_SB_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Mayak_inside\IMAYAK_SB_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Mayak_inside\IMAYAK_SB_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Mayak_inside\IMAYAK_W_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Mayak_inside\IMAYAK_W_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Mayak_inside\IMAYAK_W_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Mayak_inside\IMAYAK_W_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Mayak_inside\PLAN_1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Mayak_inside\PLAN_1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Mayak_inside\PLAN_1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Mayak_inside\PLAN_1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Mayak_inside\PLAN_2_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Mayak_inside\PLAN_2_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Mayak_inside\PLAN_2_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Mayak_inside\PLAN_2_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Passage\pass1_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Passage\pass1_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Passage\pass1_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Passage\pass1_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Passage\pass1_sb_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Passage\pass1_sb_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Passage\pass1_sb_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Passage\pass1_sb_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Passage\pass2_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Passage\pass2_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Passage\pass2_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Passage\pass2_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Passage\pass2_sb_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Passage\pass2_sb_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Passage\pass2_sb_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Passage\pass2_sb_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Passage\PLAN_1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Passage\PLAN_1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Passage\PLAN_1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Passage\PLAN_1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Passage\PLAN_2_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Passage\PLAN_2_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Passage\PLAN_2_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Passage\PLAN_2_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Passage\PLAN_3_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Passage\PLAN_3_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Passage\PLAN_3_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Passage\PLAN_3_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Pirate_outer_Location\PIRL_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Pirate_outer_Location\PIRL_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Pirate_outer_Location\PIRL_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Pirate_outer_Location\PIRL_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Pirate_outer_Location\PIRL_FD_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Pirate_outer_Location\PIRL_FD_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Pirate_outer_Location\PIRL_FD_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Pirate_outer_Location\PIRL_FD_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Pirate_outer_Location\PLAN_1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Pirate_outer_Location\PLAN_1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Pirate_outer_Location\PLAN_1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Pirate_outer_Location\PLAN_1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Pirate_outer_Location\PLAN_2_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Pirate_outer_Location\PLAN_2_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Pirate_outer_Location\PLAN_2_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Pirate_outer_Location\PLAN_2_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Pirate_outer_Location\PLAN_3_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Pirate_outer_Location\PLAN_3_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Pirate_outer_Location\PLAN_3_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Pirate_outer_Location\PLAN_3_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Rheims House\RHOUSE_B01_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Rheims House\RHOUSE_B01_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Rheims House\RHOUSE_B01_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Rheims House\RHOUSE_B01_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Rheims House\RHOUSE_B02_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Rheims House\RHOUSE_B02_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Rheims House\RHOUSE_B02_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Rheims House\RHOUSE_B02_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Rheims House\RHOUSE_B03_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Rheims House\RHOUSE_B03_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Rheims House\RHOUSE_B03_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Rheims House\RHOUSE_B03_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Rheims House\RHOUSE_B04_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Rheims House\RHOUSE_B04_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Rheims House\RHOUSE_B04_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Rheims House\RHOUSE_B04_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Rheims House\RHouse_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Rheims House\RHouse_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Rheims House\RHouse_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Rheims House\RHouse_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_1\PLAN_1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_1\PLAN_1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_1\PLAN_1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_1\PLAN_1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_1\PLAN_2_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_1\PLAN_2_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_1\PLAN_2_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_1\PLAN_2_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_1\PLAN_3_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_1\PLAN_3_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_1\PLAN_3_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_1\PLAN_3_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_1\SHORE01_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_1\SHORE01_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_1\SHORE01_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_1\SHORE01_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_1\SHORE01_SB_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_1\SHORE01_SB_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_1\SHORE01_SB_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_1\SHORE01_SB_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_10\PLAN_1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_10\PLAN_1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_10\PLAN_1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_10\PLAN_1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_10\PLAN_2_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_10\PLAN_2_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_10\PLAN_2_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_10\PLAN_2_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_10\PLAN_3_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_10\PLAN_3_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_10\PLAN_3_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_10\PLAN_3_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_10\SHORE10_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_10\SHORE10_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_10\SHORE10_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_10\SHORE10_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_10\SHORE10_SB_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_10\SHORE10_SB_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_10\SHORE10_SB_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_10\SHORE10_SB_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_2\PLAN_1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_2\PLAN_1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_2\PLAN_1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_2\PLAN_1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_2\PLAN_2_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_2\PLAN_2_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_2\PLAN_2_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_2\PLAN_2_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_2\PLAN_3_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_2\PLAN_3_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_2\PLAN_3_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_2\PLAN_3_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_2\SHORE02_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_2\SHORE02_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_2\SHORE02_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_2\SHORE02_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_2\SHORE02_SB_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_2\SHORE02_SB_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_2\SHORE02_SB_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_2\SHORE02_SB_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_3\PLAN_1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_3\PLAN_1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_3\PLAN_1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_3\PLAN_1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_3\PLAN_2_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_3\PLAN_2_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_3\PLAN_2_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_3\PLAN_2_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_3\PLAN_3_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_3\PLAN_3_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_3\PLAN_3_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_3\PLAN_3_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_3\SHORE03_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_3\SHORE03_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_3\SHORE03_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_3\SHORE03_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_3\SHORE03_SB_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_3\SHORE03_SB_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_3\SHORE03_SB_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_3\SHORE03_SB_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_4\PLAN_1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_4\PLAN_1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_4\PLAN_1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_4\PLAN_1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_4\PLAN_2_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_4\PLAN_2_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_4\PLAN_2_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_4\PLAN_2_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_4\PLAN_3_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_4\PLAN_3_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_4\PLAN_3_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_4\PLAN_3_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_4\SHORE04_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_4\SHORE04_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_4\SHORE04_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_4\SHORE04_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_4\SHORE04_SB_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_4\SHORE04_SB_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_4\SHORE04_SB_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_4\SHORE04_SB_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_5\PLAN_1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_5\PLAN_1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_5\PLAN_1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_5\PLAN_1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_5\PLAN_2_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_5\PLAN_2_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_5\PLAN_2_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_5\PLAN_2_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_5\PLAN_3_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_5\PLAN_3_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_5\PLAN_3_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_5\PLAN_3_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_5\SHORE05_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_5\SHORE05_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_5\SHORE05_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_5\SHORE05_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_5\SHORE05_SB_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_5\SHORE05_SB_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_5\SHORE05_SB_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_5\SHORE05_SB_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_6\SHORE06_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_6\SHORE06_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_6\SHORE06_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_6\SHORE06_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_6\SHORE06_SB_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_6\SHORE06_SB_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_6\SHORE06_SB_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_6\SHORE06_SB_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_7\SHORE07_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_7\SHORE07_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_7\SHORE07_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_7\SHORE07_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_7\SHORE07_SB_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_7\SHORE07_SB_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_7\SHORE07_SB_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_7\SHORE07_SB_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_8\PLAN_1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_8\PLAN_1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_8\PLAN_1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_8\PLAN_1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_8\PLAN_2_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_8\PLAN_2_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_8\PLAN_2_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_8\PLAN_2_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_8\PLAN_3_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_8\PLAN_3_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_8\PLAN_3_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_8\PLAN_3_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_8\SHORE08_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_8\SHORE08_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_8\SHORE08_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_8\SHORE08_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_8\SHORE08_SB_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_8\SHORE08_SB_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_8\SHORE08_SB_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_8\SHORE08_SB_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_9\PLAN_1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_9\PLAN_1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_9\PLAN_1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_9\PLAN_1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_9\PLAN_2_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_9\PLAN_2_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_9\PLAN_2_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_9\PLAN_2_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_9\PLAN_3_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_9\PLAN_3_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_9\PLAN_3_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_9\PLAN_3_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_9\SHORE09_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_9\SHORE09_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_9\SHORE09_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_9\SHORE09_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_9\SHORE09_SB_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_9\SHORE09_SB_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_9\SHORE09_SB_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_9\SHORE09_SB_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_ship\PLAN_1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_ship\PLAN_1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_ship\PLAN_1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_ship\PLAN_1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_ship\PLAN_2_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_ship\PLAN_2_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_ship\PLAN_2_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_ship\PLAN_2_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_ship\PLAN_3_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_ship\PLAN_3_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_ship\PLAN_3_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_ship\PLAN_3_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_ship\SHORESHIP_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_ship\SHORESHIP_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_ship\SHORESHIP_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_ship\SHORESHIP_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_ship\SHORESHIP_SB_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_ship\SHORESHIP_SB_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_ship\SHORESHIP_SB_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_ship\SHORESHIP_SB_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Pirate Fort\pif_b01_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Pirate Fort\pif_b01_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Pirate Fort\pif_b01_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Pirate Fort\pif_b01_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Pirate Fort\pif_b02_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Pirate Fort\pif_b02_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Pirate Fort\pif_b02_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Pirate Fort\pif_b02_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Pirate Fort\pif_b03_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Pirate Fort\pif_b03_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Pirate Fort\pif_b03_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Pirate Fort\pif_b03_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Pirate Fort\pif_b04_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Pirate Fort\pif_b04_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Pirate Fort\pif_b04_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Pirate Fort\pif_b04_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Pirate Fort\pif_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Pirate Fort\pif_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Pirate Fort\pif_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Pirate Fort\pif_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Pirate Fort\pif_fd_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Pirate Fort\pif_fd_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Pirate Fort\pif_fd_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Pirate Fort\pif_fd_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Pirate Fort\pif_fn_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Smuggler Lair\Exit\plan_1_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Smuggler Lair\Exit\plan_1_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Smuggler Lair\Exit\plan_1_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Smuggler Lair\Exit\plan_1_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Smuggler Lair\Exit\plan_2_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Smuggler Lair\Exit\plan_2_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Smuggler Lair\Exit\plan_2_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Smuggler Lair\Exit\plan_2_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Smuggler Lair\Exit\plan_3_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Smuggler Lair\Exit\plan_3_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Smuggler Lair\Exit\plan_3_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Smuggler Lair\Exit\plan_3_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Smuggler Lair\Exit\smlexit_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Smuggler Lair\Exit\smlexit_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Smuggler Lair\Exit\smlexit_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Smuggler Lair\Exit\smlexit_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Smuggler Lair\Exit\smlexit_fd_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Smuggler Lair\Exit\smlexit_fd_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Smuggler Lair\Exit\smlexit_fd_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Smuggler Lair\Exit\smlexit_fd_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Smuggler Lair\Town\PLAN_1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Smuggler Lair\Town\PLAN_1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Smuggler Lair\Town\PLAN_1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Smuggler Lair\Town\PLAN_1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Smuggler Lair\Town\PLAN_2_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Smuggler Lair\Town\PLAN_2_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Smuggler Lair\Town\PLAN_2_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Smuggler Lair\Town\PLAN_2_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Smuggler Lair\Town\PLAN_3_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Smuggler Lair\Town\PLAN_3_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Smuggler Lair\Town\PLAN_3_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Smuggler Lair\Town\PLAN_3_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Smuggler Lair\Town\PLAN_4_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Smuggler Lair\Town\PLAN_4_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Smuggler Lair\Town\PLAN_4_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Smuggler Lair\Town\PLAN_4_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Smuggler Lair\Town\SML_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Smuggler Lair\Town\SML_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Smuggler Lair\Town\SML_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Smuggler Lair\Town\SML_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Smuggler Lair\Town\SML_FD_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Smuggler Lair\Town\SML_FD_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Smuggler Lair\Town\SML_FD_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Smuggler Lair\Town\SML_FD_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Exit\conexit_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Exit\conexit_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Exit\conexit_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Exit\conexit_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Exit\conexit_fd_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Exit\conexit_fd_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Exit\conexit_fd_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Exit\conexit_fd_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Exit\plan_1_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Exit\plan_1_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Exit\plan_1_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Exit\plan_1_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Exit\plan_2_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Exit\plan_2_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Exit\plan_2_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Exit\plan_2_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Exit\plan_3_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Exit\plan_3_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Exit\plan_3_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Exit\plan_3_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Port\CONPORT_B04_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Port\CONPORT_B04_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Port\CONPORT_B04_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Port\CONPORT_B04_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Port\CONPORT_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Port\CONPORT_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Port\CONPORT_E01_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Port\CONPORT_E01_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Port\CONPORT_E01_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Port\CONPORT_E01_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Port\CONPORT_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Port\CONPORT_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Port\CONPORT_FD_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Port\CONPORT_FD_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Port\CONPORT_FD_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Port\CONPORT_FD_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Port\CONPORT_SB_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Port\CONPORT_SB_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Port\CONPORT_SB_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Port\CONPORT_SB_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Town\CONTOWN_B02_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Town\CONTOWN_B02_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Town\CONTOWN_B02_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Town\CONTOWN_B02_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Town\CONTOWN_B03_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Town\CONTOWN_B03_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Town\CONTOWN_B03_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Town\CONTOWN_B03_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Town\CONTOWN_B04_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Town\CONTOWN_B04_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Town\CONTOWN_B04_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Town\CONTOWN_B04_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Town\ConTown_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Town\ConTown_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Town\ConTown_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Town\ConTown_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Town\ConTown_fd_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Town\ConTown_fd_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Town\ConTown_fd_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Conceicao\Town\ConTown_fd_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Exit\DOUEXIT_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Exit\DOUEXIT_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Exit\DOUEXIT_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Exit\DOUEXIT_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Exit\DOUEXIT_FD_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Exit\DOUEXIT_FD_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Exit\DOUEXIT_FD_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Exit\DOUEXIT_FD_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Exit\PLAN_1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Exit\PLAN_1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Exit\PLAN_1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Exit\PLAN_1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Exit\PLAN_2_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Exit\PLAN_2_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Exit\PLAN_2_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Exit\PLAN_2_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Exit\PLAN_3_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Exit\PLAN_3_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Exit\PLAN_3_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Exit\PLAN_3_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Exit\PLAN_4_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Exit\PLAN_4_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Exit\PLAN_4_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Exit\PLAN_4_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Exit\WATERFALL_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Exit\WATERFALL_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Exit\WATERFALL_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Exit\WATERFALL_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Exit\WATERFALL2_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Exit\WATERFALL2_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Exit\WATERFALL2_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Exit\WATERFALL2_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Port\DOUPORT_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Port\DOUPORT_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Port\DOUPORT_E01_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Port\DOUPORT_E01_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Port\DOUPORT_E01_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Port\DOUPORT_E01_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Port\DOUPORT_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Port\DOUPORT_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Port\DOUPORT_FD_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Port\DOUPORT_FD_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Port\DOUPORT_FD_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Port\DOUPORT_FD_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Port\DOUPORT_SB_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Port\DOUPORT_SB_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Port\DOUPORT_SB_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Port\DOUPORT_SB_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Town\DOUTOWN_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Town\DOUTOWN_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Town\DOUTOWN_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Town\DOUTOWN_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Town\DOUTOWN_FD_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Town\DOUTOWN_FD_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Town\DOUTOWN_FD_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Town\DOUTOWN_FD_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Town\PLAN_1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Town\PLAN_1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Town\PLAN_1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Town\PLAN_1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Town\PLAN_2_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Town\PLAN_2_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Town\PLAN_2_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Town\PLAN_2_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Town\PLAN_3_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Town\PLAN_3_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Town\PLAN_3_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Douwesen\Town\PLAN_3_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Exit\ffexit_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Exit\ffexit_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Exit\ffexit_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Exit\ffexit_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Exit\ffexit_fd_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Exit\ffexit_fd_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Exit\ffexit_fd_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Exit\ffexit_fd_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Exit\plan_1_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Exit\plan_1_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Exit\plan_1_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Exit\plan_1_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Exit\plan_2_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Exit\plan_2_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Exit\plan_2_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Exit\plan_2_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Exit\plan_3_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Exit\plan_3_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Exit\plan_3_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Exit\plan_3_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\port\FFport01_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\port\FFport01_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\port\FFport01_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\port\FFport01_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\port\ffport01_fd_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\port\ffport01_fd_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\port\ffport01_fd_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\port\ffport01_fd_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\port\ffport01_fn_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\port\ffport01_sb_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\port\ffport01_sb_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\port\ffport01_sb_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\port\ffport01_sb_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\port2\FFPORT02_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\port2\FFPORT02_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\port2\FFPORT02_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\port2\FFPORT02_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\port2\FFPORT02_FD_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\port2\FFPORT02_FD_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\port2\FFPORT02_FD_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\port2\FFPORT02_FD_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\port2\FFPORT02_SB_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\port2\FFPORT02_SB_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\port2\FFPORT02_SB_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\port2\FFPORT02_SB_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Town_01\ff01_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Town_01\ff01_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Town_01\ff01_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Town_01\ff01_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Town_01\ff01_fd_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Town_01\ff01_fd_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Town_01\ff01_fd_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Town_01\ff01_fd_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Town_01\ff01_fn_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Town_01\PLAN_1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Town_01\PLAN_1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Town_01\PLAN_1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Town_01\PLAN_1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Town_01\PLAN_2_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Town_01\PLAN_2_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Town_01\PLAN_2_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Town_01\PLAN_2_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Town_01\PLAN_3_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Town_01\PLAN_3_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Town_01\PLAN_3_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Town_01\PLAN_3_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Town_02\FF02_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Town_02\FF02_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Town_02\FF02_e01_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Town_02\FF02_e01_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Town_02\FF02_e01_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Town_02\FF02_e01_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Town_02\ff02_e1_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Town_02\FF02_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Town_02\FF02_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Town_02\ff02_fd_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Town_02\ff02_fd_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Town_02\ff02_fd_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Town_02\ff02_fd_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Town_02\ff02_fn_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Town_03\ff03_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Town_03\ff03_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Town_03\ff03_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Town_03\ff03_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Town_03\ff03_fd_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Town_03\ff03_fd_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Town_03\ff03_fd_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Town_03\ff03_fd_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Town_04\ff04_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Town_04\ff04_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Town_04\ff04_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Town_04\ff04_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Town_04\ff04_fd_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Town_04\ff04_fd_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Town_04\ff04_fd_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_FalaiseDeFleur\Town_04\ff04_fd_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Exit\grexit_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Exit\grexit_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Exit\grexit_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Exit\grexit_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Exit\GrExit_fd_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Exit\GrExit_fd_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Exit\GrExit_fd_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Exit\GrExit_fd_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Exit\GrExit_fn_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Exit\plan_1_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Exit\plan_1_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Exit\plan_1_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Exit\plan_1_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Exit\plan_2_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Exit\plan_2_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Exit\plan_2_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Exit\plan_2_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Exit\plan_3_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Exit\plan_3_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Exit\plan_3_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Exit\plan_3_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Port\GRPORT_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Port\GRPORT_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Port\GRPORT_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Port\GRPORT_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Port\GRPORT_FD_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Port\GRPORT_FD_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Port\GRPORT_FD_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Port\GRPORT_FD_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Port\GRPORT_SB_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Port\GRPORT_SB_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Port\GRPORT_SB_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Port\GRPORT_SB_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Town\GRTOWN_B02_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Town\GRTOWN_B02_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Town\GRTOWN_B02_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Town\GRTOWN_B02_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Town\GRTOWN_B03_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Town\GRTOWN_B03_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Town\GRTOWN_B03_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Town\GRTOWN_B03_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Town\GRTOWN_B04_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Town\GRTOWN_B04_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Town\GRTOWN_B04_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Town\GRTOWN_B04_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Town\GrTown_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Town\GRTOWN_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Town\GrTown_e01_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Town\GRTOWN_E01_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Town\GRTOWN_E01_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Town\GRTOWN_E01_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Town\GRTOWN_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Town\GRTOWN_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Town\GRTOWN_FD_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Town\GRTOWN_FD_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Town\GRTOWN_FD_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Town\GRTOWN_FD_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Greenford\Town\GrTown_fn_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Exit\muexit_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Exit\muexit_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Exit\muexit_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Exit\muexit_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Exit\muexit_fd_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Exit\muexit_fd_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Exit\muexit_fd_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Exit\muexit_fd_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Exit\PLAN_1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Exit\plan_1_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Exit\plan_1_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Exit\plan_1_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Exit\PLAN_2_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Exit\plan_2_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Exit\plan_2_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Exit\plan_2_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Exit\PLAN_3_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Exit\plan_3_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Exit\plan_3_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Exit\plan_3_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Port\MUPORT_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Port\MUPORT_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Port\MUPORT_E1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Port\MUPORT_E1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Port\MUPORT_E1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Port\MUPORT_E1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Port\MUPORT_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Port\MUPORT_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Port\MUPORT_FD_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Port\MUPORT_FD_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Port\MUPORT_FD_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Port\MUPORT_FD_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Port\MUPORT_SB_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Port\MUPORT_SB_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Port\MUPORT_SB_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Port\MUPORT_SB_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Town_01\mu01_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Town_01\mu01_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Town_01\Mu01_e1_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Town_01\Mu01_e1_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Town_01\Mu01_e1_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Town_01\Mu01_e1_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Town_01\mu01_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Town_01\mu01_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Town_01\mu01_fd_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Town_01\mu01_fd_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Town_01\mu01_fd_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Town_01\mu01_fd_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Town_02\mu02_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Town_02\mu02_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Town_02\mu02_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Town_02\mu02_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Town_02\mu02_fd_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Town_02\mu02_fd_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Town_02\mu02_fd_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Town_02\mu02_fd_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Town_03\mu03_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Town_03\mu03_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Town_03\mu03_e1_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Town_03\mu03_e1_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Town_03\mu03_e1_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Town_03\mu03_e1_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Town_03\mu03_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Town_03\mu03_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Town_03\mu03_fd_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Town_03\mu03_fd_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Town_03\mu03_fd_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Town_03\mu03_fd_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Town_04\MU04_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Town_04\MU04_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Town_04\MU04_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Town_04\MU04_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Town_04\MU04_FD_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Town_04\MU04_FD_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Town_04\MU04_FD_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_IslaMuelle\Town_04\MU04_FD_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Oxbay\Exit\OXEXIT_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Oxbay\Exit\OXEXIT_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Oxbay\Exit\OXEXIT_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Oxbay\Exit\OXEXIT_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Oxbay\Exit\OXEXIT_FD_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Oxbay\Exit\OXEXIT_FD_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Oxbay\Exit\OXEXIT_FD_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Oxbay\Exit\OXEXIT_FD_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Oxbay\Exit\OXexit_fn_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Oxbay\Exit\PLAN_1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Oxbay\Exit\PLAN_1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Oxbay\Exit\PLAN_1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Oxbay\Exit\PLAN_1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Oxbay\Exit\PLAN_2_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Oxbay\Exit\PLAN_2_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Oxbay\Exit\PLAN_2_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Oxbay\Exit\PLAN_2_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Oxbay\Exit\PLAN_3_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Oxbay\Exit\PLAN_3_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Oxbay\Exit\PLAN_3_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Oxbay\Exit\PLAN_3_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Oxbay\Port\OXPORT_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Oxbay\Port\OXPORT_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Oxbay\Port\OXPORT_E1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Oxbay\Port\OXPORT_E1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Oxbay\Port\OXPORT_E1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Oxbay\Port\OXPORT_E1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Oxbay\Port\OXPORT_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Oxbay\Port\OXPORT_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Oxbay\Port\OXPORT_FD_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Oxbay\Port\OXPORT_FD_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Oxbay\Port\OXPORT_FD_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Oxbay\Port\OXPORT_FD_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Oxbay\Port\OXPORT_SB_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Oxbay\Port\OXPORT_SB_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Oxbay\Port\OXPORT_SB_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Oxbay\Port\OXPORT_SB_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Oxbay\Town\OXTOWN_B04_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Oxbay\Town\OXTOWN_B04_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Oxbay\Town\OXTOWN_B04_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Oxbay\Town\OXTOWN_B04_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Oxbay\Town\oxtown_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Oxbay\Town\oxtown_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Oxbay\Town\oxtown_e1_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Oxbay\Town\oxtown_e1_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Oxbay\Town\oxtown_e1_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Oxbay\Town\oxtown_e1_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Oxbay\Town\oxtown_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Oxbay\Town\oxtown_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Oxbay\Town\OXtown_fd_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Oxbay\Town\OXtown_fd_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Oxbay\Town\OXtown_fd_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Oxbay\Town\OXtown_fd_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Oxbay\Town\OXtown_fn_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Exit\plan_1_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Exit\plan_1_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Exit\plan_1_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Exit\plan_1_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Exit\plan_2_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Exit\plan_2_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Exit\plan_2_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Exit\plan_2_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Exit\plan_3_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Exit\plan_3_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Exit\plan_3_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Exit\plan_3_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Exit\qcexit_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Exit\qcexit_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Exit\qcexit_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Exit\qcexit_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Port\PLAN_1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Port\PLAN_1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Port\PLAN_1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Port\PLAN_1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Port\PLAN_2_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Port\PLAN_2_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Port\PLAN_2_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Port\PLAN_2_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Port\PLAN_3_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Port\PLAN_3_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Port\PLAN_3_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Port\PLAN_3_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Port\QCPORT_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Port\QCPORT_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Port\QCPORT_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Port\QCPORT_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Port\QCPORT_SB_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Port\QCPORT_SB_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Port\QCPORT_SB_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Port\QCPORT_SB_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Town\PLAN_1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Town\PLAN_1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Town\PLAN_1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Town\PLAN_1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Town\PLAN_2_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Town\PLAN_2_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Town\PLAN_2_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Town\PLAN_2_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Town\PLAN_3_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Town\PLAN_3_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Town\PLAN_3_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Town\PLAN_3_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Town\QCTOWN_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Town\QCTOWN_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Town\QCTOWN_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Town\QCTOWN_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Town\QCTOWN_FD_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Town\QCTOWN_FD_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Town\QCTOWN_FD_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Town\QCTOWN_FD_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Port\REDPORT_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Port\REDPORT_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Port\REDPORT_E01_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Port\REDPORT_E01_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Port\REDPORT_E01_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Port\REDPORT_E01_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Port\REDPORT_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Port\REDPORT_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Port\REDPORT_FD_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Port\REDPORT_FD_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Port\REDPORT_FD_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Port\REDPORT_FD_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Port\REDPORT_L_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Port\REDPORT_L_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Port\REDPORT_L_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Port\REDPORT_L_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Port\REDPORT_SB_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Port\REDPORT_SB_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Port\REDPORT_SB_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Port\REDPORT_SB_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\redexit1\plan_1_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\redexit1\plan_1_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\redexit1\plan_1_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\redexit1\plan_1_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\redexit1\plan_2_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\redexit1\plan_2_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\redexit1\plan_2_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\redexit1\plan_2_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\redexit1\plan_3_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\redexit1\plan_3_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\redexit1\plan_3_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\redexit1\plan_3_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\redexit1\redexit1_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\redexit1\redexit1_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\redexit1\redexit1_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\redexit1\redexit1_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\redexit1\redexit1_fd_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\redexit1\redexit1_fd_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\redexit1\redexit1_fd_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\redexit1\redexit1_fd_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\redexit2\PLAN_1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\redexit2\PLAN_1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\redexit2\PLAN_1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\redexit2\PLAN_1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\redexit2\PLAN_2_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\redexit2\PLAN_2_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\redexit2\PLAN_2_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\redexit2\PLAN_2_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\redexit2\PLAN_3_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\redexit2\PLAN_3_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\redexit2\PLAN_3_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\redexit2\PLAN_3_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\redexit2\REDEXIT2_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\redexit2\REDEXIT2_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\redexit2\REDEXIT2_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\redexit2\REDEXIT2_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\redexit2\REDEXIT2_FD_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\redexit2\REDEXIT2_FD_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\redexit2\REDEXIT2_FD_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\redexit2\REDEXIT2_FD_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_01\RED01_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_01\RED01_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_01\RED01_E01_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_01\RED01_E01_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_01\RED01_E01_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_01\RED01_E01_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_01\RED01_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_01\RED01_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_01\RED01_FD_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_01\RED01_FD_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_01\RED01_FD_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_01\RED01_FD_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_01\RED01_RB01_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_01\RED01_RB01_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_01\RED01_RB01_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_01\RED01_RB01_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_01\RED01_RE01_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_01\RED01_RE01_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_01\RED01_RE01_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_01\RED01_RE01_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_01\RED01_RT01_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_01\RED01_RT01_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_01\RED01_RT01_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_01\RED01_RT01_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_03\RED03_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_03\RED03_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_03\RED03_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_03\RED03_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_03\RED03_FD_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_03\RED03_FD_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_03\RED03_FD_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_03\RED03_FD_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_03\RED03_RB01_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_03\RED03_RB01_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_03\RED03_RB01_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_03\RED03_RB01_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_03\RED03_RE01_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_03\RED03_RE01_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_03\RED03_RE01_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_03\RED03_RE01_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_03\RED03_RT01_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_03\RED03_RT01_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_03\RED03_RT01_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_03\RED03_RT01_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_04\RED04_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_04\RED04_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_04\RED04_E01_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_04\RED04_E01_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_04\RED04_E01_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_04\RED04_E01_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_04\RED04_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_04\RED04_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_04\RED04_FD_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_04\RED04_FD_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_04\RED04_FD_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_04\RED04_FD_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_04\RED04_RB_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_04\RED04_RB_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_04\RED04_RB_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_04\RED04_RB_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_04\RED04_RE_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_04\RED04_RE_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_04\RED04_RE_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_04\RED04_RE_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_04\RED04_RT_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_04\RED04_RT_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_04\RED04_RT_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Town_04\RED04_RT_EVENING2.COL"

  ; Delete useless ship model files
  RMDir /r $INSTDIR\RESOURCE\MODELS\Ships\Fearless
  Delete $INSTDIR\RESOURCE\MODELS\Ships\Barque1\barque1_rey_b4.gm
  Delete $INSTDIR\RESOURCE\MODELS\Ships\Barque1\barque1_rey_c4.gm
  Delete $INSTDIR\RESOURCE\MODELS\Ships\Barque2\barque2_rey_b4.gm
  Delete $INSTDIR\RESOURCE\MODELS\Ships\Barque2\barque2_rey_c4.gm
  Delete $INSTDIR\RESOURCE\MODELS\Ships\BlackPearl\blackpearl_rey_a4.gm
  Delete $INSTDIR\RESOURCE\MODELS\Ships\BlackPearl\blackpearl_rey_b4.gm
  Delete $INSTDIR\RESOURCE\MODELS\Ships\Corvette1\corvette1_rey_a4.gm
  Delete $INSTDIR\RESOURCE\MODELS\Ships\Corvette2\corvette2_rey_a4.gm
  Delete $INSTDIR\RESOURCE\MODELS\Ships\Fleut1\Fleut1_rey_a1.gm
  Delete $INSTDIR\RESOURCE\MODELS\Ships\Fleut1\Fleut1_rey_b1.gm
  Delete $INSTDIR\RESOURCE\MODELS\Ships\Fleut2\fleut2_rey_a1.gm
  Delete $INSTDIR\RESOURCE\MODELS\Ships\Fleut2\fleut2_rey_b1.gm
  Delete $INSTDIR\RESOURCE\MODELS\Ships\Frigate1\frigate1_mast1.gm
  Delete $INSTDIR\RESOURCE\MODELS\Ships\Frigate1\frigate1_rey_a4.gm
  Delete $INSTDIR\RESOURCE\MODELS\Ships\Frigate2\frigate2_mast1.gm
  Delete $INSTDIR\RESOURCE\MODELS\Ships\Frigate2\frigate2_rey_a4.gm

  ; Delete useless sound files
  Delete $INSTDIR\RESOURCE\SOUNDS\dsstdfx.bin
  Delete $INSTDIR\RESOURCE\SOUNDS\AMBIENT\CHURCH\bench3.sfk
  Delete $INSTDIR\RESOURCE\SOUNDS\INTERFACE\drink.sfk
  Delete $INSTDIR\RESOURCE\SOUNDS\INTERFACE\knock.sfk
  Delete $INSTDIR\RESOURCE\SOUNDS\OBJECTS\VOICES\DEAD\male\dead4.sfk
  Delete $INSTDIR\RESOURCE\SOUNDS\PEOPLE\step_grass.sfk
  Delete $INSTDIR\RESOURCE\Sounds\MUSIC\March.ogg
  Delete $INSTDIR\RESOURCE\SOUNDS\MUSIC\Spokplavaniye.ogg

  ; Delete useless texture files
  RMDir /r $INSTDIR\RESOURCE\Textures\tips
  Delete $INSTDIR\RESOURCE\Textures\*.tga
  Delete $INSTDIR\RESOURCE\Textures\*.xbx
  Delete $INSTDIR\RESOURCE\Textures\flagall.tga.tx
  Delete $INSTDIR\RESOURCE\Textures\Loading\initialization.tga.tx
  Delete $INSTDIR\RESOURCE\Textures\Loading\load.tga.tx
  Delete $INSTDIR\RESOURCE\Textures\Loading\load_game.tga.tx
  Delete $INSTDIR\RESOURCE\Textures\Loading\Save_Game.tga.tx

  ; Delete useless character texture files
  Delete $INSTDIR\RESOURCE\Textures\Characters\Liza.tga.tx
  Delete $INSTDIR\RESOURCE\Textures\Characters\Offic_eng.tga.tx

  ; Delete useless interface texture files
  Delete $INSTDIR\RESOURCE\Textures\BATTLE_INTERFACE\all_nations.tga.tx
  Delete $INSTDIR\RESOURCE\Textures\BATTLE_INTERFACE\cicons_locators.tga.tx
  Delete $INSTDIR\RESOURCE\Textures\BATTLE_INTERFACE\fast_commands.tga.tx
  Delete $INSTDIR\RESOURCE\Textures\BATTLE_INTERFACE\small_nations.tga.tx
  Delete $INSTDIR\RESOURCE\Textures\BATTLE_INTERFACE\moor_1.tga.tx
  Delete $INSTDIR\RESOURCE\Textures\BATTLE_INTERFACE\moor_2.tga.tx
  Delete $INSTDIR\RESOURCE\Textures\BATTLE_INTERFACE\moor_3.tga.tx
  Delete $INSTDIR\RESOURCE\Textures\BATTLE_INTERFACE\moor_4.tga.tx
  Delete $INSTDIR\RESOURCE\Textures\BATTLE_INTERFACE\moor_5.tga.tx
  Delete $INSTDIR\RESOURCE\Textures\BATTLE_INTERFACE\moor_6.tga.tx
  Delete $INSTDIR\RESOURCE\Textures\BATTLE_INTERFACE\moor_7.tga.tx
  Delete $INSTDIR\RESOURCE\Textures\BATTLE_INTERFACE\moor_8.tga.tx

  Delete $INSTDIR\RESOURCE\Textures\INTERFACES\nations_2.tga.tx
  Delete $INSTDIR\RESOURCE\Textures\INTERFACES\nations_4.tga.tx
  Delete $INSTDIR\RESOURCE\Textures\INTERFACES\potc_logo_rus.tga.tx
  Delete $INSTDIR\RESOURCE\Textures\INTERFACES\ship-1.tga.tx

  ; Delete useless worldmap texture files
  RMDir /r $INSTDIR\RESOURCE\Textures\WorldMap\reload
  Delete $INSTDIR\RESOURCE\Textures\Worldmap\Interfaces\icons.tga.tx
  Delete $INSTDIR\RESOURCE\Textures\Worldmap\geometry\sails_shiplet.tga.tx
  Delete $INSTDIR\RESOURCE\Textures\Worldmap\geometry\shiplet.tga.tx
  Delete $INSTDIR\RESOURCE\Textures\Worldmap\geometry\shipletlet.tga.tx

  ; Delete old sail files
  Delete $INSTDIR\RESOURCE\Textures\Ships\parus_england.tga.tx
  Delete $INSTDIR\RESOURCE\Textures\Ships\parus_france.tga.tx
  Delete $INSTDIR\RESOURCE\Textures\Ships\parus_holland.tga.tx
  Delete $INSTDIR\RESOURCE\Textures\Ships\parus_pirate.tga.tx
  Delete $INSTDIR\RESOURCE\Textures\Ships\parus_portugal.tga.tx
  Delete $INSTDIR\RESOURCE\Textures\Ships\parus_spain.tga.tx
  Delete $INSTDIR\RESOURCE\Textures\Ships\sail_*.tga.tx

  ; Delete old Beta 2.5 left-over files
  Delete "$INSTDIR\Documentation\Archipelago Map.png"
  Delete "$INSTDIR\RESOURCE\foam\islands\Aruba\Aruba.ini"
  Delete "$INSTDIR\RESOURCE\foam\islands\Aruba\Aruba.tga.zap"
  Delete "$INSTDIR\RESOURCE\foam\islands\redmond\redmond.ini"
  Delete "$INSTDIR\RESOURCE\foam\islands\redmond\redmond.tga.zap"
  Delete "$INSTDIR\RESOURCE\foam\locations\Town_Alice\Alice.ini"
  Delete "$INSTDIR\RESOURCE\foam\locations\Town_Alice\Alice.tga.zap"
  Delete "$INSTDIR\RESOURCE\foam\locations\town_Conceicao\port\Hispaniola_port.ini"
  Delete "$INSTDIR\RESOURCE\foam\locations\town_Conceicao\port\Hispaniola_port.tga.zap"
  Delete "$INSTDIR\RESOURCE\foam\locations\town_PoPrince\PORT\Hispaniola_port.ini"
  Delete "$INSTDIR\RESOURCE\foam\locations\town_PoPrince\PORT\Hispaniola_port.tga.zap"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Antigua\ANTIGUA_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Antigua\ANTIGUA_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Antigua\ANTIGUA_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Antigua\ANTIGUA_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Antigua\ANTIGUA_FORT1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Antigua\ANTIGUA_FORT1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Antigua\ANTIGUA_FORT1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Antigua\ANTIGUA_FORT1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Antigua\ANTIGUA_REFL_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Antigua\ANTIGUA_REFL_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Antigua\ANTIGUA_REFL_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Antigua\ANTIGUA_REFL_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Antigua\ANTIGUA_SEABED_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Antigua\ANTIGUA_SEABED_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Antigua\ANTIGUA_SEABED_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Antigua\ANTIGUA_SEABED_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Aruba\ARUBA_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Aruba\ARUBA_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Aruba\ARUBA_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Aruba\ARUBA_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Aruba\ARUBA_REFL_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Aruba\ARUBA_REFL_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Aruba\ARUBA_REFL_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Aruba\ARUBA_REFL_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Aruba\ARUBA_SEABED_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Aruba\ARUBA_SEABED_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Aruba\ARUBA_SEABED_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Aruba\ARUBA_SEABED_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Cayman\CAYMAN_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Cayman\CAYMAN_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Cayman\CAYMAN_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Cayman\CAYMAN_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Cayman\CAYMAN_FORT1_DAY1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Cayman\CAYMAN_FORT1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Cayman\CAYMAN_FORT1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Cayman\CAYMAN_FORT1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Cayman\CAYMAN_FORT1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Cayman\CAYMAN_FORT1_EVENING3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Cayman\CAYMAN_FORT1_MORNING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Cayman\CAYMAN_FORT1_NIGHT1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Cayman\CAYMAN_REFL_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Cayman\CAYMAN_REFL_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Cayman\CAYMAN_REFL_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Cayman\CAYMAN_REFL_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Cayman\CAYMAN_SEABED_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Cayman\CAYMAN_SEABED_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Cayman\CAYMAN_SEABED_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Cayman\CAYMAN_SEABED_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Cuba\CUBA_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Cuba\CUBA_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Cuba\CUBA_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Cuba\CUBA_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Cuba\CUBA_FORT1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Cuba\CUBA_FORT1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Cuba\CUBA_FORT1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Cuba\CUBA_FORT1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Cuba\CUBA_FORT2_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Cuba\CUBA_FORT2_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Cuba\CUBA_FORT2_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Cuba\CUBA_FORT2_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Cuba\CUBA_REFL_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Cuba\CUBA_REFL_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Cuba\CUBA_REFL_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Cuba\CUBA_REFL_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Cuba\CUBA_SEABED_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Cuba\CUBA_SEABED_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Cuba\CUBA_SEABED_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Cuba\CUBA_SEABED_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Curacao\Curacao_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Curacao\Curacao_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Curacao\Curacao_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Curacao\Curacao_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Curacao\Curacao_REFL_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Curacao\Curacao_REFL_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Curacao\Curacao_REFL_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Curacao\Curacao_REFL_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Curacao\Curacao_SEABED_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Curacao\Curacao_SEABED_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Curacao\Curacao_SEABED_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Curacao\Curacao_SEABED_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\Eleuthera_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\Eleuthera_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\ELEUTHERA_DAY4.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\Eleuthera_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\Eleuthera_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\ELEUTHERA_EVENING4.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\ELEUTHERA_FORT1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\ELEUTHERA_FORT1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\ELEUTHERA_FORT1_DAY4.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\ELEUTHERA_FORT1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\ELEUTHERA_FORT1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\ELEUTHERA_FORT1_EVENING4.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\ELEUTHERA_FORT1_MORNING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\ELEUTHERA_FORT1_MORNING3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\ELEUTHERA_FORT1_MORNING4.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\ELEUTHERA_FORT1_NIGHT2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\ELEUTHERA_FORT1_NIGHT3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\ELEUTHERA_FORT1_NIGHT4.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\ELEUTHERA_FORT1_STORM1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\ELEUTHERA_FORT1_STORM2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\ELEUTHERA_FORT1_STORM3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\ELEUTHERA_FORT1_STORM4.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\ELEUTHERA_MORNING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\ELEUTHERA_MORNING3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\ELEUTHERA_MORNING4.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\ELEUTHERA_NIGHT2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\ELEUTHERA_NIGHT3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\ELEUTHERA_NIGHT4.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\Eleuthera_REFL_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\Eleuthera_REFL_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\ELEUTHERA_REFL_DAY4.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\Eleuthera_REFL_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\Eleuthera_REFL_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\ELEUTHERA_REFL_EVENING4.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\ELEUTHERA_REFL_MORNING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\ELEUTHERA_REFL_MORNING3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\ELEUTHERA_REFL_MORNING4.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\ELEUTHERA_REFL_NIGHT2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\ELEUTHERA_REFL_NIGHT3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\ELEUTHERA_REFL_NIGHT4.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\ELEUTHERA_REFL_STORM1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\ELEUTHERA_REFL_STORM2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\ELEUTHERA_REFL_STORM3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\ELEUTHERA_REFL_STORM4.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\Eleuthera_SEABED_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\Eleuthera_SEABED_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\ELEUTHERA_SEABED_DAY4.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\Eleuthera_SEABED_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\Eleuthera_SEABED_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\ELEUTHERA_SEABED_EVENING4.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\ELEUTHERA_SEABED_MORNING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\ELEUTHERA_SEABED_MORNING3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\ELEUTHERA_SEABED_MORNING4.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\ELEUTHERA_SEABED_NIGHT2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\ELEUTHERA_SEABED_NIGHT3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\ELEUTHERA_SEABED_NIGHT4.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\ELEUTHERA_SEABED_STORM1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\ELEUTHERA_SEABED_STORM2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\ELEUTHERA_SEABED_STORM3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\ELEUTHERA_SEABED_STORM4.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\ELEUTHERA_STORM1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\ELEUTHERA_STORM2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Eleuthera\ELEUTHERA_STORM3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Gaity\GAITY_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Gaity\GAITY_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Gaity\GAITY_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Gaity\GAITY_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Gaity\GAITY_FORT1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Gaity\GAITY_FORT1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Gaity\GAITY_FORT1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Gaity\GAITY_FORT1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Gaity\GAITY_FORT2_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Gaity\GAITY_FORT2_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Gaity\GAITY_FORT2_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Gaity\GAITY_FORT2_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Gaity\GAITY_FORT3_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Gaity\GAITY_FORT3_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Gaity\GAITY_FORT3_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Gaity\GAITY_FORT3_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Gaity\GAITY_REFL_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Gaity\GAITY_REFL_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Gaity\GAITY_REFL_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Gaity\GAITY_REFL_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Gaity\GAITY_SEABED_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Gaity\GAITY_SEABED_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Gaity\GAITY_SEABED_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Gaity\GAITY_SEABED_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Guadelupa\GUADELUPA_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Guadelupa\GUADELUPA_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Guadelupa\GUADELUPA_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Guadelupa\GUADELUPA_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Guadelupa\GUADELUPA_FORT1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Guadelupa\GUADELUPA_FORT1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Guadelupa\GUADELUPA_FORT1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Guadelupa\GUADELUPA_FORT1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Guadelupa\GUADELUPA_REFL_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Guadelupa\GUADELUPA_REFL_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Guadelupa\GUADELUPA_REFL_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Guadelupa\GUADELUPA_REFL_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Guadelupa\GUADELUPA_SEABED_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Guadelupa\GUADELUPA_SEABED_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Guadelupa\GUADELUPA_SEABED_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Guadelupa\GUADELUPA_SEABED_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaDeMuerte\ISLAMONA_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaDeMuerte\ISLAMONA_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaDeMuerte\ISLAMONA_DAY4.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaDeMuerte\ISLAMONA_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaDeMuerte\ISLAMONA_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaDeMuerte\ISLAMONA_EVENING4.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaDeMuerte\ISLAMONA_MORNING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaDeMuerte\ISLAMONA_MORNING3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaDeMuerte\ISLAMONA_MORNING4.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaDeMuerte\ISLAMONA_NIGHT2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaDeMuerte\ISLAMONA_NIGHT3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaDeMuerte\ISLAMONA_NIGHT4.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaDeMuerte\ISLAMONA_REFL_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaDeMuerte\ISLAMONA_REFL_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaDeMuerte\ISLAMONA_REFL_DAY4.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaDeMuerte\ISLAMONA_REFL_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaDeMuerte\ISLAMONA_REFL_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaDeMuerte\ISLAMONA_REFL_EVENING4.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaDeMuerte\ISLAMONA_REFL_MORNING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaDeMuerte\ISLAMONA_REFL_MORNING3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaDeMuerte\ISLAMONA_REFL_MORNING4.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaDeMuerte\ISLAMONA_REFL_NIGHT2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaDeMuerte\ISLAMONA_REFL_NIGHT3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaDeMuerte\ISLAMONA_REFL_NIGHT4.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaDeMuerte\ISLAMONA_REFL_STORM1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaDeMuerte\ISLAMONA_REFL_STORM2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaDeMuerte\ISLAMONA_REFL_STORM3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaDeMuerte\ISLAMONA_REFL_STORM4.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaDeMuerte\ISLAMONA_SEABED_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaDeMuerte\ISLAMONA_SEABED_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaDeMuerte\ISLAMONA_SEABED_DAY4.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaDeMuerte\ISLAMONA_SEABED_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaDeMuerte\ISLAMONA_SEABED_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaDeMuerte\ISLAMONA_SEABED_EVENING4.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaDeMuerte\ISLAMONA_SEABED_MORNING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaDeMuerte\ISLAMONA_SEABED_MORNING3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaDeMuerte\ISLAMONA_SEABED_MORNING4.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaDeMuerte\ISLAMONA_SEABED_NIGHT2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaDeMuerte\ISLAMONA_SEABED_NIGHT3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaDeMuerte\ISLAMONA_SEABED_NIGHT4.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaDeMuerte\ISLAMONA_SEABED_STORM1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaDeMuerte\ISLAMONA_SEABED_STORM2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaDeMuerte\ISLAMONA_SEABED_STORM3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaDeMuerte\ISLAMONA_SEABED_STORM4.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaDeMuerte\ISLAMONA_STORM1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaDeMuerte\ISLAMONA_STORM2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaDeMuerte\ISLAMONA_STORM3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaDeMuerte\ISLAMONA_STORM4.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\IslaMuelle\SanFelipe.gm"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Sent\SENT_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Sent\SENT_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Sent\SENT_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Sent\SENT_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Sent\SENT_FORT1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Sent\SENT_FORT1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Sent\SENT_FORT1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Sent\SENT_FORT1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Sent\SENT_REFL_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Sent\SENT_REFL_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Sent\SENT_REFL_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Sent\SENT_REFL_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Sent\SENT_SEABED_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Sent\SENT_SEABED_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Sent\SENT_SEABED_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Sent\SENT_SEABED_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Terks\TERKS_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Terks\TERKS_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Terks\TERKS_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Terks\TERKS_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Terks\TERKS_REFL_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Terks\TERKS_REFL_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Terks\TERKS_REFL_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Terks\TERKS_REFL_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Terks\TERKS_SEABED_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Terks\TERKS_SEABED_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Terks\TERKS_SEABED_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Islands\Terks\TERKS_SEABED_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Deck1_yellow\DECK1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Deck1_yellow\DECK1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Deck1_yellow\DECK1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Deck1_yellow\DECK1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Deck1_yellow\DECK1_FD_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Deck1_yellow\DECK1_FD_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Deck1_yellow\DECK1_FD_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Deck1_yellow\DECK1_FD_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Deck1_yellow\elevator&ropes_G1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Deck1_yellow\elevator&ropes_G1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Deck1_yellow\elevator&ropes_G1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Deck1_yellow\elevator&ropes_G1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Deck1_yellow\elevator&ropes_G2_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Deck1_yellow\elevator&ropes_G2_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Deck1_yellow\elevator&ropes_G2_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Deck1_yellow\elevator&ropes_G2_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Deck2_red\deck2_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Deck2_red\DECK2_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Deck2_red\DECK2_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Deck2_red\DECK2_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Deck2_red\deck2_fd_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Deck2_red\DECK2_FD_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Deck2_red\DECK2_FD_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Deck2_red\DECK2_FD_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Hold_red\elevator&ropes_G0_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Hold_red\elevator&ropes_G0_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Hold_red\elevator&ropes_G0_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Hold_red\elevator&ropes_G0_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Hold_red\elevator&ropes_G1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Hold_red\elevator&ropes_G1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Hold_red\elevator&ropes_G1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Hold_red\elevator&ropes_G1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Hold_red\elevator&ropes_G2_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Hold_red\elevator&ropes_G2_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Hold_red\elevator&ropes_G2_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Hold_red\elevator&ropes_G2_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Hold_red\elevatornoropes_G0_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Hold_red\elevatornoropes_G0_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Hold_red\elevatornoropes_G0_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Hold_red\elevatornoropes_G0_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Hold_red\HOLD_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Hold_red\HOLD_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Hold_red\HOLD_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Hold_red\HOLD_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Hold_red\HOLD_FD_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Hold_red\HOLD_FD_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Hold_red\HOLD_FD_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Hold_red\HOLD_FD_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Hold_red\plank1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Hold_red\plank1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Hold_red\plank1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Hold_red\plank1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Hold_red\plank2_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Hold_red\plank2_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Hold_red\plank2_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Hold_red\plank2_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Hold_red\ropes0_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Hold_red\ropes0_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Hold_red\ropes0_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Hold_red\ropes0_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Hold_red\ropes2_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Hold_red\ropes2_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Hold_red\ropes2_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Hold_red\ropes2_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Qdeck_open\anchor_small1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Qdeck_open\anchor_small1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Qdeck_open\anchor_small1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Qdeck_open\anchor_small1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Qdeck_open\anchor0_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Qdeck_open\anchor0_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Qdeck_open\anchor0_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Qdeck_open\anchor0_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Qdeck_open\cannon_pipe_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Qdeck_open\cannon_pipe_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Qdeck_open\cannon_pipe_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Qdeck_open\cannon_pipe_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Qdeck_open\door_broken_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Qdeck_open\door_broken_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Qdeck_open\door_broken_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Qdeck_open\door_broken_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Qdeck_open\elevator&ropes_C1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Qdeck_open\elevator&ropes_C1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Qdeck_open\elevator&ropes_C1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Qdeck_open\elevator&ropes_C1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Qdeck_open\elevator&ropes_C2_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Qdeck_open\elevator&ropes_C2_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Qdeck_open\elevator&ropes_C2_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Qdeck_open\elevator&ropes_C2_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Qdeck_open\QDECK_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Qdeck_open\QDECK_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Qdeck_open\QDECK_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Qdeck_open\QDECK_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\SwampWreck\CERESSMITHY_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\SwampWreck\CERESSMITHY_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\SwampWreck\CERESSMITHY_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\SwampWreck\CERESSMITHY_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\SwampWreck\CERESSMITHY_SB_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\SwampWreck\CERESSMITHY_SB_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\SwampWreck\CERESSMITHY_SB_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\SwampWreck\CERESSMITHY_SB_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\SwampWreck\CERESSMITHY_SB_STORM1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\SwampWreck\CERESSMITHY_STORM1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\SwampWreck\CERESSMITHY_WINDOWS_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\SwampWreck\CERESSMITHY_WINDOWS_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\SwampWreck\CERESSMITHY_WINDOWS_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\SwampWreck\CERESSMITHY_WINDOWS_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\SwampWreck\CERESSMITHY_WINDOWS_STORM1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\anchor_lost_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\anchor_lost_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\anchor_lost_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\anchor_lost_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\anchor_small1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\anchor_small1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\anchor_small1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\anchor_small1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\anchor0_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\anchor0_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\anchor0_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\anchor0_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\anchor1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\anchor1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\anchor1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\anchor1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\cannon_E0_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\cannon_E0_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\cannon_E0_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\cannon_E0_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\cannon_E1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\cannon_E1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\cannon_E1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\cannon_E1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\cannon_E2_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\cannon_E2_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\cannon_E2_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\cannon_E2_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\cannon_E3_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\cannon_E3_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\cannon_E3_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\cannon_E3_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\cannon_pipe_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\cannon_pipe_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\cannon_pipe_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\cannon_pipe_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\cannon_ropes1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\cannon_ropes1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\cannon_ropes1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\cannon_ropes1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\cannon_ropes2_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\cannon_ropes2_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\cannon_ropes2_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\cannon_ropes2_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\cannon_S0_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\cannon_S0_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\cannon_S0_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\cannon_S0_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\cannon_S1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\cannon_S1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\cannon_S1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\cannon_S1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\cannon_S1X_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\cannon_S1X_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\cannon_S1X_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\cannon_S1X_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\cannon_S2_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\cannon_S2_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\cannon_S2_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\cannon_S2_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\cannon_S3_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\cannon_S3_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\cannon_S3_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\cannon_S3_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\deck_box_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\deck_box_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\deck_box_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\deck_box_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\door_broken_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\door_broken_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\door_broken_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\door_broken_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\door_N12_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\door_N12_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\door_N12_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\door_N12_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\elevator&ropes_C1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\elevator&ropes_C1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\elevator&ropes_C1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\elevator&ropes_C1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\elevator&ropes_C2_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\elevator&ropes_C2_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\elevator&ropes_C2_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\elevator&ropes_C2_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\elevator&ropes_G0_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\elevator&ropes_G0_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\elevator&ropes_G0_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\elevator&ropes_G0_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\elevator&ropes_G1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\elevator&ropes_G1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\elevator&ropes_G1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\elevator&ropes_G1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\elevator&ropes_G2_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\elevator&ropes_G2_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\elevator&ropes_G2_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\elevator&ropes_G2_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\goods_pile_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\goods_pile_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\goods_pile_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\goods_pile_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\plank1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\plank1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\plank1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\plank1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\plank2_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\plank2_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\plank2_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\plank2_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\ropes0_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\ropes0_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\ropes0_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\ropes0_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\ropes2_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\ropes2_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\ropes2_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\ropes2_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\ropesA_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\ropesA_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\ropesA_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\ropesA_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\UDECK_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\UDECK_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\UDECK_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\decks\Udeck_open\UDECK_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\bars_down_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\bars_down_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\bars_down_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\bars_down_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\bars_up_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\bars_up_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\bars_up_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\bars_up_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\MEDIUMHOUSE01_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\MEDIUMHOUSE01_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\MEDIUMHOUSE01_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\MEDIUMHOUSE01_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\MEDIUMHOUSE01_RAND_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\MEDIUMHOUSE01_RAND_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\MEDIUMHOUSE01_RAND_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\MEDIUMHOUSE01_RAND_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\MEDIUMHOUSE01_RAND_STORM1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\MEDIUMHOUSE01_RAND_STORM2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\MEDIUMHOUSE01_STORM1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\MEDIUMHOUSE01_STORM2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\MEDIUMHOUSE01_STORM3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\MEDIUMHOUSE01_STORM4.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\MEDIUMHOUSE01_WINDOWS_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\MEDIUMHOUSE01_WINDOWS_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\MEDIUMHOUSE01_WINDOWS_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\MEDIUMHOUSE01_WINDOWS_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\MEDIUMHOUSE01_WINDOWS_STORM1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\MEDIUMHOUSE01_WINDOWS_STORM2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\MEDIUMHOUSE01_WINDOWS_STORM3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\MEDIUMHOUSE01_WINDOWS_STORM4.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\MEDIUMHOUSE01_WINDOWS2_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\MEDIUMHOUSE01_WINDOWS2_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\MEDIUMHOUSE01_WINDOWS2_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\MEDIUMHOUSE01_WINDOWS2_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\MEDIUMHOUSE01_WINDOWS2_STORM1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\MEDIUMHOUSE01_WINDOWS2_STORM2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\MEDIUMHOUSE01_WINDOWS2_STORM3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\MEDIUMHOUSE01_WINDOWS2_STORM4.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\plank_down_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\plank_down_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\plank_down_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\plank_down_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\plank_up_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\plank_up_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\plank_up_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\plank_up_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\rope_down_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\rope_down_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\rope_down_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\rope_down_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\rope_up_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\rope_up_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\rope_up_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\rope_up_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\steplock_v_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\steplock_v_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\steplock_v_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\alchemist\steplock_v_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\ANIMISTS_Cave\lever_base_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\ANIMISTS_Cave\lever_base_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\ANIMISTS_Cave\lever_base_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\ANIMISTS_Cave\lever_base_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\ANIMISTS_Cave\lever_base2_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\ANIMISTS_Cave\lever_base2_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\ANIMISTS_Cave\lever_base2_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\ANIMISTS_Cave\lever_base2_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\ANIMISTS_Cave\mine_bomb_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\ANIMISTS_Cave\mine_bomb_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\ANIMISTS_Cave\mine_bomb_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\ANIMISTS_Cave\mine_bomb_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\ANIMISTS_Cave\wood_box_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\ANIMISTS_Cave\wood_box_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\ANIMISTS_Cave\wood_box_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\ANIMISTS_Cave\wood_box_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Bank\BANK_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Bank\BANK_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Bank\BANK_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Bank\BANK_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Bank\CHOIR_WINDOWS_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Bank\CHOIR_WINDOWS_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Bank\CHOIR_WINDOWS_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Bank\CHOIR_WINDOWS_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\brothel_room\BROTHEL_ROOM_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\brothel_room\BROTHEL_ROOM_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\brothel_room\BROTHEL_ROOM_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\brothel_room\BROTHEL_ROOM_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\brothel_room\BROTHEL_ROOM_WINDOW_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\brothel_room\BROTHEL_ROOM_WINDOW_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\brothel_room\BROTHEL_ROOM_WINDOW_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\brothel_room\BROTHEL_ROOM_WINDOW_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\brothel_room_wr\BROTHEL_ROOM_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\brothel_room_wr\BROTHEL_ROOM_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\brothel_room_wr\BROTHEL_ROOM_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\brothel_room_wr\BROTHEL_ROOM_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\brothel_room_wr\BROTHEL_ROOM_WINDOW_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\brothel_room_wr\BROTHEL_ROOM_WINDOW_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\brothel_room_wr\BROTHEL_ROOM_WINDOW_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\brothel_room_wr\BROTHEL_ROOM_WINDOW_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Cavern_blue\cavern_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Cavern_blue\cavern_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Cavern_blue\cavern_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Cavern_blue\cavern_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Cavern_blue\Crystals_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Cavern_blue\Crystals_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Cavern_blue\Crystals_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Cavern_blue\Crystals_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Cavern_blue\ladder_very_big_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Cavern_blue\ladder_very_big_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Cavern_blue\ladder_very_big_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Cavern_blue\ladder_very_big_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Cellar_downstairs\CELLAR_DOWNSTAIRS_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Cellar_downstairs\CELLAR_DOWNSTAIRS_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Cellar_downstairs\CELLAR_DOWNSTAIRS_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Cellar_downstairs\CELLAR_DOWNSTAIRS_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Cellar_downstairs\CELLAR_DOWNSTAIRS_stuff_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Cellar_downstairs\CELLAR_DOWNSTAIRS_stuff_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Cellar_downstairs\CELLAR_DOWNSTAIRS_stuff_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Cellar_downstairs\CELLAR_DOWNSTAIRS_stuff_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Cellar_downstairs\steplock_v_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Cellar_downstairs\steplock_v_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Cellar_downstairs\steplock_v_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Cellar_downstairs\steplock_v_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Church_1\collectbox_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Church_1\collectbox_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Church_1\collectbox_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Church_1\collectbox_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Corridor\scroll46_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Corridor\scroll46_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Corridor\scroll46_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Corridor\scroll46_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Corridor\SS_FN_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Corridor\SS_FN_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Corridor\SS_FN_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Corridor\SS_FN_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Corridor\storesmall_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Corridor\storesmall_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Corridor\storesmall_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Corridor\storesmall_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Dungeon_1_wood\d01_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Dungeon_1_wood\d01_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Dungeon_1_wood\d01_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Dungeon_1_wood\d01_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Dungeon_4\ROCK3_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Dungeon_4\ROCK3_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Dungeon_4\ROCK3_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Dungeon_4\ROCK3_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\flamhouse\FLAMHOUSE_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\flamhouse\FLAMHOUSE_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\flamhouse\FLAMHOUSE_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\flamhouse\FLAMHOUSE_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\flamhouse\FLAMHOUSE_WINDOW_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\flamhouse\FLAMHOUSE_WINDOW_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\flamhouse\FLAMHOUSE_WINDOW_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\flamhouse\FLAMHOUSE_WINDOW_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\flamhouse\lever_base_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\flamhouse\lever_base_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\flamhouse\lever_base_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\flamhouse\lever_base_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Hut\HUT_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Hut\HUT_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Hut\HUT_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Hut\HUT_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Hut\HUT_WINDOW_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Hut\HUT_WINDOW_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Hut\HUT_WINDOW_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Hut\HUT_WINDOW_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\largehouse01\door_sklad_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\largehouse01\door_sklad_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\largehouse01\door_sklad_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\largehouse01\door_sklad_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\largehouse01\LARGEHOUSE01_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\largehouse01\LARGEHOUSE01_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\largehouse01\LARGEHOUSE01_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\largehouse01\LARGEHOUSE01_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\largehouse01\LARGEHOUSE01_RAND_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\largehouse01\LARGEHOUSE01_RAND_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\largehouse01\LARGEHOUSE01_RAND_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\largehouse01\LARGEHOUSE01_RAND_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\largehouse01\LARGEHOUSE01_RAND_STORM1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\largehouse01\LARGEHOUSE01_RAND_STORM2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\largehouse01\LARGEHOUSE01_STORM1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\largehouse01\LARGEHOUSE01_STORM2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\largehouse01\LARGEHOUSE01_STORM3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\largehouse01\LARGEHOUSE01_STORM4.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\largehouse01\LARGEHOUSE01_WINDOWS_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\largehouse01\LARGEHOUSE01_WINDOWS_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\largehouse01\LARGEHOUSE01_WINDOWS_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\largehouse01\LARGEHOUSE01_WINDOWS_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\largehouse01\LARGEHOUSE01_WINDOWS_STORM1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\largehouse01\LARGEHOUSE01_WINDOWS_STORM2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\largehouse01\LARGEHOUSE01_WINDOWS_STORM3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\largehouse01\LARGEHOUSE01_WINDOWS_STORM4.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\largehouse02_farm\2doors_largeh_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\largehouse02_farm\2doors_largeh_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\largehouse02_farm\2doors_largeh_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\largehouse02_farm\2doors_largeh_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\largehouse02_farm\LARGEHOUSE02_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\largehouse02_farm\LARGEHOUSE02_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\largehouse02_farm\LARGEHOUSE02_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\largehouse02_farm\LARGEHOUSE02_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\largehouse02_farm\LARGEHOUSE02_RAND_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\largehouse02_farm\LARGEHOUSE02_RAND_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\largehouse02_farm\LARGEHOUSE02_RAND_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\largehouse02_farm\LARGEHOUSE02_RAND_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\largehouse02_farm\LARGEHOUSE02_WINDOWS_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\largehouse02_farm\LARGEHOUSE02_WINDOWS_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\largehouse02_farm\LARGEHOUSE02_WINDOWS_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\largehouse02_farm\LARGEHOUSE02_WINDOWS_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\largehouse02_farm\LARGEHOUSE02_WINDOWS2_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\largehouse02_farm\LARGEHOUSE02_WINDOWS2_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\largehouse02_farm\LARGEHOUSE02_WINDOWS2_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\largehouse02_farm\LARGEHOUSE02_WINDOWS2_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\MediumHouse\MH_w2_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\MediumHouse\MH_W2_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\MediumHouse\MH_W2_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\MediumHouse\MH_W2_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\MediumStore_Gps\MS_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\MediumStore_Gps\MS_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\MediumStore_Gps\MS_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\MediumStore_Gps\MS_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\MediumStore_Gps\MS_W_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\MediumStore_Gps\MS_W_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\MediumStore_Gps\MS_W_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\MediumStore_Gps\MS_W_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\MediumStore_inner\MS_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\MediumStore_inner\MS_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\MediumStore_inner\MS_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\MediumStore_inner\MS_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\MediumStore_inner\MS_W_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\MediumStore_inner\MS_W_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\MediumStore_inner\MS_W_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\MediumStore_inner\MS_W_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh6_galley\MH6_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh6_galley\MH6_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh6_galley\MH6_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh6_galley\MH6_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh6_galley\MH6_W_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh6_galley\MH6_W_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh6_galley\MH6_W_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh6_galley\MH6_W_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh9_cellar\MH9_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh9_cellar\MH9_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh9_cellar\MH9_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh9_cellar\MH9_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh9_cellar\MH9_W_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh9_cellar\MH9_W_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh9_cellar\MH9_W_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\mh9_cellar\MH9_W_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence2\lever_base_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence2\lever_base_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence2\lever_base_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence2\lever_base_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence2_admiral\RES02_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence2_admiral\RES02_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence2_admiral\Res02_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence2_admiral\Res02_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence2_admiral\RES02_W_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence2_admiral\RES02_W_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence2_admiral\Res02_w_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence2_admiral\Res02_w_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence3_red\Res03_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence3_red\Res03_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence3_red\Res03_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence3_red\Res03_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence3_red\Res03_w_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence3_red\Res03_w_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\ResidenceSmall2\SmallResidence_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\ResidenceSmall2\SmallResidence_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\ResidenceSmall2\SmallResidence_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\ResidenceSmall2\SmallResidence_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\ResidenceSmall2\SmallResidence_windows_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\ResidenceSmall2\SmallResidence_windows_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\ResidenceSmall2\SmallResidence_windows_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\ResidenceSmall2\SmallResidence_windows_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Sewer\d01_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Sewer\d01_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Sewer\d01_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Sewer\d01_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Shipyard5\SH05_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Shipyard5\SH05_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Shipyard5\SH05_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Shipyard5\SH05_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Shipyard5\SH05_WINDOW_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Shipyard5\SH05_WINDOW_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Shipyard5\SH05_WINDOW_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Shipyard5\SH05_WINDOW_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\ShipyardPirates\SHIPYARDPIRATES_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\ShipyardPirates\SHIPYARDPIRATES_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\ShipyardPirates\SHIPYARDPIRATES_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\ShipyardPirates\SHIPYARDPIRATES_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\ShipyardPirates\SHIPYARDPIRATES_FN_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\ShipyardPirates\SHIPYARDPIRATES_FN_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\ShipyardPirates\SHIPYARDPIRATES_FN_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\ShipyardPirates\SHIPYARDPIRATES_FN_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\ShipyardPirates\SHIPYARDPIRATES_ROCK_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\ShipyardPirates\SHIPYARDPIRATES_ROCK_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\ShipyardPirates\SHIPYARDPIRATES_ROCK_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\ShipyardPirates\SHIPYARDPIRATES_ROCK_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Sklad\SKLAD_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Sklad\SKLAD_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Sklad\SKLAD_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Sklad\SKLAD_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Sklad\SKLAD_WINDOWS_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Sklad\SKLAD_WINDOWS_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Sklad\SKLAD_WINDOWS_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Sklad\SKLAD_WINDOWS_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Store03\STORE03_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Store03\STORE03_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Store03\STORE03_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Store03\STORE03_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Store03\STORE03_WINDOW_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Store03\STORE03_WINDOW_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Store03\STORE03_WINDOW_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Store03\STORE03_WINDOW_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\store04\STORE04_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\store04\STORE04_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\store04\STORE04_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\store04\STORE04_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\store04\STORE04_WINDOW_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\store04\STORE04_WINDOW_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\store04\STORE04_WINDOW_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\store04\STORE04_WINDOW_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\store04_stone\STORE04_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\store04_stone\STORE04_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\store04_stone\STORE04_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\store04_stone\STORE04_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\store04_stone\STORE04_WINDOW_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\store04_stone\STORE04_WINDOW_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\store04_stone\STORE04_WINDOW_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\store04_stone\STORE04_WINDOW_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\StoreHouse_Rogers\lever_base_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\StoreHouse_Rogers\lever_base_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\StoreHouse_Rogers\lever_base_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\StoreHouse_Rogers\lever_base_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\StoreHouse_Rogers\RESIDENCE05_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\StoreHouse_Rogers\RESIDENCE05_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\StoreHouse_Rogers\RESIDENCE05_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\StoreHouse_Rogers\RESIDENCE05_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\StoreHouse_Rogers\RESIDENCE05_WINDOW_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\StoreHouse_Rogers\RESIDENCE05_WINDOW_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\StoreHouse_Rogers\RESIDENCE05_WINDOW_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\StoreHouse_Rogers\RESIDENCE05_WINDOW_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Tavern_1\tavern_1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Tavern_1\tavern_1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Tavern_1\TAVERN_1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Tavern_1\tavern_1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Tavern_2\tavern_2_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Tavern_2\tavern_2_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Tavern_2\TAVERN_2_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Tavern_2\tavern_2_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Tavern_room\TAVERN_ROOM_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Tavern_room\TAVERN_ROOM_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Tavern_room\TAVERN_ROOM_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Tavern_room\TAVERN_ROOM_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Tavern_room\TAVERN_ROOM_WINDOW_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Tavern_room\TAVERN_ROOM_WINDOW_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Tavern_room\TAVERN_ROOM_WINDOW_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Tavern_room\TAVERN_ROOM_WINDOW_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Tavern02\TAVERN02_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Tavern02\TAVERN02_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Tavern02\TAVERN02_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Tavern02\TAVERN02_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Tavern02\TAVERN02_WINDOW_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Tavern02\TAVERN02_WINDOW_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Tavern02\TAVERN02_WINDOW_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Tavern02\TAVERN02_WINDOW_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Tavern03\TAVERN03_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Tavern03\TAVERN03_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Tavern03\TAVERN03_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Tavern03\TAVERN03_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Tavern03\TAVERN03_WINDOW_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Tavern03\TAVERN03_WINDOW_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Tavern03\TAVERN03_WINDOW_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Tavern03\TAVERN03_WINDOW_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Warehouse\WAREHOUSE_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Warehouse\WAREHOUSE_L_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Wine_cellar\DungeonVault1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Wine_cellar\DungeonVault1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Wine_cellar\DungeonVault1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Wine_cellar\DungeonVault1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Wine_cellar\steplock_v_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Wine_cellar\steplock_v_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Wine_cellar\steplock_v_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Wine_cellar\steplock_v_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Mayak_inside\barrel3_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Mayak_inside\barrel3_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Mayak_inside\barrel3_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Mayak_inside\barrel3_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Morro\MORRO_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Morro\MORRO_L_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Morro\MORROFORT_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Pirate_outer_Location_2\PIRL_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Pirate_outer_Location_2\PIRL_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Pirate_outer_Location_2\PIRL_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Pirate_outer_Location_2\PIRL_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Pirate_outer_Location_2\PIRL_FD_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Pirate_outer_Location_2\PIRL_FD_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Pirate_outer_Location_2\PIRL_FD_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Pirate_outer_Location_2\PIRL_FD_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Pirate_outer_Location_2\PLAN_1_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Pirate_outer_Location_2\PLAN_1_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Pirate_outer_Location_2\PLAN_1_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Pirate_outer_Location_2\PLAN_1_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Pirate_outer_Location_2\PLAN_2_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Pirate_outer_Location_2\PLAN_2_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Pirate_outer_Location_2\PLAN_2_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Pirate_outer_Location_2\PLAN_2_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Pirate_outer_Location_2\PLAN_3_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Pirate_outer_Location_2\PLAN_3_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Pirate_outer_Location_2\PLAN_3_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Pirate_outer_Location_2\PLAN_3_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Swamp_island2\TOWNEXITW_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Swamp_island2\TOWNEXITW_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Swamp_island2\TOWNEXITW_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Swamp_island2\TOWNEXITW_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Swamp_island2\TOWNEXITW_STORM1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Cartagena\town\1007001.gm"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Cartagena\town\1007001_DAY1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Cartagena\town\1007001_EVENING3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Cartagena\town\1007001_MORNING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Cartagena\town\1007001_NIGHT1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Cartagena\town\gr1007001.gm"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Cartagena\town\locator.gm"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Cartagena\town\LOCATOR_DAY1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Cartagena\town\LOCATOR_EVENING3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Cartagena\town\LOCATOR_MORNING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Cartagena\town\LOCATOR_NIGHT1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Cartagena\town\locator_start.gm"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Cartagena\town\ludeng.gm"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Cartagena\town\walk_patch.gm"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Cartagena\town\walk_patch.ptc"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Exit\qcexit_JRH_day2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Exit\qcexit_JRH_day3.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Exit\qcexit_JRH_evening1.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Exit\qcexit_JRH_evening2.col"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Town\QCTOWN_black_DAY2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Town\QCTOWN_black_DAY3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Town\QCTOWN_black_EVENING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_QC\Town\QCTOWN_black_EVENING2.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Ships\Blackpearl\blackPearl_stuff.gm"
  Delete "$INSTDIR\RESOURCE\MODELS\Ships\CursedPearl\CursedPearl_stuff.gm"
  Delete "$INSTDIR\RESOURCE\MODELS\Ships\FleutWar\FleutWar_mast1.gm"
  Delete "$INSTDIR\RESOURCE\MODELS\Ships\FleutWar\FleutWar_rey_a1.gm"
  Delete "$INSTDIR\RESOURCE\MODELS\Ships\FleutWar\FleutWar_rey_b1.gm"
  Delete "$INSTDIR\RESOURCE\MODELS\Ships\HMS_Dauntless\HMS_Endeavour_mast1.gm"
  Delete "$INSTDIR\RESOURCE\MODELS\Ships\RN_SuperiorWarship\RN_SuperiorWarship - kopie.gm"
  Delete "$INSTDIR\RESOURCE\MODELS\Ships\SP_Frigate\SP_Frigate.gm"
  Delete "$INSTDIR\RESOURCE\MODELS\Ships\SP_Frigate\SP_Frigate_deck.gm"
  Delete "$INSTDIR\RESOURCE\MODELS\Ships\SP_Frigate\SP_Frigate_fish.gm"
  Delete "$INSTDIR\RESOURCE\MODELS\Ships\SP_Frigate\SP_Frigate_mast1.gm"
  Delete "$INSTDIR\RESOURCE\MODELS\Ships\SP_Frigate\SP_Frigate_mast2.gm"
  Delete "$INSTDIR\RESOURCE\MODELS\Ships\SP_Frigate\SP_Frigate_mast3.gm"
  Delete "$INSTDIR\RESOURCE\MODELS\Ships\SP_Frigate\SP_Frigate_mast4.gm"
  Delete "$INSTDIR\RESOURCE\MODELS\Ships\SP_Frigate\SP_Frigate_path.gm"
  Delete "$INSTDIR\RESOURCE\MODELS\Ships\SP_Frigate\SP_Frigate_rey_a1.gm"
  Delete "$INSTDIR\RESOURCE\MODELS\Ships\SP_Frigate\SP_Frigate_rey_a2.gm"
  Delete "$INSTDIR\RESOURCE\MODELS\Ships\SP_Frigate\SP_Frigate_rey_a3.gm"
  Delete "$INSTDIR\RESOURCE\MODELS\Ships\SP_Frigate\SP_Frigate_rey_a4.gm"
  Delete "$INSTDIR\RESOURCE\MODELS\Ships\SP_Frigate\SP_Frigate_rey_b1.gm"
  Delete "$INSTDIR\RESOURCE\MODELS\Ships\SP_Frigate\SP_Frigate_rey_b2.gm"
  Delete "$INSTDIR\RESOURCE\MODELS\Ships\SP_Frigate\SP_Frigate_rey_b3.gm"
  Delete "$INSTDIR\RESOURCE\MODELS\Ships\SP_Frigate\SP_Frigate_rey_b4.gm"
  Delete "$INSTDIR\RESOURCE\MODELS\Ships\SP_Frigate\SP_Frigate_rey_c2.gm"
  Delete "$INSTDIR\RESOURCE\MODELS\Ships\SP_Frigate\SP_Frigate_rey_c3.gm"
  Delete "$INSTDIR\RESOURCE\MODELS\Ships\SP_Frigate\SP_Frigate_rey_flag.gm"
  Delete "$INSTDIR\RESOURCE\MODELS\Ships\UncursedPearl\UncursedPearl_stuff.gm"
  Delete "$INSTDIR\RESOURCE\MODELS\Ships\WickedWench\WickedWench_stuff.gm"
  Delete "$INSTDIR\RESOURCE\Sounds\MUSIC\12-WorldMap.ogg"
  Delete "$INSTDIR\RESOURCE\Sounds\MUSIC\15-Sailing 2 (Night).ogg"
  Delete "$INSTDIR\RESOURCE\Sounds\MUSIC\16-Sailing 3 (Old Storm).ogg"
  Delete "$INSTDIR\RESOURCE\Sounds\MUSIC\CutthroatIsland_Main_Theme.ogg"
  Delete "$INSTDIR\RESOURCE\Sounds\MUSIC\sea.ogg"
  Delete "$INSTDIR\RESOURCE\Textures\BATTLE_INTERFACE\moor_10.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\BATTLE_INTERFACE\moor_11.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\BATTLE_INTERFACE\moor_12.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\BATTLE_INTERFACE\moor_13.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\BATTLE_INTERFACE\moor_14.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\BATTLE_INTERFACE\UsedItems3.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\bortoutcorvette6.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\flags\perflg6.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\flags\perpnt6.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\flags\pirflg4.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\flags\pirflg5.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\flags\pirflg6.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\flags\pirpnt4.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\flags\pirpnt5.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\flags\pirpnt6.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\INTERFACES\crests.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\INTERFACES\nations.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\INTERFACES\PORTRAITS\128\face_212.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\INTERFACES\PORTRAITS\128\face_213.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\INTERFACES\PORTRAITS\128\face_325.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\INTERFACES\PORTRAITS\128\face_327.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\INTERFACES\PORTRAITS\128\face_328.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\INTERFACES\PORTRAITS\128\face_329.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\INTERFACES\PORTRAITS\128\face_330.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\INTERFACES\PORTRAITS\128\face_482.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\INTERFACES\PORTRAITS\128\face_538.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\INTERFACES\PORTRAITS\128\face_539.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\INTERFACES\PORTRAITS\256\face_212.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\INTERFACES\PORTRAITS\256\face_213.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\INTERFACES\PORTRAITS\256\face_325.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\INTERFACES\PORTRAITS\256\face_327.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\INTERFACES\PORTRAITS\256\face_328.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\INTERFACES\PORTRAITS\256\face_329.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\INTERFACES\PORTRAITS\256\face_330.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\INTERFACES\PORTRAITS\256\face_482.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\INTERFACES\PORTRAITS\256\face_538.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\INTERFACES\PORTRAITS\256\face_539.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\INTERFACES\PORTRAITS\64\face_212.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\INTERFACES\PORTRAITS\64\face_213.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\INTERFACES\PORTRAITS\64\face_325.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\INTERFACES\PORTRAITS\64\face_327.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\INTERFACES\PORTRAITS\64\face_328.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\INTERFACES\PORTRAITS\64\face_329.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\INTERFACES\PORTRAITS\64\face_330.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\INTERFACES\PORTRAITS\64\face_482.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\INTERFACES\PORTRAITS\64\face_538.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\INTERFACES\PORTRAITS\64\face_539.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\lighting\evening\loctions\Outside\Isle\shadow.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\lighting\evening\Town_Cartagena\port\shadow.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\lighting\evening\Town_Cartagena\Residence\Shadow.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\lighting\mn\loctions\Outside\Isle\shadow.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\lighting\mn\Town_Cartagena\port\shadow.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\lighting\mn\Town_Cartagena\Residence\Shadow.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\lighting\storm\loctions\Outside\Isle\shadow.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\lighting\storm\Town_Cartagena\port\shadow.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\lighting\storm\Town_Cartagena\Residence\Shadow.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\Ships\frg8.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\Ships\Raa12.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\Ships\Raa13.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\Ships\Raa14.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\Ships\Raa3.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\Ships\Raa5.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\Ships\Raa6.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\Ships\Raa9.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\Ships\Raaq.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\Ships\SPAINNWFRIGATE1.TGA.TX"


; ================================================
;  Install Main Modpack Files
; ================================================

  ; Extract 7-Zip File
  SetOutPath "$EXEDIR"
  ${If} ${FileExists} "$EXEDIR\b14_beta3_full.potc"
    Nsis7z::ExtractWithDetails "b14_beta3_full.potc" "Extracting Main Modpack Files: %s..."
  ${Else}
    Nsis7z::ExtractWithDetails "b14_beta3_full.7z"   "Extracting Main Modpack Files: %s..."
  ${EndIf}


  ; Copy from EXE Folder to Installation Directory
  !insertmacro MoveFolder "$EXEDIR\b14_beta3_full\" "$INSTDIR\" "*.*"


; ================================================
;  Copy Modpack Files
; ================================================

  ; Copy lighting files
  CreateDirectory $INSTDIR\RESOURCE\Textures\lighting\day\locations\Town_PoPrince\port
  CreateDirectory $INSTDIR\RESOURCE\Textures\lighting\day\locations\Town_PoPrince\town
  CreateDirectory $INSTDIR\RESOURCE\Textures\lighting\day\locations\Town_PoPrince\exit
  CopyFiles /SILENT $INSTDIR\RESOURCE\Textures\lighting\day\locations\town_Conceicao\port\*.*		$INSTDIR\RESOURCE\Textures\lighting\day\locations\Town_PoPrince\port
  CopyFiles /SILENT $INSTDIR\RESOURCE\Textures\lighting\day\locations\town_Conceicao\town\*.*		$INSTDIR\RESOURCE\Textures\lighting\day\locations\Town_PoPrince\town
  CopyFiles /SILENT $INSTDIR\RESOURCE\Textures\lighting\day\locations\town_Conceicao\exit\*.*		$INSTDIR\RESOURCE\Textures\lighting\day\locations\Town_PoPrince\exit

  CreateDirectory $INSTDIR\RESOURCE\Textures\lighting\evening\locations\Town_PoPrince\port
  CreateDirectory $INSTDIR\RESOURCE\Textures\lighting\evening\locations\Town_PoPrince\town
  CreateDirectory $INSTDIR\RESOURCE\Textures\lighting\evening\locations\Town_PoPrince\exit
  CopyFiles /SILENT $INSTDIR\RESOURCE\Textures\lighting\evening\locations\town_Conceicao\port\*.*	$INSTDIR\RESOURCE\Textures\lighting\evening\locations\Town_PoPrince\port
  CopyFiles /SILENT $INSTDIR\RESOURCE\Textures\lighting\evening\locations\town_Conceicao\town\*.*	$INSTDIR\RESOURCE\Textures\lighting\evening\locations\Town_PoPrince\town
  CopyFiles /SILENT $INSTDIR\RESOURCE\Textures\lighting\evening\locations\town_Conceicao\exit\*.*	$INSTDIR\RESOURCE\Textures\lighting\evening\locations\Town_PoPrince\exit

  CreateDirectory $INSTDIR\RESOURCE\Textures\lighting\mn\locations\Town_PoPrince\port
  CreateDirectory $INSTDIR\RESOURCE\Textures\lighting\mn\locations\Town_PoPrince\town
  CreateDirectory $INSTDIR\RESOURCE\Textures\lighting\mn\locations\Town_PoPrince\exit
  CopyFiles /SILENT $INSTDIR\RESOURCE\Textures\lighting\mn\locations\town_Conceicao\port\*.*		$INSTDIR\RESOURCE\Textures\lighting\mn\locations\Town_PoPrince\port
  CopyFiles /SILENT $INSTDIR\RESOURCE\Textures\lighting\mn\locations\town_Conceicao\town\*.*		$INSTDIR\RESOURCE\Textures\lighting\mn\locations\Town_PoPrince\town
  CopyFiles /SILENT $INSTDIR\RESOURCE\Textures\lighting\mn\locations\town_Conceicao\exit\*.*		$INSTDIR\RESOURCE\Textures\lighting\mn\locations\Town_PoPrince\exit

  CreateDirectory $INSTDIR\RESOURCE\Textures\lighting\storm\locations\Town_PoPrince\port
  CreateDirectory $INSTDIR\RESOURCE\Textures\lighting\storm\locations\Town_PoPrince\town
  CreateDirectory $INSTDIR\RESOURCE\Textures\lighting\storm\locations\Town_PoPrince\exit
  CopyFiles /SILENT $INSTDIR\RESOURCE\Textures\lighting\storm\locations\town_Conceicao\port\*.*		$INSTDIR\RESOURCE\Textures\lighting\storm\locations\Town_PoPrince\port
  CopyFiles /SILENT $INSTDIR\RESOURCE\Textures\lighting\storm\locations\town_Conceicao\town\*.*		$INSTDIR\RESOURCE\Textures\lighting\storm\locations\Town_PoPrince\town
  CopyFiles /SILENT $INSTDIR\RESOURCE\Textures\lighting\storm\locations\town_Conceicao\exit\*.*		$INSTDIR\RESOURCE\Textures\lighting\storm\locations\Town_PoPrince\exit

  ; Copy location files
  CreateDirectory $INSTDIR\RESOURCE\MODELS\Locations\decks\deckBP
  CopyFiles /SILENT $INSTDIR\RESOURCE\MODELS\Locations\decks\deckBig\DECKBIG_DAY1.COL			$INSTDIR\RESOURCE\MODELS\Locations\decks\deckBP\DECKBIG_DAY1.COL
  CopyFiles /SILENT $INSTDIR\RESOURCE\MODELS\Locations\decks\deckBig\DECKBIG_EVENING3.COL		$INSTDIR\RESOURCE\MODELS\Locations\decks\deckBP\DECKBIG_EVENING3.COL
  CopyFiles /SILENT $INSTDIR\RESOURCE\MODELS\Locations\decks\deckBig\deckBig_fd.gm			$INSTDIR\RESOURCE\MODELS\Locations\decks\deckBP\deckBig_fd.gm
  CopyFiles /SILENT $INSTDIR\RESOURCE\MODELS\Locations\decks\deckBig\DECKBIG_FD_DAY1.COL		$INSTDIR\RESOURCE\MODELS\Locations\decks\deckBP\DECKBIG_FD_DAY1.COL
  CopyFiles /SILENT $INSTDIR\RESOURCE\MODELS\Locations\decks\deckBig\deckBig_fn.gm			$INSTDIR\RESOURCE\MODELS\Locations\decks\deckBP\deckBig_fn.gm
  CopyFiles /SILENT $INSTDIR\RESOURCE\MODELS\Locations\decks\deckBig\DECKBIG_FN_NIGHT1.COL		$INSTDIR\RESOURCE\MODELS\Locations\decks\deckBP\DECKBIG_FN_NIGHT1.COL
  CopyFiles /SILENT $INSTDIR\RESOURCE\MODELS\Locations\decks\deckBig\deckBig_l.gm			$INSTDIR\RESOURCE\MODELS\Locations\decks\deckBP\deckBig_l.gm
  CopyFiles /SILENT $INSTDIR\RESOURCE\MODELS\Locations\decks\deckBig\deckBig_ld.gm			$INSTDIR\RESOURCE\MODELS\Locations\decks\deckBP\deckBig_ld.gm
  CopyFiles /SILENT $INSTDIR\RESOURCE\MODELS\Locations\decks\deckBig\DECKBIG_LD_DAY1.COL		$INSTDIR\RESOURCE\MODELS\Locations\decks\deckBP\DECKBIG_LD_DAY1.COL
  CopyFiles /SILENT $INSTDIR\RESOURCE\MODELS\Locations\decks\deckBig\DECKBIG_MORNING1.COL		$INSTDIR\RESOURCE\MODELS\Locations\decks\deckBP\DECKBIG_MORNING1.COL
  CopyFiles /SILENT $INSTDIR\RESOURCE\MODELS\Locations\decks\deckBig\DECKBIG_NIGHT1.COL			$INSTDIR\RESOURCE\MODELS\Locations\decks\deckBP\DECKBIG_NIGHT1.COL
  CopyFiles /SILENT $INSTDIR\RESOURCE\MODELS\Locations\decks\deckBig\deckBig_p.ptc			$INSTDIR\RESOURCE\MODELS\Locations\decks\deckBP\deckBig_p.ptc
  CopyFiles /SILENT $INSTDIR\RESOURCE\MODELS\Ships\SP_Galeon50\*.*					$INSTDIR\RESOURCE\MODELS\Locations\Outside\Shore_5

  ; Copy ship texture files
  CopyFiles /SILENT $INSTDIR\resource\textures\Ships\bortouttartane3.tga.tx 				$INSTDIR\resource\textures\bortouttartane3.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Ships\cabin2.tga.tx 					$INSTDIR\resource\textures\cabin2.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Ships\capmd.tga.tx 					$INSTDIR\resource\textures\capmd.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Ships\Capsm.tga.tx 					$INSTDIR\resource\textures\Capsm.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Ships\chear1c.tga.tx 					$INSTDIR\resource\textures\chear1c.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Ships\checker.tga.tx 					$INSTDIR\resource\textures\checker.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Ships\de04.tga.tx 					$INSTDIR\resource\textures\de04.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Ships\deck.tga.tx 					$INSTDIR\resource\textures\deck.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Ships\derevo.tga.tx 					$INSTDIR\resource\textures\derevo.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Ships\desk.tga.tx 					$INSTDIR\resource\textures\desk.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Ships\doorLH.tga.tx 					$INSTDIR\resource\textures\doorLH.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Ships\fightdeck2.tga.tx 					$INSTDIR\resource\textures\fightdeck2.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Ships\fightdeck4.tga.tx 					$INSTDIR\resource\textures\fightdeck4.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Ships\fonar_day.tga.tx					$INSTDIR\resource\textures\fonar_day.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Ships\fonar_night.tga.tx 				$INSTDIR\resource\textures\fonar_night.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Ships\galeonskin3_50.tga.tx 				$INSTDIR\resource\textures\galeonskin3_50.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Ships\gunU1.tga.tx 					$INSTDIR\resource\textures\gunU1.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Ships\gunU5.tga.tx 					$INSTDIR\resource\textures\gunU5.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Ships\itemsLSC.tga.tx 					$INSTDIR\resource\textures\itemsLSC.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Ships\Kapitan.tga.tx 					$INSTDIR\resource\textures\Kapitan.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Ships\lampK3.tga.tx 					$INSTDIR\resource\textures\lampK3.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Ships\metalU2.tga.tx 					$INSTDIR\resource\textures\metalU2.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Ships\metalU4.tga.tx					$INSTDIR\resource\textures\metalU4.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Ships\metalU5.tga.tx					$INSTDIR\resource\textures\metalU5.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Ships\objects_tex1.tga.tx				$INSTDIR\resource\textures\objects_tex1.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Ships\ropeJR.tga.tx					$INSTDIR\resource\textures\ropeJR.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Ships\ropeU1.tga.tx 					$INSTDIR\resource\textures\ropeU1.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Ships\woodOldJR.tga.tx 					$INSTDIR\resource\textures\woodOldJR.tga.tx

  CopyFiles /SILENT $INSTDIR\resource\textures\Foudation_Win_Door.tga.tx 				$INSTDIR\resource\textures\Ships\Foudation_Win_Door.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Items.tga.tx 						$INSTDIR\resource\textures\Ships\Items.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\lowmen.tga.tx 						$INSTDIR\resource\textures\Ships\lowmen.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\metall.tga.tx 						$INSTDIR\resource\textures\Ships\metall.tga.tx

  ; Copy BuildingSet texture files
  CopyFiles /SILENT $INSTDIR\resource\textures\ANIMALS\LIZARD.TGA.tx					$INSTDIR\resource\textures\CHARACTERS\LIZARD.TGA.tx

  CopyFiles /SILENT $INSTDIR\resource\textures\Ships\objects_tex2.tga.tx 				$INSTDIR\resource\textures\objects_tex2.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Ships\cabin2.tga.tx 					$INSTDIR\resource\textures\Ammo\cabin2.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Ships\dec1.tga.tx 					$INSTDIR\resource\textures\Ammo\dec1.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Ships\deck.tga.tx 					$INSTDIR\resource\textures\Ammo\deck.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Ships\dekk.tga.tx 					$INSTDIR\resource\textures\Ammo\dekk.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Ships\langang.tga.tx 					$INSTDIR\resource\textures\Ammo\langang.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Ships\objects_tex1.tga.tx 				$INSTDIR\resource\textures\Ammo\objects_tex1.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Ships\objects_tex2.tga.tx 				$INSTDIR\resource\textures\Ammo\objects_tex2.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Ships\ropeU1.tga.tx 					$INSTDIR\resource\textures\Ammo\ropeU1.tga.tx

  CopyFiles /SILENT "$INSTDIR\resource\textures\brck48L copy.tga.tx"					"$INSTDIR\resource\textures\Ammo\brck48L copy.tga.tx"
  CopyFiles /SILENT "$INSTDIR\resource\textures\sib_stuff copy.tga.tx"					"$INSTDIR\resource\textures\Ammo\sib_stuff copy.tga.tx"
  CopyFiles /SILENT $INSTDIR\resource\textures\1grass1.tga.tx						$INSTDIR\resource\textures\Ammo\1grass1.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\4000183.tga.tx 						$INSTDIR\resource\textures\Ammo\4000183.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\4001630.tga.tx 						$INSTDIR\resource\textures\Ammo\4001630.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\4001938.tga.tx 						$INSTDIR\resource\textures\Ammo\4001938.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\anchor.tga.tx 						$INSTDIR\resource\textures\Ammo\anchor.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\axe.tga.tx						$INSTDIR\resource\textures\Ammo\axe.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\back_mountains.tga.tx					$INSTDIR\resource\textures\Ammo\back_mountains.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\balkU2.tga.tx						$INSTDIR\resource\textures\Ammo\balkU2.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Bardel.tga.tx						$INSTDIR\resource\textures\Ammo\Bardel.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Barracks.tga.tx						$INSTDIR\resource\textures\Ammo\Barracks.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\bd1.tga.tx						$INSTDIR\resource\textures\Ammo\bd1.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\boat.tga.tx						$INSTDIR\resource\textures\Ammo\boat.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\brdg.tga.tx						$INSTDIR\resource\textures\Ammo\brdg.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\bump_city.tga.tx						$INSTDIR\resource\textures\Ammo\bump_city.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\BUMP_LAND.TGA.tx						$INSTDIR\resource\textures\Ammo\BUMP_LAND.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Button_lv3.tga.tx					$INSTDIR\resource\textures\Ammo\Button_lv3.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\cabinet1c.tga.tx						$INSTDIR\resource\textures\Ammo\cabinet1c.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Cann3.tga.tx						$INSTDIR\resource\textures\Ammo\Cann3.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Cann4.tga.tx						$INSTDIR\resource\textures\Ammo\Cann4.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\cave_3.tga.tx						$INSTDIR\resource\textures\Ammo\cave_3.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\checker.tga.tx						$INSTDIR\resource\textures\Ammo\checker.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\church1.tga.tx						$INSTDIR\resource\textures\Ammo\church1.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\church1Dam.tga.tx					$INSTDIR\resource\textures\Ammo\church1Dam.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\CITY_RADMOND.TGA.tx					$INSTDIR\resource\textures\Ammo\CITY_RADMOND.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\common1_1.tga.tx						$INSTDIR\resource\textures\Ammo\common1_1.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\dec2.tga.tx						$INSTDIR\resource\textures\Ammo\dec2.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\derevo.tga.tx						$INSTDIR\resource\textures\Ammo\derevo.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\detailWoodU1.tga.tx					$INSTDIR\resource\textures\Ammo\detailWoodU1.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\dfrigate.tga.tx						$INSTDIR\resource\textures\Ammo\dfrigate.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\dirtK2.tga.tx						$INSTDIR\resource\textures\Ammo\dirtK2.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\divider1c.tga.tx						$INSTDIR\resource\textures\Ammo\divider1c.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\doorLH.tga.tx						$INSTDIR\resource\textures\Ammo\doorLH.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\DoorSklad.tga.tx						$INSTDIR\resource\textures\Ammo\DoorSklad.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\doorU1.tga.tx						$INSTDIR\resource\textures\Ammo\doorU1.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\dorme.tga.tx						$INSTDIR\resource\textures\Ammo\dorme.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\duck.tga.tx						$INSTDIR\resource\textures\Ammo\duck.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\en2.tga.tx						$INSTDIR\resource\textures\Ammo\en2.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\eng_palace.tga.tx					$INSTDIR\resource\textures\Ammo\eng_palace.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\FALAISE_DE_FLEUR_TH_PALACE.TGA.tx			$INSTDIR\resource\textures\Ammo\FALAISE_DE_FLEUR_TH_PALACE.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Ferns.tga.tx						$INSTDIR\resource\textures\Ammo\Ferns.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\feuille.tga.tx						$INSTDIR\resource\textures\Ammo\feuille.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\ffpw.tga.tx						$INSTDIR\resource\textures\Ammo\ffpw.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Flaman_House.tga.tx					$INSTDIR\resource\textures\Ammo\Flaman_House.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\FontainTex1.tga.tx					$INSTDIR\resource\textures\Ammo\FontainTex1.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Foudation_Win_Door.tga.tx 				$INSTDIR\resource\textures\Ammo\Foudation_Win_Door.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Frying_p.tga.tx						$INSTDIR\resource\textures\Ammo\Frying_p.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\GOVNO.TGA.tx						$INSTDIR\resource\textures\Ammo\GOVNO.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\GRASSGREEN1.TGA.tx					$INSTDIR\resource\textures\Ammo\GRASSGREEN1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\GridsLSCInsides.tga.tx					$INSTDIR\resource\textures\Ammo\GridsLSCInsides.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\gunU5.tga.tx						$INSTDIR\resource\textures\Ammo\gunU5.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\House_Fra07.tga.tx					$INSTDIR\resource\textures\Ammo\House_Fra07.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\hut3.tga.tx						$INSTDIR\resource\textures\Ammo\hut3.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\IRONAMENT.TGA.tx						$INSTDIR\resource\textures\Ammo\IRONAMENT.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Items.tga.tx 						$INSTDIR\resource\textures\Ammo\Items.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\itemsLS2.tga.tx						$INSTDIR\resource\textures\Ammo\itemsLS2.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\jungle1.tga.tx						$INSTDIR\resource\textures\Ammo\jungle1.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\jungleU2.tga.tx						$INSTDIR\resource\textures\Ammo\jungleU2.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\keysim.tga.tx						$INSTDIR\resource\textures\Ammo\keysim.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\kocher.tga.tx						$INSTDIR\resource\textures\Ammo\kocher.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\LEAFPALMS.TGA.tx						$INSTDIR\resource\textures\Ammo\LEAFPALMS.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\lvbas.tga.tx						$INSTDIR\resource\textures\Ammo\lvbas.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\mahs051.tga.tx						$INSTDIR\resource\textures\Ammo\mahs051.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\map3c.tga.tx						$INSTDIR\resource\textures\Ammo\map3c.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\mastsU1.tga.tx						$INSTDIR\resource\textures\Ammo\mastsU1.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\MAYAK_PESOK01.TGA.tx					$INSTDIR\resource\textures\Ammo\MAYAK_PESOK01.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\MAYAK_PESOK02.TGA.tx					$INSTDIR\resource\textures\Ammo\MAYAK_PESOK02.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\mayak01.tga.tx						$INSTDIR\resource\textures\Ammo\mayak01.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\ME0.tga.tx						$INSTDIR\resource\textures\Ammo\ME0.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\metall.tga.tx 						$INSTDIR\resource\textures\Ammo\metall.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\N02b04.tga.tx						$INSTDIR\resource\textures\Ammo\N02b04.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\NavalCollege.tga.tx					$INSTDIR\resource\textures\Ammo\NavalCollege.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\objects_tex2.tga.tx					$INSTDIR\resource\textures\Ammo\objects_tex2.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\objects_tex2.tga.tx					$INSTDIR\resource\textures\Ammo\objects_tex2.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\objects_tex3.tga.tx					$INSTDIR\resource\textures\Ammo\objects_tex3.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\oxbay_brick.tga.tx					$INSTDIR\resource\textures\Ammo\oxbay_brick.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\planks.tga.tx						$INSTDIR\resource\textures\Ammo\planks.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\PORTUGAL_CHURCHE_TH.TGA.tx				$INSTDIR\resource\textures\Ammo\PORTUGAL_CHURCHE_TH.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Rammr.tga.tx						$INSTDIR\resource\textures\Ammo\Rammr.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Residence_5_inside.tga.tx				$INSTDIR\resource\textures\Ammo\Residence_5_inside.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\residence2_wd4.tga.tx					$INSTDIR\resource\textures\Ammo\residence2_wd4.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\residence2_wd6.tga.tx					$INSTDIR\resource\textures\Ammo\residence2_wd6.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\rockK4.tga.tx						$INSTDIR\resource\textures\Ammo\rockK4.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Roof_All.tga.tx						$INSTDIR\resource\textures\Ammo\Roof_All.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\ropJRH.tga.tx						$INSTDIR\resource\textures\Ammo\ropJRH.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\rsd_1.tga.tx						$INSTDIR\resource\textures\Ammo\rsd_1.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\sailDeckU1.tga.tx					$INSTDIR\resource\textures\Ammo\sailDeckU1.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\ShipDCLSU2.tga.tx					$INSTDIR\resource\textures\Ammo\ShipDCLSU2.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\ShipDCLSU3.tga.tx					$INSTDIR\resource\textures\Ammo\ShipDCLSU3.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\ShipNCLSU1.tga.tx					$INSTDIR\resource\textures\Ammo\ShipNCLSU1.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\ShipNCLSU2.tga.tx					$INSTDIR\resource\textures\Ammo\ShipNCLSU2.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\ShipNCLSU3.tga.tx					$INSTDIR\resource\textures\Ammo\ShipNCLSU3.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Shipyard1.tga.tx						$INSTDIR\resource\textures\Ammo\Shipyard1.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\sib_jun_hos.tga.tx					$INSTDIR\resource\textures\Ammo\sib_jun_hos.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\SKALA_JUNGLE.TGA.tx					$INSTDIR\resource\textures\Ammo\SKALA_JUNGLE.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\skala_jungle1.tga.tx					$INSTDIR\resource\textures\Ammo\skala_jungle1.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Skel2.tga.tx						$INSTDIR\resource\textures\Ammo\Skel2.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\spain_pesok.tga.tx					$INSTDIR\resource\textures\Ammo\spain_pesok.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\SQUERE_256.TGA.tx					$INSTDIR\resource\textures\Ammo\SQUERE_256.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\StoneH1.tga.tx						$INSTDIR\resource\textures\Ammo\StoneH1.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\t_house_01.tga.tx					$INSTDIR\resource\textures\Ammo\t_house_01.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\t_house_02.tga.tx					$INSTDIR\resource\textures\Ammo\t_house_02.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\town_objects_tex1.tga.tx					$INSTDIR\resource\textures\Ammo\town_objects_tex1.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Town_Stuff.tga.tx					$INSTDIR\resource\textures\Ammo\Town_Stuff.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\treePalms.tga.tx						$INSTDIR\resource\textures\Ammo\treePalms.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\TROPA256.TGA.tx						$INSTDIR\resource\textures\Ammo\TROPA256.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\WALK_256.TGA.tx						$INSTDIR\resource\textures\Ammo\WALK_256.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\WALKL_256.TGA.tx						$INSTDIR\resource\textures\Ammo\WALKL_256.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\WALKR_256.TGA.tx						$INSTDIR\resource\textures\Ammo\WALKR_256.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\WALL_1_512.TGA.tx					$INSTDIR\resource\textures\Ammo\WALL_1_512.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\WALL_2_512.TGA.tx					$INSTDIR\resource\textures\Ammo\WALL_2_512.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\wall_list_01.tga.tx					$INSTDIR\resource\textures\Ammo\wall_list_01.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\wall_list_fra_01.tga.tx					$INSTDIR\resource\textures\Ammo\wall_list_fra_01.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\WareHouse.tga.tx						$INSTDIR\resource\textures\Ammo\WareHouse.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Weapon_Set_1.tga.tx					$INSTDIR\resource\textures\Ammo\Weapon_Set_1.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\windbardel.tga.tx					$INSTDIR\resource\textures\Ammo\windbardel.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\windbrothel.tga.tx					$INSTDIR\resource\textures\Ammo\windbrothel.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Windmill.tga.tx						$INSTDIR\resource\textures\Ammo\Windmill.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\WindmillDam.tga.tx					$INSTDIR\resource\textures\Ammo\WindmillDam.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\WindmillFan.tga.tx					$INSTDIR\resource\textures\Ammo\WindmillFan.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\wood_all.tga.tx						$INSTDIR\resource\textures\Ammo\wood_all.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\woodburn.tga.tx						$INSTDIR\resource\textures\Ammo\woodburn.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\woodOldU1.tga.tx						$INSTDIR\resource\textures\Ammo\woodOldU1.tga.tx

  ; Copy Item texture files
  CopyFiles /SILENT $INSTDIR\resource\textures\keysim.tga.tx 						$INSTDIR\resource\textures\Items\keysim.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\map3c.tga.tx 						$INSTDIR\resource\textures\Items\map3c.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\ropJRH.tga.tx 						$INSTDIR\resource\textures\Items\ropJRH.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\town_objects_tex1.tga.tx 				$INSTDIR\resource\textures\Items\town_objects_tex1.tga.tx

  CopyFiles /SILENT $INSTDIR\resource\textures\Ammo\bla641.tga.tx 					$INSTDIR\resource\textures\Items\bla641.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Ammo\fish_01.tga.tx 					$INSTDIR\resource\textures\Items\fish_01.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Ammo\itemsLSC.tga.tx 					$INSTDIR\resource\textures\Items\itemsLSC.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Ammo\mdch_F1.tga.tx 					$INSTDIR\resource\textures\Items\mdch_F1.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Ammo\mdch_F2.tga.tx 					$INSTDIR\resource\textures\Items\mdch_F2.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Ammo\mdch_F4.tga.tx 					$INSTDIR\resource\textures\Items\mdch_F4.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Ammo\mgphone.tga.tx 					$INSTDIR\resource\textures\Items\mgphone.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Ammo\musket.tga.tx 					$INSTDIR\resource\textures\Items\musket.tga.tx
  CopyFiles /SILENT "$INSTDIR\resource\textures\Ammo\sib_stuff food.tga.tx"				"$INSTDIR\resource\textures\Items\sib_stuff food.tga.tx"
  CopyFiles /SILENT $INSTDIR\resource\textures\Ammo\spygla5.tga.tx 					$INSTDIR\resource\textures\Items\spygla5.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Ammo\surgkit.tga.tx					$INSTDIR\resource\textures\Items\surgkit.tga.tx

  ; Copy location texture files
  CopyFiles /SILENT $INSTDIR\resource\textures\cap_deck_glass.tga.tx 					$INSTDIR\resource\textures\Locations\decks\BlackPearl\cap_deck_glass.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\stones2.tga.tx 						$INSTDIR\resource\textures\Locations\decks\BlackPearl\stones2.tga.tx

  CopyFiles /SILENT "$INSTDIR\resource\textures\BRCK48L COPY.TGA.tx" 					"$INSTDIR\resource\textures\Locations\ENGLAND\BRCK48L COPY.TGA.tx"
  CopyFiles /SILENT "$INSTDIR\resource\textures\Grass022 copy.TGA.tx" 					"$INSTDIR\resource\textures\Locations\ENGLAND\Grass022 copy.TGA.tx"
  CopyFiles /SILENT "$INSTDIR\resource\textures\sib_stuff cop0.tga.tx"					"$INSTDIR\resource\textures\Locations\ENGLAND\sib_stuff cop0.tga.tx"
  CopyFiles /SILENT "$INSTDIR\resource\textures\sib_stuff cop2.tga.tx"					"$INSTDIR\resource\textures\Locations\ENGLAND\sib_stuff cop2.tga.tx"
  CopyFiles /SILENT "$INSTDIR\resource\textures\sib_stuff copy.tga.tx"					"$INSTDIR\resource\textures\Locations\ENGLAND\sib_stuff copy.tga.tx"
  CopyFiles /SILENT $INSTDIR\resource\textures\back_JUNGLE.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\back_JUNGLE.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\back_MOUNTAINS.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\back_MOUNTAINS.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\BACK_PLANTS.TGA.tx					$INSTDIR\resource\textures\Locations\ENGLAND\BACK_PLANTS.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\back4.TGA.tx 						$INSTDIR\resource\textures\Locations\ENGLAND\back4.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\back6.TGA.tx 						$INSTDIR\resource\textures\Locations\ENGLAND\back6.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\BARRACKS.TGA.tx 						$INSTDIR\resource\textures\Locations\ENGLAND\BARRACKS.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\BORTOUTTARTANE1.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\BORTOUTTARTANE1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\BUMP_LAND.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\BUMP_LAND.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\church.TGA.tx 						$INSTDIR\resource\textures\Locations\ENGLAND\church.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\CONCEISAO_ROCKS.TGA.tx					$INSTDIR\resource\textures\Locations\ENGLAND\CONCEISAO_ROCKS.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\CORALL3_256.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\CORALL3_256.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\CORALL5_256.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\CORALL5_256.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\DECK.tga.tx 						$INSTDIR\resource\textures\Locations\ENGLAND\DECK.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\dutch_palace.tga.tx					$INSTDIR\resource\textures\Locations\ENGLAND\dutch_palace.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\eng_palace.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\eng_palace.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Eng_Signs.tga.tx						$INSTDIR\resource\textures\Locations\ENGLAND\Eng_Signs.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\FALAISE_DE_FLEUR_TH_PALACE.TGA.tx 			$INSTDIR\resource\textures\Locations\ENGLAND\FALAISE_DE_FLEUR_TH_PALACE.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\FALAISE_DE_FLEUR_TH_PALACE02.TGA.tx 			$INSTDIR\resource\textures\Locations\ENGLAND\FALAISE_DE_FLEUR_TH_PALACE02.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Falaise_refl.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\Falaise_refl.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\FalDeFL_P0.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\FalDeFL_P0.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\FalDeFL_P0_02.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\FalDeFL_P0_02.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\FalDeFL_P1.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\FalDeFL_P1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\FFP_SAND.TGA.tx 						$INSTDIR\resource\textures\Locations\ENGLAND\FFP_SAND.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\FFP2ROCK.TGA.tx 						$INSTDIR\resource\textures\Locations\ENGLAND\FFP2ROCK.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Flore1_512.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\Flore1_512.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Flore11.tga.tx						$INSTDIR\resource\textures\Locations\ENGLAND\Flore11.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Flore2_512.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\Flore2_512.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Flore3a_512.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\Flore3a_512.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Flore4_512.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\Flore4_512.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\fonar.TGA.tx 						$INSTDIR\resource\textures\Locations\ENGLAND\fonar.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\fonar_day.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\fonar_day.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\fonar_night.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\fonar_night.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\fonar_noactive.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\fonar_noactive.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\fort_inside_other.TGA.tx 				$INSTDIR\resource\textures\Locations\ENGLAND\fort_inside_other.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\fort_inside_stuff.TGA.tx 				$INSTDIR\resource\textures\Locations\ENGLAND\fort_inside_stuff.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Foudation_Win_Door.TGA.tx 				$INSTDIR\resource\textures\Locations\ENGLAND\Foudation_Win_Door.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Fra_Signs.tga.tx						$INSTDIR\resource\textures\Locations\ENGLAND\Fra_Signs.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\govno.TGA.tx 						$INSTDIR\resource\textures\Locations\ENGLAND\govno.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\grassgreen1.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\grassgreen1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\gray.TGA.tx 						$INSTDIR\resource\textures\Locations\ENGLAND\gray.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\greenf.tga.tx						$INSTDIR\resource\textures\Locations\ENGLAND\greenf.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\GREENF.TGA.tx 						$INSTDIR\resource\textures\Locations\ENGLAND\GREENF.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\grey.TGA.tx						$INSTDIR\resource\textures\Locations\ENGLAND\grey.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Hisp_Signs.tga.tx					$INSTDIR\resource\textures\Locations\ENGLAND\Hisp_Signs.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\IRONAMENT.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\IRONAMENT.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Isla_Muelle_4_BG.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\Isla_Muelle_4_BG.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Isla_Muelle_BG.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\Isla_Muelle_BG.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\IslaMuelle_refl.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\IslaMuelle_refl.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island.TGA.tx 						$INSTDIR\resource\textures\Locations\ENGLAND\Island.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island_all_sm.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\Island_all_sm.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island_conceicao.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\Island_conceicao.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island_Falaise_de_Fleur.TGA.tx 				$INSTDIR\resource\textures\Locations\ENGLAND\Island_Falaise_de_Fleur.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island_Gaity.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\Island_Gaity.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island_Khael_Roa.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\Island_Khael_Roa.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island_Khael_Roa_incas.TGA.tx 				$INSTDIR\resource\textures\Locations\ENGLAND\Island_Khael_Roa_incas.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island_Oxbay.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\Island_Oxbay.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island_Quebralas_Costilla2.TGA.tx 			$INSTDIR\resource\textures\Locations\ENGLAND\Island_Quebralas_Costilla2.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island_Quebralas_Costilla3.TGA.tx 			$INSTDIR\resource\textures\Locations\ENGLAND\Island_Quebralas_Costilla3.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island_Quebralas_Costillas.TGA.tx 			$INSTDIR\resource\textures\Locations\ENGLAND\Island_Quebralas_Costillas.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island_Redmond.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\Island_Redmond.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\ITEMS.TGA.tx 						$INSTDIR\resource\textures\Locations\ENGLAND\ITEMS.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\KhaelRoa_refl.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\KhaelRoa_refl.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\kora.TGA.tx 						$INSTDIR\resource\textures\Locations\ENGLAND\kora.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\kora_1.TGA.tx 						$INSTDIR\resource\textures\Locations\ENGLAND\kora_1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\kora_2.TGA.tx 						$INSTDIR\resource\textures\Locations\ENGLAND\kora_2.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\kora_3.TGA.tx 						$INSTDIR\resource\textures\Locations\ENGLAND\kora_3.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\kora_4.TGA.tx 						$INSTDIR\resource\textures\Locations\ENGLAND\kora_4.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\leafPalms.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\leafPalms.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Leaves.TGA.tx 						$INSTDIR\resource\textures\Locations\ENGLAND\Leaves.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Leaves1.TGA.tx 						$INSTDIR\resource\textures\Locations\ENGLAND\Leaves1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\MAYAK01.TGA.tx 						$INSTDIR\resource\textures\Locations\ENGLAND\MAYAK01.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\NAVALCOLLEGE.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\NAVALCOLLEGE.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\New_Mountain.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\New_Mountain.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\oxbay_brick.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\oxbay_brick.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\oxbay_refl.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\oxbay_refl.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\oxbay_rocks.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\oxbay_rocks.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\oxbay_tile.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\oxbay_tile.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Port_Radmond.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\Port_Radmond.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Portugal_Churche_th.TGA.tx 				$INSTDIR\resource\textures\Locations\ENGLAND\Portugal_Churche_th.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\River.TGA.tx 						$INSTDIR\resource\textures\Locations\ENGLAND\River.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\River_Caustik.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\River_Caustik.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\River_top.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\River_top.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\River_top1.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\River_top1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\River1.TGA.tx 						$INSTDIR\resource\textures\Locations\ENGLAND\River1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\RIVER2.TGA.tx 						$INSTDIR\resource\textures\Locations\ENGLAND\RIVER2.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\rockground1.tga.tx					$INSTDIR\resource\textures\Locations\ENGLAND\rockground1.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Sand_D_256.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\Sand_D_256.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\SAND_D_256_SVET.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\SAND_D_256_SVET.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Sand_L_256.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\Sand_L_256.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Sand_L_256_svet.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\Sand_L_256_svet.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Sand_L1_256.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\Sand_L1_256.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\SandGrassR1.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\SandGrassR1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Sandground2.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\Sandground2.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Sandtile.TGA.tx 						$INSTDIR\resource\textures\Locations\ENGLAND\Sandtile.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\seaTile.TGA.tx 						$INSTDIR\resource\textures\Locations\ENGLAND\seaTile.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\SHIPYARD3.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\SHIPYARD3.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\SIB_JUN_HOS.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\SIB_JUN_HOS.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\SKALA_JUNGLE.TGA.tx					$INSTDIR\resource\textures\Locations\ENGLAND\SKALA_JUNGLE.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\skala_jungle1.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\skala_jungle1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\skala_jungle2.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\skala_jungle2.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\skala_jungle3.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\skala_jungle3.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\skala_jungle6.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\skala_jungle6.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\skala_jungle8.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\skala_jungle8.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\skala_jungleDEX.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\skala_jungleDEX.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\spa_palace1.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\spa_palace1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\spain_pesok.tga.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\spain_pesok.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\SQUERE_256.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\SQUERE_256.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\STONES1.TGA.tx 						$INSTDIR\resource\textures\Locations\ENGLAND\STONES1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Tree.TGA.tx 						$INSTDIR\resource\textures\Locations\ENGLAND\Tree.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Tree1.TGA.tx 						$INSTDIR\resource\textures\Locations\ENGLAND\Tree1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\treePalms.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\treePalms.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Trees.TGA.tx 						$INSTDIR\resource\textures\Locations\ENGLAND\Trees.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\TROPA256.TGA.tx 						$INSTDIR\resource\textures\Locations\ENGLAND\TROPA256.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\tropa256_1.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\tropa256_1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\walk_256.TGA.tx 						$INSTDIR\resource\textures\Locations\ENGLAND\walk_256.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\walkL_256.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\walkL_256.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\walkR_256.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\walkR_256.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\wall_1_512.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\wall_1_512.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\wall_2_512.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\wall_2_512.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\WAREHOUSE.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\WAREHOUSE.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\WaterFall.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\WaterFall.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\WaterFall2.TGA.tx 					$INSTDIR\resource\textures\Locations\ENGLAND\WaterFall2.TGA.tx

  CopyFiles /SILENT "$INSTDIR\resource\textures\BRCK48L COPY.TGA.tx" 					"$INSTDIR\resource\textures\Locations\FRANCE\BRCK48L COPY.TGA.tx"
  CopyFiles /SILENT "$INSTDIR\resource\textures\Grass022 copy.TGA.tx" 					"$INSTDIR\resource\textures\Locations\FRANCE\Grass022 copy.TGA.tx"
  CopyFiles /SILENT "$INSTDIR\resource\textures\sib_stuff cop0.tga.tx"					"$INSTDIR\resource\textures\Locations\FRANCE\sib_stuff cop0.tga.tx"
  CopyFiles /SILENT "$INSTDIR\resource\textures\sib_stuff cop2.tga.tx"					"$INSTDIR\resource\textures\Locations\FRANCE\sib_stuff cop2.tga.tx"
  CopyFiles /SILENT "$INSTDIR\resource\textures\sib_stuff copy.tga.tx"					"$INSTDIR\resource\textures\Locations\FRANCE\sib_stuff copy.tga.tx"
  CopyFiles /SILENT $INSTDIR\resource\textures\back_JUNGLE.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\back_JUNGLE.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\back_MOUNTAINS.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\back_MOUNTAINS.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\BACK_PLANTS.TGA.tx					$INSTDIR\resource\textures\Locations\FRANCE\BACK_PLANTS.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\back4.TGA.tx 						$INSTDIR\resource\textures\Locations\FRANCE\back4.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\back6.TGA.tx 						$INSTDIR\resource\textures\Locations\FRANCE\back6.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\BARRACKS.TGA.tx 						$INSTDIR\resource\textures\Locations\FRANCE\BARRACKS.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\BORTOUTTARTANE1.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\BORTOUTTARTANE1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\BUMP_LAND.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\BUMP_LAND.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\church.TGA.tx 						$INSTDIR\resource\textures\Locations\FRANCE\church.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\City_Radmond.tga.tx					$INSTDIR\resource\textures\Locations\FRANCE\City_Radmond.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\CONCEISAO_ROCKS.TGA.tx					$INSTDIR\resource\textures\Locations\FRANCE\CONCEISAO_ROCKS.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\CORALL3_256.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\CORALL3_256.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\CORALL5_256.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\CORALL5_256.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\DECK.tga.tx 						$INSTDIR\resource\textures\Locations\FRANCE\DECK.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\dutch_palace.tga.tx					$INSTDIR\resource\textures\Locations\FRANCE\dutch_palace.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\eng_palace.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\eng_palace.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\FALAISE_DE_FLEUR_TH_PALACE.TGA.tx 			$INSTDIR\resource\textures\Locations\FRANCE\FALAISE_DE_FLEUR_TH_PALACE.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\FALAISE_DE_FLEUR_TH_PALACE02.TGA.tx 			$INSTDIR\resource\textures\Locations\FRANCE\FALAISE_DE_FLEUR_TH_PALACE02.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Falaise_refl.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\Falaise_refl.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\FalDeFL_P0.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\FalDeFL_P0.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\FalDeFL_P0_02.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\FalDeFL_P0_02.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\FalDeFL_P1.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\FalDeFL_P1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\FFP_SAND.TGA.tx 						$INSTDIR\resource\textures\Locations\FRANCE\FFP_SAND.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\FFP2ROCK.TGA.tx 						$INSTDIR\resource\textures\Locations\FRANCE\FFP2ROCK.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\ffpw.tga.tx 						$INSTDIR\resource\textures\Locations\FRANCE\ffpw.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Flore1_512.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\Flore1_512.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Flore11.tga.tx						$INSTDIR\resource\textures\Locations\FRANCE\Flore11.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Flore2_512.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\Flore2_512.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Flore3a_512.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\Flore3a_512.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Flore4_512.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\Flore4_512.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\fonar.TGA.tx 						$INSTDIR\resource\textures\Locations\FRANCE\fonar.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\fonar_day.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\fonar_day.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\fonar_night.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\fonar_night.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\fonar_noactive.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\fonar_noactive.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\fort_inside_other.TGA.tx 				$INSTDIR\resource\textures\Locations\FRANCE\fort_inside_other.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\fort_inside_stuff.TGA.tx 				$INSTDIR\resource\textures\Locations\FRANCE\fort_inside_stuff.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Foudation_Win_Door.TGA.tx 				$INSTDIR\resource\textures\Locations\FRANCE\Foudation_Win_Door.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Fra_Signs.tga.tx						$INSTDIR\resource\textures\Locations\FRANCE\Fra_Signs.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\govno.TGA.tx 						$INSTDIR\resource\textures\Locations\FRANCE\govno.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\grassgreen1.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\grassgreen1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\gray.TGA.tx 						$INSTDIR\resource\textures\Locations\FRANCE\gray.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\greenf.tga.tx						$INSTDIR\resource\textures\Locations\FRANCE\greenf.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\GREENF.TGA.tx 						$INSTDIR\resource\textures\Locations\FRANCE\GREENF.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\grey.TGA.tx						$INSTDIR\resource\textures\Locations\FRANCE\grey.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\IRONAMENT.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\IRONAMENT.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Isla_Muelle_4_BG.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\Isla_Muelle_4_BG.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Isla_Muelle_BG.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\Isla_Muelle_BG.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\IslaMuelle_refl.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\IslaMuelle_refl.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island.TGA.tx 						$INSTDIR\resource\textures\Locations\FRANCE\Island.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island_all_sm.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\Island_all_sm.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island_conceicao.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\Island_conceicao.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island_Falaise_de_Fleur.TGA.tx 				$INSTDIR\resource\textures\Locations\FRANCE\Island_Falaise_de_Fleur.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island_Gaity.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\Island_Gaity.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island_Khael_Roa.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\Island_Khael_Roa.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island_Khael_Roa_incas.TGA.tx 				$INSTDIR\resource\textures\Locations\FRANCE\Island_Khael_Roa_incas.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island_Oxbay.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\Island_Oxbay.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island_Quebralas_Costilla2.TGA.tx 			$INSTDIR\resource\textures\Locations\FRANCE\Island_Quebralas_Costilla2.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island_Quebralas_Costilla3.TGA.tx 			$INSTDIR\resource\textures\Locations\FRANCE\Island_Quebralas_Costilla3.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island_Quebralas_Costillas.TGA.tx 			$INSTDIR\resource\textures\Locations\FRANCE\Island_Quebralas_Costillas.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island_Redmond.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\Island_Redmond.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\ITEMS.TGA.tx 						$INSTDIR\resource\textures\Locations\FRANCE\ITEMS.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\KhaelRoa_refl.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\KhaelRoa_refl.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\kora.TGA.tx 						$INSTDIR\resource\textures\Locations\FRANCE\kora.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\kora_1.TGA.tx 						$INSTDIR\resource\textures\Locations\FRANCE\kora_1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\kora_2.TGA.tx 						$INSTDIR\resource\textures\Locations\FRANCE\kora_2.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\kora_3.TGA.tx 						$INSTDIR\resource\textures\Locations\FRANCE\kora_3.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\kora_4.TGA.tx 						$INSTDIR\resource\textures\Locations\FRANCE\kora_4.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\leafPalms.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\leafPalms.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Leaves.TGA.tx 						$INSTDIR\resource\textures\Locations\FRANCE\Leaves.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Leaves1.TGA.tx 						$INSTDIR\resource\textures\Locations\FRANCE\Leaves1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\MAYAK01.TGA.tx 						$INSTDIR\resource\textures\Locations\FRANCE\MAYAK01.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\NAVALCOLLEGE.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\NAVALCOLLEGE.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\New_Mountain.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\New_Mountain.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\oxbay_brick.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\oxbay_brick.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\oxbay_refl.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\oxbay_refl.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\oxbay_rocks.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\oxbay_rocks.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\oxbay_tile.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\oxbay_tile.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Port_Radmond.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\Port_Radmond.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Portugal_Signs.tga.tx					$INSTDIR\resource\textures\Locations\FRANCE\Portugal_Signs.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\River.TGA.tx 						$INSTDIR\resource\textures\Locations\FRANCE\River.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\River_Caustik.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\River_Caustik.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\River_top.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\River_top.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\River_top1.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\River_top1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\River1.TGA.tx 						$INSTDIR\resource\textures\Locations\FRANCE\River1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\RIVER2.TGA.tx 						$INSTDIR\resource\textures\Locations\FRANCE\RIVER2.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\rockground1.tga.tx					$INSTDIR\resource\textures\Locations\FRANCE\rockground1.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Roof_All.tga.tx 						$INSTDIR\resource\textures\Locations\FRANCE\Roof_All.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Sand_D_256.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\Sand_D_256.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\SAND_D_256_SVET.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\SAND_D_256_SVET.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Sand_L_256.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\Sand_L_256.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Sand_L_256_svet.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\Sand_L_256_svet.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Sand_L1_256.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\Sand_L1_256.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\SandGrassR1.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\SandGrassR1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Sandground2.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\Sandground2.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Sandtile.TGA.tx 						$INSTDIR\resource\textures\Locations\FRANCE\Sandtile.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\seaTile.TGA.tx 						$INSTDIR\resource\textures\Locations\FRANCE\seaTile.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\SHIPYARD3.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\SHIPYARD3.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\SIB_JUN_HOS.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\SIB_JUN_HOS.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\SKALA_JUNGLE.TGA.tx					$INSTDIR\resource\textures\Locations\FRANCE\SKALA_JUNGLE.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\skala_jungle1.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\skala_jungle1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\skala_jungle2.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\skala_jungle2.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\skala_jungle3.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\skala_jungle3.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\skala_jungle6.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\skala_jungle6.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\skala_jungle8.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\skala_jungle8.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\skala_jungleDEX.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\skala_jungleDEX.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\spa_palace1.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\spa_palace1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\spain_pesok.tga.tx 					$INSTDIR\resource\textures\Locations\FRANCE\spain_pesok.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\SQUERE_256.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\SQUERE_256.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\STONES1.TGA.tx 						$INSTDIR\resource\textures\Locations\FRANCE\STONES1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Tree.TGA.tx 						$INSTDIR\resource\textures\Locations\FRANCE\Tree.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Tree1.TGA.tx 						$INSTDIR\resource\textures\Locations\FRANCE\Tree1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\treePalms.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\treePalms.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Trees.TGA.tx 						$INSTDIR\resource\textures\Locations\FRANCE\Trees.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\TROPA256.TGA.tx 						$INSTDIR\resource\textures\Locations\FRANCE\TROPA256.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\tropa256_1.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\tropa256_1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\walk_256.TGA.tx 						$INSTDIR\resource\textures\Locations\FRANCE\walk_256.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\walkL_256.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\walkL_256.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\walkR_256.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\walkR_256.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\wall_2_512.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\wall_2_512.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\wall_list_spa_01.tga.tx					$INSTDIR\resource\textures\Locations\FRANCE\wall_list_spa_01.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\WAREHOUSE.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\WAREHOUSE.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\WaterFall.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\WaterFall.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\WaterFall2.TGA.tx 					$INSTDIR\resource\textures\Locations\FRANCE\WaterFall2.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\wood_all.tga.tx 						$INSTDIR\resource\textures\Locations\FRANCE\wood_all.tga.tx

  CopyFiles /SILENT "$INSTDIR\resource\textures\BRCK48L COPY.TGA.tx" 					"$INSTDIR\resource\textures\Locations\HOLLAND\BRCK48L COPY.TGA.tx"
  CopyFiles /SILENT "$INSTDIR\resource\textures\Grass022 copy.TGA.tx" 					"$INSTDIR\resource\textures\Locations\HOLLAND\Grass022 copy.TGA.tx"
  CopyFiles /SILENT "$INSTDIR\resource\textures\sib_stuff cop0.tga.tx"					"$INSTDIR\resource\textures\Locations\HOLLAND\sib_stuff cop0.tga.tx"
  CopyFiles /SILENT "$INSTDIR\resource\textures\sib_stuff cop2.tga.tx"					"$INSTDIR\resource\textures\Locations\HOLLAND\sib_stuff cop2.tga.tx"
  CopyFiles /SILENT "$INSTDIR\resource\textures\sib_stuff copy.tga.tx"					"$INSTDIR\resource\textures\Locations\HOLLAND\sib_stuff copy.tga.tx"
  CopyFiles /SILENT $INSTDIR\resource\textures\back_JUNGLE.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\back_JUNGLE.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\back_MOUNTAINS.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\back_MOUNTAINS.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\BACK_PLANTS.TGA.tx					$INSTDIR\resource\textures\Locations\HOLLAND\BACK_PLANTS.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\back4.TGA.tx 						$INSTDIR\resource\textures\Locations\HOLLAND\back4.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\back6.TGA.tx 						$INSTDIR\resource\textures\Locations\HOLLAND\back6.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\BARRACKS.TGA.tx 						$INSTDIR\resource\textures\Locations\HOLLAND\BARRACKS.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\BORTOUTTARTANE1.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\BORTOUTTARTANE1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\BUMP_LAND.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\BUMP_LAND.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\church.TGA.tx 						$INSTDIR\resource\textures\Locations\HOLLAND\church.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\City_Radmond.tga.tx					$INSTDIR\resource\textures\Locations\HOLLAND\City_Radmond.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\CONCEISAO_ROCKS.TGA.tx					$INSTDIR\resource\textures\Locations\HOLLAND\CONCEISAO_ROCKS.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\CORALL3_256.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\CORALL3_256.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\CORALL5_256.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\CORALL5_256.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\DECK.tga.tx 						$INSTDIR\resource\textures\Locations\HOLLAND\DECK.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\eng_palace.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\eng_palace.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Eng_Signs.tga.tx						$INSTDIR\resource\textures\Locations\HOLLAND\Eng_Signs.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\FALAISE_DE_FLEUR_TH_PALACE.TGA.tx 			$INSTDIR\resource\textures\Locations\HOLLAND\FALAISE_DE_FLEUR_TH_PALACE.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\FALAISE_DE_FLEUR_TH_PALACE02.TGA.tx 			$INSTDIR\resource\textures\Locations\HOLLAND\FALAISE_DE_FLEUR_TH_PALACE02.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Falaise_refl.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\Falaise_refl.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\FalDeFL_P0.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\FalDeFL_P0.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\FalDeFL_P0_02.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\FalDeFL_P0_02.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\FalDeFL_P1.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\FalDeFL_P1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\FFP_SAND.TGA.tx 						$INSTDIR\resource\textures\Locations\HOLLAND\FFP_SAND.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\FFP2ROCK.TGA.tx 						$INSTDIR\resource\textures\Locations\HOLLAND\FFP2ROCK.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Flore1_512.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\Flore1_512.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Flore2_512.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\Flore2_512.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Flore3a_512.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\Flore3a_512.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Flore4_512.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\Flore4_512.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\fonar.TGA.tx 						$INSTDIR\resource\textures\Locations\HOLLAND\fonar.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\fonar_day.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\fonar_day.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\fonar_night.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\fonar_night.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\fonar_noactive.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\fonar_noactive.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\fort_inside_other.TGA.tx 				$INSTDIR\resource\textures\Locations\HOLLAND\fort_inside_other.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\fort_inside_stuff.TGA.tx 				$INSTDIR\resource\textures\Locations\HOLLAND\fort_inside_stuff.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\govno.TGA.tx 						$INSTDIR\resource\textures\Locations\HOLLAND\govno.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\grassgreen1.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\grassgreen1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\gray.TGA.tx 						$INSTDIR\resource\textures\Locations\HOLLAND\gray.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\greenf.tga.tx						$INSTDIR\resource\textures\Locations\HOLLAND\greenf.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\GREENF.TGA.tx 						$INSTDIR\resource\textures\Locations\HOLLAND\GREENF.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\grey.TGA.tx						$INSTDIR\resource\textures\Locations\HOLLAND\grey.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Hol_Signs.tga.tx						$INSTDIR\resource\textures\Locations\HOLLAND\Hol_Signs.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\IRONAMENT.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\IRONAMENT.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Isla_Muelle_4_BG.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\Isla_Muelle_4_BG.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Isla_Muelle_BG.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\Isla_Muelle_BG.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\IslaMuelle_refl.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\IslaMuelle_refl.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island.TGA.tx 						$INSTDIR\resource\textures\Locations\HOLLAND\Island.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island_all_sm.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\Island_all_sm.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island_conceicao.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\Island_conceicao.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island_Falaise_de_Fleur.TGA.tx 				$INSTDIR\resource\textures\Locations\HOLLAND\Island_Falaise_de_Fleur.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island_Gaity.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\Island_Gaity.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island_Khael_Roa.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\Island_Khael_Roa.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island_Khael_Roa_incas.TGA.tx 				$INSTDIR\resource\textures\Locations\HOLLAND\Island_Khael_Roa_incas.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island_Oxbay.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\Island_Oxbay.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island_Quebralas_Costilla2.TGA.tx 			$INSTDIR\resource\textures\Locations\HOLLAND\Island_Quebralas_Costilla2.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island_Quebralas_Costilla3.TGA.tx 			$INSTDIR\resource\textures\Locations\HOLLAND\Island_Quebralas_Costilla3.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island_Quebralas_Costillas.TGA.tx 			$INSTDIR\resource\textures\Locations\HOLLAND\Island_Quebralas_Costillas.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island_Redmond.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\Island_Redmond.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\ITEMS.TGA.tx 						$INSTDIR\resource\textures\Locations\HOLLAND\ITEMS.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\KhaelRoa_refl.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\KhaelRoa_refl.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\kora.TGA.tx 						$INSTDIR\resource\textures\Locations\HOLLAND\kora.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\kora_1.TGA.tx 						$INSTDIR\resource\textures\Locations\HOLLAND\kora_1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\kora_2.TGA.tx 						$INSTDIR\resource\textures\Locations\HOLLAND\kora_2.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\kora_3.TGA.tx 						$INSTDIR\resource\textures\Locations\HOLLAND\kora_3.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\kora_4.TGA.tx 						$INSTDIR\resource\textures\Locations\HOLLAND\kora_4.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\leafPalms.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\leafPalms.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Leaves.TGA.tx 						$INSTDIR\resource\textures\Locations\HOLLAND\Leaves.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Leaves1.TGA.tx 						$INSTDIR\resource\textures\Locations\HOLLAND\Leaves1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\MAYAK01.TGA.tx 						$INSTDIR\resource\textures\Locations\HOLLAND\MAYAK01.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\NAVALCOLLEGE.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\NAVALCOLLEGE.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\New_Mountain.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\New_Mountain.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\oxbay_brick.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\oxbay_brick.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\oxbay_refl.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\oxbay_refl.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\oxbay_rocks.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\oxbay_rocks.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\oxbay_tile.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\oxbay_tile.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Port_Radmond.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\Port_Radmond.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\River.TGA.tx 						$INSTDIR\resource\textures\Locations\HOLLAND\River.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\River_Caustik.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\River_Caustik.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\River_top.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\River_top.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\River_top1.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\River_top1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\River1.TGA.tx 						$INSTDIR\resource\textures\Locations\HOLLAND\River1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\RIVER2.TGA.tx 						$INSTDIR\resource\textures\Locations\HOLLAND\RIVER2.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\rockground1.tga.tx					$INSTDIR\resource\textures\Locations\HOLLAND\rockground1.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Sand_D_256.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\Sand_D_256.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\SAND_D_256_SVET.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\SAND_D_256_SVET.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Sand_L_256.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\Sand_L_256.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Sand_L_256_svet.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\Sand_L_256_svet.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Sand_L1_256.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\Sand_L1_256.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\SandGrassR1.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\SandGrassR1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Sandground2.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\Sandground2.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Sandtile.TGA.tx 						$INSTDIR\resource\textures\Locations\HOLLAND\Sandtile.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\seaTile.TGA.tx 						$INSTDIR\resource\textures\Locations\HOLLAND\seaTile.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\SHIPYARD3.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\SHIPYARD3.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\SIB_JUN_HOS.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\SIB_JUN_HOS.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\SKALA_JUNGLE.TGA.tx					$INSTDIR\resource\textures\Locations\HOLLAND\SKALA_JUNGLE.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\skala_jungle1.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\skala_jungle1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\skala_jungle2.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\skala_jungle2.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\skala_jungle3.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\skala_jungle3.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\skala_jungle6.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\skala_jungle6.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\skala_jungle8.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\skala_jungle8.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\skala_jungleDEX.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\skala_jungleDEX.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\spa_palace1.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\spa_palace1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\spain_pesok.tga.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\spain_pesok.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\SQUERE_256.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\SQUERE_256.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\STONES1.TGA.tx 						$INSTDIR\resource\textures\Locations\HOLLAND\STONES1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Tree.TGA.tx 						$INSTDIR\resource\textures\Locations\HOLLAND\Tree.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Tree1.TGA.tx 						$INSTDIR\resource\textures\Locations\HOLLAND\Tree1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\treePalms.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\treePalms.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Trees.TGA.tx 						$INSTDIR\resource\textures\Locations\HOLLAND\Trees.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\TROPA256.TGA.tx 						$INSTDIR\resource\textures\Locations\HOLLAND\TROPA256.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\tropa256_1.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\tropa256_1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\walk_256.TGA.tx 						$INSTDIR\resource\textures\Locations\HOLLAND\walk_256.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\walkL_256.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\walkL_256.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\walkR_256.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\walkR_256.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\wall_1_512.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\wall_1_512.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\wall_2_512.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\wall_2_512.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\WAREHOUSE.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\WAREHOUSE.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\WaterFall.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\WaterFall.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\WaterFall2.TGA.tx 					$INSTDIR\resource\textures\Locations\HOLLAND\WaterFall2.TGA.tx

  CopyFiles /SILENT $INSTDIR\resource\textures\back_jungle.tga.tx					$INSTDIR\resource\textures\Locations\JUNGLES\back_jungle.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\back_mountains.tga.tx					$INSTDIR\resource\textures\Locations\JUNGLES\back_mountains.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\back_plants.tga.tx					$INSTDIR\resource\textures\Locations\JUNGLES\back_plants.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\bump_land.tga.tx       					$INSTDIR\resource\textures\Locations\JUNGLES\bump_land.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\grassgreen1.tga.tx					$INSTDIR\resource\textures\Locations\JUNGLES\grassgreen1.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\leafPalms.tga.tx       					$INSTDIR\resource\textures\Locations\JUNGLES\leafPalms.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\skala_jungle1.tga.tx					$INSTDIR\resource\textures\Locations\JUNGLES\skala_jungle1.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\skala_jungle6.tga.tx					$INSTDIR\resource\textures\Locations\JUNGLES\skala_jungle6.tga.tx

  CopyFiles /SILENT "$INSTDIR\resource\textures\BRCK48L COPY.TGA.tx" 					"$INSTDIR\resource\textures\Locations\NATIVES\BRCK48L COPY.TGA.tx"
  CopyFiles /SILENT "$INSTDIR\resource\textures\Grass022 copy.TGA.tx" 					"$INSTDIR\resource\textures\Locations\NATIVES\Grass022 copy.TGA.tx"
  CopyFiles /SILENT "$INSTDIR\resource\textures\sib_stuff cop0.tga.tx"					"$INSTDIR\resource\textures\Locations\NATIVES\sib_stuff cop0.tga.tx"
  CopyFiles /SILENT "$INSTDIR\resource\textures\sib_stuff cop2.tga.tx"					"$INSTDIR\resource\textures\Locations\NATIVES\sib_stuff cop2.tga.tx"
  CopyFiles /SILENT "$INSTDIR\resource\textures\sib_stuff copy.tga.tx"					"$INSTDIR\resource\textures\Locations\NATIVES\sib_stuff copy.tga.tx"
  CopyFiles /SILENT $INSTDIR\resource\textures\back_JUNGLE.TGA.tx 					"$INSTDIR\resource\textures\Locations\NATIVES\back_JUNGLE.TGA.tx"
  CopyFiles /SILENT $INSTDIR\resource\textures\back_MOUNTAINS.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\back_MOUNTAINS.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\BACK_PLANTS.TGA.tx					$INSTDIR\resource\textures\Locations\NATIVES\BACK_PLANTS.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\back4.TGA.tx 						$INSTDIR\resource\textures\Locations\NATIVES\back4.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\back6.TGA.tx 						$INSTDIR\resource\textures\Locations\NATIVES\back6.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\BARRACKS.TGA.tx 						$INSTDIR\resource\textures\Locations\NATIVES\BARRACKS.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\BORTOUTTARTANE1.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\BORTOUTTARTANE1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\BUMP_LAND.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\BUMP_LAND.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Cave3.tga.tx             				$INSTDIR\resource\textures\Locations\NATIVES\Cave3.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\church.TGA.tx 						$INSTDIR\resource\textures\Locations\NATIVES\church.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\City_Radmond.tga.tx            				$INSTDIR\resource\textures\Locations\NATIVES\City_Radmond.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\CONCEISAO_ROCKS.TGA.tx					$INSTDIR\resource\textures\Locations\NATIVES\CONCEISAO_ROCKS.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\CORALL3_256.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\CORALL3_256.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\CORALL5_256.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\CORALL5_256.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\DECK.tga.tx 						$INSTDIR\resource\textures\Locations\NATIVES\DECK.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\eng_palace.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\eng_palace.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\FALAISE_DE_FLEUR_TH_PALACE.TGA.tx 			$INSTDIR\resource\textures\Locations\NATIVES\FALAISE_DE_FLEUR_TH_PALACE.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\FALAISE_DE_FLEUR_TH_PALACE02.TGA.tx 			$INSTDIR\resource\textures\Locations\NATIVES\FALAISE_DE_FLEUR_TH_PALACE02.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Falaise_refl.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\Falaise_refl.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\FalDeFL_P0.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\FalDeFL_P0.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\FalDeFL_P0_02.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\FalDeFL_P0_02.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\FalDeFL_P1.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\FalDeFL_P1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\FFP_SAND.TGA.tx 						$INSTDIR\resource\textures\Locations\NATIVES\FFP_SAND.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\FFP2ROCK.TGA.tx 						$INSTDIR\resource\textures\Locations\NATIVES\FFP2ROCK.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\ffpw.tga.tx                                 		$INSTDIR\resource\textures\Locations\NATIVES\ffpw.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Flore1_512.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\Flore1_512.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Flore11.tga.tx						$INSTDIR\resource\textures\Locations\NATIVES\Flore11.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Flore2_512.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\Flore2_512.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Flore3a_512.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\Flore3a_512.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Flore4_512.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\Flore4_512.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\fonar.TGA.tx 						$INSTDIR\resource\textures\Locations\NATIVES\fonar.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\fonar_day.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\fonar_day.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\fonar_night.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\fonar_night.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\fonar_noactive.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\fonar_noactive.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\fort_inside_other.TGA.tx 				$INSTDIR\resource\textures\Locations\NATIVES\fort_inside_other.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\fort_inside_stuff.TGA.tx 				$INSTDIR\resource\textures\Locations\NATIVES\fort_inside_stuff.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Foudation_Win_Door.TGA.tx 				$INSTDIR\resource\textures\Locations\NATIVES\Foudation_Win_Door.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\govno.TGA.tx 						$INSTDIR\resource\textures\Locations\NATIVES\govno.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\grassgreen1.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\grassgreen1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\gray.TGA.tx 						$INSTDIR\resource\textures\Locations\NATIVES\gray.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\greenf.tga.tx						$INSTDIR\resource\textures\Locations\NATIVES\greenf.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\GREENF.TGA.tx 						$INSTDIR\resource\textures\Locations\NATIVES\GREENF.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\grey.TGA.tx						$INSTDIR\resource\textures\Locations\NATIVES\grey.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\IRONAMENT.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\IRONAMENT.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Isla_Muelle_4_BG.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\Isla_Muelle_4_BG.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Isla_Muelle_BG.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\Isla_Muelle_BG.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\IslaMuelle_refl.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\IslaMuelle_refl.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island.TGA.tx 						$INSTDIR\resource\textures\Locations\NATIVES\Island.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island_all_sm.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\Island_all_sm.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island_conceicao.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\Island_conceicao.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island_Falaise_de_Fleur.TGA.tx 				$INSTDIR\resource\textures\Locations\NATIVES\Island_Falaise_de_Fleur.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island_Gaity.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\Island_Gaity.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island_Khael_Roa.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\Island_Khael_Roa.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island_Khael_Roa_incas.TGA.tx 				$INSTDIR\resource\textures\Locations\NATIVES\Island_Khael_Roa_incas.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island_Oxbay.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\Island_Oxbay.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island_Quebralas_Costilla2.TGA.tx 			$INSTDIR\resource\textures\Locations\NATIVES\Island_Quebralas_Costilla2.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island_Quebralas_Costilla3.TGA.tx 			$INSTDIR\resource\textures\Locations\NATIVES\Island_Quebralas_Costilla3.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island_Quebralas_Costillas.TGA.tx 			$INSTDIR\resource\textures\Locations\NATIVES\Island_Quebralas_Costillas.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island_Redmond.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\Island_Redmond.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\ITEMS.TGA.tx 						$INSTDIR\resource\textures\Locations\NATIVES\ITEMS.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\KhaelRoa_refl.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\KhaelRoa_refl.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\kora.TGA.tx 						$INSTDIR\resource\textures\Locations\NATIVES\kora.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\kora_1.TGA.tx 						$INSTDIR\resource\textures\Locations\NATIVES\kora_1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\kora_2.TGA.tx 						$INSTDIR\resource\textures\Locations\NATIVES\kora_2.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\kora_3.TGA.tx 						$INSTDIR\resource\textures\Locations\NATIVES\kora_3.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\kora_4.TGA.tx 						$INSTDIR\resource\textures\Locations\NATIVES\kora_4.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\leafPalms.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\leafPalms.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Leaves.TGA.tx 						$INSTDIR\resource\textures\Locations\NATIVES\Leaves.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Leaves1.TGA.tx 						$INSTDIR\resource\textures\Locations\NATIVES\Leaves1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\MAYAK01.TGA.tx 						$INSTDIR\resource\textures\Locations\NATIVES\MAYAK01.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\NAVALCOLLEGE.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\NAVALCOLLEGE.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\New_Mountain.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\New_Mountain.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\oxbay_brick.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\oxbay_brick.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\oxbay_refl.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\oxbay_refl.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\oxbay_rocks.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\oxbay_rocks.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\oxbay_tile.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\oxbay_tile.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Port_Radmond.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\Port_Radmond.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\River.TGA.tx 						$INSTDIR\resource\textures\Locations\NATIVES\River.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\River_Caustik.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\River_Caustik.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\River_top.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\River_top.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\River_top1.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\River_top1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\River1.TGA.tx 						$INSTDIR\resource\textures\Locations\NATIVES\River1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\RIVER2.TGA.tx 						$INSTDIR\resource\textures\Locations\NATIVES\RIVER2.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\rockground1.tga.tx					$INSTDIR\resource\textures\Locations\NATIVES\rockground1.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Sand_D_256.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\Sand_D_256.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\SAND_D_256_SVET.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\SAND_D_256_SVET.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Sand_L_256.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\Sand_L_256.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Sand_L_256_svet.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\Sand_L_256_svet.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Sand_L1_256.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\Sand_L1_256.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\SandGrassR1.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\SandGrassR1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Sandground2.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\Sandground2.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Sandtile.TGA.tx 						$INSTDIR\resource\textures\Locations\NATIVES\Sandtile.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\seaTile.TGA.tx 						$INSTDIR\resource\textures\Locations\NATIVES\seaTile.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\SHIPYARD3.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\SHIPYARD3.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\SIB_JUN_HOS.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\SIB_JUN_HOS.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\SKALA_JUNGLE.TGA.tx					$INSTDIR\resource\textures\Locations\NATIVES\SKALA_JUNGLE.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\skala_jungle1.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\skala_jungle1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\skala_jungle2.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\skala_jungle2.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\skala_jungle3.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\skala_jungle3.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\skala_jungle6.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\skala_jungle6.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\skala_jungle8.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\skala_jungle8.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\skala_jungleDEX.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\skala_jungleDEX.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\spa_palace1.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\spa_palace1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\spain_pesok.tga.tx 					$INSTDIR\resource\textures\Locations\NATIVES\spain_pesok.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\SQUERE_256.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\SQUERE_256.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\STONES1.TGA.tx 						$INSTDIR\resource\textures\Locations\NATIVES\STONES1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Tree.TGA.tx 						$INSTDIR\resource\textures\Locations\NATIVES\Tree.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Tree1.TGA.tx 						$INSTDIR\resource\textures\Locations\NATIVES\Tree1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\treePalms.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\treePalms.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Trees.TGA.tx 						$INSTDIR\resource\textures\Locations\NATIVES\Trees.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\TROPA256.TGA.tx 						$INSTDIR\resource\textures\Locations\NATIVES\TROPA256.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\tropa256_1.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\tropa256_1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\walk_256.TGA.tx 						$INSTDIR\resource\textures\Locations\NATIVES\walk_256.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\walkL_256.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\walkL_256.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\walkR_256.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\walkR_256.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\wall_2_512.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\wall_2_512.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\WAREHOUSE.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\WAREHOUSE.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\WaterFall.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\WaterFall.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\WaterFall2.TGA.tx 					$INSTDIR\resource\textures\Locations\NATIVES\WaterFall2.TGA.tx

  CopyFiles /SILENT "$INSTDIR\resource\textures\BRCK48L COPY.TGA.tx" 					"$INSTDIR\resource\textures\Locations\SPAIN\BRCK48L COPY.TGA.tx"
  CopyFiles /SILENT "$INSTDIR\resource\textures\Grass022 copy.TGA.tx" 					"$INSTDIR\resource\textures\Locations\SPAIN\Grass022 copy.TGA.tx"
  CopyFiles /SILENT "$INSTDIR\resource\textures\Island_Isla Muelle.TGA.tx" 				"$INSTDIR\resource\textures\Locations\SPAIN\Island_Isla Muelle.TGA.tx"
  CopyFiles /SILENT "$INSTDIR\resource\textures\sib_stuff cop0.tga.tx"					"$INSTDIR\resource\textures\Locations\SPAIN\sib_stuff cop0.tga.tx"
  CopyFiles /SILENT "$INSTDIR\resource\textures\sib_stuff cop2.tga.tx"					"$INSTDIR\resource\textures\Locations\SPAIN\sib_stuff cop2.tga.tx"
  CopyFiles /SILENT "$INSTDIR\resource\textures\sib_stuff copy.tga.tx"					"$INSTDIR\resource\textures\Locations\SPAIN\sib_stuff copy.tga.tx"
  CopyFiles /SILENT $INSTDIR\resource\textures\back_JUNGLE.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\back_JUNGLE.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\back_MOUNTAINS.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\back_MOUNTAINS.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\BACK_PLANTS.TGA.tx					$INSTDIR\resource\textures\Locations\SPAIN\BACK_PLANTS.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\back4.TGA.tx 						$INSTDIR\resource\textures\Locations\SPAIN\back4.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\back6.TGA.tx 						$INSTDIR\resource\textures\Locations\SPAIN\back6.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\BARRACKS.TGA.tx 						$INSTDIR\resource\textures\Locations\SPAIN\BARRACKS.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\BORTOUTTARTANE1.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\BORTOUTTARTANE1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\BUMP_LAND.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\BUMP_LAND.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Cave3.tga.tx             				$INSTDIR\resource\textures\Locations\SPAIN\Cave3.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\church1.tga.tx             				$INSTDIR\resource\textures\Locations\SPAIN\church1.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\CITY_RADMOND.TGA.tx             				$INSTDIR\resource\textures\Locations\SPAIN\CITY_RADMOND.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\CONCEISAO_ROCKS.TGA.tx					$INSTDIR\resource\textures\Locations\SPAIN\CONCEISAO_ROCKS.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\CORALL3_256.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\CORALL3_256.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\CORALL5_256.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\CORALL5_256.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\DECK.tga.tx 						$INSTDIR\resource\textures\Locations\SPAIN\DECK.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Dirt.tga.tx                               		$INSTDIR\resource\textures\Locations\SPAIN\Dirt.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\eng_palace_exit.tga.tx          				$INSTDIR\resource\textures\Locations\SPAIN\eng_palace_exit.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Falaise_refl.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\Falaise_refl.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\FalDeFL_P0.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\FalDeFL_P0.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\FalDeFL_P0_02.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\FalDeFL_P0_02.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\FalDeFL_P1.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\FalDeFL_P1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\FFP_SAND.TGA.tx 						$INSTDIR\resource\textures\Locations\SPAIN\FFP_SAND.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\FFP2ROCK.TGA.tx 						$INSTDIR\resource\textures\Locations\SPAIN\FFP2ROCK.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Flore1_512.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\Flore1_512.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Flore2_512.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\Flore2_512.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Flore3a_512.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\Flore3a_512.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\fonar.TGA.tx 						$INSTDIR\resource\textures\Locations\SPAIN\fonar.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\fonar_day.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\fonar_day.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\fonar_night.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\fonar_night.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\fonar_noactive.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\fonar_noactive.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\fort_inside_stuff.TGA.tx 				$INSTDIR\resource\textures\Locations\SPAIN\fort_inside_stuff.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\govno.TGA.tx 						$INSTDIR\resource\textures\Locations\SPAIN\govno.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\grassgreen1.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\grassgreen1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\gray.TGA.tx 						$INSTDIR\resource\textures\Locations\SPAIN\gray.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\greenf.tga.tx						$INSTDIR\resource\textures\Locations\SPAIN\greenf.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\GREENF.TGA.tx 						$INSTDIR\resource\textures\Locations\SPAIN\GREENF.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\grey.TGA.tx						$INSTDIR\resource\textures\Locations\SPAIN\grey.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Hisp_Signs.tga.tx             				$INSTDIR\resource\textures\Locations\SPAIN\Hisp_Signs.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Isla_Muelle_4_BG.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\Isla_Muelle_4_BG.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Isla_Muelle_BG.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\Isla_Muelle_BG.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\IslaMuelle_refl.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\IslaMuelle_refl.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island.TGA.tx 						$INSTDIR\resource\textures\Locations\SPAIN\Island.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island_all_sm.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\Island_all_sm.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island_conceicao.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\Island_conceicao.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island_Falaise_de_Fleur.TGA.tx 				$INSTDIR\resource\textures\Locations\SPAIN\Island_Falaise_de_Fleur.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island_Gaity.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\Island_Gaity.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island_Khael_Roa.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\Island_Khael_Roa.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island_Khael_Roa_incas.TGA.tx 				$INSTDIR\resource\textures\Locations\SPAIN\Island_Khael_Roa_incas.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island_Oxbay.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\Island_Oxbay.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island_Quebralas_Costilla2.TGA.tx 			$INSTDIR\resource\textures\Locations\SPAIN\Island_Quebralas_Costilla2.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island_Quebralas_Costilla3.TGA.tx 			$INSTDIR\resource\textures\Locations\SPAIN\Island_Quebralas_Costilla3.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island_Quebralas_Costillas.TGA.tx 			$INSTDIR\resource\textures\Locations\SPAIN\Island_Quebralas_Costillas.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Island_Redmond.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\Island_Redmond.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\ITEMS.TGA.tx 						$INSTDIR\resource\textures\Locations\SPAIN\ITEMS.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\KhaelRoa_refl.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\KhaelRoa_refl.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\kora.TGA.tx 						$INSTDIR\resource\textures\Locations\SPAIN\kora.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\kora_1.TGA.tx 						$INSTDIR\resource\textures\Locations\SPAIN\kora_1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\kora_2.TGA.tx 						$INSTDIR\resource\textures\Locations\SPAIN\kora_2.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\kora_3.TGA.tx 						$INSTDIR\resource\textures\Locations\SPAIN\kora_3.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\kora_4.TGA.tx 						$INSTDIR\resource\textures\Locations\SPAIN\kora_4.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\leafPalms.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\leafPalms.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Leaves.TGA.tx 						$INSTDIR\resource\textures\Locations\SPAIN\Leaves.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Leaves1.TGA.tx 						$INSTDIR\resource\textures\Locations\SPAIN\Leaves1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\MAYAK01.TGA.tx 						$INSTDIR\resource\textures\Locations\SPAIN\MAYAK01.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\NAVALCOLLEGE.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\NAVALCOLLEGE.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\New_Mountain.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\New_Mountain.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\oxbay_refl.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\oxbay_refl.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\oxbay_rocks.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\oxbay_rocks.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\oxbay_tile.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\oxbay_tile.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Port_Radmond.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\Port_Radmond.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Portugal_Signs.tga.tx					$INSTDIR\resource\textures\Locations\SPAIN\Portugal_Signs.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\RED_ED.TGA.tx             				$INSTDIR\resource\textures\Locations\SPAIN\RED_ED.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\RED_EDA.TGA.tx             				$INSTDIR\resource\textures\Locations\SPAIN\RED_EDA.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\RED_EDB.TGA.tx             				$INSTDIR\resource\textures\Locations\SPAIN\RED_EDB.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\res_listik.tga.tx             				$INSTDIR\resource\textures\Locations\SPAIN\res_listik.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\res_win.tga.tx             				$INSTDIR\resource\textures\Locations\SPAIN\res_win.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\River.TGA.tx 						$INSTDIR\resource\textures\Locations\SPAIN\River.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\River_Caustik.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\River_Caustik.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\River_top.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\River_top.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\River_top1.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\River_top1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\River1.TGA.tx 						$INSTDIR\resource\textures\Locations\SPAIN\River1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\RIVER2.TGA.tx 						$INSTDIR\resource\textures\Locations\SPAIN\RIVER2.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\rockground1.tga.tx					$INSTDIR\resource\textures\Locations\SPAIN\rockground1.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Sand_D_256.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\Sand_D_256.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\SAND_D_256_SVET.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\SAND_D_256_SVET.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Sand_L_256.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\Sand_L_256.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Sand_L_256_svet.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\Sand_L_256_svet.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Sand_L1_256.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\Sand_L1_256.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\SandGrassR1.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\SandGrassR1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Sandground2.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\Sandground2.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Sandtile.TGA.tx 						$INSTDIR\resource\textures\Locations\SPAIN\Sandtile.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\seaTile.TGA.tx 						$INSTDIR\resource\textures\Locations\SPAIN\seaTile.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\SHIPYARD3.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\SHIPYARD3.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\SIB_JUN_HOS.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\SIB_JUN_HOS.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\SKALA_JUNGLE.TGA.tx					$INSTDIR\resource\textures\Locations\SPAIN\SKALA_JUNGLE.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\skala_jungle1.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\skala_jungle1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\skala_jungle2.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\skala_jungle2.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\skala_jungle3.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\skala_jungle3.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\skala_jungle6.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\skala_jungle6.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\skala_jungle8.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\skala_jungle8.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\skala_jungleDEX.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\skala_jungleDEX.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\spa_palace1.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\spa_palace1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\spain_pesok.tga.tx 					$INSTDIR\resource\textures\Locations\SPAIN\spain_pesok.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\STONES1.TGA.tx 						$INSTDIR\resource\textures\Locations\SPAIN\STONES1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Tree.TGA.tx 						$INSTDIR\resource\textures\Locations\SPAIN\Tree.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Tree1.TGA.tx 						$INSTDIR\resource\textures\Locations\SPAIN\Tree1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\treePalms.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\treePalms.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Trees.TGA.tx 						$INSTDIR\resource\textures\Locations\SPAIN\Trees.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\TROPA256.TGA.tx 						$INSTDIR\resource\textures\Locations\SPAIN\TROPA256.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\tropa256_1.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\tropa256_1.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\wall_1_512.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\wall_1_512.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\wall_2_512.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\wall_2_512.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\WAREHOUSE.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\WAREHOUSE.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\WaterFall.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\WaterFall.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\WaterFall2.TGA.tx 					$INSTDIR\resource\textures\Locations\SPAIN\WaterFall2.TGA.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\_ladde_.tga.tx 				  		$INSTDIR\resource\textures\Locations\SPAIN\_ladde_.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\Borgga_rd.tga.tx 					$INSTDIR\resource\textures\Locations\SPAIN\Borgga_rd.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\checker.tga.tx 						$INSTDIR\resource\textures\Locations\SPAIN\checker.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\h_sida.tga.tx 						$INSTDIR\resource\textures\Locations\SPAIN\h_sida.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\TH.tga.tx 						$INSTDIR\resource\textures\Locations\SPAIN\TH.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\TN.tga.tx 						$INSTDIR\resource\textures\Locations\SPAIN\TN.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\TO.tga.tx 						$INSTDIR\resource\textures\Locations\SPAIN\TO.tga.tx
  CopyFiles /SILENT $INSTDIR\resource\textures\TV.tga.tx 						$INSTDIR\resource\textures\Locations\SPAIN\TV.tga.tx

SectionEnd


; ================================================
;  Start UPDATE Files Section
; ================================================

Section "UPDATE Files" SEC02
  SectionIn RO

  ${If} ${FileExists} "$INSTDIR\ENGINE.exe"
    ${If} ${FileExists} "$INSTDIR\readme.txt"
    ${Else}
      MessageBox MB_OK|MB_ICONINFORMATION "Original game not found. Make sure you install the 2003 Pirates of the Caribbean game by Akella first!" IDOK abort1
      abort1:
      Banner::destroy
      Abort
    ${EndIf}
  ${EndIf}

  ${If} ${FileExists} "$INSTDIR\Build Info.txt"
  ${Else}
    MessageBox MB_OK|MB_ICONINFORMATION "Build 14 Beta 3 Main Files not found. Make sure to install those first!" IDOK abort2
    abort2:
    Banner::destroy
    Abort
  ${EndIf}


; ================================================
;  Install UPDATE Files
; ================================================

  SetOutPath "$INSTDIR"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\Build Info.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\Config.exe"
  SetOutPath "$INSTDIR\Documentation"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\Documentation\Archipelago Map.png"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\Documentation\Default Key Assignments.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\Documentation\New Horizons Tutorials & History.pdf"
  SetOutPath "$INSTDIR"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\ENGINE.exe"
  SetOutPath "$INSTDIR\PROGRAM"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\animals.c"
  SetOutPath "$INSTDIR\PROGRAM\BATTLE_INTERFACE"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\BATTLE_INTERFACE\BattleInterface.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\BATTLE_INTERFACE\fast_reload_table.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\BATTLE_INTERFACE\Flags.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\BATTLE_INTERFACE\LandInterface.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\BATTLE_INTERFACE\reload_tables.c"
  SetOutPath "$INSTDIR\PROGRAM"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\calendar.c"
  SetOutPath "$INSTDIR\PROGRAM\CANNONS"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\CANNONS\Cannons.c"
  SetOutPath "$INSTDIR\PROGRAM"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\CCCdirectsail.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\CCCFunctions.c"
  SetOutPath "$INSTDIR\PROGRAM\Characters"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Characters\characters.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Characters\characters.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Characters\characters_events.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Characters\characters_init.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Characters\characters_login.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Characters\CharacterUtilite.c"
  SetOutPath "$INSTDIR\PROGRAM\Characters\init"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Characters\init\Antigua.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Characters\init\Aruba.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Characters\init\cayman.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Characters\init\Colombia.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Characters\init\CommonQuest.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Characters\init\Conceicao.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Characters\init\cuba.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Characters\init\Curacao.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Characters\init\DockyardOwners.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Characters\init\Douwesen.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Characters\init\Eleuthera.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Characters\init\FalaiseDeFleur.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Characters\init\FortCommandants.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Characters\init\Guadeloupe.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Characters\init\Hispaniola.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Characters\init\IslaMona.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Characters\init\IslaMuelle.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Characters\init\monks.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Characters\init\NK.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Characters\init\Officers.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Characters\init\Oxbay.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Characters\init\QuebradasCostillas.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Characters\init\Redmond.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Characters\init\SaintMartin.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Characters\init\SideQuest.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Characters\init\StoreOwners.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Characters\init\StreetMerchants.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Characters\init\TActors.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Characters\init\Taverns.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Characters\init\Turks.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Characters\init\Usurers.c"
  SetOutPath "$INSTDIR\PROGRAM"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\console.c"
  SetOutPath "$INSTDIR\PROGRAM\CONTROLS"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\CONTROLS\controls.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\CONTROLS\DefaultControls.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\CONTROLS\init_pc.c"
  SetOutPath "$INSTDIR\PROGRAM"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\dialog.c"
  SetOutPath "$INSTDIR\PROGRAM\DIALOGS"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Abraham Hollander_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Alan Milds_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Albin Bonaventure_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Alice citizen_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Amerigo Vieira_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\anacleto_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Andre Figaux_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\andre juliao_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Antigua_dockyard.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Antigua_victualler.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Antoine Lebretton_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Arabella Silehard_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Arabella's guard_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Arendt Dickman_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Arendt Verheugen_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Arnaud Matton_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Artois Voysey_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\baldewyn coffier_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Bartolomeu o Portugues_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Bella Froelich_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Benoit Bertignac_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Bernardo Gamboa_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Blackbeard_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Blacksmith2_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Blacksmith3_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Blacksmith4_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Blacksmith5_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Blacksmith6_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Blacksmith7_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Blacksmith_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Blacksmith_fetch.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\blaze_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Brian Armstrong_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Brian Moods_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\B_shipyard.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Cabinfight_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Captured governor_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Cayman Citizen_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Charles Windem_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Christofor Manuel De Alencar_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\church.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Clair Larrouse_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\claudio burrieza_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Clauss_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Clint Eastwood_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Cole Arkwright_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Contre-Amirale Cesar Beauregard_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Corentin Lucay_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\corpse_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Crewmember_alc_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Crewmember_fight_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\CursedPirate_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Danielle hireling_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\danielle_quests_pirate_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\danielle_sailor_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\dark teacher_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\David Fairweather_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Desmond Ray Beltrop_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Docker_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Duarte Correja_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Edmund Christobel Shaw_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Elizabeth Swann_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Emiliano Rionda_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Emissary_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Enc_DirectSail_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Enc_fort_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Enc_Inn.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Enc_Officer_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Enc_Raiders_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Enc_resident_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Enc_shipmate.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Enc_Walker.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Enc_WorldMap_dialog.c"
  SetOutPath "$INSTDIR\PROGRAM\DIALOGS\ENGLISH"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Alan Milds_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Albin Bonaventure_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Amerigo Vieira_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\anacleto_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\andre Figaux_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\andre juliao_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Antigua_dockyard.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\antigua_portadmiral.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Antigua_victualler.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Antoine Lebretton_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Arabella Silehard_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Arabella's guard_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Arnaud Matton_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Artois Voysey_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\baldewyn coffier_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Balltesar Figueiredo_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Bartolomeu o Portugues_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\bartpirate_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Bella Froelich_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Bernardo Gamboa_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Blackbeard_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Blacksmith2_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Blacksmith3_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Blacksmith4_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Blacksmith5_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Blacksmith6_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Blacksmith7_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Blacksmith_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Blacksmith_fetch.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\blaze_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Brian Armstrong_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Brian Moods_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\b_fortification.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\B_KEEP.H"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\b_mansion.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Cabinfight_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Cayman citizen_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Charles Windem_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Christofor Manuel De Alencar_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\church.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\citizen.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Clair Larrouse_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\claudio burrieza_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Clauss_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Clint Eastwood_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Cole Arkwright_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Contre-Amirale Cesar Beauregard_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Corentin Lucay_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Crewmember_fight_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Danielle hireling_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\danielle_quests_pirate_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\danielle_sailor_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\dark teacher_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Desmond Ray Beltrop_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Docker_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Duarte Correja_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Elizabeth Swann_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Emiliano Rionda_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Enc_Officer_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Enc_Raiders_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Enc_Walker.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\eng_officiant_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Everard Gordon_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Fabiao Dunga_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Fadrique Castillo_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Fletcher Rosewood_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Florentin Destot_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Francois Chabert_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Fred Bob_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Friedrich Corleis_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Friend_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Gervasio Serrao_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Gheerlof Darlang_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Gheraed Drabbe_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\governor.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Greenford Commander_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Gregorio Montavez_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Gunsmith_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Gunsmith_fetch.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Habitue_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\hardouin aufort_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Havana citizen_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Havana_Crewmember_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Ines Diaz_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Jacinto Arcibaldo Barreto_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Jaoquin de masse_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Joaquin Da Saldanha_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Johannes Harlekeyn_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\John Adams_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\John Clifford Brin_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\John Filbert_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Jordano_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Joseph Claude Le Moigne_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Josephine Bonassieu_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\LaCroix_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Lambrecht Fobes_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Larry_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Lastcrew_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Laurence Wellman_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Librarian.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Lorenzo Delgado_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Lucas Da Saldanha_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\lucien bescanceny_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Malcolm Hatcher_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\marc blacque_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Marcus Maas_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Mario Figuiera_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Martinho Guterres_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\milon blacque_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\monk_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Nigel Blythe_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Olyver Littlejohn_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\orable caron_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Oranjestad citizen_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Oswald Chappel_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Oweyn McDorey_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Oxbay citizen_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\pater jourdain_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\patric cardone_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Pedro Fructoso_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Pedro Rivera_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\permanent_crewmember_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Pete Manchester_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\PGov_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Pierart Kamerling_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Pieter at Douwesen_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Pieter Boelen_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Prisoned_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Quest_ANIMISTS_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\quest_pirate_01_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\rachel blacque_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Randolf Blecher_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\random_guards_group_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\raoul calmes_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Redmond commendant_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Reynard Grueneveldt_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Robert Wicker_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Rodrigo Ramos_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Rys Bloom_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Sabine Matton_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Salvador Allende_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Santiago citizen_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\SantoDomingo citizen_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\shipyard.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Simon Hanpool_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Skipper Wife_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Smuggler Agent_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Smuggler_OnShore_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Sylvie Bondies_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\tailor.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\tailor_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Tanneken Oremans_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\tavern.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Thomas O'Reily_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Toff Oremans_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Tortuga citizen_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\turpin cabanel_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Txiki Pijuan_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\vigila mendes_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Watch_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Wilfred Burman_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Will Turner_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\Yedam Kinne_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\ENGLISH\zaid murro_dialog.h"
  SetOutPath "$INSTDIR\PROGRAM\DIALOGS"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\eng_officiant_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\esteban castillo_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Everard Gordon_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Fabiao Dunga_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Fadrique Castillo_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\falaise de fleur citizen_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Father Bernard_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Felipe Cisneros_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Fletcher Rosewood_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Florentin Destot_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Fox Ratter_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Francois Chabert_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Fred Bob_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Friedrich Corleis_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Gervasio Serrao_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Gheerlof Darlang_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Gheraed Drabbe_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Gheret Bogardus_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Gilbert Ballester_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\governor.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Greenford Commander_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Gregorio Montavez_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Gunsmith_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Gunsmith_fetch.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Habitue_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Hans Kloss_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\hardouin aufort_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Havana citizen_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Havana_Crewmember_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Hendrick van der Kuylen_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Hendrick Vanderdecken_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Henry_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Hugh_Chadman_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Humberto de Paiva_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Ines Diaz_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Isabelle de Cussy_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Isenbrandt Jurcksen_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Jacinto Arcibaldo Barreto_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Jakob Nickerson_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Jaoquin de masse_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Javier Balboa_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\jean filaut_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Joaquin Da Saldanha_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Johannes Harlekeyn_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\John Adams_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\John Clifford Brin_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\John Filbert_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Jordano_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Jorge Suarez_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Joseph Claude Le Moigne_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Josephine Bonassieu_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Konrad Kulczycki_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\LaCroix_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Lambrecht Fobes_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Larry_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Lastcrew_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Librarian.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Lorenzo Delgado_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Lucas Da Saldanha_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\lucien bescanceny_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Malcolm Hatcher_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\marc blacque_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Marcus Maas_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Mario Figuiera_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Martinho Guterres_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Mary Wood_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Maurice Dupont_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Michael Wainwright_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\milon blacque_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\monk_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Nigel Blythe_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Olyver Littlejohn_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\orable caron_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Oswald Chappel_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Oweyn McDorey_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Oxbay citizen_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Pablo Duarte_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\padre Domingues_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\pater jourdain_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\patric cardone_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Patrick Webster_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Pedro Fructoso_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Pedro Rivera_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\permanent_crewmember_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Pete Manchester_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\PGov_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Philippe de Rivarol_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Philippe_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Philipsburg citizen_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Pierart Kamerling_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Pieter Boelen_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Pirate Soldier_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Prisoned_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Prosper Fraigneau_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\QC citizen_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Quest_ANIMISTS_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\quest_pirate_01_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\rachel blacque_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Randolf Blecher_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\random_guards_group_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\raoul calmes_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Redmond commendant_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\RelationAgent_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Remy Gatien_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Reynard Grueneveldt_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Robert Wicker_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Rodrigo Ramos_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Roger Murray_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Rys Bloom_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Sabine Matton_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Salvador Allende_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\SantoDomingo citizen_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\second_spaniard_priest_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\shipyard.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Simon Hanpool_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Skipper Wife_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Smuggler Agent_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Smuggler_OnShore_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\stunned_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Sylvie Bondies_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\tailor.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\tailor_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Tanneken Oremans_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\tavern.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Teodinus Serrano_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Thomas Modiford_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Thomas O'Reily_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Toff Oremans_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Tortuga citizen_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\turpin cabanel_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Txiki Pijuan_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Usurer_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Virginie d'Espivant_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Watch_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Wilfred Burman_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Will Turner_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\Yedam Kinne_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\DIALOGS\zaid murro_dialog.c"
  SetOutPath "$INSTDIR\PROGRAM"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Dialog_func.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\elrapido.c"
  SetOutPath "$INSTDIR\PROGRAM\Encounters"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Encounters\Encounters_map.c"
  SetOutPath "$INSTDIR\PROGRAM"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\globals.c"
  SetOutPath "$INSTDIR\PROGRAM\INTERFACE"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\INTERFACE\boal_map.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\INTERFACE\Book.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\INTERFACE\character.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\INTERFACE\gamble.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\INTERFACE\hirecrew.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\INTERFACE\info_box.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\INTERFACE\interface.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\INTERFACE\interface.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\INTERFACE\items.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\INTERFACE\itemsbox.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\INTERFACE\itemstrade.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\INTERFACE\mainmenu.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\INTERFACE\map.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\INTERFACE\mutiny_map.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\INTERFACE\NationRelation.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\INTERFACE\passengers.c"
  SetOutPath "$INSTDIR\PROGRAM\INTERFACE\Perks"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\INTERFACE\Perks\perks.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\INTERFACE\Perks\perks_init.c"
  SetOutPath "$INSTDIR\PROGRAM\INTERFACE"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\INTERFACE\perks.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\INTERFACE\ransack_main.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\INTERFACE\salary.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\INTERFACE\save_load.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\INTERFACE\select_storyline.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\INTERFACE\ship.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\INTERFACE\shipyard.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\INTERFACE\store.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\INTERFACE\TradeBook.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\INTERFACE\transfer_characters.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\INTERFACE\transfer_main.c"
  SetOutPath "$INSTDIR\PROGRAM"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\InternalSettings.h"
  SetOutPath "$INSTDIR\PROGRAM\ISLANDS"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\ISLANDS\islands.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\ISLANDS\Islands_init.c"
  SetOutPath "$INSTDIR\PROGRAM\ITEMS"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\ITEMS\initItems.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\ITEMS\itemLogic.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\ITEMS\items.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\ITEMS\items_utilite.c"
  SetOutPath "$INSTDIR\PROGRAM"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\KB_routines.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\KR_Reinit.c"
  SetOutPath "$INSTDIR\PROGRAM\LandEncounters"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\LandEncounters\LandEnc_init.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\LandEncounters\LEnc_login.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\LandEncounters\LEnc_monsters.c"
  SetOutPath "$INSTDIR\PROGRAM\Locations\init"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Locations\init\Antigua.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Locations\init\Aruba.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Locations\init\BattleRocks.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Locations\init\boarding.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Locations\init\ccclocations.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Locations\init\Colombia.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Locations\init\Cuba.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Locations\init\Guadeloupe.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Locations\init\Hispaniola.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Locations\init\IslaDeMuerte.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Locations\init\Oxbay.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Locations\init\QuebradasCostillas.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Locations\init\Ship.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Locations\init\SideQuestLocations.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Locations\init\Turks.c"
  SetOutPath "$INSTDIR\PROGRAM\Locations"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Locations\locations_init.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Locations\locations_loader.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Locations\particles.c"
  SetOutPath "$INSTDIR\PROGRAM\Loc_ai"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Loc_ai\LAi_boarding.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Loc_ai\LAi_character.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Loc_ai\LAi_CreateOfficer.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Loc_ai\LAi_deck.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Loc_ai\LAi_equip.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Loc_ai\LAi_events.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Loc_ai\LAi_fightparams.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Loc_ai\LAi_groups.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Loc_ai\LAi_init.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Loc_ai\LAi_login.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Loc_ai\LAi_monsters.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Loc_ai\LAi_mutiny.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Loc_ai\LAi_utils.c"
  SetOutPath "$INSTDIR\PROGRAM\Loc_ai\templates"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Loc_ai\templates\LAi_fight.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Loc_ai\templates\LAi_player.c"
  SetOutPath "$INSTDIR\PROGRAM\Loc_ai\types"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Loc_ai\types\LAi_stunned.c"
  SetOutPath "$INSTDIR\PROGRAM"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\MAXIMUS_Functions.c"
  SetOutPath "$INSTDIR\PROGRAM\Models"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Models\initModels.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Models\models.h"
  SetOutPath "$INSTDIR\PROGRAM\NATIONS"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\NATIONS\nations.c"
  SetOutPath "$INSTDIR\PROGRAM"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\NK.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\officers.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Periods.c"
  SetOutPath "$INSTDIR\PROGRAM\QUESTS"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\QUESTS\quests.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\QUESTS\quests_check.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\QUESTS\quests_common.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\QUESTS\quests_side.c"
  SetOutPath "$INSTDIR\PROGRAM"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Reinit.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\reload.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Rumour_Data.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Screwface_functions.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\seadogs.c"
  SetOutPath "$INSTDIR\PROGRAM\SEA_AI"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\SEA_AI\AIFantom.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\SEA_AI\AIGroup.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\SEA_AI\AISea.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\SEA_AI\AIShip.c"
  SetOutPath "$INSTDIR\PROGRAM\SEA_AI\AITasks"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\SEA_AI\AITasks\AIAbordage.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\SEA_AI\AITasks\AIDefend.c"
  SetOutPath "$INSTDIR\PROGRAM\SEA_AI"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\SEA_AI\sea.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\SEA_AI\shipWalk.c"
  SetOutPath "$INSTDIR\PROGRAM\SEA_AI\walk"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\SEA_AI\walk\PinnaceMedium_walk.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\SEA_AI\walk\PinnaceMerchant_walk.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\SEA_AI\walk\Polacca_walk.c"
  SetOutPath "$INSTDIR\PROGRAM\Ships"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Ships\Ships.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Ships\Ships_init.c"
  SetOutPath "$INSTDIR\PROGRAM"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\smuggling.c"
  SetOutPath "$INSTDIR\PROGRAM\sound\ALIAS"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\sound\ALIAS\music_standard.c"
  SetOutPath "$INSTDIR\PROGRAM\sound"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\sound\sound.c"
  SetOutPath "$INSTDIR\PROGRAM\STORE"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\STORE\store.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\STORE\StoreUtilite.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\STORE\store_init.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\Assassin\characters\init"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Assassin\characters\init\Story.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Assassin\characters\init\TempQuest.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Assassin\characters\init\TempQuestEnemy.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\Assassin\dialogs"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Assassin\dialogs\Duarte Correja_dialog.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\Assassin\dialogs\ENGLISH"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Assassin\dialogs\ENGLISH\Ambroz Bricenos_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Assassin\dialogs\ENGLISH\Andrew Parson_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Assassin\dialogs\ENGLISH\Arawak chief_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Assassin\dialogs\ENGLISH\Baltasar Salgada_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Assassin\dialogs\ENGLISH\Bartolomeu o Portugues_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Assassin\dialogs\ENGLISH\Chico Cois_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Assassin\dialogs\ENGLISH\Damski_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Assassin\dialogs\ENGLISH\Divers_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Assassin\dialogs\ENGLISH\Enrique Padilla_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Assassin\dialogs\ENGLISH\Henry Morgan_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Assassin\dialogs\ENGLISH\Jeremy Tripper_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Assassin\dialogs\ENGLISH\Nicholas Butcher_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Assassin\dialogs\ENGLISH\Salvadore Benavides_dialog.h"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\Assassin\dialogs"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Assassin\dialogs\Pierart Kamerling_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Assassin\dialogs\Reynard Grueneveldt_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Assassin\dialogs\Salvadore Benavides_dialog.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\Assassin\items"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Assassin\items\initQuestItems.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\Assassin\quests"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Assassin\quests\both_reaction.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Assassin\quests\quests_reaction.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\Assassin"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Assassin\StartStoryline.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Assassin.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\Bartolomeu\characters\init"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Bartolomeu\characters\init\Story.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Bartolomeu\characters\init\TempQuest.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Bartolomeu\characters\init\TempQuestEnemy.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\Bartolomeu\dialogs"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Bartolomeu\dialogs\Albin Bonaventure_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Bartolomeu\dialogs\Arie Dierman_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Bartolomeu\dialogs\Augusto Queiroz_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Bartolomeu\dialogs\BC citizen_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Bartolomeu\dialogs\David Fairweather_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Bartolomeu\dialogs\Divers_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Bartolomeu\dialogs\Emilio Soares_dialog.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\Bartolomeu\dialogs\ENGLISH"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Bartolomeu\dialogs\ENGLISH\Arie Dierman_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Bartolomeu\dialogs\ENGLISH\Augusto Queiroz_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Bartolomeu\dialogs\ENGLISH\Christopher Backer_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Bartolomeu\dialogs\ENGLISH\David Fairweather_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Bartolomeu\dialogs\ENGLISH\Divers_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Bartolomeu\dialogs\ENGLISH\Duarte Felgueiras_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Bartolomeu\dialogs\ENGLISH\Emilio Soares_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Bartolomeu\dialogs\ENGLISH\Eugene Martin_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Bartolomeu\dialogs\ENGLISH\Francois Ollonais_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Bartolomeu\dialogs\ENGLISH\Henry Morgan_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Bartolomeu\dialogs\ENGLISH\Hugh_Chadman_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Bartolomeu\dialogs\ENGLISH\Jacinto Arcibaldo Barreto_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Bartolomeu\dialogs\ENGLISH\Johan Elting_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Bartolomeu\dialogs\ENGLISH\Lucia Montavez_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Bartolomeu\dialogs\ENGLISH\Matthew Gilroy_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Bartolomeu\dialogs\ENGLISH\Nathaniel Hawk_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Bartolomeu\dialogs\ENGLISH\Oweyn McDorey_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Bartolomeu\dialogs\ENGLISH\Pirate KK_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Bartolomeu\dialogs\ENGLISH\Roxanne Lalliere_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Bartolomeu\dialogs\ENGLISH\Sarah Roebuck_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Bartolomeu\dialogs\ENGLISH\Sebastian Ortega_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Bartolomeu\dialogs\ENGLISH\Walter Foreman_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Bartolomeu\dialogs\ENGLISH\William Klein_dialog.h"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\Bartolomeu\dialogs"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Bartolomeu\dialogs\Francois Ollonais_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Bartolomeu\dialogs\Hugh_Chadman_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Bartolomeu\dialogs\Jacinto Arcibaldo Barreto_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Bartolomeu\dialogs\Johan Elting_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Bartolomeu\dialogs\John Adams_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Bartolomeu\dialogs\Lucia Montavez_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Bartolomeu\dialogs\Navy Portugal_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Bartolomeu\dialogs\Oweyn McDorey_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Bartolomeu\dialogs\Remy Gatien_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Bartolomeu\dialogs\Reynard Grueneveldt_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Bartolomeu\dialogs\Sebastian Ortega_dialog.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\Bartolomeu\items"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Bartolomeu\items\initQuestItems.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\Bartolomeu\Locations\init"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Bartolomeu\Locations\init\QuestLocations.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\Bartolomeu\quests"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Bartolomeu\quests\both_reaction.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Bartolomeu\quests\quests_reaction.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\Bartolomeu"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Bartolomeu\SL_utils.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Bartolomeu\StartStoryline.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Bartolomeu.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\characters\init"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\BraveBlackFlag\characters\init\Officers.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\BraveBlackFlag\characters\init\TempQuest.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\BraveBlackFlag\characters\init\TempQuestEnemy.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Arnold McGill_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Bart Renault_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Celestino Villalobos_dialog.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Arnold McGill_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Bart Renault_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Celestino Villalobos_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Enrique Padilla_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Padre Gerardo_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Robert Fletcher_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Shipguard_dialog.h"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Enrique Padilla_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Padre Gerardo_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Robert Fletcher_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Shipguard_dialog.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\Locations\init"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\BraveBlackFlag\Locations\init\QuestLocations.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\quests"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\BraveBlackFlag\quests\both_reaction.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\BraveBlackFlag\quests\quests_reaction.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\BraveBlackFlag\SL_Reinit.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\BraveBlackFlag\StartStoryline.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\BraveBlackFlag.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\DevlinOpera\characters\init"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\DevlinOpera\characters\init\Story.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\DevlinOpera\dialogs\ENGLISH"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\DevlinOpera\dialogs\ENGLISH\Catalina the Pirate_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\DevlinOpera\dialogs\ENGLISH\Couch Captain Charles_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\DevlinOpera\dialogs\ENGLISH\Konrad Kulczycki_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\DevlinOpera\dialogs\ENGLISH\Maximus_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\DevlinOpera\dialogs\ENGLISH\Nathan Kell_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\DevlinOpera\dialogs\ENGLISH\Petros_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\DevlinOpera\dialogs\ENGLISH\Sir Christopher Mings_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\DevlinOpera\dialogs\ENGLISH\Skull_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\DevlinOpera\dialogs\ENGLISH\Thomas the Terror_dialog.h"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\DevlinOpera\dialogs"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\DevlinOpera\dialogs\Josephine Bonassieu_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\DevlinOpera\dialogs\Konrad Kulczycki_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\DevlinOpera\dialogs\Pieter Boelen_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\DevlinOpera\dialogs\Skull_dialog.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\DevlinOpera\items"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\DevlinOpera\items\initQuestItems.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\DevlinOpera\quests"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\DevlinOpera\quests\both_reaction.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\DevlinOpera"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\DevlinOpera\StartStoryline.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\DevlinOpera.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\GoldBug\Characters\init"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\GoldBug\Characters\init\TempQuest.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\GoldBug\dialogs"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\GoldBug\dialogs\A G Pym_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\GoldBug\dialogs\Bessop guard_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\GoldBug\dialogs\Bessop slave_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\GoldBug\dialogs\blaze_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\GoldBug\dialogs\Captain Kidd_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\GoldBug\dialogs\Chinaguests_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\GoldBug\dialogs\Chinarestaurant_dialog.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\GoldBug\dialogs\ENGLISH"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\GoldBug\dialogs\ENGLISH\A G Pym_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\GoldBug\dialogs\ENGLISH\Bessop guard_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\GoldBug\dialogs\ENGLISH\Bessop slave_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\GoldBug\dialogs\ENGLISH\blaze_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\GoldBug\dialogs\ENGLISH\Captain Kidd_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\GoldBug\dialogs\ENGLISH\Chinaguests_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\GoldBug\dialogs\ENGLISH\Chinarestaurant_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\GoldBug\dialogs\ENGLISH\Goldbug Trader_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\GoldBug\dialogs\ENGLISH\Jupiter_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\GoldBug\dialogs\ENGLISH\Lieutenant G_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\GoldBug\dialogs\ENGLISH\Maroon_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\GoldBug\dialogs\ENGLISH\Poe_dialog.h"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\GoldBug\dialogs"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\GoldBug\dialogs\Goldbug Trader_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\GoldBug\dialogs\Jupiter_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\GoldBug\dialogs\Lieutenant G_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\GoldBug\dialogs\Maroon_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\GoldBug\dialogs\Moultrie soldier_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\GoldBug\dialogs\Poe_dialog.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\GoldBug\items"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\GoldBug\items\initQuestItems.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\GoldBug\Locations\init"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\GoldBug\Locations\init\QuestLocations.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\GoldBug\quests"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\GoldBug\quests\quests_reaction.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\GoldBug"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\GoldBug\SL_Reinit.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\GoldBug\SL_utils.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\GoldBug\StartStoryline_off.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\GoldBug.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\Hornblower\characters\init"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Hornblower\characters\init\Story.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Hornblower\characters\init\TempQuest.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\Hornblower\dialogs"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Hornblower\dialogs\Antigua_dockyard.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Hornblower\dialogs\C.S. Forester_dialog.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\Hornblower\dialogs\ENGLISH"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Hornblower\dialogs\ENGLISH\Antigua_dockyard.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Hornblower\dialogs\ENGLISH\antigua_patrol_Dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Hornblower\dialogs\ENGLISH\Archie Kennedy_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Hornblower\dialogs\ENGLISH\Arthur Wellesley_Dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Hornblower\dialogs\ENGLISH\Black Charlie Hammond_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Hornblower\dialogs\ENGLISH\Captain Harvey_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Hornblower\dialogs\ENGLISH\Captain James Sawyer_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Hornblower\dialogs\ENGLISH\Captain Murray_Dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Hornblower\dialogs\ENGLISH\Don Masseredo_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Hornblower\dialogs\ENGLISH\Dreadnought Foster_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Hornblower\dialogs\ENGLISH\Etienne de Vergasse_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Hornblower\dialogs\ENGLISH\Francisco Manuel Ortega_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Hornblower\dialogs\ENGLISH\Guerilla_Dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Hornblower\dialogs\ENGLISH\Henry Wellard_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Hornblower\dialogs\ENGLISH\Jack Hammond_Dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Hornblower\dialogs\ENGLISH\Lt. Percy Buckland_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Hornblower\dialogs\ENGLISH\Lt. Uriah Quelp_Dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Hornblower\dialogs\ENGLISH\Lt. William Bush_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Hornblower\dialogs\ENGLISH\Major Dunnitt_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Hornblower\dialogs\ENGLISH\Major Hogan_Dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Hornblower\dialogs\ENGLISH\Maria Mason_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Hornblower\dialogs\ENGLISH\Matthews_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Hornblower\dialogs\ENGLISH\Midshipman Hunter_Dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Hornblower\dialogs\ENGLISH\Mrs. Mason_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Hornblower\dialogs\ENGLISH\patrol_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Hornblower\dialogs\ENGLISH\Richard Sharpe_Dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Hornblower\dialogs\ENGLISH\Rifleman Cooper_Dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Hornblower\dialogs\ENGLISH\Rifleman Tongue_Dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Hornblower\dialogs\ENGLISH\RN_Sailor_Dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Hornblower\dialogs\ENGLISH\Sir Edward Pellew_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Hornblower\dialogs\ENGLISH\Sir Hew Dalrymple_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Hornblower\dialogs\ENGLISH\Smug Larr_Dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Hornblower\dialogs\ENGLISH\Styles_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Hornblower\dialogs\ENGLISH\Teresa Moreno_Dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Hornblower\dialogs\ENGLISH\The Duchess of Wharfedale_Dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Hornblower\dialogs\ENGLISH\The Earl of Edrington_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Hornblower\dialogs\ENGLISH\William Chumley_Dialog.h"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\Hornblower\dialogs"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Hornblower\dialogs\Maria Mason_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Hornblower\dialogs\William Chumley_Dialog.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\Hornblower\quests"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Hornblower\quests\both_reaction.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Hornblower\quests\quests_reaction.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\Hornblower"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Hornblower\StartStoryline.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\Hornblower.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\JackSparrow\characters\init"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\JackSparrow\characters\init\Officers.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\JackSparrow\characters\init\QuebradasCostillas.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\JackSparrow\characters\init\Redmond.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\JackSparrow\characters\init\TempQuest.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\JackSparrow\characters\init\TempQuestEnemy.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\JackSparrow\dialogs"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\JackSparrow\dialogs\Albin Bonaventure_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\JackSparrow\dialogs\Annabella Brin_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\JackSparrow\dialogs\Antoine Lebretton_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\JackSparrow\dialogs\blaze_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\JackSparrow\dialogs\Brian Armstrong_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\JackSparrow\dialogs\Charles Windem_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\JackSparrow\dialogs\claudio burrieza_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\JackSparrow\dialogs\Duarte Correja_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\JackSparrow\dialogs\Edmund Christobel Shaw_dialog.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\JackSparrow\dialogs\ENGLISH"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\JackSparrow\dialogs\ENGLISH\Albin Bonaventure_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\JackSparrow\dialogs\ENGLISH\blaze_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\JackSparrow\dialogs\ENGLISH\Charles Windem_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\JackSparrow\dialogs\ENGLISH\Davy Jones_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\JackSparrow\dialogs\ENGLISH\Everard Gordon_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\JackSparrow\dialogs\ENGLISH\Konrad Kulczycki_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\JackSparrow\dialogs\ENGLISH\Laurence Wellman_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\JackSparrow\dialogs\ENGLISH\Peter Willemoes_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\JackSparrow\dialogs\ENGLISH\Pintel_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\JackSparrow\dialogs\ENGLISH\Reynard Grueneveldt_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\JackSparrow\dialogs\ENGLISH\Robert Christopher Silehard_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\JackSparrow\dialogs\ENGLISH\Storyteller_dialog.h"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\JackSparrow\dialogs"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\JackSparrow\dialogs\Everard Gordon_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\JackSparrow\dialogs\Father Bernard_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\JackSparrow\dialogs\Fred Bob_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\JackSparrow\dialogs\Friedrich Corleis_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\JackSparrow\dialogs\Ines Diaz_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\JackSparrow\dialogs\Jaoquin de masse_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\JackSparrow\dialogs\John Adams_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\JackSparrow\dialogs\John Clifford Brin_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\JackSparrow\dialogs\Joseph Claude Le Moigne_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\JackSparrow\dialogs\Josephine Bonassieu_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\JackSparrow\dialogs\Konrad Kulczycki_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\JackSparrow\dialogs\Lastcrew_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\JackSparrow\dialogs\padre Domingues_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\JackSparrow\dialogs\Pierart Kamerling_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\JackSparrow\dialogs\Robert Christopher Silehard_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\JackSparrow\dialogs\Sao Feng_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\JackSparrow\dialogs\Simon Hanpool_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\JackSparrow\dialogs\Skull_dialog.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\JackSparrow\items"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\JackSparrow\items\initQuestItems.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\JackSparrow\quests"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\JackSparrow\quests\both_reaction.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\JackSparrow\quests\quests_reaction.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\JackSparrow"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\JackSparrow\StartStoryline.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\JackSparrow.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\standard\characters\init"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\standard\characters\init\Officers.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\standard\characters\init\Story.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\standard\characters\init\TempQuest.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\standard\characters\init\TempQuestEnemy.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\standard\DIALOGS\Counterspy_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\standard\DIALOGS\Edgar Attwood_dialog.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\Edgar Attwood_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\Ewan Glover_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\Faust Gasquet_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\Ferro Cerezo_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\Pirates_vs_Blaze.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\Rene Dutruel_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\Vincent Bethune_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\Wilfred Bythesea_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\Wilfred_dialog.h"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\standard\DIALOGS\Ewan Glover_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\standard\DIALOGS\Faust Gasquet_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\standard\DIALOGS\Ferro Cerezo_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\standard\DIALOGS\Pirates_vs_Blaze.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\standard\DIALOGS\Rene Dutruel_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\standard\DIALOGS\Robert Christopher Silehard_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\standard\DIALOGS\Vincent Bethune_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\standard\DIALOGS\Wilfred Bythesea_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\standard\DIALOGS\Wilfred_dialog.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\standard\items"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\standard\items\initQuestItems.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\standard\Locations\init"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\standard\Locations\init\QuestLocations.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\standard\quests"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\standard\quests\both_reaction.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\standard\quests\quests_reaction.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\standard"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\standard\Rumour_Data.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\standard\SL_Reinit.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\standard\StartStoryline.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\standard.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\WoodesRogers\characters\init"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\WoodesRogers\characters\init\TempQuest.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\WoodesRogers\dialogs"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\WoodesRogers\dialogs\Charles Vane_dialog.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\WoodesRogers\dialogs\ENGLISH"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\WoodesRogers\dialogs\ENGLISH\Charles Vane_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\WoodesRogers\dialogs\ENGLISH\pircap defence_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\WoodesRogers\dialogs\ENGLISH\pircap fencingA_dialog.h"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\WoodesRogers\dialogs\ENGLISH\pircap fencingB_dialog.h"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\WoodesRogers\dialogs"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\WoodesRogers\dialogs\pircap defence_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\WoodesRogers\dialogs\pircap fencingA_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\WoodesRogers\dialogs\pircap fencingB_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\WoodesRogers\dialogs\pircap Taylor_dialog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\WoodesRogers\dialogs\Teach head_dialog.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\WoodesRogers\quests"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\WoodesRogers\quests\quests_reaction.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline\WoodesRogers"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\WoodesRogers\SL_utils.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\WoodesRogers\StartStoryline.c"
  SetOutPath "$INSTDIR\PROGRAM\Storyline"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Storyline\WoodesRogers.c"
  SetOutPath "$INSTDIR\PROGRAM"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\sulan_shipslog.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\sulan_shipslog.h"
  SetOutPath "$INSTDIR\PROGRAM\Towns"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Towns\Events.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Towns\ImportExport.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Towns\InitTowns.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Towns\Towntable.c"
  SetOutPath "$INSTDIR\PROGRAM\Weather\Init"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Weather\Init\WhrFogRainCheck.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Weather\Init\WhrSetAzmAng.c"
  SetOutPath "$INSTDIR\PROGRAM\Weather"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\Weather\WhrWeather.c"
  SetOutPath "$INSTDIR\PROGRAM\WorldMap"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\WorldMap\DailyCrewUpdate.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\WorldMap\worldmap.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\WorldMap\worldmap_encgen.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\WorldMap\worldmap_events.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\WorldMap\worldmap_globals.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\WorldMap\worldmap_init.c"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\PROGRAM\WorldMap\worldmap_reload.c"
  SetOutPath "$INSTDIR\RESOURCE\animation"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\animation\fast_man.an"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\animation\fast_man.ani"
  SetOutPath "$INSTDIR\RESOURCE\animation\Heads"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\animation\Heads\h_47_JRMMCmd.ani"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\animation\Heads\h_47_JRMMCpt.ani"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\animation\Heads\h_47_JRMMLcm.ani"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\animation\Heads\h_47_JRMMLt1.ani"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\animation\Heads\h_47_JRMMLt2.ani"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\animation\Heads\h_47_JRMMSub.ani"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\animation\Heads\h_Animist_Elting.ani"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\animation\Heads\h_Arthur Gordon Pym.ani"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\animation\Heads\h_CapJRMM.ani"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\animation\Heads\h_Captain Kidd.ani"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\animation\Heads\h_Corsair1_J.ani"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\animation\Heads\h_Corsair2_J.ani"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\animation\Heads\h_Corsair3_J.ani"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\animation\Heads\h_Corsair4_J.ani"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\animation\Heads\h_Cpnnelson.ani"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\animation\Heads\h_deserter_us1.ani"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\animation\Heads\h_deserter_us2.ani"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\animation\Heads\h_Howard_Pyle.ani"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\animation\Heads\h_hunter_bandit.ani"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\animation\Heads\h_indian_bandit.ani"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\animation\Heads\h_indian_trader.ani"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\animation\Heads\h_Laurens_de_Graaf.ani"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\animation\Heads\h_maroon1.ani"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\animation\Heads\h_maroon2.ani"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\animation\Heads\h_maroon3.ani"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\animation\Heads\h_maroon4.ani"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\animation\Heads\h_maroon5.ani"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\animation\Heads\h_maroon_girl.ani"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\animation\Heads\h_mayan_warrior.ani"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\animation\Heads\h_mystery_monk.ani"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\animation\Heads\h_Peter_Blood.ani"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\animation\Heads\h_white_trash1.ani"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\animation\Heads\h_white_trash2.ani"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\animation\Heads\h_William Legrand2.ani"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\animation\Heads\h_William Legrand3.ani"
  SetOutPath "$INSTDIR\RESOURCE\foam\islands"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\foam\islands\QuebradasCostillas.ini"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\foam\islands\QuebradasCostillas.tga.zap"
  SetOutPath "$INSTDIR\RESOURCE\foam\locations\Outside\Passage"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\foam\locations\Outside\Passage\Cuba_shore_02.ini"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\foam\locations\Outside\Passage\Cuba_shore_02.tga.zap"
  SetOutPath "$INSTDIR\RESOURCE\foam\locations\Outside\Shore_6"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\foam\locations\Outside\Shore_6\Colombia_shore.ini"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\foam\locations\Outside\Shore_6\Colombia_shore.tga.zap"
  SetOutPath "$INSTDIR\RESOURCE\foam\locations\Town_Oranjestad\port"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\foam\locations\Town_Oranjestad\port\Oranjestad_port.ini"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\foam\locations\Town_Oranjestad\port\Oranjestad_port.tga.zap"
  SetOutPath "$INSTDIR\RESOURCE\foam\locations\town_QC\port"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\foam\locations\town_QC\port\QC_port.tga.zap"
  SetOutPath "$INSTDIR\RESOURCE\foam\locations\Town_Santiago\port"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\foam\locations\Town_Santiago\port\Santiago_port.ini"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\foam\locations\Town_Santiago\port\Santiago_port.tga.zap"
  SetOutPath "$INSTDIR\RESOURCE\foam\locations\Town_Tortuga"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\foam\locations\Town_Tortuga\Tortuga_port.ini"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\foam\locations\Town_Tortuga\Tortuga_port.tga.zap"
  SetOutPath "$INSTDIR\RESOURCE\INI\ALIASES"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\ALIASES\Greetings_alias.ini"
  SetOutPath "$INSTDIR\RESOURCE\INI\INTERFACES"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\INTERFACES\book.ini"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\INTERFACES\gamble.ini"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\INTERFACES\items.ini"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\INTERFACES\perks.ini"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\INTERFACES\pictures.ini"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\INTERFACES\select_storyline.ini"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\INTERFACES\TradeBook.ini"
  SetOutPath "$INSTDIR\RESOURCE\INI\NEW_INTERFACES\animation"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\NEW_INTERFACES\animation\TradeBook.ini"
  SetOutPath "$INSTDIR\RESOURCE\INI\NEW_INTERFACES"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\NEW_INTERFACES\book.ini"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\NEW_INTERFACES\gamble.ini"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\NEW_INTERFACES\items.ini"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\NEW_INTERFACES\perks.ini"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\NEW_INTERFACES\select_storyline.ini"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\NEW_INTERFACES\TradeBook.ini"
  SetOutPath "$INSTDIR\RESOURCE\INI\PARTICLES"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\PARTICLES\particles.ini"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\PARTICLES\ship_fire.ini"
  SetOutPath "$INSTDIR\RESOURCE\INI"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\sound_scheme.ini"
  SetOutPath "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\AbilityDescribe.txt"
  SetOutPath "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\BOOKS"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\BOOKS\book2.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\BOOKS\book_exorcist.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\BOOKS\patrolbook.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\BOOKS\skillbook1.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\BOOKS\skillbook3.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\BOOKS\smugglingbook.txt"
  SetOutPath "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\characters_names.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\commands_name.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\common.ini"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\EventsDesribe.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\InterfaceDescribe.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\interface_strings.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\ItemsDescribe.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\models_description.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\PlayerType_descriptions.txt"
  SetOutPath "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\QUESTBOOK"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\QUESTBOOK\animists.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\QUESTBOOK\artois.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\QUESTBOOK\bartolomeu.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\QUESTBOOK\Blacques.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\QUESTBOOK\Church_help.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\QUESTBOOK\Contact.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\QUESTBOOK\convoy.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\QUESTBOOK\crew_affairs.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\QUESTBOOK\daughter.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\QUESTBOOK\estrella.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\QUESTBOOK\fetch.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\QUESTBOOK\fred_bob.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\QUESTBOOK\Hire_by_france_for_defeat_england_corvette.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\QUESTBOOK\Hitman.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\QUESTBOOK\Jackpot.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\QUESTBOOK\larrouse.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\QUESTBOOK\Lucas.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\QUESTBOOK\mendes.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\QUESTBOOK\Moulin.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\QUESTBOOK\murro.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\QUESTBOOK\nigel.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\QUESTBOOK\Patric.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\QUESTBOOK\Santiago.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\QUESTBOOK\smuggle.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\QUESTBOOK\telescope.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\QUESTBOOK\Thomas_delivery.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\QUESTBOOK\Thomas_OReily_contraband.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\QUESTBOOK\Turkshelp.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\QUESTBOOK\Vogelstruijs.txt"
  SetOutPath "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\rumour_strings.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\ShipModels_descriptions.txt"
  SetOutPath "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\Assassin"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\Storyline\Assassin\characters_names.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\Storyline\Assassin\ItemsDescribe.txt"
  SetOutPath "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\Assassin\QUESTBOOK"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\Storyline\Assassin\QUESTBOOK\Cannons.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\Storyline\Assassin\QUESTBOOK\Trap.txt"
  SetOutPath "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\Bartolomeu"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\Storyline\Bartolomeu\ItemsDescribe.txt"
  SetOutPath "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\Bartolomeu\QUESTBOOK"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\Storyline\Bartolomeu\QUESTBOOK\Bad_Blaze.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\Storyline\Bartolomeu\QUESTBOOK\Firework.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\Storyline\Bartolomeu\QUESTBOOK\Zombie.txt"
  SetOutPath "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\BraveBlackFlag"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\Storyline\BraveBlackFlag\characters_names.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\Storyline\BraveBlackFlag\ItemsDescribe.txt"
  SetOutPath "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\BraveBlackFlag\QUESTBOOK"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\Storyline\BraveBlackFlag\QUESTBOOK\Beginning_Agent.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\Storyline\BraveBlackFlag\QUESTBOOK\Beginning_Navy.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\Storyline\BraveBlackFlag\QUESTBOOK\Beginning_Rogue.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\Storyline\BraveBlackFlag\QUESTBOOK\StormyStart.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\Storyline\BraveBlackFlag\QUESTBOOK\Tutorial_AppearedOnIsland.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\Storyline\BraveBlackFlag\QUESTBOOK\Tutorial_Shipyard.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\Storyline\BraveBlackFlag\QUESTBOOK\Tutorial_SpyGlass.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\Storyline\BraveBlackFlag\QUESTBOOK\Tutorial_Store.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\Storyline\BraveBlackFlag\QUESTBOOK\Tutorial_Tavern.txt"
  SetOutPath "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\DevlinOpera"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\Storyline\DevlinOpera\characters_names.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\Storyline\DevlinOpera\ItemsDescribe.txt"
  SetOutPath "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\DevlinOpera\QUESTBOOK"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\Storyline\DevlinOpera\QUESTBOOK\Capture FdF.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\Storyline\DevlinOpera\QUESTBOOK\Such Devoted Sisters.txt"
  SetOutPath "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\GoldBug"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\Storyline\GoldBug\ItemsDescribe.txt"
  SetOutPath "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\GoldBug\QUESTBOOK"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\Storyline\GoldBug\QUESTBOOK\Bishop's_Hostel.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\Storyline\GoldBug\QUESTBOOK\Charcoal.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\Storyline\GoldBug\QUESTBOOK\Fireworks.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\Storyline\GoldBug\QUESTBOOK\Gunpowder.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\Storyline\GoldBug\QUESTBOOK\Navigation_items.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\Storyline\GoldBug\QUESTBOOK\Salpeter.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\Storyline\GoldBug\QUESTBOOK\Sulfur.txt"
  SetOutPath "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\Hornblower\QUESTBOOK"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\Storyline\Hornblower\QUESTBOOK\Attack on Antigua.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\Storyline\Hornblower\QUESTBOOK\Mutiny.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\Storyline\Hornblower\QUESTBOOK\Old Friends - New Enemies.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\Storyline\Hornblower\QUESTBOOK\Retribution.txt"
  SetOutPath "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\JackSparrow"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\Storyline\JackSparrow\characters_names.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\Storyline\JackSparrow\ItemsDescribe.txt"
  SetOutPath "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\standard"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\Storyline\standard\ItemsDescribe.txt"
  SetOutPath "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\standard\QUESTBOOK"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\Storyline\standard\QUESTBOOK\StormyStart.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\Storyline\standard\QUESTBOOK\Story_OxbayCaptured.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\Storyline\standard\QUESTBOOK\Tutorial_Tavern.txt"
  SetOutPath "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\standard"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\Storyline\standard\rumour_strings.txt"
  SetOutPath "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\WoodesRogers"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\INI\TEXTS\ENGLISH\Storyline\WoodesRogers\ItemsDescribe.txt"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Ammo"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\arrow.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\battleax.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\bladeC35.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\bladetriton.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\Blade_ProudOfAnvil.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\blowgun.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\blthag02.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\bow.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Ammo\BuildingItemsJRH"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\1_lanternD_day.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\1_lanternD_night.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\1_lanternE_day.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\1_lanternE_night.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\1_lanternF_day.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\1_lanternF_night.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\2_lanternsA_day.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\2_lanternsA_night.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\2_lanternsB_day.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\2_lanternsB_night.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\2_lanternsC_day.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\2_lanternsC_night.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\2_sabres.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\32_chairs_L.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\32_chairs_R.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\anchor_big.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\anchor_item.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\bars_down.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\bench_scales.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\body.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\BugIllustration.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\cannon1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\cannon2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\cannon_pipe45_up.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\carpet3V.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\carpet4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\chimney_45.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\chimney_45_night.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\chimney_pot_night.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\confessional.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\derrick.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\door_panel.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\door_PL.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\door_Tortuga.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\door_Tortuga2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\gatedoor_BRI.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\gatedoor_plantation.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\gatedoor_shipyard.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\gatedoor_Tortuga1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\gatedoor_Tortuga1_night.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\gatedoor_Tortuga2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\Gatefloor_cavern.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\Gatefloor_w45.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\gibbet.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\hatch11DB.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\hatch11D_O3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\hatch16_T.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\hatch16_V.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\hay.GM"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\jars.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\market_tent.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\market_tent_fruit.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\NicheBooks.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\palm2_big.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\palm2_big_night.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\periscope.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\pirate_flag.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\pole3_small.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\port_mast1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\port_mast2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\port_rey1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\pyrite_basket.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\pyrite_basket_up.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\roof_top.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\ROPE_vertical_long.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\ship_building.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\ship_building_night.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\skull3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\stonebox.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\Textile.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\Textile2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\Textile3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\Textile4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\tree2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\tree2_night.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\tree3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\tree_barrel.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\wagon.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\walk_plank.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\walk_plank_180.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\watchtower.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\BuildingItemsJRH\WhalingShip.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Ammo"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\halberd.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\LongRifle_BT.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\LongRifle_BT_back.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\LongRifle_C.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\LongRifle_CT.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\LongRifle_CT_back.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\LongRifle_C_back.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\LongRifle_W.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\LongRifle_WT.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\LongRifle_WT_back.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\LongRifle_W_back.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\machete.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\maquahuitl.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Ammo\OtherItemsJRH"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\OtherItemsJRH\bladeacid.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\OtherItemsJRH\bladefireworks.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\OtherItemsJRH\bladefryingpan.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\OtherItemsJRH\bottle_AC2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\OtherItemsJRH\bottle_AG2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\OtherItemsJRH\bottle_AN2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\OtherItemsJRH\bottle_AY2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\OtherItemsJRH\bottle_AZ2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\OtherItemsJRH\bottle_BC1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\OtherItemsJRH\bottle_BC2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\OtherItemsJRH\bottle_BE0.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\OtherItemsJRH\bottle_BG1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\OtherItemsJRH\bottle_BG2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\OtherItemsJRH\bottle_BN1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\OtherItemsJRH\bottle_BS1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\OtherItemsJRH\bottle_BS2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\OtherItemsJRH\bottle_BY1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\OtherItemsJRH\bottle_BY2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\OtherItemsJRH\bottle_BZ1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\OtherItemsJRH\bottle_BZ2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\OtherItemsJRH\clubmusketoon.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\OtherItemsJRH\firesteel.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\OtherItemsJRH\flintstone.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\OtherItemsJRH\sack2_big.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\OtherItemsJRH\sextant2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\OtherItemsJRH\sledgehammer.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\OtherItemsJRH\sulphur_basket_F.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\OtherItemsJRH\tinderbox.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\OtherItemsJRH\wood2.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Ammo"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\pistol26.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\PoisenedDagger.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\rocket.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\shield_back.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\shield_hand.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\tomahawk.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\trident.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\whip_out.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ammo\whip_rolled.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Characters"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\47_JRMMCmd.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\47_JRMMCpt.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\47_JRMMLcm.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\47_JRMMLt1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\47_JRMMLt2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\47_JRMMSub.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\Animist_ELting.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\Blaze4_A1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\Blaze4_A2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\Blaze4_A3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\Blaze5_A1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\Blaze5_A2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\Blaze5_A3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\Blaze6_A1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\Blaze6_A2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\Blaze6_A3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\Blaze7_A1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\Blaze7_A2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\Blaze7_A3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\Blaze_A1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\Blaze_A2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\Blaze_A3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\Blaze_NB.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\Blaze_NB_A1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\Blaze_NB_A2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\Blaze_NB_A3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\boulder.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\box_ghost.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\CapJRMM.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\Captain Kidd.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\conquistador.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\Corsair1_J.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\Corsair2_J.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\Corsair3_J.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\Corsair4_J.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\Cpnnelson.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\deserter_us1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\deserter_us2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\GypsyCaptn_11.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\hunter_bandit.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\indian_bandit.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\indian_trader.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\inquisition_monk1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\inquisition_monk2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\inquisition_monk3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\inquisition_monk4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\inquisition_priest.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\Laurens_de_Graaf.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\maroon1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\maroon2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\maroon3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\maroon4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\maroon5.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\maroon_girl.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\Mayan_warrior.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\mystery_monk.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\Peter_Blood.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\white_trash1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\white_trash2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\William Legrand2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Characters\William Legrand3.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Heads"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Heads\h_47_JRMMCmd.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Heads\h_47_JRMMCpt.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Heads\h_47_JRMMLcm.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Heads\h_47_JRMMLt1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Heads\h_47_JRMMLt2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Heads\h_47_JRMMSub.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Heads\h_Animist_Elting.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Heads\h_Arthur Gordon Pym.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Heads\h_Blaze4_A1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Heads\h_Blaze4_A2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Heads\h_Blaze4_A3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Heads\h_Blaze5_A1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Heads\h_Blaze5_A2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Heads\h_Blaze5_A3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Heads\h_Blaze6_A1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Heads\h_Blaze6_A2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Heads\h_Blaze6_A3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Heads\h_Blaze7_A1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Heads\h_Blaze7_A2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Heads\h_Blaze7_A3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Heads\h_BlazeNB_A1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Heads\h_BlazeNB_A2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Heads\h_BlazeNB_A3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Heads\h_Blaze_A1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Heads\h_Blaze_A2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Heads\h_Blaze_A3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Heads\h_Blaze_NB.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Heads\h_CapJRMM.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Heads\h_Captain Kidd.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Heads\h_Corsair1_J.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Heads\h_Corsair2_J.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Heads\h_Corsair3_J.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Heads\H_Corsair4_J.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Heads\h_Cpnnelson.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Heads\h_deserter_us1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Heads\h_deserter_us2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Heads\h_GypsyCaptn_10.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Heads\h_GypsyCaptn_9.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Heads\h_Howard_Pyle.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Heads\h_hunter_bandit.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Heads\h_indian_bandit.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Heads\h_indian_trader.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Heads\h_Laurens_de_Graaf.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Heads\h_maroon1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Heads\h_maroon2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Heads\h_maroon3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Heads\h_maroon4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Heads\h_maroon5.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Heads\h_maroon_girl.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Heads\h_mayan_warrior.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Heads\h_mystery_monk.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Heads\h_Peter_Blood.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Heads\h_white_trash1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Heads\h_white_trash2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Heads\h_William Legrand2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Heads\h_William Legrand3.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Islands\QuebradasCostillas"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Islands\QuebradasCostillas\QuebradasCostillas.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Islands\QuebradasCostillas\QUEBRADASCOSTILLAS_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Islands\QuebradasCostillas\QUEBRADASCOSTILLAS_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Islands\QuebradasCostillas\QuebradasCostillas_fort1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Islands\QuebradasCostillas\QuebradasCostillas_fort1_locators.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Islands\QuebradasCostillas\QuebradasCostillas_fort1_Part1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Islands\QuebradasCostillas\QUEBRADASCOSTILLAS_FORT1_PART1_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Islands\QuebradasCostillas\QUEBRADASCOSTILLAS_FORT1_PART1_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Islands\QuebradasCostillas\QUEBRADASCOSTILLAS_FORT1_PART1_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Islands\QuebradasCostillas\QUEBRADASCOSTILLAS_FORT1_PART1_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Islands\QuebradasCostillas\QuebradasCostillas_locators.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Islands\QuebradasCostillas\QUEBRADASCOSTILLAS_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Islands\QuebradasCostillas\QUEBRADASCOSTILLAS_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Islands\QuebradasCostillas\QuebradasCostillas_refl.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Islands\QuebradasCostillas\QUEBRADASCOSTILLAS_REFL_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Islands\QuebradasCostillas\QUEBRADASCOSTILLAS_REFL_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Islands\QuebradasCostillas\QUEBRADASCOSTILLAS_REFL_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Islands\QuebradasCostillas\QUEBRADASCOSTILLAS_REFL_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Islands\QuebradasCostillas\QuebradasCostillas_seabed.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Islands\QuebradasCostillas\QUEBRADASCOSTILLAS_SEABED_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Islands\QuebradasCostillas\QUEBRADASCOSTILLAS_SEABED_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Islands\QuebradasCostillas\QUEBRADASCOSTILLAS_SEABED_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Islands\QuebradasCostillas\QUEBRADASCOSTILLAS_SEABED_NIGHT1.COL"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Items"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Items\Animist_cloth.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Items\calabash.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Items\doc4A.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Items\Herbs.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Items\mayan_compass.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Items\mdchest_broken.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Items\spyglass6.GM"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\decks\deckBig"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\decks\deckBig\deckBigB_ld.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\decks\deckBig\deckBig_ld_x.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\decks\Kidds_cabin"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\decks\Kidds_cabin\PlutoStoreSmall.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\decks\Kidds_cabin\PlutoStoreSmall_day1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\decks\Kidds_cabin\PlutoStoreSmall_evening3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\decks\Kidds_cabin\PlutoStoreSmall_fd.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\decks\Kidds_cabin\PlutoStoreSmall_FD_day1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\decks\Kidds_cabin\PlutoStoreSmall_FD_evening3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\decks\Kidds_cabin\PlutoStoreSmall_FD_morning1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\decks\Kidds_cabin\PlutoStoreSmall_FD_night1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\decks\Kidds_cabin\PlutoStoreSmall_fn.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\decks\Kidds_cabin\PlutoStoreSmall_FN_day1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\decks\Kidds_cabin\PlutoStoreSmall_FN_evening3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\decks\Kidds_cabin\PlutoStoreSmall_FN_morning1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\decks\Kidds_cabin\PlutoStoreSmall_FN_night1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\decks\Kidds_cabin\PlutoStoreSmall_locators.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\decks\Kidds_cabin\PlutoStoreSmall_locators_GB.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\decks\Kidds_cabin\PlutoStoreSmall_morning1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\decks\Kidds_cabin\PlutoStoreSmall_night1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\decks\Kidds_cabin\PlutoStoreSmall_patch_day.ptc"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\decks\Kidds_cabin\PlutoStoreSmall_windows.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Fort_Inside\White_Fort"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Fort_Inside\White_Fort\fort2_locators_GB1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Fort_Inside\White_Fort\fort2_locators_GB2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Fort_Inside\White_Fort\fort2_locators_GB3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Fort_Inside\White_Fort\fort2_locators_GB4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Fort_Inside\White_Fort\plankA.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Fort_Inside\White_Fort\plankA_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Fort_Inside\White_Fort\plankA_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Fort_Inside\White_Fort\plankA_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Fort_Inside\White_Fort\plankA_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Fort_Inside\White_Fort\plankB.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Fort_Inside\White_Fort\plankB_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Fort_Inside\White_Fort\plankB_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Fort_Inside\White_Fort\plankB_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Fort_Inside\White_Fort\plankB_NIGHT1.COL"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Incas Temple\Labirint"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Incas Temple\Labirint\lab1_l_test.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Incas Temple\Labirint\lab2_l_ccc.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Incas Temple\Labirint\Tunel_p.ptc"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Inside\apothecary\back"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\apothecary\back\GRMS_D_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\apothecary\back\GRMS_E_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\apothecary\back\GRMS_N_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\apothecary\back\GRMS_N_EVENING3.COL"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Inside\apothecary"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\apothecary\RESP_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\apothecary\RESP_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\apothecary\RESP_L_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\apothecary\RESP_L_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\apothecary\RESP_L_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\apothecary\ResP_l_pym_CLOSED.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\apothecary\ResP_l_pym_OPEN.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\apothecary\RESP_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\apothecary\RESP_W_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\apothecary\RESP_W_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\apothecary\RESP_W_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\apothecary\sack2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\apothecary\sack2_big.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\apothecary\sack2_big_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\apothecary\sack2_big_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\apothecary\sack2_big_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\apothecary\sack2_big_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\apothecary\sack2_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\apothecary\sack2_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\apothecary\sack2_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\apothecary\sack2_NIGHT1.COL"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Bank\back"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Bank\back\tor3_d.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Bank\back\tor3_e.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Bank\back\tor3_m.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Bank\back\tor3_n.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Bank"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Bank\Bank_locators_Tortuga.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Bank\bars_down.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Blacksmith1"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Blacksmith1\mh_l_GB.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Brothel\back"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Brothel\back\tor2_d.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Brothel\back\tor2_e.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Brothel\back\tor2_m.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Brothel\back\tor2_n.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Inside\brothel_room\back"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\brothel_room\back\tor_d.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\brothel_room\back\tor_e.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\brothel_room\back\tor_m.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\brothel_room\back\tor_n.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Inside\cavernMedium"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\cavernMedium\barrelA.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\cavernMedium\barrelA_day1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\cavernMedium\barrelA_evening3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\cavernMedium\barrelA_morning1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\cavernMedium\barrelA_night1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\cavernMedium\barrelB.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\cavernMedium\barrelB_day1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\cavernMedium\barrelB_evening3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\cavernMedium\barrelB_morning1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\cavernMedium\barrelB_night1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\cavernMedium\barrelC.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\cavernMedium\barrelC_day1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\cavernMedium\barrelC_evening3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\cavernMedium\barrelC_morning1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\cavernMedium\barrelC_night1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\cavernMedium\bottleA.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\cavernMedium\bottleA_cork.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\cavernMedium\bottleB.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\cavernMedium\bottleB_cork.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\cavernMedium\bottleC.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\cavernMedium\bottleC_cork.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\cavernMedium\cavernMedium_locators_GB_dry.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\cavernMedium\cavernMedium_locators_GB_flooded.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\cavernMedium\ladder_bottom.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\cavernMedium\ladder_bottom_day1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\cavernMedium\ladder_bottom_evening3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\cavernMedium\ladder_bottom_morning1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\cavernMedium\ladder_bottom_night1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\cavernMedium\ladder_rope.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\cavernMedium\ladder_rope_day1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\cavernMedium\ladder_rope_evening3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\cavernMedium\ladder_rope_morning1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\cavernMedium\ladder_rope_night1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\cavernMedium\ladder_wall.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\cavernMedium\ladder_wall_day1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\cavernMedium\ladder_wall_evening3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\cavernMedium\ladder_wall_morning1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\cavernMedium\ladder_wall_night1.COL"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Cave_Ship"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Cave_Ship\Cave_Ship_l_GB.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Cave_Ship\Cave_Ship_l_GB_box.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Cave_Ship\Cave_Ship_l_GB_closed.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Cave_Ship\Cave_Ship_l_GB_open.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Cellar_downstairs"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Cellar_downstairs\Cellar_downstairs_locators.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Chinese_restaurant"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Chinese_restaurant\1054004_day1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Chinese_restaurant\1054004_evening3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Chinese_restaurant\1054004_morning1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Chinese_restaurant\1054004_night1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Chinese_restaurant\chinarest_l_empty.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Chinese_restaurant\chinarest_l_guests.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Chinese_restaurant\chinarest_l_items.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Chinese_restaurant\nc_day1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Chinese_restaurant\nc_evening3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Chinese_restaurant\nc_morning1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Chinese_restaurant\nc_night1.COL"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Inside\church_3"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\church_3\church3_l_BOP_closed.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\church_3\church3_l_BOP_neutral.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\church_3\church3_l_BOP_open.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Corridor"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Corridor\storeSmall_locators_dark_Tortuga.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Corridor\storeSmall_locators_JRH_dark_sulfur.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Inside\dark_storeroom"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\dark_storeroom\dark_storeroom.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\dark_storeroom\dark_storeroom_day1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\dark_storeroom\dark_storeroom_evening3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\dark_storeroom\dark_storeroom_l_GB1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\dark_storeroom\dark_storeroom_l_GB2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\dark_storeroom\dark_storeroom_l_GB4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\dark_storeroom\dark_storeroom_morning1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\dark_storeroom\dark_storeroom_night1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\dark_storeroom\dark_storeroom_p.ptc"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Inside\den\back"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\den\back\tor_d.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\den\back\tor_e.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\den\back\tor_m.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\den\back\tor_n.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Doubleflour_house\back"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Doubleflour_house\back\tor2_d.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Doubleflour_house\back\tor2_e.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Doubleflour_house\back\tor2_m.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Doubleflour_house\back\tor2_n.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Doubleflour_house"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Doubleflour_house\lh_F1_l_charcoal.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Doubleflour_house\lh_F1_l_GB_maroon.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Doubleflour_house\lh_F1_l_pym.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Doubleflour_house\lh_F1_l_Tortuga.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Doubleflour_house\lh_F2_l_pym_CLOSED.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Doubleflour_house\lh_F2_l_pym_CLOSED_ANCHOR.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Doubleflour_house\lh_F2_l_pym_OPEN.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Doubleflour_house\lh_F2_l_Tortuga.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Doubleflour_house\LH_F2_w_pym.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Doubleflour_house\LH_F2_W_pym_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Doubleflour_house\LH_F2_W_pym_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Doubleflour_house\LH_F2_W_pym_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Doubleflour_house\LH_F2_W_pym_NIGHT1.COL"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Dungeon_1_wood"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Dungeon_1_wood\d01_l_GB2.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Hut"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Hut\Hut_locators_charcoal1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Hut\Hut_locators_charcoal2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Hut\Hut_locators_charcoal3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Hut\Hut_locators_charcoal4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Hut\Hut_locators_charcoal5.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Hut\Hut_locators_charcoal6.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Hut\Hut_locators_charcoal7.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Hut\wood4_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Hut\wood4_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Hut\wood4_stump.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Hut\wood4_stump_day1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Hut\wood4_stump_evening3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Hut\wood4_stump_morning1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Hut\wood4_stump_night1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Hut\wood_short_floor.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Hut\wood_short_floor_day1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Hut\wood_short_floor_evening3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Hut\wood_short_floor_morning1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Hut\wood_short_floor_night1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Hut\wood_short_stump.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Hut\wood_short_stump_day1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Hut\wood_short_stump_evening3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Hut\wood_short_stump_morning1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Hut\wood_short_stump_night1.COL"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Inside\HutRoundInside"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\HutRoundInside\chimney.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\HutRoundInside\chimney_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\HutRoundInside\chimney_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\HutRoundInside\chimney_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\HutRoundInside\chimney_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\HutRoundInside\HutRoundInside.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\HutRoundInside\HutRoundInside_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\HutRoundInside\HutRoundInside_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\HutRoundInside\HutRoundInside_locators.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\HutRoundInside\HutRoundInside_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\HutRoundInside\HutRoundInside_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\HutRoundInside\HutRoundInside_patch.ptc"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\HutRoundInside\wood4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\HutRoundInside\wood4_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\HutRoundInside\wood4_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\HutRoundInside\wood4_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\HutRoundInside\wood4_NIGHT1.COL"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Inside\InquisitionCave"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\InquisitionCave\InquisitionCave.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\InquisitionCave\InquisitionCave_alpha.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\InquisitionCave\InquisitionCave_alpha_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\InquisitionCave\InquisitionCave_alpha_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\InquisitionCave\InquisitionCave_alpha_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\InquisitionCave\InquisitionCave_alpha_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\InquisitionCave\InquisitionCave_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\InquisitionCave\InquisitionCave_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\InquisitionCave\InquisitionCave_locators.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\InquisitionCave\InquisitionCave_locators_BOP.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\InquisitionCave\InquisitionCave_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\InquisitionCave\InquisitionCave_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\InquisitionCave\InquisitionCave_patch.ptc"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\InquisitionCave\InquisitionCave_rand.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\InquisitionCave\InquisitionCave_rand_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\InquisitionCave\InquisitionCave_rand_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\InquisitionCave\InquisitionCave_rand_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\InquisitionCave\InquisitionCave_rand_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\InquisitionCave\InquisitionCave_torches.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\InquisitionCave\InquisitionCave_torches_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\InquisitionCave\InquisitionCave_torches_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\InquisitionCave\InquisitionCave_torches_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\InquisitionCave\InquisitionCave_torches_NIGHT1.COL"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Inside\largehouse01"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\largehouse01\largehouse01_locators_GB2.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Inside\largehouse02_farm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\largehouse02_farm\largehouse02_locators_GB.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Pirate_House\back"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Pirate_House\back\tor2_d.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Pirate_House\back\tor2_e.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Pirate_House\back\tor2_m.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Pirate_House\back\tor2_n.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Prison"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Prison\Pri_l_gibbet_GB.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Inside\ResBedRoom"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\ResBedRoom\bed_l_GB.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence2_admiral"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Residence2_admiral\Res02_l_GB.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Residence4"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Residence4\Res04_l_GB.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Shipyard\back"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Shipyard\back\tor3_d.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Shipyard\back\tor3_e.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Shipyard\back\tor3_m.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Shipyard\back\tor3_n.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Shipyard"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Shipyard\Sh01_l_Tortuga.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Shipyard2\back"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Shipyard2\back\tor3_d.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Shipyard2\back\tor3_e.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Shipyard2\back\tor3_m.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Shipyard2\back\tor3_n.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Shipyard3"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Shipyard3\sh03_l_GB_lutG.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Shipyard5"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Shipyard5\sh05_locators_GB.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Sklad_gunpowder"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Sklad_gunpowder\bottle_LZ1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Sklad_gunpowder\bottle_LZ2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Sklad_gunpowder\bottle_MZ2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Sklad_gunpowder\sklad.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Sklad_gunpowder\sklad_l_GB_barrel.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Sklad_gunpowder\sklad_l_GB_empty.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Inside\SmallChamber\back"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\SmallChamber\back\redb_d.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\SmallChamber\back\redb_e.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\SmallChamber\back\redb_m.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\SmallChamber\back\redb_n.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Inside\SmallChamber"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\SmallChamber\sh05.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\SmallChamber\SH05_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\SmallChamber\SH05_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\SmallChamber\sh05_l_chamber.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\SmallChamber\sh05_l_chamber1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\SmallChamber\sh05_l_chamber2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\SmallChamber\sh05_l_chamber3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\SmallChamber\sh05_l_chamber4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\SmallChamber\sh05_l_chamber5.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\SmallChamber\sh05_l_chamber6.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\SmallChamber\SH05_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\SmallChamber\SH05_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\SmallChamber\sh05_patch.ptc"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\SmallChamber\sh05_window.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\SmallChamber\SH05_WINDOW_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\SmallChamber\SH05_WINDOW_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\SmallChamber\SH05_WINDOW_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\SmallChamber\SH05_WINDOW_NIGHT1.COL"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Smallhome"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Smallhome\sh_l_GB.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Smallhome\sh_l_GB_loghouse.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Inside\StoneHouse\back"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\StoneHouse\back\tor2_d.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\StoneHouse\back\tor2_e.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\StoneHouse\back\tor2_m.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\StoneHouse\back\tor2_n.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Store01\back"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Store01\back\tor2_d.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Store01\back\tor2_e.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Store01\back\tor2_m.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Store01\back\tor2_n.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Store02"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Store02\Store02_locators_GB.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Inside\store04"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\store04\Store04_locators_GB_tower2B.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\store04\Store04_locators_GB_tower3A.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\store04\Store04_locators_GB_tower3B.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Inside\StoreHouse\back"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\StoreHouse\back\tor3_d.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\StoreHouse\back\tor3_e.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\StoreHouse\back\tor3_m.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\StoreHouse\back\tor3_n.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Inside\StoreHouse"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\StoreHouse\Storehouse_locators_Tortuga.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Inside\StoreSmall"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\StoreSmall\ss_l_GB_tailor.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Tavern01\back"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Tavern01\back\tor_d.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Tavern01\back\tor_e.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Tavern01\back\tor_m.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Tavern01\back\tor_n.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Tavern01"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Tavern01\tavern01_locators_GB.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Tavern01\tavern01_locators_Tortuga.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Tavern_2"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Tavern_2\tavern_2_l.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Tavern_2\tavern_2_l_bessop.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Inside\TempleRoundInside"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\TempleRoundInside\lever_down.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\TempleRoundInside\lever_down_day1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\TempleRoundInside\lever_down_evening3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\TempleRoundInside\lever_down_morning1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\TempleRoundInside\lever_down_night1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\TempleRoundInside\lever_up.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\TempleRoundInside\lever_up_day1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\TempleRoundInside\lever_up_evening3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\TempleRoundInside\lever_up_morning1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\TempleRoundInside\lever_up_night1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\TempleRoundInside\pyrite_stones1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\TempleRoundInside\pyrite_stones2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\TempleRoundInside\TRI_l_sulphur_closed.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\TempleRoundInside\TRI_l_sulphur_open.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\TempleRoundInside\wood_floor.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\TempleRoundInside\wood_floor_day1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\TempleRoundInside\wood_floor_evening3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\TempleRoundInside\wood_floor_morning1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\TempleRoundInside\wood_floor_night1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\TempleRoundInside\wood_sulph.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\TempleRoundInside\wood_sulph_day1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\TempleRoundInside\wood_sulph_evening3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\TempleRoundInside\wood_sulph_morning1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\TempleRoundInside\wood_sulph_night1.COL"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Warehouse"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Warehouse\lever0_down.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Warehouse\lever0_up.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Warehouse\lever2_down.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Warehouse\Roll_of_planks3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Warehouse\Roll_of_planks3_day1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Warehouse\Roll_of_planks3_evening3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Warehouse\Roll_of_planks3_morning1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Warehouse\Roll_of_planks3_night1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Warehouse\Roll_of_planks4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Warehouse\Roll_of_planks4_day1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Warehouse\Roll_of_planks4_evening3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Warehouse\Roll_of_planks4_morning1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Warehouse\Roll_of_planks4_night1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Warehouse\Roll_of_planks5.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Warehouse\Roll_of_planks5_day1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Warehouse\Roll_of_planks5_evening3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Warehouse\Roll_of_planks5_morning1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Warehouse\Roll_of_planks5_night1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Warehouse\warehouse_l_nitre_DD.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Warehouse\warehouse_l_nitre_DN.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Warehouse\warehouse_l_nitre_DW.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Warehouse\warehouse_l_nitre_ND.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Warehouse\warehouse_l_nitre_NN.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Warehouse\warehouse_l_nitre_NW.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Warehouse\warehouse_l_nitre_WD.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Warehouse\warehouse_l_nitre_WN.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Warehouse\warehouse_l_nitre_WW.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Inside\Wine_cellar"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Wine_cellar\bars_down.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Wine_cellar\BARS_DOWN_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Wine_cellar\bars_up.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Wine_cellar\BARS_UP_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Wine_cellar\door_N10.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Wine_cellar\DOOR_N10_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Wine_cellar\DOOR_N10_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Wine_cellar\DungeonVault1b_patch.ptc"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Wine_cellar\DUNGEONVAULT1_FONARS_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Wine_cellar\DUNGEONVAULT1_FONARS_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Wine_cellar\DUNGEONVAULT1_ORIG_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Wine_cellar\DUNGEONVAULT1_ORIG_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Wine_cellar\insidefort_locators.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Wine_cellar\INSIDEFORT_LOCATORS_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Inside\Wine_cellar\INSIDEFORT_LOCATORS_NIGHT1.COL"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\outside\Bishops_Hostel"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Bishops_Hostel\locator_BH1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Bishops_Hostel\locator_BH2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Bishops_Hostel\wood_step1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Bishops_Hostel\wood_step2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Bishops_Hostel\wood_step3.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\outside\Chinatown"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Chinatown\chinatown_locator.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Chinatown\chinese_room_locator.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Chinatown\night_nc.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Chinatown\NIGHT_NC_NIGHT1.COL"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\outside\Isle"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Isle\isle.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Isle\ISLE_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Isle\ISLE_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Isle\Isle_l.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Isle\ISLE_L_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Isle\ISLE_L_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Isle\ISLE_L_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Isle\ISLE_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Isle\ISLE_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Isle\isle_p.ptc"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle5"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Jungle5\donkey.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Jungle5\jungle5_locators.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_5"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Jungle_5\JUNGLE05_l_GB.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\outside\Jungle_Church"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Jungle_Church\rhouse_l_GB.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\outside\Passage"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Passage\bars_down.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Passage\bars_stuck.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Passage\bars_up.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Passage\ladder_gibbet.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Passage\ladder_gibbet_day1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Passage\ladder_gibbet_evening3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Passage\ladder_gibbet_morning1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Passage\ladder_gibbet_night1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Passage\ladder_lever.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Passage\ladder_lever_day1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Passage\ladder_lever_evening3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Passage\ladder_lever_morning1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Passage\ladder_lever_night1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Passage\ladder_rope.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Passage\ladder_rope_day1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Passage\ladder_rope_evening3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Passage\ladder_rope_morning1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Passage\ladder_rope_night1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Passage\lever_down.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Passage\lever_ground.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Passage\lever_up.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Passage\pass1_l_GB.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Passage\pass1_l_GB10.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Passage\pass1_l_GB9.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Passage\pass2_l_GB.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Passage\pass2_l_GB_raft.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Passage\plank2A.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Passage\plank2A_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Passage\plank2A_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Passage\plank2A_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Passage\plank2A_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Passage\plank2B.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Passage\plank2B_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Passage\plank2B_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Passage\plank2B_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Passage\plank2B_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Passage\plank_gate.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Passage\plank_gate_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Passage\plank_gate_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Passage\plank_gate_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Passage\plank_gate_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Passage\plank_ground.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Passage\plank_ground_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Passage\plank_ground_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Passage\plank_ground_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Passage\plank_ground_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Passage\rope_gibbet.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Passage\rope_gibbet_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Passage\rope_gibbet_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Passage\rope_gibbet_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Passage\rope_gibbet_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Passage\wood_step1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Passage\wood_step2.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\outside\Plantation"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Plantation\Plantation_l_GB_day.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Plantation\Plantation_l_GB_night.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\outside\Shore_ship"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Shore_ship\ShoreShip_l_GB_birds.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\outside\Shore_ship\ShoreShip_l_GB_wood.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\QuestTown_Charleston\Port"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\QuestTown_Charleston\Port\locator_port.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\QuestTown_Charleston\Port\night_smallmodel.GM"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\QuestTown_Charleston\Port\NIGHT_SMALLMODEL_NIGHT1.COL"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\QuestTown_Charleston\Town"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\QuestTown_Charleston\Town\locator_town.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\QuestTown_Charleston\Town\night_smallmodel.GM"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\QuestTown_Charleston\Town\NIGHT_SMALLMODEL_NIGHT1.COL"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Town_Cartagena\Palace"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Palace\Palais_l.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Town_Cartagena\Port"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Port\Cartfort_l.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Port\CARTFORT_L_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Port\CARTFORT_L_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Port\CARTFORT_L_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Port\CARTFORT_L_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Port\Cartfort_pd.ptc"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Port\Cartfort_pn.ptc"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Port\cartportB_l.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Port\CartportB_pd.ptc"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Port\CartportB_pn.ptc"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Port\CARTPORT_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Port\CARTPORT_E1_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Port\CARTPORT_E1_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Port\CARTPORT_E1_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Port\CARTPORT_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Port\CARTPORT_FD_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Port\CARTPORT_FD_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Port\CARTPORT_FD_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Port\CARTPORT_FN_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Port\cartport_l.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Port\CARTPORT_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Port\Cartport_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Port\CARTPORT_SB_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Port\CARTPORT_SB_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Port\CARTPORT_SB_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Port\CARTPORT_SB_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Port\ladder.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Port\mortar.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Port\MORTAR_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Port\SanFelipe.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Port\SANFELIPE_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Port\SANFELIPE_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Port\SANFELIPE_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Port\SANFELIPE_NIGHT1.COL"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Town_Cartagena\Residence"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Residence\fontain1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Residence\FONTAIN1_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Residence\FONTAIN1_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Residence\FONTAIN1_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Residence\FONTAIN1_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Residence\fontain2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Residence\FONTAIN2_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Residence\FONTAIN2_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Residence\FONTAIN2_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Residence\FONTAIN2_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Residence\PIERRE2_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Residence\PIERRE2_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Residence\PIERRE2_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Residence\PIERRE2_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Residence\PIERRE3_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Residence\PIERRE3_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Residence\PIERRE3_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Residence\PIERRE3_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Residence\PIERRE_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Residence\PIERRE_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Residence\PIERRE_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Residence\PIERRE_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Residence\Townhall.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Residence\TOWNHALL_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Residence\TOWNHALL_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Residence\Townhall_l.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Residence\TOWNHALL_L_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Residence\TOWNHALL_L_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Residence\TOWNHALL_L_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Residence\TOWNHALL_L_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Residence\TOWNHALL_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Residence\TOWNHALL_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Residence\Townhall_pd.ptc"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Residence\Townhall_pn.ptc"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Residence\TOWNHALL_SB_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Residence\TOWNHALL_SB_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Residence\TOWNHALL_SB_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\Residence\TOWNHALL_SB_NIGHT1.COL"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Town_Cartagena\town"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\town\cartTown_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\town\cartTown_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\town\cartTown_l.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\town\cartTown_lb.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\town\cartTown_l_BOP.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\town\cartTown_l_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\town\cartTown_l_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\town\cartTown_l_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\town\cartTown_l_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\town\cartTown_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\town\cartTown_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\town\ludeng.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\town\LUDENG_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\town\LUDENG_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\town\LUDENG_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\town\LUDENG_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\town\TREE_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\town\TREE_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\town\TREE_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Cartagena\town\TREE_NIGHT1.COL"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Town_Havana\center"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Havana\center\bottom.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Havana\center\BOTTOM_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Havana\center\BOTTOM_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Havana\center\BOTTOM_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Havana\center\BOTTOM_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Havana\center\fontain.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Havana\center\FONTAIN_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Havana\center\FONTAIN_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Havana\center\FONTAIN_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Havana\center\FONTAIN_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Havana\center\Havana_center.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Havana\center\HAVANA_CENTER_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Havana\center\HAVANA_CENTER_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Havana\center\Havana_center_l.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Havana\center\Havana_center_lb.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Havana\center\HAVANA_CENTER_L_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Havana\center\HAVANA_CENTER_L_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Havana\center\HAVANA_CENTER_L_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Havana\center\HAVANA_CENTER_L_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Havana\center\HAVANA_CENTER_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Havana\center\HAVANA_CENTER_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Havana\center\light.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Havana\center\LIGHT_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Havana\center\LIGHT_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Havana\center\LIGHT_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Havana\center\LIGHT_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Havana\center\tree.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Havana\center\TREE_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Havana\center\TREE_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Havana\center\TREE_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Havana\center\TREE_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Havana\center\walk_patch.ptc"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Town_Oranjestad\port"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oranjestad\port\door_OJ2_A.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oranjestad\port\door_OJ2_A_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oranjestad\port\door_OJ2_A_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oranjestad\port\door_OJ2_A_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oranjestad\port\door_OJ2_A_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oranjestad\port\door_OJ2_B.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oranjestad\port\door_OJ2_B_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oranjestad\port\door_OJ2_B_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oranjestad\port\door_OJ2_B_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oranjestad\port\door_OJ2_B_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oranjestad\port\ladder2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oranjestad\port\ladder2_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oranjestad\port\ladder2_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oranjestad\port\ladder2_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oranjestad\port\ladder2_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oranjestad\port\light.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oranjestad\port\LIGHT_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oranjestad\port\LIGHT_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oranjestad\port\LIGHT_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oranjestad\port\LIGHT_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oranjestad\port\locator_l.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oranjestad\port\locator_lb.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oranjestad\port\LOCATOR_L_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oranjestad\port\LOCATOR_L_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oranjestad\port\LOCATOR_L_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oranjestad\port\LOCATOR_L_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oranjestad\port\ludeng.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oranjestad\port\LUDENG_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oranjestad\port\LUDENG_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oranjestad\port\LUDENG_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oranjestad\port\LUDENG_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oranjestad\port\OJport.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oranjestad\port\OJPORT_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oranjestad\port\OJPORT_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oranjestad\port\OJport_landscape.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oranjestad\port\OJport_landscape_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oranjestad\port\OJport_landscape_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oranjestad\port\OJport_landscape_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oranjestad\port\OJport_landscape_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oranjestad\port\OJPORT_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oranjestad\port\OJPORT_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oranjestad\port\tree.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oranjestad\port\TREE_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oranjestad\port\TREE_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oranjestad\port\TREE_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oranjestad\port\TREE_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oranjestad\port\walk_patch.ptc"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Town_Oxbay\Exit"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oxbay\Exit\flagpole.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oxbay\Exit\flagpole_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oxbay\Exit\flagpole_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oxbay\Exit\flagpole_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oxbay\Exit\flagpole_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oxbay\Exit\hill.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oxbay\Exit\hill_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oxbay\Exit\hill_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oxbay\Exit\hill_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oxbay\Exit\hill_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oxbay\Exit\oxexit_l_Tortuga.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oxbay\Exit\Tortuga_walls.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oxbay\Exit\Tortuga_walls_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oxbay\Exit\Tortuga_walls_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oxbay\Exit\Tortuga_walls_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Oxbay\Exit\Tortuga_walls_NIGHT1.COL"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Town_Redmond\Port"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Redmond\Port\RedPort_l.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Redmond\Port\RedPort_lb.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Redmond\Port\RedPort_l_JRH.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Redmond\Port\RedPort_l_JRH0.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Town_Santiago\center"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\center\light.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\center\LIGHT_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\center\LIGHT_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\center\LIGHT_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\center\LIGHT_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\center\SC_center.GM"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\center\SC_CENTER_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\center\SC_CENTER_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\center\SC_center_l.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\center\SC_center_lb.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\center\SC_CENTER_L_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\center\SC_CENTER_L_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\center\SC_CENTER_L_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\center\SC_CENTER_L_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\center\SC_CENTER_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\center\SC_CENTER_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\center\tree.GM"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\center\TREE_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\center\TREE_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\center\TREE_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\center\TREE_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\center\walk_patch.ptc"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\center\xiao.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\center\XIAO_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\center\XIAO_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\center\XIAO_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\center\XIAO_NIGHT1.COL"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Town_Santiago\port"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\port\light.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\port\LIGHT_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\port\LIGHT_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\port\LIGHT_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\port\LIGHT_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\port\pole.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\port\POLE_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\port\POLE_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\port\POLE_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\port\POLE_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\port\SCport.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\port\SCPORT_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\port\SCPORT_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\port\SCport_g.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\port\SCport_l.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\port\SCport_landscape.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\port\SCPORT_LANDSCAPE_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\port\SCPORT_LANDSCAPE_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\port\SCPORT_LANDSCAPE_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\port\SCPORT_LANDSCAPE_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\port\SCport_lb.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\port\SCPORT_L_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\port\SCPORT_L_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\port\SCPORT_L_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\port\SCPORT_L_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\port\SCPORT_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\port\SCPORT_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\port\tree.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\port\TREE_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\port\TREE_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\port\TREE_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\port\TREE_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\port\walk_patch.ptc"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\port\xiao.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\port\XIAO_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\port\XIAO_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\port\XIAO_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Santiago\port\XIAO_NIGHT1.COL"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Town_SantoDomingo\center"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_SantoDomingo\center\lights.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_SantoDomingo\center\LIGHTS_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_SantoDomingo\center\LIGHTS_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_SantoDomingo\center\LIGHTS_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_SantoDomingo\center\LIGHTS_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_SantoDomingo\center\SDTown.GM"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_SantoDomingo\center\SDTOWN_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_SantoDomingo\center\SDTOWN_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_SantoDomingo\center\SDTown_l.GM"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_SantoDomingo\center\SDTown_lb.GM"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_SantoDomingo\center\SDTOWN_L_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_SantoDomingo\center\SDTOWN_L_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_SantoDomingo\center\SDTOWN_L_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_SantoDomingo\center\SDTOWN_L_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_SantoDomingo\center\SDTOWN_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_SantoDomingo\center\SDTOWN_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_SantoDomingo\center\tree.GM"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_SantoDomingo\center\TREE_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_SantoDomingo\center\TREE_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_SantoDomingo\center\TREE_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_SantoDomingo\center\TREE_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_SantoDomingo\center\walk_patch.ptc"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Town_StJohns"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_StJohns\StJohns_locators.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Locations\Town_Tortuga"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Tortuga\flagpole.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Tortuga\flagpole2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Tortuga\flagpole2_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Tortuga\flagpole2_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Tortuga\flagpole2_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Tortuga\flagpole2_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Tortuga\flagpole_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Tortuga\flagpole_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Tortuga\flagpole_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Tortuga\flagpole_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Tortuga\Tortuga.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Tortuga\Tortuga_fd.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Tortuga\Tortuga_fd_DAY1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Tortuga\Tortuga_fd_EVENING3.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Tortuga\Tortuga_fd_MORNING1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Tortuga\Tortuga_fn.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Tortuga\Tortuga_fn_NIGHT1.COL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Tortuga\Tortuga_l.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Tortuga\Tortuga_landscape.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Tortuga\Tortuga_lb.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Tortuga\Tortuga_l_day.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Tortuga\Tortuga_l_night.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Locations\Town_Tortuga\walk_patch.ptc"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Ships\Barque1"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Barque1\barque1_deck.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Ships\Barque2"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Barque2\barque2_deck.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Ships\Barque3_50"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Barque3_50\Barque3_50_deck.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Ships\Battleship1"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship1\battleship1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship1\battleship1_deck.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship1\battleship1_lateen.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship1\battleship1_mast1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship1\battleship1_mast2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship1\battleship1_mast3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship1\battleship1_mast4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship1\battleship1_path.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship1\battleship1_rey_a1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship1\battleship1_rey_a2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship1\battleship1_rey_a3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship1\battleship1_rey_a4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship1\battleship1_rey_b1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship1\battleship1_rey_b2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship1\battleship1_rey_b3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship1\battleship1_rey_b4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship1\battleship1_rey_c2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship1\battleship1_rey_c3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship1\battleship1_rey_c4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship1\battleship1_rey_flag.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Ships\Battleship2"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship2\battleship2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship2\battleship2_deck.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship2\battleship2_lateen.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship2\battleship2_mast1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship2\battleship2_mast2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship2\battleship2_mast3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship2\battleship2_mast4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship2\battleship2_path.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship2\battleship2_rey_a1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship2\battleship2_rey_a2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship2\battleship2_rey_a3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship2\battleship2_rey_a4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship2\battleship2_rey_b1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship2\battleship2_rey_b2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship2\battleship2_rey_b3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship2\battleship2_rey_b4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship2\battleship2_rey_c2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship2\battleship2_rey_c3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship2\battleship2_rey_c4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship2\battleship2_rey_flag.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Ships\Battleship3"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship3\battleship3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship3\battleship3_deck.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship3\battleship3_lateen.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship3\battleship3_mast1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship3\battleship3_mast2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship3\battleship3_mast3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship3\battleship3_mast4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship3\battleship3_path.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship3\battleship3_rey_a1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship3\battleship3_rey_a2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship3\battleship3_rey_a3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship3\battleship3_rey_a4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship3\battleship3_rey_b1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship3\battleship3_rey_b2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship3\battleship3_rey_b3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship3\battleship3_rey_b4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship3\battleship3_rey_c2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship3\battleship3_rey_c3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship3\battleship3_rey_c4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Battleship3\battleship3_rey_flag.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Ships\Blackpearl"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Blackpearl\blackpearl_mast2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Blackpearl\blackpearl_mast3.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Ships\CursedPearl"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\CursedPearl\CursedPearl_mast2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\CursedPearl\CursedPearl_mast3.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Ships\Cutter1"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Cutter1\cutter1_mast2.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Ships\Cutter2"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Cutter2\Cutter2_mast2.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Ships\FastCaravel"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FastCaravel\FastCaravel_deck.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Ships\FastGalleon1"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FastGalleon1\FastGalleon1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FastGalleon1\FastGalleon1_mast0.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FastGalleon1\FastGalleon1_mast2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FastGalleon1\FastGalleon1_mast3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FastGalleon1\FastGalleon1_mast4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FastGalleon1\FastGalleon1_part1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FastGalleon1\FastGalleon1_part2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FastGalleon1\FastGalleon1_part3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FastGalleon1\FastGalleon1_part4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FastGalleon1\FastGalleon1_part5.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FastGalleon1\FastGalleon1_path.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FastGalleon1\FastGalleon1_rey_a1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FastGalleon1\FastGalleon1_rey_a2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FastGalleon1\FastGalleon1_rey_a3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FastGalleon1\FastGalleon1_rey_a4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FastGalleon1\FastGalleon1_rey_b1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FastGalleon1\FastGalleon1_rey_b2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FastGalleon1\FastGalleon1_rey_b3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FastGalleon1\FastGalleon1_rey_b4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FastGalleon1\FastGalleon1_rey_b41.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FastGalleon1\FastGalleon1_rey_c2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FastGalleon1\FastGalleon1_rey_c3.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Ships\FastGalleon2"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FastGalleon2\FastGalleon2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FastGalleon2\FastGalleon2_mast0.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FastGalleon2\FastGalleon2_mast2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FastGalleon2\FastGalleon2_mast3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FastGalleon2\FastGalleon2_mast4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FastGalleon2\FastGalleon2_part1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FastGalleon2\FastGalleon2_part2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FastGalleon2\FastGalleon2_part3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FastGalleon2\FastGalleon2_part4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FastGalleon2\FastGalleon2_part5.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FastGalleon2\FastGalleon2_path.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FastGalleon2\FastGalleon2_rey_a1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FastGalleon2\FastGalleon2_rey_a2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FastGalleon2\FastGalleon2_rey_a3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FastGalleon2\FastGalleon2_rey_a4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FastGalleon2\FastGalleon2_rey_b1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FastGalleon2\FastGalleon2_rey_b2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FastGalleon2\FastGalleon2_rey_b3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FastGalleon2\FastGalleon2_rey_b4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FastGalleon2\FastGalleon2_rey_b41.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FastGalleon2\FastGalleon2_rey_c2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FastGalleon2\FastGalleon2_rey_c3.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Ships\FastMerchantman1"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FastMerchantman1\FastMerchantman1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FastMerchantman1\FastMerchantman1_mast2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FastMerchantman1\FastMerchantman1_mast3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FastMerchantman1\FastMerchantman1_mast4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FastMerchantman1\FastMerchantman1_rey_b4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FastMerchantman1\FastMerchantman1_rey_c4.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Ships\FastMerchantman2"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FastMerchantman2\FastMerchantman2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FastMerchantman2\FastMerchantman2_mast2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FastMerchantman2\FastMerchantman2_mast3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FastMerchantman2\FastMerchantman2_mast4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FastMerchantman2\FastMerchantman2_rey_b4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FastMerchantman2\FastMerchantman2_rey_c4.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Ships\Fleut1"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Fleut1\Fleut1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Fleut1\Fleut1_anchors.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Fleut1\Fleut1_deck.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Fleut1\Fleut1_Deckshelf1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Fleut1\Fleut1_Deckshelf2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Fleut1\Fleut1_Deckshelf3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Fleut1\Fleut1_Deckshelf4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Fleut1\Fleut1_part.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Ships\Fleut2"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Fleut2\Fleut2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Fleut2\Fleut2_anchors.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Fleut2\Fleut2_deck.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Fleut2\Fleut2_Deckshelf1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Fleut2\Fleut2_Deckshelf2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Fleut2\Fleut2_Deckshelf3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Fleut2\Fleut2_Deckshelf4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Fleut2\Fleut2_part.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Ships\FleutWar"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FleutWar\FleutWar.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FleutWar\FleutWar_deck.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FleutWar\FleutWar_Deckshelf1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FleutWar\FleutWar_Deckshelf2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FleutWar\FleutWar_Deckshelf3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FleutWar\FleutWar_Deckshelf4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FleutWar\FleutWar_part.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Ships\FR_Belette"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FR_Belette\FR_Belette.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FR_Belette\FR_Belette_deck.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FR_Belette\FR_Belette_lateen.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FR_Belette\FR_Belette_mast1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FR_Belette\FR_Belette_mast2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FR_Belette\FR_Belette_mast3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FR_Belette\FR_Belette_mast4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FR_Belette\FR_Belette_path.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FR_Belette\FR_Belette_rey_a1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FR_Belette\FR_Belette_rey_a2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FR_Belette\FR_Belette_rey_a3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FR_Belette\FR_Belette_rey_a4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FR_Belette\FR_Belette_rey_b1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FR_Belette\FR_Belette_rey_b2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FR_Belette\FR_Belette_rey_b3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FR_Belette\FR_Belette_rey_b4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FR_Belette\FR_Belette_rey_c2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FR_Belette\FR_Belette_rey_c3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FR_Belette\FR_Belette_rey_c4.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Ships\FR_Derfflinger"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FR_Derfflinger\FR_Derfflinger.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FR_Derfflinger\FR_Derfflinger_lateen.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FR_Derfflinger\FR_Derfflinger_mast4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FR_Derfflinger\FR_Derfflinger_rey_a4.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Ships\FR_Superbe"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FR_Superbe\FR_Superbe.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FR_Superbe\FR_Superbe_mast0.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FR_Superbe\FR_Superbe_mast2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FR_Superbe\FR_Superbe_mast3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FR_Superbe\FR_Superbe_mast4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FR_Superbe\FR_Superbe_rey_a1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FR_Superbe\FR_Superbe_rey_a2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FR_Superbe\FR_Superbe_rey_a3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FR_Superbe\FR_Superbe_rey_a6.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FR_Superbe\FR_Superbe_rey_b2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FR_Superbe\FR_Superbe_rey_b3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FR_Superbe\FR_Superbe_rey_b4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FR_Superbe\FR_Superbe_rey_b5.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FR_Superbe\FR_Superbe_rey_c1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FR_Superbe\FR_Superbe_rey_c2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FR_Superbe\FR_Superbe_rey_c3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\FR_Superbe\FR_Superbe_Spanker.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Ships\Galeon50"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Galeon50\Galeon50_deck.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Ships\HeavyLineship"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\HeavyLineship\HeavyLineship.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\HeavyLineship\HeavyLineship_mast1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\HeavyLineship\HeavyLineship_mast2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\HeavyLineship\HeavyLineship_mast3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\HeavyLineship\HeavyLineship_mast4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\HeavyLineship\HeavyLineship_part4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\HeavyLineship\HeavyLineship_rey_a1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\HeavyLineship\HeavyLineship_rey_a2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\HeavyLineship\HeavyLineship_rey_a3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\HeavyLineship\HeavyLineship_rey_a4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\HeavyLineship\HeavyLineship_rey_b1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\HeavyLineship\HeavyLineship_rey_b2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\HeavyLineship\HeavyLineship_rey_b3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\HeavyLineship\HeavyLineship_rey_b4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\HeavyLineship\HeavyLineship_rey_b41.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\HeavyLineship\HeavyLineship_rey_c2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\HeavyLineship\HeavyLineship_rey_c3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\HeavyLineship\HeavyLineship_rey_flag.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Ships\HMS_Surprise"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\HMS_Surprise\HMS_Surprise.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Ships\NL_Derfflinger"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\NL_Derfflinger\NL_Derfflinger_lateen.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\NL_Derfflinger\NL_Derfflinger_mast4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\NL_Derfflinger\NL_Derfflinger_rey_a4.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Ships\NL_Fleut50"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\NL_Fleut50\NL_Fleut50.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\NL_Fleut50\NL_Fleut50_anchors.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\NL_Fleut50\NL_Fleut50_deck.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\NL_Fleut50\NL_Fleut50_Deckshelf1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\NL_Fleut50\NL_Fleut50_Deckshelf2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\NL_Fleut50\NL_Fleut50_Deckshelf3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\NL_Fleut50\NL_Fleut50_Deckshelf4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\NL_Fleut50\NL_Fleut50_part.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Ships\NL_PinnaceofWar47"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\NL_PinnaceofWar47\NL_PinnaceofWar47.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\NL_PinnaceofWar47\NL_PinnaceofWar47_deck.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\NL_PinnaceofWar47\NL_PinnaceofWar47_lateen.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\NL_PinnaceofWar47\NL_PinnaceofWar47_mast1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\NL_PinnaceofWar47\NL_PinnaceofWar47_mast2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\NL_PinnaceofWar47\NL_PinnaceofWar47_mast3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\NL_PinnaceofWar47\NL_PinnaceofWar47_mast4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\NL_PinnaceofWar47\NL_PinnaceofWar47_mast5.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\NL_PinnaceofWar47\NL_PinnaceofWar47_path.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\NL_PinnaceofWar47\NL_PinnaceofWar47_rey_a1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\NL_PinnaceofWar47\NL_PinnaceofWar47_rey_a2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\NL_PinnaceofWar47\NL_PinnaceofWar47_rey_a3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\NL_PinnaceofWar47\NL_PinnaceofWar47_rey_a4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\NL_PinnaceofWar47\NL_PinnaceofWar47_rey_b2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\NL_PinnaceofWar47\NL_PinnaceofWar47_rey_b3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\NL_PinnaceofWar47\NL_PinnaceofWar47_rey_b4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\NL_PinnaceofWar47\NL_PinnaceofWar47_rey_c2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\NL_PinnaceofWar47\NL_PinnaceofWar47_rey_c3.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Ships\NL_SevenProvincien"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\NL_SevenProvincien\NL_SevenProvincien_mast1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\NL_SevenProvincien\NL_SevenProvincien_mast2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\NL_SevenProvincien\NL_SevenProvincien_mast3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\NL_SevenProvincien\NL_SevenProvincien_mast4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\NL_SevenProvincien\NL_SevenProvincien_part4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\NL_SevenProvincien\NL_SevenProvincien_rey_a1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\NL_SevenProvincien\NL_SevenProvincien_rey_a2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\NL_SevenProvincien\NL_SevenProvincien_rey_a3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\NL_SevenProvincien\NL_SevenProvincien_rey_a4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\NL_SevenProvincien\NL_SevenProvincien_rey_b1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\NL_SevenProvincien\NL_SevenProvincien_rey_b2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\NL_SevenProvincien\NL_SevenProvincien_rey_b3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\NL_SevenProvincien\NL_SevenProvincien_rey_b4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\NL_SevenProvincien\NL_SevenProvincien_rey_b41.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\NL_SevenProvincien\NL_SevenProvincien_rey_c2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\NL_SevenProvincien\NL_SevenProvincien_rey_c3.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Ships\obj_ladder2"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\obj_ladder2\obj_ladder2.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Ships\PinnaceMedium"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PinnaceMedium\PinnaceMedium.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PinnaceMedium\PinnaceMedium_mast0.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PinnaceMedium\PinnaceMedium_mast2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PinnaceMedium\PinnaceMedium_mast3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PinnaceMedium\PinnaceMedium_mast4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PinnaceMedium\PinnaceMedium_part1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PinnaceMedium\PinnaceMedium_path.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PinnaceMedium\PinnaceMedium_rey_a1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PinnaceMedium\PinnaceMedium_rey_a2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PinnaceMedium\PinnaceMedium_rey_a21.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PinnaceMedium\PinnaceMedium_rey_a3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PinnaceMedium\PinnaceMedium_rey_a31.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PinnaceMedium\PinnaceMedium_rey_a4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PinnaceMedium\PinnaceMedium_rey_a41.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PinnaceMedium\PinnaceMedium_rey_b1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PinnaceMedium\PinnaceMedium_rey_b2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PinnaceMedium\PinnaceMedium_rey_b3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PinnaceMedium\PinnaceMedium_rey_b4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PinnaceMedium\PinnaceMedium_rey_b41.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Ships\PinnaceMerchant"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PinnaceMerchant\PinnaceMerchant.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PinnaceMerchant\PinnaceMerchant_fonar_day.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PinnaceMerchant\PinnaceMerchant_fonar_night.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PinnaceMerchant\PinnaceMerchant_mast0.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PinnaceMerchant\PinnaceMerchant_mast2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PinnaceMerchant\PinnaceMerchant_mast3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PinnaceMerchant\PinnaceMerchant_mast4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PinnaceMerchant\PinnaceMerchant_part1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PinnaceMerchant\PinnaceMerchant_part2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PinnaceMerchant\PinnaceMerchant_part4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PinnaceMerchant\PinnaceMerchant_path.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PinnaceMerchant\PinnaceMerchant_rey_a1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PinnaceMerchant\PinnaceMerchant_rey_a2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PinnaceMerchant\PinnaceMerchant_rey_a3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PinnaceMerchant\PinnaceMerchant_rey_a4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PinnaceMerchant\PinnaceMerchant_rey_b1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PinnaceMerchant\PinnaceMerchant_rey_b2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PinnaceMerchant\PinnaceMerchant_rey_b3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PinnaceMerchant\PinnaceMerchant_rey_b4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PinnaceMerchant\PinnaceMerchant_rey_b41.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Ships\PiratFastGal"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PiratFastGal\PiratFastGal.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PiratFastGal\PiratFastGal_mast0.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PiratFastGal\PiratFastGal_mast2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PiratFastGal\PiratFastGal_mast3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PiratFastGal\PiratFastGal_mast4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PiratFastGal\PiratFastGal_part1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PiratFastGal\PiratFastGal_part2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PiratFastGal\PiratFastGal_part3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PiratFastGal\PiratFastGal_part4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PiratFastGal\PiratFastGal_part5.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PiratFastGal\PiratFastGal_path.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PiratFastGal\PiratFastGal_rey_a1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PiratFastGal\PiratFastGal_rey_a2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PiratFastGal\PiratFastGal_rey_a3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PiratFastGal\PiratFastGal_rey_a4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PiratFastGal\PiratFastGal_rey_b1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PiratFastGal\PiratFastGal_rey_b2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PiratFastGal\PiratFastGal_rey_b3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PiratFastGal\PiratFastGal_rey_b4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PiratFastGal\PiratFastGal_rey_b41.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PiratFastGal\PiratFastGal_rey_c2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PiratFastGal\PiratFastGal_rey_c3.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Ships\Polacca"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Polacca\Polacca.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Polacca\Polacca_mast1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Polacca\Polacca_mast2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Polacca\Polacca_mast3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Polacca\Polacca_part1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Polacca\Polacca_part11.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Polacca\Polacca_part12.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Polacca\Polacca_part2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Polacca\Polacca_part3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Polacca\Polacca_part31.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Polacca\Polacca_part5.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Polacca\Polacca_part51.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Polacca\Polacca_part52.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Polacca\Polacca_path.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Polacca\Polacca_rey_a1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Polacca\Polacca_rey_a2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Polacca\Polacca_rey_a3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Polacca\Polacca_rey_b2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Polacca\Polacca_rey_b3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\Polacca\Polacca_rey_c2.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Ships\PO_FastNavy"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PO_FastNavy\PO_FastNavy.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PO_FastNavy\PO_FastNavy_Deadeye1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PO_FastNavy\PO_FastNavy_Deadeye2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PO_FastNavy\PO_FastNavy_Deadeye3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PO_FastNavy\PO_FastNavy_Deadeye4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PO_FastNavy\PO_FastNavy_deck.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PO_FastNavy\PO_FastNavy_lateena.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PO_FastNavy\PO_FastNavy_lateenb.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PO_FastNavy\PO_FastNavy_mast0.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PO_FastNavy\PO_FastNavy_mast2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PO_FastNavy\PO_FastNavy_mast3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PO_FastNavy\PO_FastNavy_mast4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PO_FastNavy\PO_FastNavy_path.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PO_FastNavy\PO_FastNavy_rey_a2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PO_FastNavy\PO_FastNavy_rey_a4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PO_FastNavy\PO_FastNavy_rey_a5.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PO_FastNavy\PO_FastNavy_rey_b1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PO_FastNavy\PO_FastNavy_rey_b2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PO_FastNavy\PO_FastNavy_rey_c2.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Ships\PO_Fleut50"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PO_Fleut50\PO_Fleut50.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PO_Fleut50\PO_Fleut50_anchors old.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PO_Fleut50\PO_Fleut50_anchors.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PO_Fleut50\PO_Fleut50_deck.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PO_Fleut50\PO_Fleut50_Deckshelf1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PO_Fleut50\PO_Fleut50_Deckshelf2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PO_Fleut50\PO_Fleut50_Deckshelf3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PO_Fleut50\PO_Fleut50_Deckshelf4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\PO_Fleut50\PO_Fleut50_part.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Ships\RN_Battleship"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\RN_Battleship\RN_Battleship.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\RN_Battleship\RN_Battleship_deck.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\RN_Battleship\RN_Battleship_lateen.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\RN_Battleship\RN_Battleship_mast1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\RN_Battleship\RN_Battleship_mast2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\RN_Battleship\RN_Battleship_mast3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\RN_Battleship\RN_Battleship_mast4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\RN_Battleship\RN_Battleship_path.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\RN_Battleship\RN_Battleship_rey_a1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\RN_Battleship\RN_Battleship_rey_a2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\RN_Battleship\RN_Battleship_rey_a3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\RN_Battleship\RN_Battleship_rey_a4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\RN_Battleship\RN_Battleship_rey_b1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\RN_Battleship\RN_Battleship_rey_b2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\RN_Battleship\RN_Battleship_rey_b3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\RN_Battleship\RN_Battleship_rey_b4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\RN_Battleship\RN_Battleship_rey_c2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\RN_Battleship\RN_Battleship_rey_c3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\RN_Battleship\RN_Battleship_rey_c4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\RN_Battleship\RN_Battleship_rey_flag.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Ships\RN_Superbe"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\RN_Superbe\RN_Superbe.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\RN_Superbe\RN_Superbe_mast0.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\RN_Superbe\RN_Superbe_mast2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\RN_Superbe\RN_Superbe_mast3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\RN_Superbe\RN_Superbe_mast4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\RN_Superbe\RN_Superbe_rey_a7.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\RN_Superbe\RN_Superbe_rey_b2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\RN_Superbe\RN_Superbe_rey_b3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\RN_Superbe\RN_Superbe_rey_b4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\RN_Superbe\RN_Superbe_rey_b5.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\RN_Superbe\RN_Superbe_rey_c1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\RN_Superbe\RN_Superbe_rey_c2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\RN_Superbe\RN_Superbe_Spanker.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Ships\RN_WarGalleon"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\RN_WarGalleon\RN_WarGalleon.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\RN_WarGalleon\RN_WarGalleon_rey_a2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\RN_WarGalleon\RN_WarGalleon_rey_a3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\RN_WarGalleon\RN_WarGalleon_rey_a4.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Ships\SP_Battleship"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SP_Battleship\SP_Battleship.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SP_Battleship\SP_Battleship_deck.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SP_Battleship\SP_Battleship_lateen.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SP_Battleship\SP_Battleship_mast1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SP_Battleship\SP_Battleship_mast2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SP_Battleship\SP_Battleship_mast3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SP_Battleship\SP_Battleship_mast4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SP_Battleship\SP_Battleship_path.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SP_Battleship\SP_Battleship_rey_a1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SP_Battleship\SP_Battleship_rey_a2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SP_Battleship\SP_Battleship_rey_a3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SP_Battleship\SP_Battleship_rey_a4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SP_Battleship\SP_Battleship_rey_b1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SP_Battleship\SP_Battleship_rey_b2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SP_Battleship\SP_Battleship_rey_b3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SP_Battleship\SP_Battleship_rey_b4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SP_Battleship\SP_Battleship_rey_c2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SP_Battleship\SP_Battleship_rey_c3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SP_Battleship\SP_Battleship_rey_c4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SP_Battleship\SP_Battleship_rey_flag.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Ships\SP_Derfflinger"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SP_Derfflinger\SP_Derfflinger_lateen.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SP_Derfflinger\SP_Derfflinger_mast4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SP_Derfflinger\SP_Derfflinger_rey_a4.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Ships\SP_WarGalleon"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SP_WarGalleon\SP_WarGalleon.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SP_WarGalleon\SP_WarGalleon_fonar_day.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SP_WarGalleon\SP_WarGalleon_fonar_night.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SP_WarGalleon\SP_WarGalleon_mast0.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SP_WarGalleon\SP_WarGalleon_mast1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SP_WarGalleon\SP_WarGalleon_mast2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SP_WarGalleon\SP_WarGalleon_mast3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SP_WarGalleon\SP_WarGalleon_mast4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SP_WarGalleon\SP_WarGalleon_mast5.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SP_WarGalleon\SP_WarGalleon_path.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SP_WarGalleon\SP_WarGalleon_rey_a1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SP_WarGalleon\SP_WarGalleon_rey_a2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SP_WarGalleon\SP_WarGalleon_rey_a3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SP_WarGalleon\SP_WarGalleon_rey_a4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SP_WarGalleon\SP_WarGalleon_rey_b1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SP_WarGalleon\SP_WarGalleon_rey_b2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SP_WarGalleon\SP_WarGalleon_rey_b3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SP_WarGalleon\SP_WarGalleon_rey_b4.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Ships\SuperFrigate"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SuperFrigate\SuperFrigate.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SuperFrigate\SuperFrigate_deck.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SuperFrigate\SuperFrigate_decor.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SuperFrigate\SuperFrigate_guns.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SuperFrigate\SuperFrigate_mast1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SuperFrigate\SuperFrigate_mast2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SuperFrigate\SuperFrigate_mast3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SuperFrigate\SuperFrigate_mast4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SuperFrigate\SuperFrigate_path.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SuperFrigate\SuperFrigate_rey_a2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SuperFrigate\SuperFrigate_rey_a22.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SuperFrigate\SuperFrigate_rey_a3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SuperFrigate\SuperFrigate_rey_a33.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SuperFrigate\SuperFrigate_rey_a4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SuperFrigate\SuperFrigate_rey_a44.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SuperFrigate\SuperFrigate_rey_b2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SuperFrigate\SuperFrigate_rey_b3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SuperFrigate\SuperFrigate_rey_b4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SuperFrigate\SuperFrigate_rey_c2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SuperFrigate\SuperFrigate_rey_c3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SuperFrigate\SuperFrigate_rey_c4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\SuperFrigate\SuperFrigate_rey_d44.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Ships\WallerPinnace"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\WallerPinnace\WallerPinnace.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\WallerPinnace\WallerPinnace_deck.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\WallerPinnace\WallerPinnace_lateen.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\WallerPinnace\WallerPinnace_mast4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\WallerPinnace\WallerPinnace_rey_a1.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\WallerPinnace\WallerPinnace_rey_a2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\WallerPinnace\WallerPinnace_rey_a3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\WallerPinnace\WallerPinnace_rey_a4.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Ships\WickedWench"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\WickedWench\WickedWench_mast2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\WickedWench\WickedWench_mast3.gm"
  SetOutPath "$INSTDIR\RESOURCE\MODELS\Ships\XebecAS"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\XebecAS\XebecAS_mast2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\XebecAS\XebecAS_mast3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\XebecAS\XebecAS_mast4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\XebecAS\XebecAS_rey_a2.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\XebecAS\XebecAS_rey_a4.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\XebecAS\XebecAS_rey_b3.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\XebecAS\XebecAS_spanker.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\XebecAS\XebecAS_spankerA.gm"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\MODELS\Ships\XebecAS\XebecAS_spankerB.gm"
  SetOutPath "$INSTDIR\RESOURCE\Sounds\AMBIENT\CHURCH"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Sounds\AMBIENT\CHURCH\bench1_2.wav"
  SetOutPath "$INSTDIR\RESOURCE\Sounds\AMBIENT\SEASHORE"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Sounds\AMBIENT\SEASHORE\fanfare2.wav"
  SetOutPath "$INSTDIR\RESOURCE\Sounds\AMBIENT\TOWN"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Sounds\AMBIENT\TOWN\window_dog.wav"
  SetOutPath "$INSTDIR\RESOURCE\Sounds\INTERFACE"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Sounds\INTERFACE\boiling_low.wav"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Sounds\INTERFACE\book_open.wav"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Sounds\INTERFACE\cauterization.wav"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Sounds\INTERFACE\metal_fall.wav"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Sounds\INTERFACE\metal_fall2.wav"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Sounds\INTERFACE\paper_small.wav"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Sounds\INTERFACE\small_door.wav"
  SetOutPath "$INSTDIR\RESOURCE\Sounds\MUSIC"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Sounds\MUSIC\Claire_theme_short.wav"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Sounds\MUSIC\night_sneaking.ogg"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Sounds\MUSIC\San_Felipe.ogg"
  SetOutPath "$INSTDIR\RESOURCE\Sounds\OBJECTS"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Sounds\OBJECTS\boulder_roll.wav"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Sounds\OBJECTS\boulder_rumble.wav"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Sounds\OBJECTS\boulder_start.wav"
  SetOutPath "$INSTDIR\RESOURCE\Sounds\OBJECTS\DUEL"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Sounds\OBJECTS\DUEL\arrow.wav"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Sounds\OBJECTS\DUEL\ArrowBlow.wav"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Sounds\OBJECTS\DUEL\arrow_shield.wav"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Sounds\OBJECTS\DUEL\bow.wav"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Sounds\OBJECTS\DUEL\electricity.wav"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Sounds\OBJECTS\DUEL\lightning.wav"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Sounds\OBJECTS\DUEL\pistol_musket.wav"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Sounds\OBJECTS\DUEL\pistol_musket2.wav"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Sounds\OBJECTS\DUEL\rocket.wav"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Sounds\OBJECTS\DUEL\shield.wav"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Sounds\OBJECTS\DUEL\steelflint.wav"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Sounds\OBJECTS\DUEL\sword_disarmed.wav"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Sounds\OBJECTS\DUEL\whip.wav"
  SetOutPath "$INSTDIR\RESOURCE\Sounds\OBJECTS"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Sounds\OBJECTS\sgboom.wav"
  SetOutPath "$INSTDIR\RESOURCE\Sounds\PEOPLE"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Sounds\PEOPLE\grass_turn.wav"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Sounds\PEOPLE\kungfu.wav"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Sounds\PEOPLE\lock_open.wav"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Sounds\PEOPLE\snoring2.wav"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Sounds\PEOPLE\spyglass.wav"
  SetOutPath "$INSTDIR\RESOURCE\Sounds\VOICE\ENGLISH"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Sounds\VOICE\ENGLISH\Barbossa01.wav"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Sounds\VOICE\ENGLISH\black_witch_ahh.WAV"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Sounds\VOICE\ENGLISH\black_witch_disappear.wav"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Sounds\VOICE\ENGLISH\black_witch_ehh.WAV"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Sounds\VOICE\ENGLISH\black_witch_laugh.wav"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Sounds\VOICE\ENGLISH\black_witch_what.wav"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Sounds\VOICE\ENGLISH\black_witch_yah.wav"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Sounds\VOICE\ENGLISH\chinese_chatting.wav"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Sounds\VOICE\ENGLISH\chinese_look_around.wav"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Sounds\VOICE\ENGLISH\chinese_need.wav"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Sounds\VOICE\ENGLISH\chinese_samples.wav"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Sounds\VOICE\ENGLISH\chinese_sorry.wav"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Sounds\VOICE\ENGLISH\Jupiter_aha.wav"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Sounds\VOICE\ENGLISH\Jupiter_mm.wav"
  SetOutPath "$INSTDIR\RESOURCE\Textures"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\00000203.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\003s.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\006ys.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\018s.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\019s.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\025s.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\026s.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\1.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\2002104222525181.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\4000039.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\4000627.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\7210047o.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\7210061s.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\7210086d.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Aden_.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\alphaDetU1.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures\Ammo"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\4000039.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\4000191.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\4001290.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\4002211.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\4002334.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\Antidote.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\Blade_ProudOfAnvil.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\blthag02.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\bois.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\bortoutpinnace1.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\Brown.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\BugIllus.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\Button_16T.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\Button_h12.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\Button_h16.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\carpetU4.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\Color_002.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\Color_005.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\Color_006.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\Color_C16.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\Color_C23.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\Color_D01.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\Color_I03.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\Corcho.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\dec3.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\desk.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\dorpa.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\dorPL.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\ducN.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\feuillN.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\ffTON.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\fightdeck2.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\flintst.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\fluteBG.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\fonar.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\fonar_day.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\fonar_nig.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\fonar_night.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\Foudation_BRI_Door.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\Foudation_CAV_Door.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\Foudation_PLA_Door.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\Foudation_To2_Door.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\Foudation_Tortug1N.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\Foudation_Tortuga1.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\Foudation_Tor_Door.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\Foudation_Tx2_Door.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\Foudation_Tx4_Door.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\gratingU1.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\halberd1.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\Incinerador.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\inzanegun1.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\item_pistol6.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\Item_RapierJM.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\Item_Sabre01L.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\kngo001.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\lkywk010.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\lkywk031.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\lkywk049.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\lkywkmt001.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\lordU1.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\Machete.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\mahs51N.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\Maquahuitl.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\metalU4.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\Metal_Aluminum_Anodized.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\Metal_Corrogated_Shiny.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\M_0024_OrangeRed.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\M_0046_Gold.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\M_0133_Gray.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\n02o011.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\ngo013.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\ngo014.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\nichbook.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\Peri_dico_Beige.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\Peri_dico_Caf_.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\pero.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\pistolR.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\plmN.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\qingnewgun02.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\qingnewgun03.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\qingnewji.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\shu001.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\shu01N.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\ssa0001.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\ssa001N.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\stbox.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\tomahawk1.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\Tree3.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\treepi.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\triton.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\usurerhouse2_tex.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\WhaleShp.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\woodGrainU5.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\Wood_Cherry_Original.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\XC1.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\XC2.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\XG1.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\XG2.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\XY2.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\XZ1.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\XZ2.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\_Metal_Aluminum_Anodized_1.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\_Metal_Aluminum_Anodized_2.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\_Wood_floor_dark_.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ammo\_Wood_floor_light_.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\aw002.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\aw003.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\aw004.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\aw014.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\ays02.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\ays029.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\ays03.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\ays031.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\ays034.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\aysyd01.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\bakedcave1U1.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\bakedcave1U2.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\bakedcave1U3.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures\BATTLE_INTERFACE"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\BATTLE_INTERFACE\cicons_command.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\BATTLE_INTERFACE\moor-town.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\BATTLE_INTERFACE\UsedItems2.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Blank.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\blood00002.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\boat.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\botcor2.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\br034.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\br035.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\br044.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\br055.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\bst05.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\bu.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Bump4.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\bump_land.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\bup001.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\bup002.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\bush3_1.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\bush3_2.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Button_ORJ.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\c01.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\c02.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\c04.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\canball.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\cao3.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\caoys.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\cavernTileU1.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures\Characters"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Characters\47_JRMMCmd.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Characters\47_JRMMCpt.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Characters\47_JRMMLcm.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Characters\47_JRMMLt1.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Characters\47_JRMMLt2.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Characters\47_JRMMSub.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Characters\64jag.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Characters\add_armor01.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Characters\add_armor02.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Characters\add_armor03.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Characters\AnimistJE.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Characters\AnimMaya1.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Characters\APym.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Characters\BillyR.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Characters\BlazN.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Characters\boulder.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Characters\CapJRMM.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Characters\Conq1.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Characters\Corsair1_J.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Characters\Corsair2_J.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Characters\Corsair3_J.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Characters\Corsair4_J.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Characters\Cuirass_conqist.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Characters\dsrt_us.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Characters\gy10.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Characters\gyphe__9.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Characters\HPM5.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Characters\indmay1.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Characters\korsKID.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Characters\MadJackKi.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Characters\MayanWar_sash.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Characters\Mnk5C.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Characters\Monk5.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Characters\pistolR.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Characters\Rhat.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Characters\Soldier_con2.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Characters\trash2.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Characters\wurmKidd.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\che01.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\cloth.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\cloth001.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\CyrcFall.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\C_1.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\C_2.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\dack.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\dao.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\dark_st_CE.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\dark_st_FL.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\dark_st_WALL.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\dddsjm.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\default.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\di.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\dirtys0001.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\dock.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\door001.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\door002.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\dp09.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Fall1.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\FallCaust1.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\FallFon1.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\ff111.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\ff111.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\ff115.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\ffh012.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\ffpw.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\flag001.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures\flags"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\flags\perflg5.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\flags\perpnt5.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\flags\pirflg3.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\floor002.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\floor004bump.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\floor205.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\floorbump002.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\foliage.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\frt_ee.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\frt_eea.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\frt_eeb.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\frt_em.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\frt_ema.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\frt_emb.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\frt_en.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\frt_ena.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\frt_enb.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\G_1.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\G_2.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\hill001.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\hill003.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\hua.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\huayelou.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\in1004i.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\in1005o.bmp.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures\INTERFACES\Flags"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\Flags\Crest_Personal24.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\Flags\Crest_Pirate52.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\Flags\Flag_Personal24.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\Flags\Flag_Pirate52.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures\INTERFACES"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\items22-1.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\items22-2.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\items22.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\items24+1.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\items24+2.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\items24+3.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\items24-1.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\items24-2.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\items24.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\itemsAS.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\itemsBOP.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\itemsBOP2.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\itemsccc.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\itemsJRH17.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\itemsJRH18.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\itemsJRH21.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\itemsJRH22.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\itemsJRH23.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\itemsJRH24.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\itemsJRH25.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\itemsLevis.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures\INTERFACES\Maps"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\Maps\book1.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\Maps\book10.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\Maps\book11.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\Maps\book12.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\Maps\book13.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\Maps\book14.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\Maps\book15.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\Maps\book3.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\Maps\book4.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\Maps\book5.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\Maps\book6.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\Maps\book7.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\Maps\book8.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\Maps\book9.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\Maps\skillbook2.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\Maps\skillbook4.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures\INTERFACES\PERKS\128"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PERKS\128\AdvanceSmuggling.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PERKS\128\HighStakes.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PERKS\128\ImproveAiming.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PERKS\128\ImproveSmuggling.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures\INTERFACES\PERKS\64"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PERKS\64\AdvanceSmuggling.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PERKS\64\HighStakes.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PERKS\64\ImproveAiming.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PERKS\64\ImproveSmuggling.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures\INTERFACES\PERKS\64Disable"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PERKS\64Disable\AdvanceSmuggling.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PERKS\64Disable\HighStakes.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PERKS\64Disable\ImproveAiming.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PERKS\64Disable\ImproveSmuggling.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures\INTERFACES\PERKS\64Forbidden"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PERKS\64Forbidden\AdvancedBattleState.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PERKS\64Forbidden\AdvancedCommerce.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PERKS\64Forbidden\AdvancedDefence.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PERKS\64Forbidden\AdvanceSmuggling.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PERKS\64Forbidden\BasicBattleState.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PERKS\64Forbidden\BasicCommerce.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PERKS\64Forbidden\BasicDefence.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PERKS\64Forbidden\BasicLandOwner.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PERKS\64Forbidden\Brander.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PERKS\64Forbidden\CannonProfessional.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PERKS\64Forbidden\CrewDamageUp.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PERKS\64Forbidden\CriticalHit.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PERKS\64Forbidden\CriticalShoot.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PERKS\64Forbidden\FastReload.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PERKS\64Forbidden\GrapplingProfessional.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PERKS\64Forbidden\GunFighter.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PERKS\64Forbidden\GunMan.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PERKS\64Forbidden\GunProfessional.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PERKS\64Forbidden\HighStakes.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PERKS\64Forbidden\HullDamageUp.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PERKS\64Forbidden\ImmediateReload.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PERKS\64Forbidden\ImproveAiming.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PERKS\64Forbidden\ImproveSmuggling.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PERKS\64Forbidden\InstantBoarding.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PERKS\64Forbidden\InstantRepair.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PERKS\64Forbidden\IronWill.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PERKS\64Forbidden\LightRepair.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PERKS\64Forbidden\LongRangeGrappling.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PERKS\64Forbidden\LongRangeShoot.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PERKS\64Forbidden\MusketsShoot.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PERKS\64Forbidden\Rush.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PERKS\64Forbidden\SailingProfessional.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PERKS\64Forbidden\SailsDamageUp.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PERKS\64Forbidden\SandbankManeuver.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PERKS\64Forbidden\SharedExperience.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PERKS\64Forbidden\ShipDefenceProfessional.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PERKS\64Forbidden\ShipSpeedUp.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PERKS\64Forbidden\ShipTurnRateUp.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PERKS\64Forbidden\StormProfessional.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PERKS\64Forbidden\SwordplayProfessional.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PERKS\64Forbidden\Toughness.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PERKS\64Forbidden\Troopers.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PERKS\64Forbidden\TrustWorthy.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PERKS\64Forbidden\Turn180.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures\INTERFACES\PORTRAITS\128"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PORTRAITS\128\face_103.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PORTRAITS\128\face_552.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PORTRAITS\128\face_553.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PORTRAITS\128\face_554.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PORTRAITS\128\face_555.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PORTRAITS\128\face_556.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PORTRAITS\128\face_557.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PORTRAITS\128\face_558.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PORTRAITS\128\face_559.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PORTRAITS\128\face_560.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PORTRAITS\128\face_561.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PORTRAITS\128\face_562.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PORTRAITS\128\face_563.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PORTRAITS\128\face_565.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PORTRAITS\128\face_566.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures\INTERFACES\PORTRAITS\256"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PORTRAITS\256\face_103.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PORTRAITS\256\face_553.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PORTRAITS\256\face_554.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PORTRAITS\256\face_555.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PORTRAITS\256\face_556.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PORTRAITS\256\face_557.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PORTRAITS\256\face_558.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PORTRAITS\256\face_559.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PORTRAITS\256\face_560.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PORTRAITS\256\face_561.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PORTRAITS\256\face_562.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PORTRAITS\256\face_563.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PORTRAITS\256\face_565.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PORTRAITS\256\face_566.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures\INTERFACES\PORTRAITS\64"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PORTRAITS\64\face_103.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PORTRAITS\64\face_548.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PORTRAITS\64\face_549.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PORTRAITS\64\face_550.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PORTRAITS\64\face_551.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PORTRAITS\64\face_552.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PORTRAITS\64\face_553.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PORTRAITS\64\face_554.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PORTRAITS\64\face_555.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PORTRAITS\64\face_556.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PORTRAITS\64\face_557.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PORTRAITS\64\face_558.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PORTRAITS\64\face_559.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PORTRAITS\64\face_560.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PORTRAITS\64\face_561.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PORTRAITS\64\face_562.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PORTRAITS\64\face_563.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PORTRAITS\64\face_564.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PORTRAITS\64\face_565.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PORTRAITS\64\face_566.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\PORTRAITS\64\face_94.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures\INTERFACES"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\shipsBR.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\shipsTL.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\INTERFACES\shipsTR.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures\Items"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Items\4000053.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Items\40doc4A.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Items\clb.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Items\clothAnime.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Items\herbs.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Items\P1.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Items\queen.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Items\side.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Itms4.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Itms5.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Itms6.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\jh_adobewall1c.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\jiaoyisuo.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\jiutong001.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\jm00jm1.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\jmdi001.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\jmwindows01.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\jmwindows03.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\JQ002.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\JQ003.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\JQ004.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\JQ005.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\JQ006.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\JQ008.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\JQ009.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\JQ011.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\JQ012.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\JQ013.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\JQ029.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\jz12N.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\k03s005.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\K05o00014.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\K05w00011.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\k7210045o.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\kgw003.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\knorw01.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\kw001.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\kxj001.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\kxj024.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\kxj025.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\kxj030.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\kxj032.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\kxj033.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\kxj041.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\kxj042.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\kxj042.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\kxj08.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\life01.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures\lighting\day\locations\Fort_Inside\White_Fort"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\lighting\day\locations\Fort_Inside\White_Fort\shadow.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures\lighting\day\locations\Town_Cartagena\Residence"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\lighting\day\locations\Town_Cartagena\Residence\Shadow.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures\lighting\day\locations\Town_Cartagena"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\lighting\day\locations\Town_Cartagena\Shadow.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures\lighting\day\locations\Town_Tortuga"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\lighting\day\locations\Town_Tortuga\Shadow.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures\lighting\evening\locations\Fort_Inside\White_Fort"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\lighting\evening\locations\Fort_Inside\White_Fort\shadow.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures\lighting\evening\locations\Town_Cartagena\Residence"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\lighting\evening\locations\Town_Cartagena\Residence\Shadow.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures\lighting\evening\locations\Town_Cartagena"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\lighting\evening\locations\Town_Cartagena\Shadow.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures\lighting\evening\locations\Town_Tortuga"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\lighting\evening\locations\Town_Tortuga\Shadow.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures\lighting\mn\locations\Fort_Inside\White_Fort"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\lighting\mn\locations\Fort_Inside\White_Fort\shadow.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures\lighting\mn\locations\Town_Cartagena\Residence"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\lighting\mn\locations\Town_Cartagena\Residence\Shadow.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures\lighting\mn\locations\Town_Cartagena"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\lighting\mn\locations\Town_Cartagena\Shadow.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures\lighting\mn\locations\Town_Tortuga"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\lighting\mn\locations\Town_Tortuga\Shadow.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures\lighting\storm\locations\Fort_Inside\White_Fort"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\lighting\storm\locations\Fort_Inside\White_Fort\shadow.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures\lighting\storm\locations\Town_Cartagena\Residence"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\lighting\storm\locations\Town_Cartagena\Residence\Shadow.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures\lighting\storm\locations\Town_Cartagena"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\lighting\storm\locations\Town_Cartagena\Shadow.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures\lighting\storm\locations\Town_Tortuga"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\lighting\storm\locations\Town_Tortuga\Shadow.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\lkywk023.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\lkywkmt006.bmp.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures\Loading\English"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Loading\English\inquisition_cave.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Loading\English\Inside_Apothecary.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Loading\English\Inside_Bank_Tortuga.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Loading\English\Inside_Brothel_Room_Tortuga.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Loading\English\Inside_Brothel_Tortuga.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Loading\English\Inside_HutRoundInside.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Loading\English\Inside_Library.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Loading\English\Inside_Loanshark_Corridor_Tortuga.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Loading\English\Inside_Prison_Tortuga.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Loading\English\inside_San_Felipe.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Loading\English\Inside_Shipyard_Tortuga.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Loading\English\Inside_Stonehouse_Tortuga.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Loading\English\Inside_Store01_Tortuga.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Loading\English\Inside_Storehouse_Tortuga.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Loading\English\Inside_Tavern01_Tortuga.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Loading\English\Inside_Tavern_Room_Tortuga.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Loading\English\Inside_Tortuga_Stairs.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Loading\English\Inside_Townhall_Stairs_Tortuga.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Loading\English\Outside_Isle.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Loading\English\Outside_Pirate_Outer_location_Turks.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Loading\English\secret_passage.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Loading\English\Town_Cartagena_Residence.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Loading\English\Town_Douwesen_Town_Spain.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Loading\English\Town_FalaiseDeFleur_Town_02_Spain.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Loading\English\Town_Greenford_Town_Spain.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Loading\English\Town_Havana_Center.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Loading\English\Town_Oranjestad_Port.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Loading\English\Town_Oxbay_Port_Spain.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Loading\English\Town_Santiago_Center.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Loading\English\Town_Santiago_Port.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Loading\English\Town_SantoDomingo_Center.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Loading\English\Town_Tortuga.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Loading\English\zoom_green.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Loading\English\zoom_tree.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures\Locations\inside\Bank\Tortuga"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Bank\Tortuga\checker.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Bank\Tortuga\objects_tex1.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Bank\Tortuga\objects_tex2.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Bank\Tortuga\objects_tex3.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Bank\Tortuga\tor_ed.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Bank\Tortuga\tor_eda.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Bank\Tortuga\tor_edb.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Bank\Tortuga\tor_ee.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Bank\Tortuga\tor_eea.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Bank\Tortuga\tor_eeb.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Bank\Tortuga\tor_em.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Bank\Tortuga\tor_ema.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Bank\Tortuga\tor_emb.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Bank\Tortuga\tor_en.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Bank\Tortuga\tor_ena.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Bank\Tortuga\tor_enb.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Bank\Tortuga\usurerhouse1_tex.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Bank\Tortuga\windusurerhouse1.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures\Locations\inside\Brothel\Tortuga"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Brothel\Tortuga\checker.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Brothel\Tortuga\map01.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Brothel\Tortuga\map02.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Brothel\Tortuga\tor_ed.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Brothel\Tortuga\tor_eda.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Brothel\Tortuga\tor_edb.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Brothel\Tortuga\tor_ee.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Brothel\Tortuga\tor_eea.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Brothel\Tortuga\tor_eeb.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Brothel\Tortuga\tor_em.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Brothel\Tortuga\tor_ema.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Brothel\Tortuga\tor_emb.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Brothel\Tortuga\tor_en.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Brothel\Tortuga\tor_ena.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Brothel\Tortuga\tor_enb.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Brothel\Tortuga\windbrothel.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Brothel\Tortuga\zanoves01.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures\Locations\inside\brothel_room\Tortuga"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\brothel_room\Tortuga\Bardel.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\brothel_room\Tortuga\checker.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\brothel_room\Tortuga\objects_tex1.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\brothel_room\Tortuga\objects_tex2.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\brothel_room\Tortuga\tor_ed.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\brothel_room\Tortuga\tor_eda.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\brothel_room\Tortuga\tor_edb.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\brothel_room\Tortuga\tor_ee.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\brothel_room\Tortuga\tor_eea.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\brothel_room\Tortuga\tor_eeb.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\brothel_room\Tortuga\tor_em.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\brothel_room\Tortuga\tor_ema.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\brothel_room\Tortuga\tor_emb.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\brothel_room\Tortuga\tor_en.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\brothel_room\Tortuga\tor_ena.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\brothel_room\Tortuga\tor_enb.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\brothel_room\Tortuga\windbardel.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures\Locations\inside\Doubleflour_house\Tortuga"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Doubleflour_house\Tortuga\common1_1.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Doubleflour_house\Tortuga\sib_stuff copy.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures\Locations\inside\Doubleflour_house\wood_tower"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Doubleflour_house\wood_tower\tor_ed.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Doubleflour_house\wood_tower\tor_eda.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Doubleflour_house\wood_tower\tor_edb.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Doubleflour_house\wood_tower\tor_ee.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Doubleflour_house\wood_tower\tor_eea.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Doubleflour_house\wood_tower\tor_eeb.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Doubleflour_house\wood_tower\tor_em.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Doubleflour_house\wood_tower\tor_ema.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Doubleflour_house\wood_tower\tor_emb.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Doubleflour_house\wood_tower\tor_en.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Doubleflour_house\wood_tower\tor_ena.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Doubleflour_house\wood_tower\tor_enb.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures\Locations\inside\Prison\fort_moultrie"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Prison\fort_moultrie\A_new_yard.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Prison\fort_moultrie\PRISON.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Prison\fort_moultrie\sib_stuff copy.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Prison\fort_moultrie\window1.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures\Locations\inside\Prison\Tortuga"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Prison\Tortuga\A_new_yard.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Prison\Tortuga\PRISON.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Prison\Tortuga\sib_stuff copy.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Prison\Tortuga\window1.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures\Locations\inside\shipyard\Tortuga"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\shipyard\Tortuga\A_new_yard.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\shipyard\Tortuga\fonar.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\shipyard\Tortuga\fonar_noactive.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\shipyard\Tortuga\Foudation_Win_Door.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\shipyard\Tortuga\grey.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\shipyard\Tortuga\sib_stuff copy.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\shipyard\Tortuga\struzhka.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\shipyard\Tortuga\tor_ed.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\shipyard\Tortuga\tor_eda.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\shipyard\Tortuga\tor_edb.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\shipyard\Tortuga\tor_ee.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\shipyard\Tortuga\tor_eea.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\shipyard\Tortuga\tor_eeb.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\shipyard\Tortuga\tor_em.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\shipyard\Tortuga\tor_ema.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\shipyard\Tortuga\tor_emb.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\shipyard\Tortuga\tor_en.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\shipyard\Tortuga\tor_ena.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\shipyard\Tortuga\tor_enb.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\shipyard\Tortuga\window1.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\shipyard\Tortuga\wood_all.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures\Locations\inside\Shipyard3\dupin"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Shipyard3\dupin\Foudation_Win_Door.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Shipyard3\dupin\Shipyard_3.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Shipyard3\dupin\sib_stuff copy.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures\Locations\inside\Shipyard3\sacristy"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Shipyard3\sacristy\Shipyard_3.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures\Locations\inside\Smallhome\store"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Smallhome\store\frt_ee.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Smallhome\store\frt_eea.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Smallhome\store\frt_eeb.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Smallhome\store\frt_em.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Smallhome\store\frt_ema.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Smallhome\store\frt_emb.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Smallhome\store\frt_en.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Smallhome\store\frt_ena.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\Smallhome\store\frt_enb.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures\Locations\inside\SmallTavern"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\SmallTavern\frt_ee.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\SmallTavern\frt_eea.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\SmallTavern\frt_eeb.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\SmallTavern\frt_em.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\SmallTavern\frt_ema.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\SmallTavern\frt_emb.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\SmallTavern\frt_en.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\SmallTavern\frt_ena.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\SmallTavern\frt_enb.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures\Locations\inside\StoneHouse\Tortuga"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\StoneHouse\Tortuga\objects_tex1.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\StoneHouse\Tortuga\objects_tex2.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\StoneHouse\Tortuga\StoneHouse_inside.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\StoneHouse\Tortuga\tor_ed.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\StoneHouse\Tortuga\tor_eda.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\StoneHouse\Tortuga\tor_edb.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\StoneHouse\Tortuga\tor_ee.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\StoneHouse\Tortuga\tor_eea.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\StoneHouse\Tortuga\tor_eeb.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\StoneHouse\Tortuga\tor_em.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\StoneHouse\Tortuga\tor_ema.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\StoneHouse\Tortuga\tor_emb.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\StoneHouse\Tortuga\tor_en.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\StoneHouse\Tortuga\tor_ena.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\StoneHouse\Tortuga\tor_enb.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\StoneHouse\Tortuga\windStoneHouse.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures\Locations\inside\store01\Tortuga"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\store01\Tortuga\checker.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\store01\Tortuga\store01ins.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\store01\Tortuga\tor_ed.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\store01\Tortuga\tor_eda.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\store01\Tortuga\tor_edb.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\store01\Tortuga\tor_ee.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\store01\Tortuga\tor_eea.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\store01\Tortuga\tor_eeb.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\store01\Tortuga\tor_em.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\store01\Tortuga\tor_ema.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\store01\Tortuga\tor_emb.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\store01\Tortuga\tor_en.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\store01\Tortuga\tor_ena.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\store01\Tortuga\tor_enb.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\store01\Tortuga\windstore01.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures\Locations\inside\store04\church"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\store04\church\frt_ee.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\store04\church\frt_eea.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\store04\church\frt_eeb.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\store04\church\frt_em.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\store04\church\frt_ema.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\store04\church\frt_emb.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\store04\church\frt_en.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\store04\church\frt_ena.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\store04\church\frt_enb.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\store04\church\smu_ed.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\store04\church\smu_eda.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\store04\church\smu_edb.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\store04\church\smu_ee.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\store04\church\smu_eea.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\store04\church\smu_eeb.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\store04\church\smu_em.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\store04\church\smu_ema.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\store04\church\smu_emb.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\store04\church\smu_en.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\store04\church\smu_ena.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\store04\church\smu_enb.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures\Locations\inside\tavern01\Tortuga"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\tavern01\Tortuga\checker.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\tavern01\Tortuga\objects_tex1.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\tavern01\Tortuga\objects_tex2.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\tavern01\Tortuga\objects_tex3.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\tavern01\Tortuga\tavern1ins.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\tavern01\Tortuga\tor_ed.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\tavern01\Tortuga\tor_eda.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\tavern01\Tortuga\tor_edb.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\tavern01\Tortuga\tor_ee.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\tavern01\Tortuga\tor_eea.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\tavern01\Tortuga\tor_eeb.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\tavern01\Tortuga\tor_em.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\tavern01\Tortuga\tor_ema.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\tavern01\Tortuga\tor_emb.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\tavern01\Tortuga\tor_en.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\tavern01\Tortuga\tor_ena.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\tavern01\Tortuga\tor_enb.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\inside\tavern01\Tortuga\windtavern1.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures\Locations\Shipyard3\dupin"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\Shipyard3\dupin\Foudation_Win_Door.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\Shipyard3\dupin\Shipyard_3.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\Shipyard3\dupin\sib_stuff copy.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures\Locations\SPAIN"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\SPAIN\ladde.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\SPAIN\Metal_Rough.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\SPAIN\Wood_Lumber_ButtJoined.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\SPAIN\YELLOW.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\SPAIN\_Corrogated_.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Locations\SPAIN\_Corrogated_3.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures\LocEfx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\LocEfx\sghor.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\lowmen.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\LSCMaskU1.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\lspms00008.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\mache copy.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\mahs038.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\mahs051.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\MAHSTHONIE~1.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\mbra008.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\mbrd012.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\md04022.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\MD04052.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\metalU1.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\mjbei01.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\mjbei02.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\mjdbump.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\mjddi.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\molin005.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\molin006.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\mr_leather1.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\ms04066.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\msn001.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Muleskin_01.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Muleskin_1.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Mule_Skin_00.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Mule_Skin_1.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Mule_Skin_2.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Mule_Skin_3.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Mule_Skin_5.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Mule_Skin_6.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Mule_Skin_7.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\N02b00.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\N02b04.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\n02d015.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\N02f00.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\n02o005.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\n02o006.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\n02o015.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\n02s005.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\n03d019.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\n03d043.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\n03S040.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\n03S052.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\n03S059.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\n03S100.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\n03S118.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\n03S124.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\n03S126.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\n03S127.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\n03S133.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\n03S134.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\N05s00049.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\n1ot002.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\n1ot008.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\n1ot013.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\n1ot014.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\n1ot019.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\n1ot032.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\n1ot038.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\n2ot005.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\n2ot011.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\N3ot0001.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\ngo006.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\ngw005.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\night.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\night001.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\night003.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\night004.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\nitd001.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\nite003.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\nite006.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\nite007.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\nite012.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\nite013.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\nite017.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\nnn04.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\nnn09.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\nong123.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\nong123.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\OranjDoor2.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\oxbay_hill.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\qz001.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\qz003.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\qz004.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\qz005.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\qz006.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\qz007.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\qz009.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\qz012.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\qz013.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\qz014.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\qz016.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\qz018.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\qz019.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\qz020.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\qz023.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\qz024.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\qz025.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\qz027.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\qz029.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\qz035.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\qz036.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\rddy.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\reda.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\ro2JRH.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\road001.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\rock160.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\rwalls0019.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\s02.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sd001.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sd002.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sd003.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sd004.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sd005.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sd006.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sd007.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sd008.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sd009.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sd010.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sd011.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sd012.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sd013.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sd014.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sd015.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sd016.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sd019.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sd020.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sd021.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sd022.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sd023.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sd024.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sd025.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sd026.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sd027.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sd028.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sd029.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sd030.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sd031.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sd032.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sd033.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sd034.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sd035.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sd036.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sd037.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sd038.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sd039.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sd040.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sd042.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sd043.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sd044.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sd045.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sd046.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sd047.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sd050.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sd051.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sd053.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sd060.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sd062.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sd063.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sdbst07.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sdbst07.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sdhill.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sdt001.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sdt002.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sdt003.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sdt004.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sdtjw01.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sdtjw03.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sdtjw06.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sdtjw07.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sdtjw08.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sdtjw09.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sdtjw10.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sdtjw11.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\shazi001.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\shazi002.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\shen.bmp.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures\Ships"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ships\Baat.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ships\bortoutGaleon_h1.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ships\bortoutgaleon_h2.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ships\bortoutpinnace6.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ships\bortoutPiratFGal.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ships\cap_deck_glass.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ships\caravel_blnk2.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ships\checkeJ.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ships\deckPlanksU2_d.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ships\deck_pinn.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ships\dekp.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ships\detal1.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ships\fightdeckp.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ships\holz_01B.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ships\HvyTrade_eng.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ships\HvyTrade_fra.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ships\HvyTrade_mer.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ships\HvyTrade_spa.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ships\lafette.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ships\lowmen.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ships\Mast1.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ships\metalU6.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ships\oese.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ships\Patp.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ships\pinnac18.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ships\rahe.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ships\rohr.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ships\stuff.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ships\SuperFrigate.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ships\win_p.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ships\woodBA1.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ships\woodRE1.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ships\woodRO1.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ships\woodRO2.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ships\WoPlO01.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Ships\WoPlU01.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\shiys0003.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\shiys0004.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Shore05_dust.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\shu001.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\shui002.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\shupiys0002.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\sklGP.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\spain_pesok.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\ssa-d.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\ssa0001.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\ssa0002.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\ssa01bump.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\ssa02bump.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\ssaqqq112.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\ssaqqq113.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\ssa_shang.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\stone001.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\t010.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\t013.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\t11ree4radial.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\tap.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\TenochtitlanPaJRHU1.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\TenochtitlanPaJRHU6.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\TenochtitlanPaJRHU7.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\tiemen001.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\tor_ed.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\tor_eda.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\tor_edb.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\tor_ee.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\tor_eea.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\tor_eeb.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\tor_em.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\tor_ema.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\tor_emb.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\tor_en.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\tor_ena.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\tor_enb.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\tree.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\tree1.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\tree1_1.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Tree2.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\treeays.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\treegen.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\treepi.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Tx_wood_weathered_rings.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\TX_W_iron_clubgrib.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\v0008S1.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\v0009S.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\v0014S.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\v00d009.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\v00d09.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\vvvbook1.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\wa001.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\wa003.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\wa004.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\wall001.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\wall002.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\wall003.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\wall004.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\wall0045.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\wall005.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\wall006.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\wall007.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\wall008.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\wall009.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\wall010.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\wall011.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\wall012.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\wall013.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\wall014.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\wall015.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\wall016.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\wall017.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\wall111.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\wall112.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\wall113.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\wallTemJRHU1.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\wallTemJRHU2.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures\WEATHER\SUN\GLOW"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\WEATHER\SUN\GLOW\moonglowfull.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\WEATHER\SUN\GLOW\moonglownew.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\WEATHER\SUN\GLOW\moonglowwan.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\WEATHER\SUN\GLOW\moonglowwanc.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\WEATHER\SUN\GLOW\moonglowwax.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\WEATHER\SUN\GLOW\moonglowwaxc.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\wood001.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\wood002.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\wood003.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\wood005.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\wood022.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\wood024.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\wood025.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\wood027.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\wood095.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\wood3.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\wood3.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\wood4.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\woodcuo.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\wu02.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\yd001.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\yd002.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\yd003.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\yd004.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\yd005.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\yd006.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\yd007.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\yd008.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\yd009.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\yd010.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\yd011.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\yd012.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\yd013.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\yd014.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\yd015.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\yd016.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\yd018.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\yd019.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\yd022.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\yd023.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\yd024.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\yd025.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\yd026.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\yd027.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\yd028.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\yd029.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\yd030.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\yd031.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\yd032.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\yd033.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\yd034.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\yd035.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\yd036.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\yd037.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\yd038.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\yd039.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\yddi.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\yz10.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\yz4.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\yz7.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\yz8.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\yz9.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\zawN.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\zawu.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\zuz.bmp.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Z_1.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\Z_2.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\_Black_.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\_Maroon_.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\Textures\_white_.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\VIDEOS\Bartolomeu"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\VIDEOS\Bartolomeu\Ilot.wmv"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\VIDEOS\Bartolomeu\stunned.wmv"
  SetOutPath "$INSTDIR\RESOURCE\VIDEOS\common"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\VIDEOS\common\PiratesAhoyLogo.wmv"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\b14_beta3_update\RESOURCE\VIDEOS\common\surrender_bart.wmv"


; ================================================
;  Clean Up Update Files
; ================================================

  CopyFiles /SILENT $INSTDIR\RESOURCE\Textures\Locations\vco\*.*				$INSTDIR\RESOURCE\Textures

  Rename "$INSTDIR\RESOURCE\Textures\INTERFACES\PERKS\128\AdvancedDefense.tga.tx"		"$INSTDIR\RESOURCE\Textures\INTERFACES\PERKS\128\AdvancedDefence.tga.tx"
  Rename "$INSTDIR\RESOURCE\Textures\INTERFACES\PERKS\128\BasicDefense.tga.tx"	 	        "$INSTDIR\RESOURCE\Textures\INTERFACES\PERKS\128\BasicDefence.tga.tx"
  Rename "$INSTDIR\RESOURCE\Textures\INTERFACES\PERKS\128\ShipDefenseProfessional.tga.tx"	"$INSTDIR\RESOURCE\Textures\INTERFACES\PERKS\128\ShipDefenceProfessional.tga.tx"
  Rename "$INSTDIR\RESOURCE\Textures\INTERFACES\PERKS\64\AdvancedDefense.tga.tx"		"$INSTDIR\RESOURCE\Textures\INTERFACES\PERKS\64\AdvancedDefence.tga.tx"
  Rename "$INSTDIR\RESOURCE\Textures\INTERFACES\PERKS\64\BasicDefense.tga.tx"	 	        "$INSTDIR\RESOURCE\Textures\INTERFACES\PERKS\64\BasicDefence.tga.tx"
  Rename "$INSTDIR\RESOURCE\Textures\INTERFACES\PERKS\64\ShipDefenseProfessional.tga.tx"	"$INSTDIR\RESOURCE\Textures\INTERFACES\PERKS\64\ShipDefenceProfessional.tga.tx"
  Rename "$INSTDIR\RESOURCE\Textures\INTERFACES\PERKS\64Disable\AdvancedDefense.tga.tx"		"$INSTDIR\RESOURCE\Textures\INTERFACES\PERKS\64Disable\AdvancedDefence.tga.tx"
  Rename "$INSTDIR\RESOURCE\Textures\INTERFACES\PERKS\64Disable\BasicDefense.tga.tx"	 	"$INSTDIR\RESOURCE\Textures\INTERFACES\PERKS\64Disable\BasicDefence.tga.tx"
  Rename "$INSTDIR\RESOURCE\Textures\INTERFACES\PERKS\64Disable\ShipDefenseProfessional.tga.tx" "$INSTDIR\RESOURCE\Textures\INTERFACES\PERKS\64Disable\ShipDefenceProfessional.tga.tx"
  Rename "$INSTDIR\RESOURCE\Textures\Loading\English\Quest_BraveBlackFlag.tga.tx"		"$INSTDIR\RESOURCE\Textures\Loading\English\Character_BraveBlackFlag.tga.tx"
  Rename "$INSTDIR\RESOURCE\Textures\Loading\English\Quest_JackAubrey.tga.tx"			"$INSTDIR\RESOURCE\Textures\Loading\English\Character_JackAubrey.tga.tx"
  Rename "$INSTDIR\RESOURCE\Textures\Loading\English\Quest_LaCroix.tga.tx"			"$INSTDIR\RESOURCE\Textures\Loading\English\Character_LaCroix.tga.tx"
  Rename "$INSTDIR\RESOURCE\MODELS\Ammo\OtherItemsJRH\defense.gm"				"$INSTDIR\RESOURCE\MODELS\Ammo\OtherItemsJRH\defence.gm"

  RMDir /r "$INSTDIR\PROGRAM\Storyline\DevlinOpera\Locations"
  RMDir /r "$INSTDIR\PROGRAM\Storyline\JackAubrey"
  RMDir /r "$INSTDIR\PROGRAM\Storyline\JeanLafitte"
  RMDir /r "$INSTDIR\PROGRAM\Storyline\LaCroix"
  RMDir /r "$INSTDIR\PROGRAM\Storyline\Nelson"
  RMDir /r "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\NATIONS"
  RMDir /r "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\items"
  RMDir /r "$INSTDIR\PROGRAM\Storyline\Hornblower\items"
  RMDir /r "$INSTDIR\PROGRAM\Storyline\Standard\NATIONS"
  RMDir /r "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\JackAubrey"
  RMDir /r "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\JeanLafitte"
  RMDir /r "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\LaCroix"
  RMDir /r "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\Nelson"
  RMDir /r "$INSTDIR\RESOURCE\MODELS\Locations\inside\Dungeon_5"
  RMDir /r "$INSTDIR\RESOURCE\MODELS\Locations\Town_Cartagena\Tunel"
  RMDir /r "$INSTDIR\SAVE\JackAubrey"
  RMDir /r "$INSTDIR\SAVE\JeanLafitte"
  RMDir /r "$INSTDIR\SAVE\LaCroix"
  RMDir /r "$INSTDIR\SAVE\Nelson"

  Delete "$INSTDIR\PROGRAM\Characters\init\Cartagena.c"
  Delete "$INSTDIR\PROGRAM\DIALOGS\AddDialog.c"
  Delete "$INSTDIR\PROGRAM\DIALOGS\Edgar Attwood_dialog.c"
  Delete "$INSTDIR\PROGRAM\DIALOGS\ENGLISH\Edgar Attwood_dialog.h"
  Delete "$INSTDIR\PROGRAM\DIALOGS\ENGLISH\Ewan Glover_dialog.h"
  Delete "$INSTDIR\PROGRAM\DIALOGS\ENGLISH\Faust Gasquet_dialog.h"
  Delete "$INSTDIR\PROGRAM\DIALOGS\ENGLISH\Ferro Cerezo_dialog.h"
  Delete "$INSTDIR\PROGRAM\DIALOGS\ENGLISH\Pirates_vs_Blaze.h"
  Delete "$INSTDIR\PROGRAM\DIALOGS\ENGLISH\Rene Dutruel_dialog.h"
  Delete "$INSTDIR\PROGRAM\DIALOGS\ENGLISH\Rumour_Data.h"
  Delete "$INSTDIR\PROGRAM\DIALOGS\ENGLISH\Tia Dalma_dialog.h"
  Delete "$INSTDIR\PROGRAM\DIALOGS\ENGLISH\Vincent Bethune_dialog.h"
  Delete "$INSTDIR\PROGRAM\DIALOGS\ENGLISH\Wilfred Bythesea_dialog.h"
  Delete "$INSTDIR\PROGRAM\DIALOGS\ENGLISH\Wilfred_dialog.h"
  Delete "$INSTDIR\PROGRAM\DIALOGS\Ewan Glover_dialog.c"
  Delete "$INSTDIR\PROGRAM\DIALOGS\Faust Gasquet_dialog.c"
  Delete "$INSTDIR\PROGRAM\DIALOGS\Ferro Cerezo_dialog.c"
  Delete "$INSTDIR\PROGRAM\DIALOGS\Pirates_vs_Blaze.c"
  Delete "$INSTDIR\PROGRAM\DIALOGS\raoul rheims_dialog.c"
  Delete "$INSTDIR\PROGRAM\DIALOGS\Rene Dutruel_dialog.c"
  Delete "$INSTDIR\PROGRAM\DIALOGS\Rumour_Data.c"
  Delete "$INSTDIR\PROGRAM\DIALOGS\Tia Dalma_dialog.c"
  Delete "$INSTDIR\PROGRAM\DIALOGS\Vincent Bethune_dialog.c"
  Delete "$INSTDIR\PROGRAM\DIALOGS\Wilfred Bythesea_dialog.c"
  Delete "$INSTDIR\PROGRAM\DIALOGS\Wilfred_dialog.c"
  Delete "$INSTDIR\PROGRAM\INTERFACE\pause.c"
  Delete "$INSTDIR\PROGRAM\Locations\init\Cartagena.c"
  Delete "$INSTDIR\PROGRAM\SEA_AI\walk\MerchantPinnace_walk.c"
  Delete "$INSTDIR\PROGRAM\Storyline\Assassin\dialogs\Amerigo Vieira_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\Assassin\dialogs\Antoine Lebretton_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\Assassin\dialogs\Cole Arkwright_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\Assassin\dialogs\ENGLISH\Amerigo Vieira_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\Assassin\dialogs\ENGLISH\Antoine Lebretton_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\Assassin\dialogs\ENGLISH\Cole Arkwright_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\Assassin\dialogs\ENGLISH\John Clifford Brin_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\Assassin\dialogs\ENGLISH\Larry_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\Assassin\dialogs\ENGLISH\Randolf Blecher_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\Assassin\dialogs\ENGLISH\Salvador Allende_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\Assassin\dialogs\ENGLISH\Wilfred Burman_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\Assassin\dialogs\John Clifford Brin_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\Assassin\dialogs\Larry_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\Assassin\dialogs\Randolf Blecher_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\Assassin\dialogs\Salvador Allende_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\Assassin\dialogs\Wilfred Burman_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\Assassin\SL_utils.c"
  Delete "$INSTDIR\PROGRAM\Storyline\Bartolomeu\dialogs\ENGLISH\Cecile Bienbonne_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\Bartolomeu\dialogs\ENGLISH\Garda_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\Bartolomeu\dialogs\ENGLISH\Gregorio Montavez_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\Bartolomeu\dialogs\ENGLISH\John Clifford Brin_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\Bartolomeu\dialogs\ENGLISH\Joseph Claude Le Moigne_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\Bartolomeu\dialogs\ENGLISH\Remy Gatien_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\Bartolomeu\dialogs\Gregorio Montavez_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\Bartolomeu\dialogs\John Clifford Brin_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\Bartolomeu\dialogs\Joseph Claude Le Moigne_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\Bartolomeu\dialogs\Pedro Rivera_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\characters\init\Douwesen.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\characters\init\FalaiseDeFleur.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\characters\init\Hispaniola.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\characters\init\IslaMuelle.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\characters\init\QuebradasCostillas.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\characters\init\Redmond.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\characters\init\Story.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\characters\init\StreetMerchants.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\characters\init\Turks.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Alan Milds_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Amerigo Vieira_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Amiel Berangere_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Anacleto Rui Sa Pinto_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\andre juliao_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Antoine Lebretton_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Arabella Morgan_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Arabella's guard_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\arnaud matton_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Artois Voysey_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\baldewyn coffier_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Bartolomeu o Portugues_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Bernardo Gamboa_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\blaze_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\christofor manuel de alencar_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Clair Larrouse_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Clauss_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Contre-Amirale Cesar Beauregard_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Corentin Lucay_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\dark teacher_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Docker_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Edgar Attwood_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\emiliano rionda_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\eng_officiant_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Alan Milds_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Amerigo Vieira_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Amiel Berangere_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Anacleto Rui Sa Pinto_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\andre juliao_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\antoine lebretton_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Arabella Morgan_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Arabella's guard_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\arnaud matton_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Artois Voysey_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\baldewyn coffier_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Bartolomeu o Portugues_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Bernardo Gamboa_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\blaze_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\christofor manuel de alencar_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Clair Larrouse_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Clauss_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Contre-Amirale Cesar Beauregard_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Corentin Lucay_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\dark teacher_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Docker_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Edgar Attwood_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\emiliano rionda_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\eng_officiant_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Fred Bob_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Gervasio Serrao_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Gheerlof Darlang_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Gheraed Drabbe_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Gordon Carpenter_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\hardouin aufort_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Havana_Crewmember_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Henry Morgan_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Henry_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Jacinto Arcibaldo Barreto_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Jaoquin de masse_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Joaquin Da Saldanha_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\John Filbert_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Jordano_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\joseph claude le moigne_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Kate Blowhorn_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\LaCroix_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Lambrecht Fobes_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Larry_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Leborio Drago_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Leonardo Violate_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Lucas Da Saldanha_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\lucien bescanceny_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Malcolm Hatcher_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\marc blacque_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Martinho Guterres_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\milon blacque_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Nigel Blythe_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\orable caron_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Oweyn McDorey_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\pater jourdain_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\patric cardone_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Pedro Rivera_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\PGov_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Quest_ANIMISTS_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\quest_pirate_01_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\rachel blacque_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\raoul calmes_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Reynard Grueneveldt_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Rys Bloom_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Sabine Matton_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Skipper Wife_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Sylvie Bondies_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Tanneken Oremans_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Thomas O'Reily_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Toff Oremans_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Txiki Pijuan_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Usurer_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Valentin Massoni_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Virgile Boon_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\Watch_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\ENGLISH\zaid murro_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Fred Bob_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Gervasio Serrao_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Gheerlof Darlang_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Gheraed Drabbe_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Gordon Carpenter_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\hardouin aufort_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Havana_Crewmember_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Henry Morgan_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Henry_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Jacinto Arcibaldo Barreto_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Jaoquin de masse_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Joaquin Da Saldanha_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\John Filbert_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Jordano_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\joseph claude le moigne_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Kate Blowhorn_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\LaCroix_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Lambrecht Fobes_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Larry_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Leborio Drago_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Leonardo Violate_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Lucas Da Saldanha_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\lucien bescanceny_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\marc blacque_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Martinho Guterres_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\milon blacque_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Nigel Blythe_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\orable caron_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Oweyn McDorey_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\pater jourdain_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\patric cardone_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\PGov_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Quest_ANIMISTS_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\quest_pirate_01_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\rachel blacque_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\raoul calmes_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Reynard Grueneveldt_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Rys Bloom_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Sabine Matton_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Skipper Wife_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Sylvie Bondies_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Tanneken Oremans_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Thomas O'Reily_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Toff Oremans_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Txiki Pijuan_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Usurer_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Valentin Massoni_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Virgile Boon_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\Watch_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\DIALOGS\zaid murro_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\BraveBlackFlag\Rumour_Data.c"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\characters\init\QuebradasCostillas.c"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\characters\init\Redmond.c"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\characters\init\SideQuest.c"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\dialogs\andre juliao_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\dialogs\Antoine Lebretton_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\dialogs\Arabella Silehard_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\dialogs\Arabella's guard_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\dialogs\arnaud matton_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\dialogs\baldewyn coffier_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\dialogs\Bernardo Gamboa_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\dialogs\blaze_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\dialogs\Corentin Lucay_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\dialogs\danielle_quests_pirate_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\dialogs\ENGLISH\andre juliao_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\dialogs\ENGLISH\antoine lebretton_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\dialogs\ENGLISH\Arabella Silehard_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\dialogs\ENGLISH\Arabella's guard_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\dialogs\ENGLISH\arnaud matton_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\dialogs\ENGLISH\baldewyn coffier_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\dialogs\ENGLISH\Bernardo Gamboa_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\dialogs\ENGLISH\blaze_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\dialogs\ENGLISH\Corentin Lucay_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\dialogs\ENGLISH\danielle_quests_pirate_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\dialogs\ENGLISH\Fred Bob_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\dialogs\ENGLISH\hardouin aufort_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\dialogs\ENGLISH\Joaquin Da Saldanha_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\DIALOGS\ENGLISH\joseph claude le moigne_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\dialogs\ENGLISH\Lucas Da Saldanha_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\dialogs\ENGLISH\marc blacque_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\dialogs\ENGLISH\milon blacque_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\dialogs\ENGLISH\orable caron_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\dialogs\ENGLISH\rachel blacque_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\dialogs\ENGLISH\Reynard Grueneveldt_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\dialogs\ENGLISH\Rys Bloom_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\dialogs\ENGLISH\Sabine Matton_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\dialogs\ENGLISH\Sylvie Bondies_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\dialogs\ENGLISH\Tanneken Oremans_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\dialogs\ENGLISH\Thomas O'Reily_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\dialogs\ENGLISH\Toff Oremans_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\dialogs\ENGLISH\zaid murro_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\dialogs\Fred Bob_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\dialogs\hardouin aufort_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\dialogs\Joaquin Da Saldanha_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\dialogs\joseph claude le moigne_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\dialogs\Lucas Da Saldanha_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\dialogs\marc blacque_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\dialogs\milon blacque_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\dialogs\orable caron_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\dialogs\rachel blacque_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\dialogs\Reynard Grueneveldt_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\dialogs\Rys Bloom_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\dialogs\Sabine Matton_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\dialogs\Sylvie Bondies_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\dialogs\Tanneken Oremans_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\dialogs\Thomas O'Reily_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\dialogs\Toff Oremans_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\dialogs\zaid murro_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\Rumour_Data.c"
  Delete "$INSTDIR\PROGRAM\Storyline\DevlinOpera\SL_utils.c"
  Delete "$INSTDIR\PROGRAM\Storyline\GoldBug\StartStoryline.c"
  Delete "$INSTDIR\PROGRAM\Storyline\Hornblower\dialogs\Blaze_Dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\Hornblower\dialogs\ENGLISH\Blaze_Dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\Hornblower\dialogs\ENGLISH\Rifleman Baker_Dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\Hornblower\dialogs\Rifleman Baker_Dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\Hornblower\SL_utils.c"
  Delete "$INSTDIR\PROGRAM\Storyline\JackAubrey.c"
  Delete "$INSTDIR\PROGRAM\Storyline\JackSparrow\dialogs\Antigua_dockyard.c"
  Delete "$INSTDIR\PROGRAM\Storyline\JackSparrow\dialogs\Antigua_victualler.c"
  Delete "$INSTDIR\PROGRAM\Storyline\JackSparrow\dialogs\Arabella Silehard_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\JackSparrow\dialogs\Arabella's guard_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\JackSparrow\dialogs\Arendt Dickman_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\JackSparrow\dialogs\Clint Eastwood_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\JackSparrow\dialogs\Cole Arkwright_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\JackSparrow\dialogs\Cops_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\JackSparrow\dialogs\CursedPirate_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\JackSparrow\dialogs\dark teacher_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\JackSparrow\dialogs\Desmond Ray Beltrop_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\JackSparrow\dialogs\Elizabeth Swann_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\JackSparrow\dialogs\eng_officiant_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\JackSparrow\dialogs\ENGLISH\Antigua_dockyard.h"
  Delete "$INSTDIR\PROGRAM\Storyline\JackSparrow\dialogs\ENGLISH\Antigua_victualler.h"
  Delete "$INSTDIR\PROGRAM\Storyline\JackSparrow\dialogs\ENGLISH\Clint Eastwood_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\JackSparrow\dialogs\ENGLISH\Cole Arkwright_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\JackSparrow\dialogs\ENGLISH\Cops_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\JackSparrow\dialogs\ENGLISH\CursedPirate_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\JackSparrow\dialogs\ENGLISH\dark teacher_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\JackSparrow\dialogs\ENGLISH\Desmond Ray Beltrop_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\JackSparrow\dialogs\ENGLISH\Elizabeth Swann_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\JackSparrow\dialogs\ENGLISH\eng_officiant_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\JackSparrow\dialogs\ENGLISH\Father Jerald_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\JackSparrow\dialogs\ENGLISH\Gilbert Ballester_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\JackSparrow\dialogs\ENGLISH\Isenbrandt Jurcksen_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\JackSparrow\dialogs\ENGLISH\Jacinto Arcibaldo Barreto_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\JackSparrow\dialogs\ENGLISH\monk_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\JackSparrow\dialogs\ENGLISH\Oswald Chappel_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\JackSparrow\dialogs\ENGLISH\Pierart Kamerling_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\JackSparrow\dialogs\ENGLISH\second_spaniard_priest_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\JackSparrow\dialogs\ENGLISH\turpin cabanel_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\JackSparrow\dialogs\ENGLISH\Will Turner_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\JackSparrow\dialogs\ENGLISH\Yedam Kinne_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\JackSparrow\dialogs\father Gareth_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\JackSparrow\dialogs\Gilbert Ballester_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\JackSparrow\dialogs\Isenbrandt Jurcksen_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\JackSparrow\dialogs\Jacinto Arcibaldo Barreto_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\JackSparrow\dialogs\Laurence Wellman_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\JackSparrow\dialogs\monk_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\JackSparrow\dialogs\Oswald Chappel_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\JackSparrow\dialogs\Reynard Grueneveldt_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\JackSparrow\dialogs\second_spaniard_priest_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\JackSparrow\dialogs\turpin cabanel_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\JackSparrow\dialogs\Will Turner_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\JackSparrow\dialogs\witness-dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\JackSparrow\dialogs\Yedam Kinne_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\JackSparrow\SL_utils.c"
  Delete "$INSTDIR\PROGRAM\Storyline\JeanLafitte.c"
  Delete "$INSTDIR\PROGRAM\Storyline\LaCroix.c"
  Delete "$INSTDIR\PROGRAM\Storyline\Nelson.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\characters\init\Douwesen.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\characters\init\FalaiseDeFleur.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\characters\init\IslaMuelle.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\characters\init\Redmond.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\characters\init\StreetMerchants.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\Alan Milds_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\Amerigo Vieira_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\andre juliao_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\Antoine Lebretton_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\Arabella Silehard_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\Arabella's guard_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\arnaud matton_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\Artois Voysey_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\baldewyn coffier_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\Bartolomeu o Portugues_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\bartpirate_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\Bernardo Gamboa_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\blaze_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\christofor manuel de alencar_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\Clair Larrouse_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\Clauss_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\Corentin Lucay_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\Danielle hireling_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\danielle_quests_pirate_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\danielle_sailor_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\dark teacher_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\emiliano rionda_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\eng_officiant_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\Alan Milds_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\Amerigo Vieira_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\andre juliao_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\antoine lebretton_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\Arabella Silehard_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\Arabella's guard_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\arnaud matton_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\Artois Voysey_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\baldewyn coffier_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\Bartolomeu o Portugues_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\bartpirate_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\Bernardo Gamboa_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\blaze_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\christofor manuel de alencar_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\Clair Larrouse_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\Clauss_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\Corentin Lucay_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\Danielle hireling_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\danielle_quests_pirate_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\danielle_sailor_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\dark teacher_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\emiliano rionda_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\eng_officiant_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\Fred Bob_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\Gervasio Serrao_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\Gheerlof Darlang_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\Gheraed Drabbe_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\Greenford Commander_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\hardouin aufort_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\Henry_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\Jacinto Arcibaldo Barreto_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\Jaoquin de masse_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\Joaquin Da Saldanha_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\John Filbert_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\Jordano_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\joseph claude le moigne_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\Kate Blowhorn_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\Lambrecht Fobes_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\Larry_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\Leonardo Violate_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\Lucas Da Saldanha_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\lucien bescanceny_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\Malcolm Hatcher_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\marc blacque_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\Martinho Guterres_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\milon blacque_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\Nigel Blythe_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\orable caron_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\Oweyn McDorey_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\pater jourdain_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\patric cardone_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\Quest_ANIMISTS_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\quest_pirate_01_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\rachel blacque_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\raoul calmes_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\Redmond commendant_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\Reynard Grueneveldt_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\Rys Bloom_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\Sabine Matton_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\Sylvie Bondies_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\Tanneken Oremans_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\Thomas O'Reily_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\Toff Oremans_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\Txiki Pijuan_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\Usurer_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\ENGLISH\zaid murro_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\Fred Bob_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\Gervasio Serrao_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\Gheerlof Darlang_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\Gheraed Drabbe_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\Greenford Commander_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\hardouin aufort_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\Henry_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\Jacinto Arcibaldo Barreto_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\Jaoquin de masse_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\Joaquin Da Saldanha_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\John Filbert_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\Jordano_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\joseph claude le moigne_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\Kate Blowhorn_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\Lambrecht Fobes_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\Larry_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\Leonardo Violate_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\Lucas Da Saldanha_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\lucien bescanceny_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\Malcolm Hatcher_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\marc blacque_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\Martinho Guterres_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\milon blacque_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\Nigel Blythe_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\orable caron_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\Oweyn McDorey_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\pater jourdain_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\patric cardone_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\Quest_ANIMISTS_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\quest_pirate_01_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\rachel blacque_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\raoul calmes_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\Redmond commendant_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\Reynard Grueneveldt_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\Rys Bloom_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\Sabine Matton_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\Sylvie Bondies_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\Tanneken Oremans_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\Thomas O'Reily_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\Toff Oremans_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\Txiki Pijuan_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\Usurer_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\DIALOGS\zaid murro_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\standard\SL_utils.c"
  Delete "$INSTDIR\PROGRAM\Storyline\WoodesRogers\dialogs\English\pircap defense_dialog.h"
  Delete "$INSTDIR\PROGRAM\Storyline\WoodesRogers\dialogs\opium_girl_dialog.c"
  Delete "$INSTDIR\PROGRAM\Storyline\WoodesRogers\dialogs\pircap defense_dialog.c"
  Delete "$INSTDIR\RESOURCE\animation\Heads\h_Offic_spa77.ani"
  Delete "$INSTDIR\RESOURCE\foam\locations\town_QC\port\QC_port.tga.tga.zap"
  Delete "$INSTDIR\RESOURCE\INI\INTERFACES\pause.ini"
  Delete "$INSTDIR\RESOURCE\INI\NEW_INTERFACES\pause.ini"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\BOOKS\skillbook2.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\BOOKS\skillbook4.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\QUESTBOOK\rival.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\BraveBlackFlag\QUESTBOOK\animists.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\BraveBlackFlag\QUESTBOOK\artois.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\BraveBlackFlag\QUESTBOOK\bartolomeu.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\BraveBlackFlag\QUESTBOOK\Being a Buccaneer.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\BraveBlackFlag\QUESTBOOK\Blacques.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\BraveBlackFlag\QUESTBOOK\chest.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\BraveBlackFlag\QUESTBOOK\Church_help.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\BraveBlackFlag\QUESTBOOK\Contact.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\BraveBlackFlag\QUESTBOOK\daughter.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\BraveBlackFlag\QUESTBOOK\Departure.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\BraveBlackFlag\QUESTBOOK\estrella.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\BraveBlackFlag\QUESTBOOK\Failure.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\BraveBlackFlag\QUESTBOOK\fred_bob.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\BraveBlackFlag\QUESTBOOK\Hire_by_france_for_defeat_england_corvette.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\BraveBlackFlag\QUESTBOOK\Hitman.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\BraveBlackFlag\QUESTBOOK\Jackpot.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\BraveBlackFlag\QUESTBOOK\Kill_Ogario.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\BraveBlackFlag\QUESTBOOK\larrouse.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\BraveBlackFlag\QUESTBOOK\Lucas.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\BraveBlackFlag\QUESTBOOK\mendes.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\BraveBlackFlag\QUESTBOOK\Moulin.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\BraveBlackFlag\QUESTBOOK\murro.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\BraveBlackFlag\QUESTBOOK\nigel.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\BraveBlackFlag\QUESTBOOK\Patric.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\BraveBlackFlag\QUESTBOOK\Santiago.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\BraveBlackFlag\QUESTBOOK\Thomas_delivery.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\BraveBlackFlag\QUESTBOOK\Thomas_OReily_contraband.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\BraveBlackFlag\QUESTBOOK\Turkshelp.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\BraveBlackFlag\QUESTBOOK\Vogelstruijs.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\BraveBlackFlag\QUESTBOOK\Where_are_i.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\BraveBlackFlag\rumour_strings.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\DevlinOpera\QUESTBOOK\Beginning.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\DevlinOpera\QUESTBOOK\Blacques.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\DevlinOpera\QUESTBOOK\Contact.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\DevlinOpera\QUESTBOOK\daughter.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\DevlinOpera\QUESTBOOK\estrella.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\DevlinOpera\QUESTBOOK\fred_bob.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\DevlinOpera\QUESTBOOK\Hire_by_france_for_defeat_england_corvette.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\DevlinOpera\QUESTBOOK\Lucas.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\DevlinOpera\QUESTBOOK\mendes.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\DevlinOpera\QUESTBOOK\Moulin.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\DevlinOpera\QUESTBOOK\murro.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\DevlinOpera\QUESTBOOK\Thomas_delivery.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\DevlinOpera\QUESTBOOK\Thomas_OReily_contraband.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\DevlinOpera\rumour_strings.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\standard\characters_names.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\standard\QUESTBOOK\animists.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\standard\QUESTBOOK\artois.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\standard\QUESTBOOK\bartolomeu.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\standard\QUESTBOOK\Blacques.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\standard\QUESTBOOK\Church_help.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\standard\QUESTBOOK\Contact.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\standard\QUESTBOOK\daughter.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\standard\QUESTBOOK\estrella.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\standard\QUESTBOOK\fred_bob.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\standard\QUESTBOOK\Hire_by_france_for_defeat_england_corvette.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\standard\QUESTBOOK\Hitman.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\standard\QUESTBOOK\Jackpot.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\standard\QUESTBOOK\larrouse.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\standard\QUESTBOOK\Lucas.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\standard\QUESTBOOK\mendes.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\standard\QUESTBOOK\Moulin.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\standard\QUESTBOOK\murro.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\standard\QUESTBOOK\nigel.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\standard\QUESTBOOK\Patric.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\standard\QUESTBOOK\Santiago.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\standard\QUESTBOOK\Thomas_delivery.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\standard\QUESTBOOK\Thomas_OReily_contraband.txt"
  Delete "$INSTDIR\RESOURCE\INI\TEXTS\ENGLISH\Storyline\standard\QUESTBOOK\Turkshelp.txt"
  Delete "$INSTDIR\RESOURCE\MODELS\Ammo\BuildingItemsJRH\door_OJ1.gm"
  Delete "$INSTDIR\RESOURCE\MODELS\Ammo\BuildingItemsJRH\door_OJ2.gm"
  Delete "$INSTDIR\RESOURCE\Models\Ammo\BuildingItemsJRH\wood_short_logs.gm"
  Delete "$INSTDIR\RESOURCE\Models\Ammo\BuildingItemsJRH\wood_short_standing.gm"
  Delete "$INSTDIR\RESOURCE\Models\Ammo\BuildingItemsJRH\wood4_item.gm"
  Delete "$INSTDIR\RESOURCE\Models\Ammo\OtherItemsJRH\bottle_AC1.gm"
  Delete "$INSTDIR\RESOURCE\Models\Ammo\OtherItemsJRH\bottle_AG1.gm"
  Delete "$INSTDIR\RESOURCE\Models\Ammo\OtherItemsJRH\bottle_AN1.gm"
  Delete "$INSTDIR\RESOURCE\Models\Ammo\OtherItemsJRH\bottle_AS1.gm"
  Delete "$INSTDIR\RESOURCE\Models\Ammo\OtherItemsJRH\bottle_AY1.gm"
  Delete "$INSTDIR\RESOURCE\MODELS\Characters\maroon6.gm"
  Delete "$INSTDIR\RESOURCE\MODELS\Characters\Offic_spa77.gm"
  Delete "$INSTDIR\RESOURCE\MODELS\Heads\h_Cpnnnelson.gm"
  Delete "$INSTDIR\RESOURCE\MODELS\Heads\h_Offic_spa77.gm"
  Delete "$INSTDIR\RESOURCE\Models\Locations\inside\Chinese_restaurant\locator.gm"
  Delete "$INSTDIR\RESOURCE\Models\Locations\inside\Sklad_gunpowder\bottle_MC1.gm"
  Delete "$INSTDIR\RESOURCE\Models\Locations\inside\Sklad_gunpowder\bottle_MG1.gm"
  Delete "$INSTDIR\RESOURCE\Models\Locations\inside\Sklad_gunpowder\bottle_MN1.gm"
  Delete "$INSTDIR\RESOURCE\Models\Locations\inside\Sklad_gunpowder\bottle_MS1.gm"
  Delete "$INSTDIR\RESOURCE\Models\Locations\inside\Sklad_gunpowder\bottle_MY1.gm"
  Delete "$INSTDIR\RESOURCE\Models\Locations\inside\Sklad_gunpowder\sklad_locators_gunpowder.gm"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Chinatown\NC_NIGHT1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\outside\Plantation\Plantation_locators_GB.gm"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\QuestTown_Charleston\Port\SMALLMODEL_NIGHT1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\QuestTown_Charleston\Town\SMALLMODEL_NIGHT1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Tortuga\fontain1.gm"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Tortuga\FONTAIN1_DAY1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Tortuga\FONTAIN1_EVENING3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Tortuga\FONTAIN1_MORNING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Tortuga\FONTAIN1_NIGHT1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Tortuga\fontain2.gm"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Tortuga\FONTAIN2_DAY1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Tortuga\FONTAIN2_EVENING3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Tortuga\FONTAIN2_MORNING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Tortuga\FONTAIN2_NIGHT1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Tortuga\plan1.gm"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Tortuga\PLAN1_DAY1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Tortuga\PLAN1_EVENING3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Tortuga\PLAN1_MORNING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Tortuga\PLAN1_NIGHT1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Tortuga\TORTUGA_DAY1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Tortuga\Tortuga_e1.gm"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Tortuga\TORTUGA_E1_DAY1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Tortuga\TORTUGA_E1_EVENING3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Tortuga\TORTUGA_E1_MORNING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Tortuga\TORTUGA_EVENING3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Tortuga\Tortuga_g.grs"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Tortuga\TORTUGA_MORNING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Tortuga\TORTUGA_NIGHT1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Tortuga\Tortuga_pd.ptc"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Tortuga\Tortuga_pn.ptc"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Tortuga\Tortuga_sb.gm"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Tortuga\TORTUGA_SB_DAY1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Tortuga\TORTUGA_SB_EVENING3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Tortuga\TORTUGA_SB_MORNING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Tortuga\TORTUGA_SB_NIGHT1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Tortuga\Tortuga_signsA.gm"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Tortuga\TORTUGA_SIGNSA_DAY1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Tortuga\TORTUGA_SIGNSA_EVENING3.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Tortuga\TORTUGA_SIGNSA_MORNING1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Locations\Town_Tortuga\TORTUGA_SIGNSA_NIGHT1.COL"
  Delete "$INSTDIR\RESOURCE\MODELS\Ships\FastGalleon1\FastGalleon1_bow.gm"
  Delete "$INSTDIR\RESOURCE\MODELS\Ships\FastGalleon1\FastGalleon1_mast1.gm"
  Delete "$INSTDIR\RESOURCE\MODELS\Ships\FastGalleon1\FastGalleon2_bow.gm"
  Delete "$INSTDIR\RESOURCE\MODELS\Ships\FastGalleon2\FastGalleon2_bow.gm"
  Delete "$INSTDIR\RESOURCE\MODELS\Ships\FastGalleon2\FastGalleon2_mast1.gm"
  Delete "$INSTDIR\RESOURCE\MODELS\Ships\PiratFastGal\PiratFastGal_bow.gm"
  Delete "$INSTDIR\RESOURCE\MODELS\Ships\PiratFastGal\PiratFastGal_mast1.gm"
  Delete "$INSTDIR\RESOURCE\Textures\3204004.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\4001410.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\50318m.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\Ammo\ffTOR.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\Ammo\OranjDoor1.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\Ammo\OranjDoor2.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\Characters\64Bl0.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\Characters\64Bl1.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\Characters\64Bl2.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\Characters\64Bl3.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\Characters\Blaz1.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\Characters\Blaz2.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\Characters\Blaz3.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\cj1.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\detail1.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\foliage_masked@tallleafyhoriz#1.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\grass_cattail.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\grass2.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\huays.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\jh_foiliage1.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\jh_foiliage4.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\jh_foiliage6.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\K05w00056.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\Loading\English\oranjestad_port.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\Locations\inside\Prison\A_new_yard.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\Locations\inside\Prison\PRISON.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\Locations\inside\Prison\sib_stuff copy.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\Locations\inside\Prison\window1.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\rdc.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\rdy11.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\shortpalmcross.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\shortpalmfill.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\shortpalmtrunk.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\shuc01.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\smallyuccacross.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\smallyuccafill.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\ss_hangvine.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\t007.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\y1.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\y2.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\z1.tga.tx"
  Delete "$INSTDIR\RESOURCE\Textures\z2.tga.tx"

SectionEnd

; ================================================
;  Additional Optional Sections
; ================================================

Section /o "Widescreen Textures" SEC03
  SetOutPath "$INSTDIR\RESOURCE\Textures"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\Widescreen\RESOURCE\Textures\Eye_BadTub.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\Widescreen\RESOURCE\Textures\Eye_BestTub.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\Widescreen\RESOURCE\Textures\Eye_commonTub.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\Widescreen\RESOURCE\Textures\eye_GoodTub.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\Widescreen\RESOURCE\Textures\telescope.tga.tx"
  SetOutPath "$INSTDIR\RESOURCE\Textures\WEATHER\SUN\GLOW"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\Widescreen\RESOURCE\Textures\WEATHER\SUN\GLOW\moonglowfull.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\Widescreen\RESOURCE\Textures\WEATHER\SUN\GLOW\moonglownew.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\Widescreen\RESOURCE\Textures\WEATHER\SUN\GLOW\moonglowwan.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\Widescreen\RESOURCE\Textures\WEATHER\SUN\GLOW\moonglowwanc.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\Widescreen\RESOURCE\Textures\WEATHER\SUN\GLOW\moonglowwax.tga.tx"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\Widescreen\RESOURCE\Textures\WEATHER\SUN\GLOW\moonglowwaxc.tga.tx"
SectionEnd

Section /o "Intel Graphics Fix" SEC04
  SetOutPath "$INSTDIR"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\Intel GFX Fix\IntelCard.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\Intel GFX Fix\Uninstall Intel Fix.exe"
  SetOutPath "$INSTDIR\MODULES"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\Intel GFX Fix\MODULES\sea.dll"
  SetOutPath "$INSTDIR\MODULES\Techniques\Weather"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\Intel GFX Fix\MODULES\Techniques\Weather\RadeonSea.sha"
SectionEnd

Section /o "ENB Improved Graphics" SEC05
  Delete "$INSTDIR\Uninstall ENB.bat"
  SetOutPath "$INSTDIR"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\ENB\d3d8.dll"
  SetOutPath "$INSTDIR\Documentation"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\ENB\Documentation\ENB Key Codes.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\ENB\Documentation\ENB License.txt"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\ENB\Documentation\ENB ReadMe.txt"
  SetOutPath "$INSTDIR"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\ENB\enbconvertor.ini"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\ENB\enbpalette.bmp"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\ENB\enbseries.ini"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\ENB\Uninstall ENB.exe"
SectionEnd

Section -Post
  CreateDirectory $INSTDIR\SAVE
  SetOverwrite off
  SetOutPath "$INSTDIR"
  File "C:\Users\PDM Boelen\Desktop\NEW\Installer\UsedFiles\options"
SectionEnd


; ================================================
;  Section Descriptions and Size
; ================================================

Function .onInit
# Section Size must be manually set to the size of the required disk space as NSIS will not do this for external files.
# set required size of section number of kilobytes
SectionSetSize ${SEC01} 7652390

; Installer must NOT be in the game directory
${If} ${FileExists} "$EXEDIR\ENGINE.exe"
  MessageBox MB_OK|MB_ICONINFORMATION "Please place the installation files OUTSIDE your game folder." IDOK abort
  abort:
  Banner::destroy
  Abort
${EndIf}

FunctionEnd

!insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC01} "Code files and resources required for Build 14. Deselect if installing an Update only."
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC02} "Additional UPDATE files for Build 14. Will ALWAYS be installed."
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC03} "Various textures adapted for 16:9 Aspect Ratio"
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC04} "WARNING: ONLY install if you have an Intel Onboard Graphics card! This will allow the game to run with it, but prevents the sea from looking as good as otherwise."
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC05} "Post-processing improved graphics. WARNING: Requires very high system specifications to run smoothly. Only install if you have a really good computer!"
!insertmacro MUI_FUNCTION_DESCRIPTION_END